/*
*****************************************************************************************
*                                                                                       *
* COPYRIGHT:                                                                            *
*   IBM Open Class Library                                                              *
*   (C) Copyright International Business Machines Corporation,  1997                    *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.                  *
*                                                                                       *
*****************************************************************************************
*/
// Revision: 10 1.6.1.4 source/albert/graph2d/igarea2d.inl, 2d, ioc.v400, 000919 
/*==========================================
||
||  File:   AreaGeometryImp.h
||
||  What:   2D Area-enclosing Geometric Primitives inline definitions
||
*/

#ifndef _IGAREA2D_INL_
#define _IGAREA2D_INL_

inline IMAreaGeometry* IAreaGeometryHandle::geometry ()
{
    return fGeometry;
}

inline const IMAreaGeometry* IAreaGeometryHandle::geometry () const
{
    return fGeometry;
}


inline IGArea& IGArea::operator+= (const IGArea& a0)
{
    add (a0);
    return *this;
}

inline IGArea operator+ (const IGArea& a0, const IGArea& a1)
{
    IGArea area (a0);
    area += a1;
    return area;
}

inline IGArea& IGArea::operator-= (const IGArea& a0)
{
    subtract (a0);
    return *this;
}

inline IGArea operator- (const IGArea& a0, const IGArea& a1)
{
    IGArea area (a0);
    area -= a1;
    return area;
}

inline IGArea& IGArea::operator*= (const IGArea& a0)
{
    intersect (a0);
    return *this;
}

inline IGArea operator* (const IGArea& a0, const IGArea& a1)
{
    IGArea area (a0);
    area *= a1;
    return area;
}

inline IGArea& IGArea::operator^= (const IGArea& a0)
{
    exclusiveOr (a0);
    return *this;
}

inline IGArea operator^ (const IGArea& a0, const IGArea& a1)
{
    IGArea area (a0);
    area ^= a1;
    return area;
}

#endif // _IGAREA2D_INL_
