// NOSHIP ...
/*
*****************************************************************************************
*                                                                                       *
* COPYRIGHT:                                                                            *
*   IBM Open Class Library                                                              *
*   (C) Copyright International Business Machines Corporation,  1997                    *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.                  *
*   US Government Users Restricted Rights - Use, duplication, or disclosure             *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                              *
*                                                                                       *
*****************************************************************************************
*/
// Revision: 93 1.2 source/albert/graph2d/imagedc.cpp, 2d, ioc.v400, 000919 


#include <imagedc.hpp>
#include <igrport.hpp>

#pragma pack(push,4)

class IGImage;
class IGrafPort;

IGImageDeviceContext::IGImageDeviceContext(const IGImage& image) :
		IPresSpaceHandle()
	{
		IPresSpaceHandle tmp;
		if (((IGImage*)&image)->grafPort() && (tmp = ((IGImage*)&image)->fGrafPort->orphanDeviceContext())) {
			IPresSpaceHandle::operator=(tmp);
			fOwnerImage = &image;
		}
		else {
			IPresSpaceHandle::operator=(image.deviceContext());
			fOwnerImage = 0 /*NIL*/;
		}
	}	

IGImageDeviceContext::~IGImageDeviceContext()
	{
		if (fOwnerImage
			&& fOwnerImage->fGrafPort
			&& fOwnerImage->deviceContext() == *this) {
			fOwnerImage->fGrafPort->adoptDeviceContext(*this);
		}
	}

#pragma pack(pop)

