// NOSHIP ...
/*
*****************************************************************************************
*                                                                                       *
* COPYRIGHT:                                                                            *
*   IBM Open Class Library                                                              *
*   (C) Copyright International Business Machines Corporation,  1997                    *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.                  *
*   US Government Users Restricted Rights - Use, duplication, or disclosure             *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                              *
*                                                                                       *
*****************************************************************************************
*/
// Revision: 78 1.6.1.5 source/albert/graph2d/imagedc.hpp, 2d, ioc.v400, 000919 

#ifndef _IMAGEDC_
#define _IMAGEDC_

#include <igimage.hpp>

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)

/**
 * inlined IGImageDeviceContext represents a special IPresSpaceHandle that manages the ownership
 * relationship of the IPresSpaceHandle with the IGImage object. This should only exist within
 * the context of an IGImage object and should not be copied, assigned or streamed.
 */
class IGImageDeviceContext : public IPresSpaceHandle {
public:
	IGImageDeviceContext(const IGImage& image) ;

	~IGImageDeviceContext();

private:
	const IGImage* fOwnerImage;	// the owner of the original IPresSpaceHandle
};

#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif // _IMAGEDC_
