// NOSHIP ...
// Revision: 15 1.1.2.3 source/albert/graph2d/ipmdc.hpp, 2d, ioc.v400, 000919  
/*******************************************************************************
* FILE NAME: ipmdc.hpp                                                         *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifndef IC_IPMDC
#define IC_IPMDC

#include <i2dghand.hpp>

#ifdef IC_PM
// this is for os/2 only

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

class IPMDC {

public:
	unsigned long fHPS;
	INativeWindowHandle fHWND;
	unsigned long fRefCount;
	
	IPMDC() :
		fRefCount(0),
		fHPS(0),
		fHWND(0)
	{}

	IPMDC(unsigned long hps, INativeWindowHandle hwnd) :
		fRefCount(1),
		fHPS(hps),
		fHWND(hwnd)
	{}

	
	~IPMDC() {}
			
	IPMDC& operator=(const IPMDC& dc) {
		if (this != &dc) {
			fRefCount = dc.fRefCount;
			fHPS = dc.fHPS;
			fHWND = dc.fHWND;
		}
		return *this;
	}
		
	unsigned long refCount() const {
		return fRefCount;
	}
	void incrementCount() {
		++fRefCount;
	}
	void decrementCount() {
		--fRefCount;
	}

private:
	IPMDC(const IPMDC& dc);
};

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif //IC_PM

#endif //IC_IPMDC

