/*
*****************************************************************************************
*                                                                                       *
* COPYRIGHT:                                                                            *
*   IBM Open Class Library                                                              *
*   (C) Copyright International Business Machines Corporation,  1997                    *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.                  *
*                                                                                       *
*****************************************************************************************
*/
// Revision: 13 1.5.1.5 source/albert/graph2d/ipt2darr.inl, 2d, ioc.v400, 000919 
/*================
||
||  File:   PointArrayImp.h
||
||  What:   inline class defining operations for arrays of TGPoints
||
||  Change History:
||
*/


#ifndef _IPT2DARR_INL_
#define _IPT2DARR_INL_

#ifndef _IGBASE2D_
#include <igbase2d.hpp>
#endif

#ifndef _IDATSTRM_
#include <idatstrm.hpp>
#endif

//
// Constructors
//

// Size access
inline unsigned long IGPoint2DArray::numberOfPoints() const
{
    return numberOfValues();
}

// Checked get/set
inline IGPoint2D IGPoint2DArray::point(unsigned long i) const
{
    return value(i);
}

inline void IGPoint2DArray::setPoint(unsigned long i, const IGPoint2D& p)
{
    setValue(i, p);
}

inline IDataStream& IGPoint2DArray::operator>>=(IDataStream& toWhere) const
{
        return IRawArray<IGPoint2D>::operator>>=(toWhere);
}

inline IDataStream& IGPoint2DArray::operator<<=(IDataStream& fromWhere)
{
        return IRawArray<IGPoint2D>::operator<<=(fromWhere);
}


////////////////////////// IGRPoint2DArray /////////////////////////

//
// Constructors
//

// Size access

inline unsigned long IGRPoint2DArray::numberOfPoints() const
{
    return numberOfValues();
}

inline IGRPoint2D IGRPoint2DArray::point(unsigned long i) const
{
    return value(i);
}

inline void IGRPoint2DArray::setPoint(unsigned long i, const IGRPoint2D& p)
{
    setValue(i, p);
}

inline IDataStream& IGRPoint2DArray::operator>>=(IDataStream& toWhere) const
{
        return IRawArray<IGRPoint2D>::operator>>=(toWhere);
}

inline IDataStream& IGRPoint2DArray::operator<<=(IDataStream& fromWhere)
{
        return IRawArray<IGRPoint2D>::operator<<=(fromWhere);
}

#endif // _IPT2DARR_INL_
