// NOSHIP ...
/*
*****************************************************************************************
*                                                                                       *
* COPYRIGHT:                                                                            *
*   IBM Open Class Library                                                              *
*   (C) Copyright International Business Machines Corporation,  1997                    *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.                  *
*   US Government Users Restricted Rights - Use, duplication, or disclosure             *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                              *
*                                                                                       *
*****************************************************************************************
*/
// Revision: 74 1.4.2.4 source/albert/graph2d/nurbs.hpp, 2d, ioc.v400, 000919 

// nurbs.hpp

#ifndef _NURBS_
#define _NURBS_

#ifndef IC_POINTARRAY
#include <ipt2darr.hpp>
#endif

#ifndef IC_BASEGEOMETRY
#include <igbase2d.hpp>
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

class INurbDiscretiser {
public:
	INurbDiscretiser(IGRect2D clipBounds);
	INurbDiscretiser(IGRect2D clipBounds, double resolution);
	
	virtual void begin() = 0;
	virtual void endPath() = 0;
	virtual void addPoint(IGPoint2D) = 0;

protected :
	IGRect2D fClipBounds;
	double 	fResolution;
	
	void DiscretizeOrderTwo( const GParametric* knotsVector, IGRPoint2DArray pointArray);
	void DiscretizeNurb( unsigned long, const GParametric* knotsVector, IGRPoint2DArray controlPoints, bool closed);

private:
	static int GetCurveSteps(int, int, const IGRPoint2D*, double);
	static bool NonEmptyIntersects(IGRect2D a, IGRect2D b);
};

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif // _NURBS_
		
