/*
*****************************************************************************************
*                                                                                       *
* COPYRIGHT:                                                                            *
*   IBM Open Class Library                                                              *
*   (C) Copyright International Business Machines Corporation,  1997                    *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.                  *
*   US Government Users Restricted Rights - Use, duplication, or disclosure             *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                              *
*                                                                                       *
*****************************************************************************************
*/
// Revision: 75 1.7.1.3 source/albert/graph2d/xpoint.cpp, 2d, ioc.v400, 000919 

//xpoint.cpp

#include <ilanglvl.hpp>

#include <xpoint.hpp>
#include <idatstrm.hpp>
#include <grassert.hpp>

// Segment definitions
#ifdef IC_PAGETUNE
#define _XPOINT_CPP_
#include <ipagetun.h>
#endif


IXPoint::IXPoint()
{
	fPoint.x = 0;
	fPoint.y = 0;
}
IXPoint::IXPoint(const XPoint& pt)
{
	fPoint = pt;
}
IXPoint::~IXPoint()
{
}
XPoint& IXPoint::point()
{
	return fPoint;
}

IDataStream& IXPoint::operator>>= (IDataStream& toWhere) const
{
	fPoint.x >>= toWhere;
	fPoint.y >>= toWhere;
	return toWhere;
}

IDataStream& IXPoint::operator<<= (IDataStream& fromWhere)
{
	fPoint.x <<= fromWhere;
	fPoint.y <<= fromWhere;
	return fromWhere;
}

#if 0
IXPoint IXPoint::operator- () const
{
	XPoint negPoint;
	negPoint.x = -fPoint.x;
	negPoint.y = -fPoint.y;
	return (IXPoint(negPoint));
}

IXPoint& IXPoint::operator+= ( const IXPoint& Src )
{
	fPoint.x += Src.fPoint.x;
	fPoint.y += Src.fPoint.y;
	return (*this);
}
IXPoint& IXPoint::operator-= ( const IXPoint& Src )
{
	fPoint.x -= Src.fPoint.x;
	fPoint.y -= Src.fPoint.y;
	return (*this);

}
IXPoint& IXPoint::operator*= ( const IXPoint& Src )
{
	fPoint.x *= Src.fPoint.x;
	fPoint.y *= Src.fPoint.y;
	return (*this);

}
IXPoint& IXPoint::operator/= ( const IXPoint& Src )
{
	fPoint.x /= Src.fPoint.x;
	fPoint.y /= Src.fPoint.y;
	return (*this);
}
#endif
IXPoint& IXPoint::operator= (const IXPoint& Src )
{
	fPoint = Src.fPoint;
	return (*this);
}

bool IXPoint::operator== ( const IXPoint& Src ) const
{
	return ((fPoint.x== Src.fPoint.x)&&(fPoint.y== Src.fPoint.y));
}
bool IXPoint::operator!= ( const IXPoint& Src ) const
{
	return ((fPoint.x!=Src.fPoint.x)||(fPoint.y!=Src.fPoint.y));
}
#if 0
short& IXPoint::operator[]( unsigned long which )
{
	switch (which) {
	case 0: return fPoint.x;
	case 1: return fPoint.y;
	default: ParameterException( true, IGraphicException::kUnknownEnumValue);
	}
	return fPoint.x;  // To supress warnings
}
#endif
