// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// "Restricted Materials of IBM"
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 27 1.3 source/core/base/del4cngt.hpp, oss, ioc.v400, 000919 
#ifndef _DEL4CNGT_HPP
#define _DEL4CNGT_HPP

#include <ingthrd.hpp>

// Open Class allocates one and only one ICurrentNonGUIThread object
// for the entire system.  This instance is allocated on the heap at
// the time of its first use.  ingthrd.cpp contains a static pointer
// to this instance.  Because this instance is heap allocated it is
// not automatically disposed of at static destruction time. This has
// resulted in the leakage of Unix System 5 semaphores.  This class is
// intended to prevent this leakage.  There will be one static
// instance of this class in ingthrd.cpp. At static destruction time
// it will clean up the IOC ICurrentNonGUIThread object.

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push, 4)
#pragma enum(4)

class DeleterForCurrentNonGUIThread
{
public:
  DeleterForCurrentNonGUIThread();
  ~DeleterForCurrentNonGUIThread();
};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif //_DEL4CNGT_HPP
