//----------------------------------------------------------------------------
// FILE NAME: ibasepl.hpp
//
// DESCRIPTION:
//      Pragma library definitions for base
//
// COPYRIGHT:
//   IBM Open Class Library
//   Licensed Materials - Property of IBM
//
//   5645-001
//   (C) Copyright IBM Corporation 1992, 1997
//
// Revision: 78  1.6.1.9  source/core/base/ibasepl.hpp, appsupport, ioc.v400, 000919  
// ----------------------------------------------------------------------------

#ifndef _IBASEPL_
#define _IBASEPL_

#ifndef IC_IMPORTB
  #if defined(__WINDOWS__) && defined(__IMPORTLIB__)
    #define IC_IMPORTB  _Import
  #else
    #define IC_IMPORTB
  #endif
#endif

#ifndef IC_EXPORTB
  #ifdef __MVS__
    #define IC_EXPORTB  _Export
  #else
    #define IC_EXPORTB
  #endif
#endif

/*-------------------------- Pragma Library Support --------------------------*/
#ifndef _IPRAGLIB_
#include <ipraglib.h>
#endif

#if !defined(__NO_DEFAULT_LIBS__)
    #if !defined(__NO_BASE_LIB__)
      	#if defined(__WINDOWS__)
            #if defined(_MSC_VER)   // MSVC
    		    #pragma comment(lib, OPENCLASS_LIBRARY_NAME_2(base,ob))
            #else                   // VAC
    		    #pragma library(OPENCLASS_LIBRARY_NAME_2(base,ob))
            #endif
            #if !defined(__IMPORTLIB__)
                #if defined(_MSC_VER)   // MSVC
                    #pragma comment(lib, "kernel32.lib")
                    #pragma comment(lib, "advapi32.lib")
                #else                   // VAC
                    #pragma library("kernel32.lib")
                    #pragma library("advapi32.lib")
                #endif
            #endif
    	#elif defined(__OS2__)
        	// OS/2 SWORD needs to be done without the OPENCLASS_LIBRARY_NAME_2 macro because
        	// the compiler doesn't support preprocessor token replacement in the pragma
    	    // library directives.
            #if __IBMCPP__ >= 360
        		#pragma library(OPENCLASS_LIBRARY_NAME_2(base,ob))
            #else // do SWORD
            	#ifdef __IMPORTLIB__
        			#pragma library("cppobi36.lib")
    	        #else
    		    	#pragma library("cppobs36.lib")
            	#endif
            #endif
            #if !defined(__IMPORTLIB__)
                #pragma library("os2386.lib")
            #endif
      	#elif defined(_AIX)
      	    #if defined(__PRAGMA_LIBRARIES_VISIBLE__)
        		#pragma library(OPENCLASS_LIBRARY_NAME_2(base,ob))
                // If we are building static, AIX cmake needs to see these in order to
                // put library references in the makefile.
                #if !defined(__IMPORTLIB__)
                    #pragma library("libpthreads.a")
                    #pragma library("libC_r.a")
                    #pragma library("libC.a")
                    #pragma library("libc_r.a")
                    #pragma library("libc.a")
                    #pragma library("libXm.a")
                    #pragma library("libXt.a")
                    #pragma library("libX11.a")
                    #pragma library("libiconv.a")
                #endif //__IMPORTLIB__
            #endif // __PRAGMA_LIBRARIES_VISIBLE__
    	#endif // platform
    #else
        // This will be seen in the context of building the library only.
        #if defined(__WINDOWS__)
            #if defined(_MSC_VER)   // MSVC
                #pragma comment(lib, "kernel32.lib")
                #pragma comment(lib, "advapi32.lib")
            #else                   // VAC
                #pragma library("kernel32.lib")
                #pragma library("advapi32.lib")
            #endif
        #elif defined(__OS2__)
            #pragma library("os2386.lib")
        #elif defined(_AIX)
            #if defined(__PRAGMA_LIBRARIES_VISIBLE__)
                // AIX doesn't support pragma library statments, but
                // include system libraries needed so cmake can find them.
                #pragma library("libpthreads.a")
                #pragma library("libC_r.a")
                #pragma library("libC.a")
                #pragma library("libc_r.a")
                #pragma library("libc.a")
                #pragma library("libXm.a")
                #pragma library("libXt.a")
                #pragma library("libX11.a")
                #pragma library("libiconv.a")
            #endif // __PRAGMA_LIBRARIES_VISIBLE__
        #endif // _AIX
    #endif // __NO_BASE_LIB__
#endif  // __NO_DEFAULT_LIBS__

#endif // _IBASEPL_
