/* NOSHIP */

// ----------------------------------------------------------------------------
// FILE NAME: iintpair.hpp
//
// DESCRIPTION:
//   Declaration of the classes:
//     IInterestConnectionListPair
//
// COPYRIGHT:
//   IBM Open Class Library
//   (C) Copyright International Business Machines Corporation 1992, 1997
//   Licensed Material - Program-Property of IBM - All Rights Reserved.
//   US Government Users Restricted Rights - Use, duplication, or disclosure
//   restricted by GSA ADP Schedule Contract with IBM Corp.
//
// Revision: 15 1.8.1.3 source/core/base/iintpair.hpp, notification, ioc.v400, 000919  
// ----------------------------------------------------------------------------

#ifndef _IINTPAIR_
#define _IINTPAIR_

#include <iintrst.hpp>
#include <ikshsh2.h>

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

class IObserverList;
class IInterestConnectionListPair;

typedef IObserverList IConnectionList;
typedef IKeySetAsHshTable<IInterestConnectionListPair, IInterest> IInterestDictionary;

IInterest const& key(IInterestConnectionListPair const& anEntry);

#pragma pack(push,4)
#pragma enum(4)

class INotifierImplementation
{
public:
    INotifierImplementation( );
    ~INotifierImplementation( );

    IInterestDictionary& interestDict();

private:
    IInterestDictionary* fInterestDict;
};


class IInterestConnectionListPair
{
public:
    IInterestConnectionListPair();
    IInterestConnectionListPair(const IInterest& anInterest,
                                IConnectionList* adoptTheList);

    IInterestConnectionListPair(IInterestConnectionListPair const& rhs);

    virtual ~IInterestConnectionListPair();


    IInterestConnectionListPair& operator=(IInterestConnectionListPair const& rhs);

    bool operator==(IInterestConnectionListPair const& rhs) const;

    bool operator<(IInterestConnectionListPair const& rhs) const
    {
        return (fInterest < rhs.fInterest);
    }

    virtual IInterest const& getKey() const;

    virtual IConnectionList* getElement( );

private:
    IInterest fInterest;
    IConnectionList* fConnectionList;
};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#include <iintpair.inl>

#endif
