// Revision: 35 1.4.1.2 source/core/base/ingthrdv.inl, oss, ioc.v400, 000919  
/*NOSHIP*/
#ifndef _INGTHRDV_INL_
#define _INGTHRDV_INL_
/*******************************************************************************
* FILE NAME: ingthrdv.inl                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the inline functions for the          *
*   classes declared in ingthrdv.hpp                                           *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/

/*------------------------------------------------------------------------------
| ITLSHandle::ITLSHandle                                                       |
------------------------------------------------------------------------------*/
inline ITLSHandle::ITLSHandle( const ITLSHandle& tlsHandle ) :
   fhandle( tlsHandle.fhandle )
{ }

inline ITLSHandle::ITLSHandle( ITLSHandle::Value  value ) :
   fhandle( value )
{ }

/*------------------------------------------------------------------------------
| ITLSHandle::operator=                                                        |
------------------------------------------------------------------------------*/
inline ITLSHandle& ITLSHandle::operator=( const ITLSHandle& tlsHandle )
{
   this->fhandle = tlsHandle.fhandle;
   return *this;
}

/*------------------------------------------------------------------------------
| ITLSHandle::asUnsigned                                                       |
------------------------------------------------------------------------------*/
inline unsigned long ITLSHandle::asUnsigned ( ) const
{
  return (unsigned long) this->fhandle;
}

/*------------------------------------------------------------------------------
| ITLSHandle::operator Value()                                                 |
------------------------------------------------------------------------------*/
inline ITLSHandle::operator ITLSHandle::Value ( ) const
{
  return this->fhandle;
}

#endif //_INGTHRDV_INL_
