// Revision: 38 1.3.1.2 source/core/base/inotadr.cpp, notification, ioc.v400, 000919 
/*******************************************************************************
* FILE NAME: inotadr.cpp                                                       *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the implementation of classes/functions declared        *
*   in inotadr.hpp.                                                            *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <inotadr.hpp>

#ifdef IC_PAGETUNE
    #define _INOTADR_CPP_
    #include <ipagetun.h>
#endif

INotifierAddress::INotifierAddress():
  fNotifier(0)
{}

INotifierAddress::~INotifierAddress()
{}

INotifierAddress::INotifierAddress (const INotifier* theNotifier):
  fNotifier(theNotifier)
{
}

bool
INotifierAddress::operator==(const INotifierAddress& src ) const
{
  //For now, if notifier addresses are equal, then return true
  return (fNotifier == src.fNotifier);
}

INotifierAddress&
INotifierAddress::operator=(const INotifierAddress& src )
{
  fNotifier = src.fNotifier;
  return *this;
}

INotifier&
INotifierAddress::notifier ()
{
  //if (! fNotifier) // no notifier associated with this address!
  return (INotifier&) *fNotifier;
}

bool INotifierAddress::operator!=(const INotifierAddress& src ) const
{
	return( !this->operator==(src) );
}



