// Revision: 04 1.4.1.4 source/core/base/itmstamp.inl, appsupport, ioc.v400, 000919 
#ifndef _ITMSTAMP_INL_
#define _ITMSTAMP_INL_
// ----------------------------------------------------------------------------
// FILE NAME: itmstamp.inl
//
// DESCRIPTION:
//   This file contains the definition of the inline functions for the
//   classes declared in itmstamp.hpp.
//
// COPYRIGHT:
//   IBM Open Class Library
//   Licensed Materials - Property of IBM
//   (C) Copyright IBM Corporation 1992, 1997  All Rights Reserved.
//
// ----------------------------------------------------------------------------

inline ITimeStamp::ITimeStamp(double seconds )
  : fTime( seconds )
{
}

inline ITimeStamp::ITimeStamp(const ITimeStamp& aTimeStamp )
  : fTime( aTimeStamp.fTime )
{
}

inline double ITimeStamp::asSeconds() const
{
    return fTime;
}

inline bool ITimeStamp::operator==(const ITimeStamp& aTimeStamp)const
{
    return(fTime == aTimeStamp.fTime);
}

inline bool ITimeStamp::operator!=(const ITimeStamp& aTimeStamp)const
{
    return(fTime != aTimeStamp.fTime);
}

inline bool ITimeStamp::operator<(const ITimeStamp& aTimeStamp)const
{
    return(fTime <  aTimeStamp.fTime);
}

inline bool ITimeStamp::operator<=(const ITimeStamp& aTimeStamp)const
{
    return(fTime <= aTimeStamp.fTime);
}

inline bool ITimeStamp::operator>(const ITimeStamp& aTimeStamp)const
{
    return(fTime >  aTimeStamp.fTime);
}

inline bool ITimeStamp::operator >=(const ITimeStamp& aTimeStamp)const
{
    return(fTime >= aTimeStamp.fTime);
}

inline ITimeStamp ITimeStamp::operator+(double seconds)const
{
    return ITimeStamp(fTime + seconds);
}

inline ITimeStamp ITimeStamp::operator-(double seconds)const
{
    return ITimeStamp(fTime - seconds);
}

inline ITimeStamp &ITimeStamp::operator+=(double seconds )
{
    fTime += seconds;
    return *this;
}

inline ITimeStamp &ITimeStamp::operator-=(double seconds )
{
    fTime -= seconds;
    return *this;
}

inline double ITimeStamp::operator -(const ITimeStamp& aTimeStamp)const
{
    return(fTime - aTimeStamp.fTime);
}

inline void ITimeStamp::operator >>=(IDataStream& toWhere )
{
    writeToStream(toWhere);
}

inline void ITimeStamp::operator <<=(IDataStream& fromWhere )
{
    readFromStream(fromWhere);
}


inline ostream& operator<<(ostream& aStream, const ITimeStamp& aTimeStamp)
{
    return aStream << aTimeStamp.asString();
}

#endif // _ITMSTAMP_INL_
