/* NOSHIP */
#ifndef _IPAGETUN_
#define _IPAGETUN_
// Revision: 11 1.3.1.2 source/core/base/win32/ipagetun.h, appsupport, ioc.v400, 000919 
/*******************************************************************************
* FILE NAME: ipagetun.h                                                        *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Definition of Page Layout                                                  *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/

// This file includes the page tuning directives for the DLL currently
// being built.  Each of the implementation files includes this file
// with the following statements (example for foo.cpp):
// #ifdef IC_PAGETUNE
//   #define _FOO_CPP_
//   #include <ipagetun.h>
// #endif
//
// This file determines the correct tuning header to include based on
// compile time switches.  Thus, object files can be re-packaged by
// changing only the build control files and tuning directives themselves...
// not the statements in the implementation files like the ones shown above.
// The tuning header for each DLL is called ituning?.h, where ? is the
// one character identifier for the DLL.

// Special case: directives for the DLL init code, which is common for all
// DLLs but does not use any DLL id macros, are handled with the base DLL.
#if defined(__NO_BASE_LIB__) || defined(_DDE4DLL2_CPP_) || defined(_DDE4UDLL_CPP_)
   #include <ituningb.h>
#endif
#if defined(__NO_DDE_LIB__)
   #include <ituningd.h>
#endif
#if defined(__NO_GRAPH2D_LIB__)
   #include <ituningg.h>
#endif
#if defined(__NO_TESTFW_LIB__)
   #include <ituningk.h>
#endif
#if defined(__NO_MULTMED_LIB__)
   #include <ituningm.h>
#endif
#if defined(__NO_TEXTDISP_LIB__)
   #include <ituningt.h>
#endif
#if defined(__NO_UI_LIB__)
   #include <ituningu.h>
#endif
#if defined(__NO_GRAPH3D_LIB__)
   #include <ituningz.h>
#endif


#endif
