// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 17 1.4.1.3 source/core/collect/iadqu.h, collection, ioc.v400, 000919 
#ifndef _IADQU_
#define _IADQU_

#include <iarstrct.h>
#include <iaorder.h>
#include <iiaseq.h>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__) 
#if defined (__RRBC_IBM__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

template <class Element>
class IADeque :
  public IARestrictedAccessCollection <Element> {

  typedef  IARestrictedAccessCollection <Element> Inherited;

  typedef  IASequenceImpl Implementation;

public:

#if ! defined (__INO_AVALON__)
           IADeque
                            (INotifier&);

#endif
          ~IADeque
                            ();

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     addAsFirst       (Element const&);

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     addAsFirst       (Element const&, ICursor&);

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     addAsLast        (Element const&);

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     addAsLast        (Element const&, ICursor&);

  long     compare          (IADeque <Element> const&,
                             long (*comparisonFunction)
                              (Element const&, Element const&)) const;
 
#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     removeFirst      ();

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     removeLast       ();

protected:

           IADeque
                            ();

           IADeque
                            (IADeque <Element> const&);

private:

  static
  Implementation&
           ImplOf           (IADeque <Element> const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           addAsFirst       (Element const&),\
           addAsFirst       (Element const&, ICursor&),\
           addAsLast        (Element const&),\
           addAsLast        (Element const&, ICursor&),\
           compare          (IADeque <Element> const&,\
                             long (*)\
                              (Element const&, Element const&) const,\
           removeLast       (),\
           ImplOf           (IADeque <Element> const&)\
                        )
#endif

};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#include <iadqu.inl>

#if defined (__SOM_ENABLED__) 
#pragma SOMAsDefault (pop)
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IADQU_
