// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 18 1.4.1.2 source/core/collect/iadqu.inl, collection, ioc.v400, 000919  
#ifndef _IADQU_INL_
#define _IADQU_INL_

// ---
// IADeque
// ---

#include <ilanglvl.hpp>

#if ! defined (__INO_AVALON__)
template <class Element>
inline
IADeque <Element>::
IADeque (INotifier& notifier)
{ this->SetImpl ((Implementation*)&notifier);
}

#endif
template <class Element>
inline
IADeque <Element>::
~IADeque ()
{
}

template <class Element>
inline void
IADeque <Element>::
addAsFirst (Element const& element)
{ this->ImplOf (*this).AddAsFirst (&element);
}

template <class Element>
inline void
IADeque <Element>::
addAsFirst (Element const& element, ICursor& cursor)
{ this->ImplOf (*this).AddAsFirst (&element, this->CrsrImplOf (cursor));
}

template <class Element>
inline void
IADeque <Element>::
addAsLast (Element const& element)
{ this->ImplOf (*this).AddAsLast (&element);
}

template <class Element>
inline void
IADeque <Element>::
addAsLast (Element const& element, ICursor& cursor)
{ this->ImplOf (*this).AddAsLast (&element, this->CrsrImplOf (cursor));
}

template <class Element>
inline long
IADeque <Element>::
compare (IADeque <Element> const& collection,
         long (*compFunc) (Element const&, Element const&)) const
{ return this->ImplOf (*this).
    Compare (this->ImplOf (collection), (ICompFunc)compFunc, 0);
}

template <class Element>
inline void
IADeque <Element>::
removeFirst ()
{ this->ImplOf (*this).RemoveFirst ();
}

template <class Element>
inline void
IADeque <Element>::
removeLast ()
{ this->ImplOf (*this).RemoveLast ();
}

// protected members

template <class Element>
inline
IADeque <Element>::
IADeque ()
{
}

template <class Element>
inline
IADeque <Element>::
IADeque (IADeque <Element> const& collection)
: Inherited (collection)
{
}

// private members

template <class Element>
inline TYPENAME IADeque <Element>::Implementation&
IADeque <Element>::
ImplOf (IADeque <Element> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

#endif // _IADQU_INL_
