// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 24 1.4.1.3 source/core/collect/iaeqsrt.h, collection, ioc.v400, 000919 
#ifndef _IAEQSRT_
#define _IAEQSRT_

#include <iaequal.h>
#include <iasrt.h>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__) 
#if defined (__RRBC_IBM__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

template <class Element>
class IAEqualitySortedCollection :
  public IAEqualityCollection <Element>,
  public IASortedCollection <Element>
{
  typedef  IACollectionImpl Implementation;

public:

#if ! defined (__INO_AVALON__)
           IAEqualitySortedCollection
                            (INotifier&);

#endif
          ~IAEqualitySortedCollection
                            ();

protected:

           IAEqualitySortedCollection
                            ();

           IAEqualitySortedCollection
                            (IAEqualitySortedCollection
                              <Element> const&);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
                        )
#endif

};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#if defined (__SOM_ENABLED__) 
#pragma SOMAsDefault (pop)
#endif

#include <iaeqsrt.inl>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IAEQSRT_
