// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 28 1.5.1.3 source/core/collect/iaes.h, collection, ioc.v400, 000919 
#ifndef _IAES_
#define _IAES_

#include <iasqntl.h>
#include <iaequal.h>
#include <iiaes.h>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__) 
#if defined (__RRBC_IBM__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

template <class Element>
class IAEqualitySequence :
  public IAEqualityCollection <Element>,
  public IASequentialCollection <Element> {

  typedef  IASequentialCollection <Element> Inherited;

  typedef  IAEqualitySequenceImpl Implementation;

public:

#if ! defined (__INO_AVALON__)
           IAEqualitySequence
                            (INotifier&);

#endif
          ~IAEqualitySequence
                            ();

  long     compare          (IAEqualitySequence <Element> const&,
                             long (*comparisonFunction)
                              (Element const&, Element const&)) const;
 
  bool     locateFirst      (Element const&, ICursor&) const;

  bool     locateLast       (Element const&, ICursor&) const;

  bool     locatePrevious   (Element const&, ICursor&) const;

  bool     operator==       (IAEqualitySequence
                              <Element> const&) const;

  bool     operator!=       (IAEqualitySequence
                              <Element> const&) const;

protected:

           IAEqualitySequence
                            ();

           IAEqualitySequence
                            (IAEqualitySequence <Element> const&);

private:

  static
  Implementation&
           ImplOf           (IAEqualitySequence <Element> const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           compare          (IAEqualitySequence <Element> const&,\
                             long (*)\
                              (Element const&, Element const&) const,\
           locateFirst      (Element const&, ICursor&) const,\
           locateLast       (Element const&, ICursor&) const,\
           locatePrevious   (Element const&, ICursor&) const,\
           operator==       (IAEqualitySequence\
                              <Element> const&) const,\
           operator!=       (IAEqualitySequence\
                              <Element> const&) const,\
           ImplOf           (IAEqualitySequence <Element> const&)\
                        )
#endif

};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#include <iaes.inl>

#if defined (__SOM_ENABLED__) 
#pragma SOMAsDefault (pop)
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IAES_
