// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 36 1.3.1.2 source/core/collect/iakey.inl, collection, ioc.v400, 000919 
#ifndef _IAKEY_INL_
#define _IAKEY_INL_

// ---------------
// IAKeyCollection
// ---------------

#include <ilanglvl.hpp>

// public members

#if ! defined (__INO_AVALON__)
template <class Element, class Key>
inline
IAKeyCollection <Element, Key>::
IAKeyCollection (INotifier& notifier)
{ this->SetImpl ((Implementation*)&notifier);
}

#endif
template <class Element, class Key>
inline
IAKeyCollection <Element, Key>::
~IAKeyCollection ()
{
}

template <class Element, class Key>
inline bool
IAKeyCollection <Element, Key>::
addOrReplaceElementWithKey (Element const& element)
{ return ImplOf (*this).AddOrReplaceElementWithKey (&element);
}

template <class Element, class Key>
inline bool
IAKeyCollection <Element, Key>::
addOrReplaceElementWithKey
  (Element const& element, ICursor& cursor)
{ return ImplOf (*this).
    AddOrReplaceElementWithKey (&element, this->CrsrImplOf (cursor));
}

template <class Element, class Key>
inline bool
IAKeyCollection <Element, Key>::
containsAllKeysFrom (IACollection <Element> const& collection) const
{ return ImplOf (*this).
    ContainsAllKeysFrom (IACollection <Element>::ImplOf (collection));
}

template <class Element, class Key>
inline bool
IAKeyCollection <Element, Key>::
containsElementWithKey (Key const& key) const
{ return ImplOf (*this).ContainsElementWithKey (&key);
}

template <class Element, class Key>
inline Element&
IAKeyCollection <Element, Key>::
elementWithKey (Key const& key)
{ return *(Element*) ImplOf (*this).ElementWithKey (&key);
}

template <class Element, class Key>
inline Element const&
IAKeyCollection <Element, Key>::
elementWithKey (Key const& key) const
{ return *(Element*) ImplOf (*this).ElementWithKey (&key);
}

template <class Element, class Key>
inline Key const&
IAKeyCollection <Element, Key>::
key (Element const& element) const
{ return *(Key*) ImplOf (*this).Key (&element);
}

template <class Element, class Key>
inline bool
IAKeyCollection <Element, Key>::
locateElementWithKey (Key const& key, ICursor& cursor) const
{ return ImplOf (*this).
    LocateElementWithKey (&key, this->CrsrImplOf (cursor));
}

template <class Element, class Key>
inline bool
IAKeyCollection <Element, Key>::
locateNextElementWithKey (Key const& key, ICursor& cursor) const
{ return ImplOf (*this).
    LocateNextElementWithKey (&key, this->CrsrImplOf (cursor));
}

template <class Element, class Key>
inline bool
IAKeyCollection <Element, Key>::
locateOrAddElementWithKey (Element const& element)
{ return ImplOf (*this).LocateOrAddElementWithKey (&element); 
}

template <class Element, class Key>
inline bool
IAKeyCollection <Element, Key>::
locateOrAddElementWithKey (Element const& element, ICursor& cursor)
{ return ImplOf (*this).
    LocateOrAddElementWithKey (&element, this->CrsrImplOf (cursor));
}

template <class Element, class Key>
inline INumber
IAKeyCollection <Element, Key>::
numberOfDifferentKeys () const
{ return ImplOf (*this).NumberOfDifferentKeys ();
}

template <class Element, class Key>
inline INumber
IAKeyCollection <Element, Key>::
numberOfElementsWithKey (Key const& key) const   
{ return ImplOf (*this).NumberOfElementsWithKey (&key);
}

template <class Element, class Key>
inline bool
IAKeyCollection <Element, Key>::
removeElementWithKey (Key const& key)
{ return ImplOf (*this).RemoveElementWithKey (&key);
}

template <class Element, class Key>
inline INumber
IAKeyCollection <Element, Key>::
removeAllElementsWithKey (Key const& key)
{ return ImplOf (*this).RemoveAllElementsWithKey (&key);
}

template <class Element, class Key>
inline bool
IAKeyCollection <Element, Key>::
replaceElementWithKey (Element const& element)
{ return ImplOf (*this).ReplaceElementWithKey (&element);
}

template <class Element, class Key>
inline bool
IAKeyCollection <Element, Key>::
replaceElementWithKey (Element const& element, ICursor& cursor)
{ return ImplOf (*this).
    ReplaceElementWithKey (&element, this->CrsrImplOf (cursor));
}

template <class Element, class Key>
inline bool
IAKeyCollection <Element, Key>::
setToNextWithDifferentKey (ICursor& cursor) const
{ return ImplOf (*this).
    SetToNextWithDifferentKey (this->CrsrImplOf (cursor));
}

// protected members

template <class Element, class Key>
inline
IAKeyCollection <Element, Key>::
IAKeyCollection ()
{
}

template <class Element, class Key>
inline
IAKeyCollection <Element, Key>::
IAKeyCollection (IAKeyCollection <Element, Key> const&)
{
}

// private members

template <class Element, class Key>
inline TYPENAME IAKeyCollection <Element, Key>::Implementation&
IAKeyCollection <Element, Key>::
ImplOf (IAKeyCollection <Element, Key> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

#endif // _IAKEY_INL_
