// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 42 1.4.1.2 source/core/collect/iaksb.inl, collection, ioc.v400, 000919  
#ifndef _IAKSB_INL_
#define _IAKSB_INL_

// ---
// IAKeySortedBag
// ---

#include <ilanglvl.hpp>

#if ! defined (__INO_AVALON__)
template <class Element, class Key>
inline
IAKeySortedBag <Element, Key>::
IAKeySortedBag (INotifier& notifier)
{ this->SetImpl ((Implementation*)&notifier);
}

#endif
template <class Element, class Key>
inline
IAKeySortedBag <Element, Key>::
~IAKeySortedBag ()
{
}

template <class Element, class Key>
inline long
IAKeySortedBag <Element, Key>::
compare (IAKeySortedBag <Element, Key> const& collection,
         long (*compFunc) (Element const&, Element const&)) const
{ return this->ImplOf (*this).
    Compare (this->ImplOf (collection), (ICompFunc)compFunc, 0);
}

// protected members

template <class Element, class Key>
inline
IAKeySortedBag <Element, Key>::
IAKeySortedBag ()
{
}

template <class Element, class Key>
inline
IAKeySortedBag <Element, Key>::
IAKeySortedBag (IAKeySortedBag <Element, Key> const& collection)
: Inherited (collection)
{
}

// private members

template <class Element, class Key>
inline TYPENAME IAKeySortedBag <Element, Key>::Implementation&
IAKeySortedBag <Element, Key>::
ImplOf (IAKeySortedBag <Element, Key> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

#endif // _IAKSB_INL_
