// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 44 1.4.1.3 source/core/collect/iaksrt.h, collection, ioc.v400, 000919 
#ifndef _IAKSRT_
#define _IAKSRT_

#include <iakey.h>
#include <iasrt.h>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__) 
#if defined (__RRBC_IBM__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

template <class Element, class Key>
class IAKeySortedCollection :
  public IAKeyCollection <Element, Key>,
  public IASortedCollection <Element>
{
  typedef  IACollectionImpl Implementation;

public:

#if ! defined (__INO_AVALON__)
           IAKeySortedCollection
                            (INotifier&);

#endif
          ~IAKeySortedCollection
                            ();

protected:

           IAKeySortedCollection
                            ();

           IAKeySortedCollection
                            (IAKeySortedCollection
                              <Element, Key> const&);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
                        )
#endif

};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#if defined (__SOM_ENABLED__) 
#pragma SOMAsDefault (pop)
#endif

#include <iaksrt.inl>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IAKSRT_
