// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 50 1.4.1.2 source/core/collect/iamap.inl, collection, ioc.v400, 000919  
#ifndef _IAMAP_INL_
#define _IAMAP_INL_

// ---
// IAMap
// ---

#include <ilanglvl.hpp>

#if ! defined (__INO_AVALON__)
template <class Element, class Key>
inline
IAMap <Element, Key>::
IAMap (INotifier& notifier)
{ this->SetImpl ((Implementation*)&notifier);
}

#endif
template <class Element, class Key>
inline
IAMap <Element, Key>::
~IAMap ()
{
}

template <class Element, class Key>
inline void
IAMap <Element, Key>::
addDifference (IAMap <Element, Key> const& collection1,
               IAMap <Element, Key> const& collection2)
{ this->ImplOf (*this).
    AddDifference (this->ImplOf (collection1), this->ImplOf (collection2));
}

template <class Element, class Key>
inline void
IAMap <Element, Key>::
addIntersection (IAMap <Element, Key> const& collection1,
                 IAMap <Element, Key> const& collection2)
{ this->ImplOf (*this).
    AddIntersection (this->ImplOf (collection1), this->ImplOf (collection2));
}

template <class Element, class Key>
inline void
IAMap <Element, Key>::
addUnion (IAMap <Element, Key> const& collection1,
          IAMap <Element, Key> const& collection2)
{ this->ImplOf (*this).
    AddUnion (this->ImplOf (collection1), this->ImplOf (collection2));
}

template <class Element, class Key>
inline void
IAMap <Element, Key>::
differenceWith (IAMap <Element, Key> const& collection)
{ this->ImplOf (*this).Difference (this->ImplOf (collection));
}

template <class Element, class Key>
inline void
IAMap <Element, Key>::
intersectionWith (IAMap <Element, Key> const& collection)
{ this->ImplOf (*this).Intersection (this->ImplOf (collection));
}

template <class Element, class Key>
inline void
IAMap <Element, Key>::
unionWith (IAMap <Element, Key> const& collection)
{ this->ImplOf (*this).Union (this->ImplOf (collection));
}

template <class Element, class Key>
inline bool
IAMap <Element, Key>::
operator== (IAMap <Element, Key> const& collection) const
{ return this->ImplOf (*this).operator== (this->ImplOf (collection));
}

template <class Element, class Key>
inline bool
IAMap <Element, Key>::
operator!= (IAMap <Element, Key> const& collection) const
{ return this->ImplOf (*this).operator!= (this->ImplOf (collection));
}

// protected members

template <class Element, class Key>
inline
IAMap <Element, Key>::
IAMap ()
{
}

template <class Element, class Key>
inline
IAMap <Element, Key>::
IAMap (IAMap <Element, Key> const& collection)
: Inherited (collection)
{
}

template <class Element, class Key>
inline bool
IAMap <Element, Key>::
locateNext (Element const& element, ICursor& cursor) const
{ return IAEqualityCollection <Element>::locateNext (element, cursor);
}

template <class Element, class Key>
inline bool
IAMap <Element, Key>::
locateNextElementWithKey (Key const& key, ICursor& cursor) const
{ return IAKeyCollection <Element, Key>::
    locateNextElementWithKey (key, cursor);
}

template <class Element, class Key>
inline INumber
IAMap <Element, Key>::
numberOfDifferentKeys () const
{ return IAKeyCollection <Element, Key>::numberOfDifferentKeys ();
}

template <class Element, class Key>
inline INumber
IAMap <Element, Key>::
numberOfElementsWithKey (Key const& key) const
{ return IAKeyCollection <Element, Key>::numberOfElementsWithKey (key);
}

template <class Element, class Key>
inline INumber
IAMap <Element, Key>::
numberOfOccurrences (Element const& element) const
{ return IAEqualityCollection <Element>::numberOfOccurrences (element);
}

template <class Element, class Key>
inline INumber
IAMap <Element, Key>::
removeAllOccurrences (Element const& element)
{ return IAEqualityCollection <Element>::removeAllOccurrences (element);
}

template <class Element, class Key>
inline INumber
IAMap <Element, Key>::
removeAllElementsWithKey (Key const& key)
{ return IAKeyCollection <Element, Key>::removeAllElementsWithKey (key);
}

template <class Element, class Key>
inline bool
IAMap <Element, Key>::
setToNextWithDifferentKey (ICursor& cursor) const
{ return
    IAKeyCollection <Element, Key>::setToNextWithDifferentKey (cursor);
}

// private members

template <class Element, class Key>
inline TYPENAME IAMap <Element, Key>::Implementation&
IAMap <Element, Key>::
ImplOf (IAMap <Element, Key> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

#endif // _IAMAP_INL_
