// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 51 1.4.1.3 source/core/collect/iamwt.h, collection, ioc.v400, 000919 
#ifndef _IAMWT_
#define _IAMWT_

#include <iatree.h>
#include <iimwt.h>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__) 
#if defined (__RRBC_IBM__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

template <INumber numOfChildren, class Element>
class IAMultiwayTree : public IATree <Element> 
{
  typedef  IMultiwayTreeImpl Implementation;

public:

  void     attachAsChild    (ITreeCursor const&, IPosition,
                             IAMultiwayTree
                              <numOfChildren, Element> const&);

  void     attachAsRoot     (IAMultiwayTree
                              <numOfChildren, Element> const&);

  void     attachSubtreeAsChild
                            (ITreeCursor const&, IPosition,
                             IAMultiwayTree
                              <numOfChildren, Element> const&,
                             ITreeCursor const&);

  void     attachSubtreeAsRoot
                            (IAMultiwayTree
                              <numOfChildren, Element> const&,
                             ITreeCursor const&);

  void     copy             (IAMultiwayTree
                              <numOfChildren, Element> const&);

  void     copySubtree      (IAMultiwayTree
                              <numOfChildren, Element> const&,
                             ITreeCursor const&);

  bool hasChild         (IPosition, ITreeCursor const&) const;

  INumber  numberOfChildren () const;

protected:

           IAMultiwayTree   ();

           IAMultiwayTree   (IAMultiwayTree
                              <numOfChildren, Element> const&);

private:

  static
  Implementation&
           ImplOf           (IAMultiwayTree
                              <numOfChildren, Element> const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           attachAsChild    (ITreeCursor const&, IPosition,\
                             Element const&),\
           hasChild         (IPosition, ITreeCursor const&),\
           numberOfChildren () const,\
           ImplOf           (IAMultiwayTree\
                              <numOfChildren, Element> const&)\
                        )
#endif

};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#if defined (__SOM_ENABLED__) 
#pragma SOMAsDefault (pop)
#endif

#include <iamwt.inl>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IAMWT_
