// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 52 1.3.1.2 source/core/collect/iamwt.inl, collection, ioc.v400, 000919 
#ifndef _IAMWT_INL_
#define _IAMWT_INL_

// --------------
// IAMultiwayTree
// --------------

#include <ilanglvl.hpp>

template <INumber numOfChildren, class Element>
inline void
IAMultiwayTree <numOfChildren, Element>::
attachAsChild (ITreeCursor const& cursor, IPosition position,
               IAMultiwayTree <numOfChildren, Element> const& tree)
{ ImplOf (*this).
    AttachAsChild (this->CrsrImplOf (cursor), position, ImplOf (tree));
}

template <INumber numOfChildren, class Element>
inline void
IAMultiwayTree <numOfChildren, Element>::
attachAsRoot (IAMultiwayTree <numOfChildren, Element> const& tree)
{ ImplOf (*this).AttachAsRoot (ImplOf (tree));
}

template <INumber numOfChildren, class Element>
inline void
IAMultiwayTree <numOfChildren, Element>::
attachSubtreeAsChild
  (ITreeCursor const& cursor, IPosition position,
   IAMultiwayTree <numOfChildren, Element> const& tree,
   ITreeCursor const& thatCursor)
{ ImplOf (*this).
    AttachSubtreeAsChild (this->CrsrImplOf (cursor), position,
                          ImplOf (tree), this->CrsrImplOf (thatCursor));
}

template <INumber numOfChildren, class Element>
inline void
IAMultiwayTree <numOfChildren, Element>::
attachSubtreeAsRoot
  (IAMultiwayTree <numOfChildren, Element> const& tree,
   ITreeCursor const& thatCursor)
{ ImplOf (*this).
    AttachSubtreeAsRoot (ImplOf (tree), this->CrsrImplOf (thatCursor));
}

template <INumber numOfChildren, class Element>
inline void
IAMultiwayTree <numOfChildren, Element>::
copy (IAMultiwayTree <numOfChildren, Element> const& tree)
{ ImplOf (*this).Copy (ImplOf (tree));
}

template <INumber numOfChildren, class Element>
inline void
IAMultiwayTree <numOfChildren, Element>::
copySubtree (IAMultiwayTree <numOfChildren, Element> const& tree,
             ITreeCursor const& thatCursor)
{ ImplOf (*this).CopySubtree (ImplOf (tree), this->CrsrImplOf (thatCursor));
}

template <INumber numOfChildren, class Element>
inline bool
IAMultiwayTree <numOfChildren, Element>::
hasChild (IPosition position, ITreeCursor const& cursor) const
{ return ImplOf (*this).HasChild (position, this->CrsrImplOf (cursor));
}

template <INumber numOfChildren, class Element>
inline INumber
IAMultiwayTree <numOfChildren, Element>::
numberOfChildren () const
{ return ImplOf (*this).NumberOfChildren ();
}

// protected members

template <INumber numOfChildren, class Element>
inline
IAMultiwayTree <numOfChildren, Element>::
IAMultiwayTree ()
: IATree <Element> ()
{
}

template <INumber numOfChildren, class Element>
inline
IAMultiwayTree <numOfChildren, Element>::
IAMultiwayTree (IAMultiwayTree <numOfChildren, Element> const& tree)
: IATree <Element> (tree)
{
}

// private members

template <INumber numOfChildren, class Element>
inline TYPENAME IAMultiwayTree <numOfChildren, Element>::Implementation&
IAMultiwayTree <numOfChildren, Element>::
ImplOf (IAMultiwayTree <numOfChildren, Element> const& tree)
{ return *(Implementation*)tree.ivImpl;
}

#endif // _IAMWT_INL_
