// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 60 1.4.1.2 source/core/collect/iaqu.inl, collection, ioc.v400, 000919  
#ifndef _IAQU_INL_
#define _IAQU_INL_

// ---
// IAQueue
// ---

#include <ilanglvl.hpp>

#if ! defined (__INO_AVALON__)
template <class Element>
inline
IAQueue <Element>::
IAQueue (INotifier& notifier)
{ this->SetImpl ((Implementation*)&notifier);
}

#endif
template <class Element>
inline
IAQueue <Element>::
~IAQueue ()
{
}

template <class Element>
inline void
IAQueue <Element>::
addAsLast (Element const& element)
{ this->ImplOf (*this).AddAsLast (&element);
}

template <class Element>
inline void
IAQueue <Element>::
addAsLast (Element const& element, ICursor& cursor)
{ this->ImplOf (*this).AddAsLast (&element, this->CrsrImplOf (cursor));
}

template <class Element>
inline long
IAQueue <Element>::
compare (IAQueue <Element> const& collection,
         long (*compFunc) (Element const&, Element const&)) const
{ return this->ImplOf (*this).
    Compare (this->ImplOf (collection), (ICompFunc)compFunc, 0);
}

template <class Element>
inline void
IAQueue <Element>::
dequeue ()
{ this->ImplOf (*this).RemoveFirst ();
}

template <class Element>
inline void
IAQueue <Element>::
dequeue (Element& element)
{ element = *(Element*) this->ImplOf (*this).First ();
  this->ImplOf (*this).RemoveFirst ();
}

template <class Element>
inline void
IAQueue <Element>::
enqueue (Element const& element)
{ this->ImplOf (*this).Add (&element);
}

template <class Element>
inline void
IAQueue <Element>::
enqueue (Element const& element, ICursor& cursor)
{ this->ImplOf (*this).Add (&element, this->CrsrImplOf (cursor));
}

template <class Element>
inline void
IAQueue <Element>::
removeFirst ()
{ this->ImplOf (*this).RemoveFirst ();
}

// protected members

template <class Element>
inline
IAQueue <Element>::
IAQueue ()
{
}

template <class Element>
inline
IAQueue <Element>::
IAQueue (IAQueue <Element> const& collection)
: Inherited (collection)
{
}

// private members

template <class Element>
inline TYPENAME IAQueue <Element>::Implementation&
IAQueue <Element>::
ImplOf (IAQueue <Element> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

#endif // _IAQU_INL_
