// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 62 1.5.1.3 source/core/collect/iarel.h, collection, ioc.v400, 000919 
#ifndef _IAREL_
#define _IAREL_

#include <iaeqkey.h>
#include <iiarel.h>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__) 
#if defined (__RRBC_IBM__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

template <class Element, class Key>
class IARelation :
  public IAEqualityKeyCollection <Element, Key> {

  typedef  IAEqualityKeyCollection <Element, Key> Inherited;

  typedef  IARelationImpl Implementation;

public:

#if ! defined (__INO_AVALON__)
           IARelation
                            (INotifier&);

#endif
          ~IARelation
                            ();

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     addDifference    (IARelation <Element, Key> const&,
                             IARelation <Element, Key> const&); 

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     addIntersection  (IARelation <Element, Key> const&,
                             IARelation <Element, Key> const&);

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     addUnion         (IARelation <Element, Key> const&,
                             IARelation <Element, Key> const&);

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     differenceWith   (IARelation <Element, Key> const&);

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     intersectionWith (IARelation <Element, Key> const&);

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     unionWith        (IARelation <Element, Key> const&);

  bool     operator==       (IARelation
                              <Element, Key> const&) const;

  bool     operator!=       (IARelation
                              <Element, Key> const&) const;

protected:

           IARelation
                            ();

           IARelation
                            (IARelation <Element, Key> const&);

  bool     locateNext       (Element const&, ICursor&) const;

  INumber  numberOfOccurrences
                            (Element const&) const;

  INumber  removeAllOccurrences
                            (Element const&);

private:

  static
  Implementation&
           ImplOf           (IARelation <Element, Key> const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           addDifference    (IARelation <Element, Key> const,\
                             IARelation <Element, Key> const&),\
           addIntersection  (IARelation <Element, Key> const&,\
                             IARelation <Element, Key> const&),\
           addUnion         (IARelation <Element, Key> const&,
                             IARelation <Element, Key> const&),\
           differenceWith   (IARelation <Element, Key> const&),\
           intersectionWith (IARelation <Element, Key> const&),\
           unionWith        (IARelation <Element, Key> const&),\
           operator==       (IARelation\
                              <Element, Key> const&) const,\
           operator!=       (IARelation\
                              <Element, Key> const&) const,\
           ImplOf           (IARelation <Element, Key> const&)\
                        )
#endif

};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#include <iarel.inl>

#if defined (__SOM_ENABLED__) 
#pragma SOMAsDefault (pop)
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IAREL_
