// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 69 1.4.1.3 source/core/collect/iaseq.h, collection, ioc.v400, 000919 
#ifndef _IASEQ_
#define _IASEQ_

#include <iasqntl.h>
#include <iiaseq.h>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__) 
#if defined (__RRBC_IBM__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

template <class Element>
class IASequence :
  public IASequentialCollection <Element> {

  typedef  IASequentialCollection <Element> Inherited;

  typedef  IASequenceImpl Implementation;

public:

#if ! defined (__INO_AVALON__)
           IASequence
                            (INotifier&);

#endif
          ~IASequence
                            ();

  long     compare          (IASequence <Element> const&,
                             long (*comparisonFunction)
                              (Element const&, Element const&)) const;
 
protected:

           IASequence
                            ();

           IASequence
                            (IASequence <Element> const&);

private:

  static
  Implementation&
           ImplOf           (IASequence <Element> const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           compare          (IASequence <Element> const&,\
                             long (*)\
                              (Element const&, Element const&) const,\
           ImplOf           (IASequence <Element> const&)\
                        )
#endif

};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#include <iaseq.inl>

#if defined (__SOM_ENABLED__) 
#pragma SOMAsDefault (pop)
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IASEQ_
