// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 71 1.5.1.3 source/core/collect/iaset.h, collection, ioc.v400, 000919 
#ifndef _IASET_
#define _IASET_

#include <iaequal.h>
#include <iiaset.h>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__) 
#if defined (__RRBC_IBM__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

template <class Element>
class IASet :
  public IAEqualityCollection <Element> {

  typedef  IAEqualityCollection <Element> Inherited;

  typedef  IASetImpl Implementation;

public:

#if ! defined (__INO_AVALON__)
           IASet
                            (INotifier&);

#endif
          ~IASet
                            ();

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     addDifference    (IASet <Element> const&,
                             IASet <Element> const&); 

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     addIntersection  (IASet <Element> const&,
                             IASet <Element> const&);

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     addUnion         (IASet <Element> const&,
                             IASet <Element> const&);

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     differenceWith   (IASet <Element> const&);

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     intersectionWith (IASet <Element> const&);

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     unionWith        (IASet <Element> const&);

  bool     operator==       (IASet
                              <Element> const&) const;

  bool     operator!=       (IASet
                              <Element> const&) const;

protected:

           IASet
                            ();

           IASet
                            (IASet <Element> const&);

  bool     locateNext       (Element const&, ICursor&) const;

  INumber  numberOfOccurrences
                            (Element const&) const;

  INumber  removeAllOccurrences
                            (Element const&);

private:

  static
  Implementation&
           ImplOf           (IASet <Element> const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           addDifference    (IASet <Element> const,\
                             IASet <Element> const&),\
           addIntersection  (IASet <Element> const&,\
                             IASet <Element> const&),\
           addUnion         (IASet <Element> const&,
                             IASet <Element> const&),\
           differenceWith   (IASet <Element> const&),\
           intersectionWith (IASet <Element> const&),\
           unionWith        (IASet <Element> const&),\
           operator==       (IASet\
                              <Element> const&) const,\
           operator!=       (IASet\
                              <Element> const&) const,\
           ImplOf           (IASet <Element> const&)\
                        )
#endif

};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#include <iaset.inl>

#if defined (__SOM_ENABLED__) 
#pragma SOMAsDefault (pop)
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IASET_
