// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 74 1.4.1.2 source/core/collect/iasm.inl, collection, ioc.v400, 000919  
#ifndef _IASM_INL_
#define _IASM_INL_

// ---
// IASortedMap
// ---

#include <ilanglvl.hpp>

#if ! defined (__INO_AVALON__)
template <class Element, class Key>
inline
IASortedMap <Element, Key>::
IASortedMap (INotifier& notifier)
{ this->SetImpl ((Implementation*)&notifier);
}

#endif
template <class Element, class Key>
inline
IASortedMap <Element, Key>::
~IASortedMap ()
{
}

template <class Element, class Key>
inline void
IASortedMap <Element, Key>::
addDifference (IASortedMap <Element, Key> const& collection1,
               IASortedMap <Element, Key> const& collection2)
{ this->ImplOf (*this).
    AddDifference (this->ImplOf (collection1), this->ImplOf (collection2));
}

template <class Element, class Key>
inline void
IASortedMap <Element, Key>::
addIntersection (IASortedMap <Element, Key> const& collection1,
                 IASortedMap <Element, Key> const& collection2)
{ this->ImplOf (*this).
    AddIntersection (this->ImplOf (collection1), this->ImplOf (collection2));
}

template <class Element, class Key>
inline void
IASortedMap <Element, Key>::
addUnion (IASortedMap <Element, Key> const& collection1,
          IASortedMap <Element, Key> const& collection2)
{ this->ImplOf (*this).
    AddUnion (this->ImplOf (collection1), this->ImplOf (collection2));
}

template <class Element, class Key>
inline long
IASortedMap <Element, Key>::
compare (IASortedMap <Element, Key> const& collection,
         long (*compFunc) (Element const&, Element const&)) const
{ return this->ImplOf (*this).
    Compare (this->ImplOf (collection), (ICompFunc)compFunc, 0);
}

template <class Element, class Key>
inline void
IASortedMap <Element, Key>::
differenceWith (IASortedMap <Element, Key> const& collection)
{ this->ImplOf (*this).Difference (this->ImplOf (collection));
}

template <class Element, class Key>
inline void
IASortedMap <Element, Key>::
intersectionWith (IASortedMap <Element, Key> const& collection)
{ this->ImplOf (*this).Intersection (this->ImplOf (collection));
}

template <class Element, class Key>
inline void
IASortedMap <Element, Key>::
unionWith (IASortedMap <Element, Key> const& collection)
{ this->ImplOf (*this).Union (this->ImplOf (collection));
}

template <class Element, class Key>
inline bool
IASortedMap <Element, Key>::
operator== (IASortedMap <Element, Key> const& collection) const
{ return this->ImplOf (*this).operator== (this->ImplOf (collection));
}

template <class Element, class Key>
inline bool
IASortedMap <Element, Key>::
operator!= (IASortedMap <Element, Key> const& collection) const
{ return this->ImplOf (*this).operator!= (this->ImplOf (collection));
}

// protected members

template <class Element, class Key>
inline
IASortedMap <Element, Key>::
IASortedMap ()
{
}

template <class Element, class Key>
inline
IASortedMap <Element, Key>::
IASortedMap (IASortedMap <Element, Key> const& collection)
: Inherited (collection)
{
}

template <class Element, class Key>
inline INumber
IASortedMap <Element, Key>::
numberOfDifferentKeys () const
{ return IAKeyCollection <Element, Key>::numberOfDifferentKeys ();
}

template <class Element, class Key>
inline INumber
IASortedMap <Element, Key>::
numberOfElementsWithKey (Key const& key) const
{ return IAKeyCollection <Element, Key>::numberOfElementsWithKey (key);
}

template <class Element, class Key>
inline INumber
IASortedMap <Element, Key>::
numberOfOccurrences (Element const& element) const
{ return IAEqualityCollection <Element>::numberOfOccurrences (element);
}

template <class Element, class Key>
inline INumber
IASortedMap <Element, Key>::
removeAllOccurrences (Element const& element)
{ return IAEqualityCollection <Element>::removeAllOccurrences (element);
}

template <class Element, class Key>
inline INumber
IASortedMap <Element, Key>::
removeAllElementsWithKey (Key const& key)
{ return IAKeyCollection <Element, Key>::removeAllElementsWithKey (key);
}

template <class Element, class Key>
inline bool
IASortedMap <Element, Key>::
setToNextWithDifferentKey (ICursor& cursor) const
{ return
    IAKeyCollection <Element, Key>::setToNextWithDifferentKey (cursor);
}

// private members

template <class Element, class Key>
inline TYPENAME IASortedMap <Element, Key>::Implementation&
IASortedMap <Element, Key>::
ImplOf (IASortedMap <Element, Key> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

#endif // _IASM_INL_
