// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 76 1.3.1.2 source/core/collect/iasqntl.inl, collection, ioc.v400, 000919 
#ifndef _IASQNTL_INL_
#define _IASQNTL_INL_

// ----------------------
// IASequentialCollection
// ----------------------

#include <ilanglvl.hpp>

// public members

#if ! defined (__INO_AVALON__)
template <class Element>
inline
IASequentialCollection <Element>::
IASequentialCollection (INotifier& notifier)
{ this->SetImpl ((Implementation*)&notifier);
}

#endif
template <class Element>
inline
IASequentialCollection <Element>::
~IASequentialCollection ()
{
}

template <class Element>
inline void
IASequentialCollection <Element>::
addAsFirst (Element const& element)
{ ImplOf (*this).AddAsFirst (&element);
}

template <class Element>
inline void
IASequentialCollection <Element>::
addAsFirst (Element const& element, ICursor& cursor)
{ ImplOf (*this).AddAsFirst (&element, this->CrsrImplOf (cursor));
}

template <class Element>
inline void
IASequentialCollection <Element>::
addAsLast (Element const& element)
{ ImplOf (*this).AddAsLast (&element);
}

template <class Element>
inline void
IASequentialCollection <Element>::
addAsLast (Element const& element, ICursor& cursor)
{ ImplOf (*this).AddAsLast (&element, this->CrsrImplOf (cursor));
}

template <class Element>
inline void
IASequentialCollection <Element>::
addAsNext (Element const& element, ICursor& cursor)
{ ImplOf (*this).AddAsNext (&element, this->CrsrImplOf (cursor));
}

template <class Element>
inline void
IASequentialCollection <Element>::
addAsPrevious (Element const& element, ICursor& cursor)
{ ImplOf (*this).AddAsPrevious (&element, this->CrsrImplOf (cursor));
}

template <class Element>
inline void
IASequentialCollection <Element>::
addAtPosition (IPosition position, Element const& element)
{ ImplOf (*this).AddAtPosition (position, &element);
}

template <class Element>
inline void
IASequentialCollection <Element>::
addAtPosition (IPosition position,
               Element const& element, ICursor& cursor)
{ ImplOf (*this).
    AddAtPosition (position, &element, this->CrsrImplOf (cursor));
}

template <class Element>
inline Element&
IASequentialCollection <Element>::
any ()
{ return *(Element*) ImplOf (*this).Any ();
}

template <class Element>
inline Element const&
IASequentialCollection <Element>::
any () const
{ return *(Element const*) ImplOf (*this).Any ();
}

template <class Element>
inline Element&
IASequentialCollection <Element>::
elementAtPosition (IPosition position)
{ return *(Element*) ImplOf (*this).ElementAtPosition (position);
}

template <class Element>
inline Element const&
IASequentialCollection <Element>::
elementAtPosition (IPosition position) const
{ return *(Element const*) ImplOf (*this).ElementAtPosition (position);
}

template <class Element>
inline Element&
IASequentialCollection <Element>::
first ()
{ return *(Element*) ImplOf (*this).First ();
}

template <class Element>
inline Element const&
IASequentialCollection <Element>::
first () const
{ return *(Element const*) ImplOf (*this).First ();
}

template <class Element>
inline Element&
IASequentialCollection <Element>::
last ()
{ return *(Element*) ImplOf (*this).Last ();
}

template <class Element>
inline Element const&
IASequentialCollection <Element>::
last () const
{ return *(Element const*) ImplOf (*this).Last ();
}

template <class Element>
inline void
IASequentialCollection <Element>::
reverse ()
{ ImplOf (*this).Reverse ();
}

template <class Element>
inline void
IASequentialCollection <Element>::
sort (long (*compFunc) (Element const&, Element const&))
{ ImplOf (*this).Sort ((ICompFunc)compFunc, 0);
}

// protected members

template <class Element>
inline
IASequentialCollection <Element>::
IASequentialCollection ()
{
}

template <class Element>
inline
IASequentialCollection <Element>::
IASequentialCollection (IASequentialCollection <Element> const&)
{
}

// private members

template <class Element>
inline TYPENAME IASequentialCollection <Element>::Implementation&
IASequentialCollection <Element>::
ImplOf (IASequentialCollection <Element> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

#endif // _IASQNTL_INL_
