// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 85 1.5.1.3 source/core/collect/iass.h, collection, ioc.v400, 000919 
#ifndef _IASS_
#define _IASS_

#include <iaeqsrt.h>
#include <iiass.h>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__) 
#if defined (__RRBC_IBM__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

template <class Element>
class IASortedSet :
  public IAEqualitySortedCollection <Element> {

  typedef  IAEqualitySortedCollection <Element> Inherited;

  typedef  IASortedSetImpl Implementation;

public:

#if ! defined (__INO_AVALON__)
           IASortedSet
                            (INotifier&);

#endif
          ~IASortedSet
                            ();

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     addDifference    (IASortedSet <Element> const&,
                             IASortedSet <Element> const&); 

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     addIntersection  (IASortedSet <Element> const&,
                             IASortedSet <Element> const&);

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     addUnion         (IASortedSet <Element> const&,
                             IASortedSet <Element> const&);

  long     compare          (IASortedSet <Element> const&,
                             long (*comparisonFunction)
                              (Element const&, Element const&)) const;
 
#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     differenceWith   (IASortedSet <Element> const&);

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     intersectionWith (IASortedSet <Element> const&);

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     unionWith        (IASortedSet <Element> const&);

  bool     operator==       (IASortedSet
                              <Element> const&) const;

  bool     operator!=       (IASortedSet
                              <Element> const&) const;

protected:

           IASortedSet
                            ();

           IASortedSet
                            (IASortedSet <Element> const&);

  INumber  numberOfOccurrences
                            (Element const&) const;

  INumber  removeAllOccurrences
                            (Element const&);

private:

  static
  Implementation&
           ImplOf           (IASortedSet <Element> const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           addDifference    (IASortedSet <Element> const,\
                             IASortedSet <Element> const&),\
           addIntersection  (IASortedSet <Element> const&,\
                             IASortedSet <Element> const&),\
           addUnion         (IASortedSet <Element> const&,
                             IASortedSet <Element> const&),\
           compare          (IASortedSet <Element> const&,\
                             long (*)\
                              (Element const&, Element const&) const,\
           differenceWith   (IASortedSet <Element> const&),\
           intersectionWith (IASortedSet <Element> const&),\
           unionWith        (IASortedSet <Element> const&),\
           operator==       (IASortedSet\
                              <Element> const&) const,\
           operator!=       (IASortedSet\
                              <Element> const&) const,\
           ImplOf           (IASortedSet <Element> const&)\
                        )
#endif

};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#include <iass.inl>

#if defined (__SOM_ENABLED__) 
#pragma SOMAsDefault (pop)
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IASS_
