// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 03 1.4.1.4 source/core/collect/ibaghsh.inl, collection, ioc.v400, 000919  
#ifndef _IBAGHSH_INL_
#define _IBAGHSH_INL_

// ---
// IGBagAsHshTableCursor
// ---

#include <ilanglvl.hpp>

// public members

template <class Element, class ElementOps>
inline
IGBagAsHshTableCursor <Element, ElementOps>::
IGBagAsHshTableCursor
  (IGBagAsHshTable
    <Element, ElementOps> const& collection)
: IElementCursor <Element>
    (collection.ivImpl->CreateCursor ())
{
}

template <class Element, class ElementOps>
inline IGBagAsHshTableCursor <Element, ElementOps>&
IGBagAsHshTableCursor <Element, ElementOps>::
operator=
  (IGBagAsHshTableCursor
    <Element, ElementOps> const& cursor)
{ Inherited::operator= (cursor);
  return *this;
}

// protected members

template <class Element, class ElementOps>
inline
IGBagAsHshTableCursor <Element, ElementOps>::
IGBagAsHshTableCursor (ICursorImpl* impl)
: IElementCursor <Element> (impl)
{
}

#if ! defined (__INO_MNGCURSOR__)
// ---
// IGBagAsHshTableMngCursor
// ---

// public members

template <class Element, class ElementOps>
inline
IGBagAsHshTableMngCursor <Element, ElementOps>::
IGBagAsHshTableMngCursor
  (IGBagAsHshTable
    <Element, ElementOps> const& collection)
: IGBagAsHshTableCursor <Element, ElementOps>
    (collection.ivImpl->CreateMngCursor ())
{
}

// protected members

template <class Element, class ElementOps>
inline
IGBagAsHshTableMngCursor <Element, ElementOps>::
IGBagAsHshTableMngCursor (ICursorImpl* impl)
: IGBagAsHshTableCursor <Element, ElementOps> (impl)
{
}

#endif
// ---
// IGBagAsHshTable
// ---

// public members

template <class Element, class ElementOps>
inline
IGBagAsHshTable <Element, ElementOps>::
IGBagAsHshTable (INumber numberOfElements)
{ this->SetImpl ((Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements));
}

template <class Element, class ElementOps>
inline
IGBagAsHshTable <Element, ElementOps>::
IGBagAsHshTable
  (IGBagAsHshTable
    <Element, ElementOps> const& collection)
{ this->CloneImplOf (collection);
}

template <class Element, class ElementOps>
inline IGBagAsHshTable <Element, ElementOps>&
IGBagAsHshTable <Element, ElementOps>::
operator= (IGBagAsHshTable
            <Element, ElementOps> const& collection)
{ this->ImplOf (*this).Copy (this->ImplOf (collection));
  return *this;
}

// protected members

template <class Element, class ElementOps>
inline
IGBagAsHshTable <Element, ElementOps>::
IGBagAsHshTable (PureImplementation& impl)
{ this->SetImpl (&impl);
}

template <class Element, class ElementOps>
inline TYPENAME IGBagAsHshTable
 <Element, ElementOps>::Implementation&
IGBagAsHshTable <Element, ElementOps>::
ImplOf (IGBagAsHshTable
         <Element, ElementOps> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

// ---
// IBagAsHshTable
// ---

// public members

template <class Element>
inline
IBagAsHshTable <Element>::
IBagAsHshTable (INumber numberOfElements)
: IGBagAsHshTable
   <Element, IEHOps <Element> > (numberOfElements)
{
}

// protected members

template <class Element>
inline
IBagAsHshTable <Element>::
IBagAsHshTable (PureImplementation& impl)
: IGBagAsHshTable
   <Element, IEHOps <Element> > (impl)
{
}
#if ! defined (__INO_AVALON__)

// ---
// IVGBagAsHshTable
// ---

// public members

template <class Element, class ElementOps>
inline
IVGBagAsHshTable <Element, ElementOps>::
IVGBagAsHshTable (INumber numberOfElements)
: IGBagAsHshTable
    <Element, ElementOps> (*(Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements))
{
}

// protected members

template <class Element, class ElementOps>
inline
IVGBagAsHshTable <Element, ElementOps>::
IVGBagAsHshTable (PureImplementation& impl)
: IGBagAsHshTable
    <Element, ElementOps> (impl)
{
}

// ---
// IVBagAsHshTable
// ---

// public members

template <class Element>
inline
IVBagAsHshTable <Element>::
IVBagAsHshTable (INumber numberOfElements)
: IVGBagAsHshTable
   <Element, IEHOps <Element> > (numberOfElements)
{
}

// protected members

template <class Element>
inline
IVBagAsHshTable <Element>::
IVBagAsHshTable (PureImplementation& impl)
: IVGBagAsHshTable
   <Element, IEHOps <Element> > (impl)
{
}
#endif

#endif // _IBAGHSH_INL_
