// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 26 1.4.1.4 source/core/collect/idqudil.inl, collection, ioc.v400, 000919  
#ifndef _IDQUDIL_INL_
#define _IDQUDIL_INL_

// ---
// IGDequeAsDilTableCursor
// ---

#include <ilanglvl.hpp>

// public members

template <class Element, class ElementOps>
inline
IGDequeAsDilTableCursor <Element, ElementOps>::
IGDequeAsDilTableCursor
  (IGDequeAsDilTable
    <Element, ElementOps> const& collection)
: IOrderedCursor <Element>
    (collection.ivImpl->CreateCursor ())
{
}

template <class Element, class ElementOps>
inline IGDequeAsDilTableCursor <Element, ElementOps>&
IGDequeAsDilTableCursor <Element, ElementOps>::
operator=
  (IGDequeAsDilTableCursor
    <Element, ElementOps> const& cursor)
{ Inherited::operator= (cursor);
  return *this;
}

// protected members

template <class Element, class ElementOps>
inline
IGDequeAsDilTableCursor <Element, ElementOps>::
IGDequeAsDilTableCursor (ICursorImpl* impl)
: IOrderedCursor <Element> (impl)
{
}

#if ! defined (__INO_MNGCURSOR__)
// ---
// IGDequeAsDilTableMngCursor
// ---

// public members

template <class Element, class ElementOps>
inline
IGDequeAsDilTableMngCursor <Element, ElementOps>::
IGDequeAsDilTableMngCursor
  (IGDequeAsDilTable
    <Element, ElementOps> const& collection)
: IGDequeAsDilTableCursor <Element, ElementOps>
    (collection.ivImpl->CreateMngCursor ())
{
}

// protected members

template <class Element, class ElementOps>
inline
IGDequeAsDilTableMngCursor <Element, ElementOps>::
IGDequeAsDilTableMngCursor (ICursorImpl* impl)
: IGDequeAsDilTableCursor <Element, ElementOps> (impl)
{
}

#endif
// ---
// IGDequeAsDilTable
// ---

// public members

template <class Element, class ElementOps>
inline
IGDequeAsDilTable <Element, ElementOps>::
IGDequeAsDilTable (INumber numberOfElements)
{ this->SetImpl ((Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements));
}

template <class Element, class ElementOps>
inline
IGDequeAsDilTable <Element, ElementOps>::
IGDequeAsDilTable
  (IGDequeAsDilTable
    <Element, ElementOps> const& collection)
{ this->CloneImplOf (collection);
}

template <class Element, class ElementOps>
inline IGDequeAsDilTable <Element, ElementOps>&
IGDequeAsDilTable <Element, ElementOps>::
operator= (IGDequeAsDilTable
            <Element, ElementOps> const& collection)
{ this->ImplOf (*this).Copy (this->ImplOf (collection));
  return *this;
}

// protected members

template <class Element, class ElementOps>
inline
IGDequeAsDilTable <Element, ElementOps>::
IGDequeAsDilTable (PureImplementation& impl)
{ this->SetImpl (&impl);
}

template <class Element, class ElementOps>
inline TYPENAME IGDequeAsDilTable
 <Element, ElementOps>::Implementation&
IGDequeAsDilTable <Element, ElementOps>::
ImplOf (IGDequeAsDilTable
         <Element, ElementOps> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

// ---
// IDequeAsDilTable
// ---

// public members

template <class Element>
inline
IDequeAsDilTable <Element>::
IDequeAsDilTable (INumber numberOfElements)
: IGDequeAsDilTable
   <Element, IStdOps <Element> > (numberOfElements)
{
}

// protected members

template <class Element>
inline
IDequeAsDilTable <Element>::
IDequeAsDilTable (PureImplementation& impl)
: IGDequeAsDilTable
   <Element, IStdOps <Element> > (impl)
{
}
#if ! defined (__INO_AVALON__)

// ---
// IVGDequeAsDilTable
// ---

// public members

template <class Element, class ElementOps>
inline
IVGDequeAsDilTable <Element, ElementOps>::
IVGDequeAsDilTable (INumber numberOfElements)
: IGDequeAsDilTable
    <Element, ElementOps> (*(Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements))
{
}

// protected members

template <class Element, class ElementOps>
inline
IVGDequeAsDilTable <Element, ElementOps>::
IVGDequeAsDilTable (PureImplementation& impl)
: IGDequeAsDilTable
    <Element, ElementOps> (impl)
{
}

// ---
// IVDequeAsDilTable
// ---

// public members

template <class Element>
inline
IVDequeAsDilTable <Element>::
IVDequeAsDilTable (INumber numberOfElements)
: IVGDequeAsDilTable
   <Element, IStdOps <Element> > (numberOfElements)
{
}

// protected members

template <class Element>
inline
IVDequeAsDilTable <Element>::
IVDequeAsDilTable (PureImplementation& impl)
: IVGDequeAsDilTable
   <Element, IStdOps <Element> > (impl)
{
}
#endif

#endif // _IDQUDIL_INL_
