// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 36 1.6.1.4 source/core/collect/ies.h, collection, ioc.v400, 000919 
#ifndef _IES_
#define _IES_

#include <ilanglvl.hpp>
#include <iaes.h>
#include <iices.h>
#if ! defined (__INO_AVALON__)
#include <iives.h>
#endif
#include <iieslst.h>

#if defined (__OSTORE__)
#include <ostore/ostore.hh>
#include <ostore/manschem.hh>
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__)
#if defined (__RRBC_IBM__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

template <class Element, class ElementOps>
class IGEqualitySequence;

#pragma pack(push,4)
#pragma enum(4)

template <class Element, class ElementOps>
class IGEqualitySequenceCursor :
  public IOrderedCursor <Element> {

  typedef  IOrderedCursor <Element> Inherited;

  typedef TYPENAME IGEqualitySequence
            <Element, ElementOps>::
              Implementation::Cursor Implementation;

public:

           IGEqualitySequenceCursor
                            (IGEqualitySequence
                              <
                               Element, ElementOps> const&);

  IGEqualitySequenceCursor <Element, ElementOps>&
           operator=        (IGEqualitySequenceCursor
                              <
                               Element, ElementOps> const&);

protected:

           IGEqualitySequenceCursor
                            (ICursorImpl*);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IGEqualitySequenceCursor\
                            (IGEqualitySequence\
                              <\
                               Element, ElementOps> const&),\
           operator=,\
           IGEqualitySequenceCursor\
                            (ICursorImpl*)\
                        )
#endif

};

#if ! defined (__INO_MNGCURSOR__)
template <class Element, class ElementOps>
class IGEqualitySequenceMngCursor :
  public IGEqualitySequenceCursor <Element, ElementOps>  {

  typedef  IGEqualitySequenceCursor
            <Element, ElementOps> Cursor;

  typedef TYPENAME IGEqualitySequence
            <Element, ElementOps>::
              Implementation::MngCursor Implementation;

public:

           IGEqualitySequenceMngCursor
                            (IGEqualitySequence
                              <
                               Element, ElementOps> const&);

protected:

           IGEqualitySequenceMngCursor
                            (ICursorImpl*);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IGEqualitySequenceMngCursor\
                            (IGEqualitySequence\
                              <\
                               Element, ElementOps> const&),\
           IGEqualitySequenceMngCursor\
                            (ICursorImpl*)\
                        )
#endif

};

#endif
template <class Element, class ElementOps>
class IGEqualitySequence :
  public IAEqualitySequence <Element> {
protected:

  typedef  IGEqualitySequence <Element, ElementOps> Self;

  typedef  IEqualitySequenceAsListImpl PureImplementation;

#if defined (INO_CHECKS)
  typedef  PureImplementation Implementation;
#else
  typedef  ICEqualitySequenceImpl
            <PureImplementation> Implementation;
#endif

#define IGEqualitySequenceTypedef(Element, ElementOps)\
  typedef  IEqualitySequenceAsListOps\
            <Element,\
             IWEOps <Element, ElementOps>,\
             Implementation> Instantiation

           IGEqualitySequenceTypedef (Element, ElementOps);

public:

#if ! defined(__INO_L1_LOCKING__)
  typedef ICollectionGuard<Element> Guard;
#endif

  typedef  IGEqualitySequenceCursor
            <Element, ElementOps> Cursor;

#if ! defined (__INO_MNGCURSOR__)
  typedef  IGEqualitySequenceMngCursor
            <Element, ElementOps> MngCursor;
#endif

           IGEqualitySequence
                            (INumber = 100);

           IGEqualitySequence
                            (IGEqualitySequence
                              <
                               Element, ElementOps> const&);

  IGEqualitySequence <Element, ElementOps>&
           operator=        (IGEqualitySequence
                              <
                               Element, ElementOps> const&);

#if defined (__OSTORE__)
  static
  os_typespec*
           get_os_typespec  ()
           { return 0; }

  static
  void     os_mark_schema_type ()
           {
             Instantiation::os_mark_schema_type ();
#if ! defined (_AIX)
             OS_MARK_SCHEMA_TYPESPEC((Self));
#else
             { Self* _OSMT_ = 0; }
#endif
           }
#endif

protected:

           IGEqualitySequence
                            (PureImplementation&);

  static
  Implementation&
           ImplOf           (IGEqualitySequence
                              <
                               Element, ElementOps> const&);

private:

  friend
  class    IGEqualitySequenceCursor <Element, ElementOps>;

#if ! defined (__INO_MNGCURSOR__)
  friend
  class    IGEqualitySequenceMngCursor
            <Element, ElementOps>;
#endif

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine ()
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IGEqualitySequence\
                            (INumber),\
           operator=,\
           IGEqualitySequence\
                            (PureImplementation&),\
           ImplOf           (IGEqualitySequence\
                              <\
                               Element, ElementOps> const&)\
                        )
#endif

};

template <class Element>
class IEqualitySequence :
  public IGEqualitySequence
          <Element, IEOps <Element> > {

  typedef  IGEqualitySequence
            <Element,
             IEOps <Element> > Inherited;

protected:

  typedef TYPENAME Inherited::PureImplementation PureImplementation;

  typedef  IEqualitySequence <Element> Self;

#define IEqualitySequenceTypedef(Element)\
  typedef  IEqualitySequenceAsListOps\
            <Element,\
             IWEOps <Element, IEOps <Element> >,\
             Implementation> Instantiation

public:

#if ! defined(__INO_L1_LOCKING__)
  typedef ICollectionGuard<Element> Guard;
#endif

           IEqualitySequence
                            (INumber = 100);

#if defined (__OSTORE__)
  static
  os_typespec*
           get_os_typespec  ()
           { return 0; }

  static
  void     os_mark_schema_type ()
           {
             Inherited::os_mark_schema_type ();
#if ! defined (_AIX)
             OS_MARK_SCHEMA_TYPESPEC((Self));
#else
             { Self* _OSMT_ = 0; }
#endif
           }
#endif

protected:

           IEqualitySequence
                              (PureImplementation&);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IEqualitySequence\
                              (INumber),\
           IEqualitySequence\
                              (PureImplementation&)\
                        )
#endif

};

#if ! defined (__INO_AVALON__)
template <class Element, class ElementOps>
class IVGEqualitySequence :
  public IGEqualitySequence
          <Element, ElementOps > {

  typedef  IVGEqualitySequence
            <Element, ElementOps> Inherited;

protected:

  typedef TYPENAME
           IGEqualitySequence
            <Element, ElementOps>::PureImplementation PureImplementation;

#if defined (INO_CHECKS)
  typedef  IVEqualitySequenceImpl
            <PureImplementation> Implementation;
#else
  typedef  ICEqualitySequenceImpl
            <IVEqualitySequenceImpl
              <PureImplementation> > Implementation;
#endif

#define IVGEqualitySequenceTypedef(Element, ElementOps)\
  typedef  IEqualitySequenceAsListOps\
            <Element,\
             IWEOps <Element, ElementOps>,\
             Implementation> Instantiation

           IVGEqualitySequenceTypedef (Element, ElementOps);

public:

#if ! defined(__INO_L1_LOCKING__)
  typedef ICollectionGuard<Element> Guard;
#endif

           IVGEqualitySequence
                            (INumber = 100);

#if defined (__OSTORE__)
  static
  os_typespec*
           get_os_typespec  ()
           { return 0; }

  static
  void     os_mark_schema_type ()
           {
             Inherited::os_mark_schema_type ();
#if ! defined (_AIX)
             OS_MARK_SCHEMA_TYPESPEC((Self));
#else
             { Self* _OSMT_ = 0; }
#endif
           }
#endif

protected:

           IVGEqualitySequence
                              (PureImplementation&);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IVGEqualitySequence\
                              (INumber),\
           IVGEqualitySequence\
                              (PureImplementation&)\
                        )
#endif

};

template <class Element>
class IVEqualitySequence :
  public IVGEqualitySequence
          <Element, IEOps <Element> > {

  typedef  IVGEqualitySequence
            <Element,
             IEOps <Element> > Inherited;

protected:

  typedef TYPENAME Inherited::PureImplementation PureImplementation;

  typedef  IVEqualitySequence <Element> Self;

#define IVEqualitySequenceTypedef(Element)\
  typedef  IVEqualitySequenceAsListOps\
            <Element,\
             IWEOps <Element, IEOps <Element> >,\
             Implementation> Instantiation

public:

#if ! defined(__INO_L1_LOCKING__)
  typedef ICollectionGuard<Element> Guard;
#endif

           IVEqualitySequence
                            (INumber = 100);

#if defined (__OSTORE__)
  static
  os_typespec*
           get_os_typespec  ()
           { return 0; }

  static
  void     os_mark_schema_type ()
           {
             Inherited::os_mark_schema_type ();
#if ! defined (_AIX)
             OS_MARK_SCHEMA_TYPESPEC((Self));
#else
             { Self* _OSMT_ = 0; }
#endif
           }
#endif

protected:

           IVEqualitySequence
                              (PureImplementation&);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IVEqualitySequence\
                              (INumber),\
           IVEqualitySequence\
                              (PureImplementation&)\
                        )
#endif

};

#endif

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#if defined (__SOM_ENABLED__) 
#pragma SOMAsDefault (pop)
#endif

#include <ies.inl>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IES_
