// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 41 1.4.1.4 source/core/collect/ieslst.inl, collection, ioc.v400, 000919  
#ifndef _IESLST_INL_
#define _IESLST_INL_

// ---
// IGEqualitySequenceAsListCursor
// ---

#include <ilanglvl.hpp>

// public members

template <class Element, class ElementOps>
inline
IGEqualitySequenceAsListCursor <Element, ElementOps>::
IGEqualitySequenceAsListCursor
  (IGEqualitySequenceAsList
    <Element, ElementOps> const& collection)
: IOrderedCursor <Element>
    (collection.ivImpl->CreateCursor ())
{
}

template <class Element, class ElementOps>
inline IGEqualitySequenceAsListCursor <Element, ElementOps>&
IGEqualitySequenceAsListCursor <Element, ElementOps>::
operator=
  (IGEqualitySequenceAsListCursor
    <Element, ElementOps> const& cursor)
{ Inherited::operator= (cursor);
  return *this;
}

// protected members

template <class Element, class ElementOps>
inline
IGEqualitySequenceAsListCursor <Element, ElementOps>::
IGEqualitySequenceAsListCursor (ICursorImpl* impl)
: IOrderedCursor <Element> (impl)
{
}

#if ! defined (__INO_MNGCURSOR__)
// ---
// IGEqualitySequenceAsListMngCursor
// ---

// public members

template <class Element, class ElementOps>
inline
IGEqualitySequenceAsListMngCursor <Element, ElementOps>::
IGEqualitySequenceAsListMngCursor
  (IGEqualitySequenceAsList
    <Element, ElementOps> const& collection)
: IGEqualitySequenceAsListCursor <Element, ElementOps>
    (collection.ivImpl->CreateMngCursor ())
{
}

// protected members

template <class Element, class ElementOps>
inline
IGEqualitySequenceAsListMngCursor <Element, ElementOps>::
IGEqualitySequenceAsListMngCursor (ICursorImpl* impl)
: IGEqualitySequenceAsListCursor <Element, ElementOps> (impl)
{
}

#endif
// ---
// IGEqualitySequenceAsList
// ---

// public members

template <class Element, class ElementOps>
inline
IGEqualitySequenceAsList <Element, ElementOps>::
IGEqualitySequenceAsList (INumber numberOfElements)
{ this->SetImpl ((Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements));
}

template <class Element, class ElementOps>
inline
IGEqualitySequenceAsList <Element, ElementOps>::
IGEqualitySequenceAsList
  (IGEqualitySequenceAsList
    <Element, ElementOps> const& collection)
{ this->CloneImplOf (collection);
}

template <class Element, class ElementOps>
inline IGEqualitySequenceAsList <Element, ElementOps>&
IGEqualitySequenceAsList <Element, ElementOps>::
operator= (IGEqualitySequenceAsList
            <Element, ElementOps> const& collection)
{ this->ImplOf (*this).Copy (this->ImplOf (collection));
  return *this;
}

// protected members

template <class Element, class ElementOps>
inline
IGEqualitySequenceAsList <Element, ElementOps>::
IGEqualitySequenceAsList (PureImplementation& impl)
{ this->SetImpl (&impl);
}

template <class Element, class ElementOps>
inline TYPENAME IGEqualitySequenceAsList
 <Element, ElementOps>::Implementation&
IGEqualitySequenceAsList <Element, ElementOps>::
ImplOf (IGEqualitySequenceAsList
         <Element, ElementOps> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

// ---
// IEqualitySequenceAsList
// ---

// public members

template <class Element>
inline
IEqualitySequenceAsList <Element>::
IEqualitySequenceAsList (INumber numberOfElements)
: IGEqualitySequenceAsList
   <Element, IEOps <Element> > (numberOfElements)
{
}

// protected members

template <class Element>
inline
IEqualitySequenceAsList <Element>::
IEqualitySequenceAsList (PureImplementation& impl)
: IGEqualitySequenceAsList
   <Element, IEOps <Element> > (impl)
{
}
#if ! defined (__INO_AVALON__)

// ---
// IVGEqualitySequenceAsList
// ---

// public members

template <class Element, class ElementOps>
inline
IVGEqualitySequenceAsList <Element, ElementOps>::
IVGEqualitySequenceAsList (INumber numberOfElements)
: IGEqualitySequenceAsList
    <Element, ElementOps> (*(Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements))
{
}

// protected members

template <class Element, class ElementOps>
inline
IVGEqualitySequenceAsList <Element, ElementOps>::
IVGEqualitySequenceAsList (PureImplementation& impl)
: IGEqualitySequenceAsList
    <Element, ElementOps> (impl)
{
}

// ---
// IVEqualitySequenceAsList
// ---

// public members

template <class Element>
inline
IVEqualitySequenceAsList <Element>::
IVEqualitySequenceAsList (INumber numberOfElements)
: IVGEqualitySequenceAsList
   <Element, IEOps <Element> > (numberOfElements)
{
}

// protected members

template <class Element>
inline
IVEqualitySequenceAsList <Element>::
IVEqualitySequenceAsList (PureImplementation& impl)
: IVGEqualitySequenceAsList
   <Element, IEOps <Element> > (impl)
{
}
#endif

#endif // _IESLST_INL_
