// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 43 1.4.1.4 source/core/collect/iestab.inl, collection, ioc.v400, 000919  
#ifndef _IESTAB_INL_
#define _IESTAB_INL_

// ---
// IGEqualitySequenceAsTableCursor
// ---

#include <ilanglvl.hpp>

// public members

template <class Element, class ElementOps>
inline
IGEqualitySequenceAsTableCursor <Element, ElementOps>::
IGEqualitySequenceAsTableCursor
  (IGEqualitySequenceAsTable
    <Element, ElementOps> const& collection)
: IOrderedCursor <Element>
    (collection.ivImpl->CreateCursor ())
{
}

template <class Element, class ElementOps>
inline IGEqualitySequenceAsTableCursor <Element, ElementOps>&
IGEqualitySequenceAsTableCursor <Element, ElementOps>::
operator=
  (IGEqualitySequenceAsTableCursor
    <Element, ElementOps> const& cursor)
{ Inherited::operator= (cursor);
  return *this;
}

// protected members

template <class Element, class ElementOps>
inline
IGEqualitySequenceAsTableCursor <Element, ElementOps>::
IGEqualitySequenceAsTableCursor (ICursorImpl* impl)
: IOrderedCursor <Element> (impl)
{
}

#if ! defined (__INO_MNGCURSOR__)
// ---
// IGEqualitySequenceAsTableMngCursor
// ---

// public members

template <class Element, class ElementOps>
inline
IGEqualitySequenceAsTableMngCursor <Element, ElementOps>::
IGEqualitySequenceAsTableMngCursor
  (IGEqualitySequenceAsTable
    <Element, ElementOps> const& collection)
: IGEqualitySequenceAsTableCursor <Element, ElementOps>
    (collection.ivImpl->CreateMngCursor ())
{
}

// protected members

template <class Element, class ElementOps>
inline
IGEqualitySequenceAsTableMngCursor <Element, ElementOps>::
IGEqualitySequenceAsTableMngCursor (ICursorImpl* impl)
: IGEqualitySequenceAsTableCursor <Element, ElementOps> (impl)
{
}

#endif
// ---
// IGEqualitySequenceAsTable
// ---

// public members

template <class Element, class ElementOps>
inline
IGEqualitySequenceAsTable <Element, ElementOps>::
IGEqualitySequenceAsTable (INumber numberOfElements)
{ this->SetImpl ((Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements));
}

template <class Element, class ElementOps>
inline
IGEqualitySequenceAsTable <Element, ElementOps>::
IGEqualitySequenceAsTable
  (IGEqualitySequenceAsTable
    <Element, ElementOps> const& collection)
{ this->CloneImplOf (collection);
}

template <class Element, class ElementOps>
inline IGEqualitySequenceAsTable <Element, ElementOps>&
IGEqualitySequenceAsTable <Element, ElementOps>::
operator= (IGEqualitySequenceAsTable
            <Element, ElementOps> const& collection)
{ this->ImplOf (*this).Copy (this->ImplOf (collection));
  return *this;
}

// protected members

template <class Element, class ElementOps>
inline
IGEqualitySequenceAsTable <Element, ElementOps>::
IGEqualitySequenceAsTable (PureImplementation& impl)
{ this->SetImpl (&impl);
}

template <class Element, class ElementOps>
inline TYPENAME IGEqualitySequenceAsTable
 <Element, ElementOps>::Implementation&
IGEqualitySequenceAsTable <Element, ElementOps>::
ImplOf (IGEqualitySequenceAsTable
         <Element, ElementOps> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

// ---
// IEqualitySequenceAsTable
// ---

// public members

template <class Element>
inline
IEqualitySequenceAsTable <Element>::
IEqualitySequenceAsTable (INumber numberOfElements)
: IGEqualitySequenceAsTable
   <Element, IEOps <Element> > (numberOfElements)
{
}

// protected members

template <class Element>
inline
IEqualitySequenceAsTable <Element>::
IEqualitySequenceAsTable (PureImplementation& impl)
: IGEqualitySequenceAsTable
   <Element, IEOps <Element> > (impl)
{
}
#if ! defined (__INO_AVALON__)

// ---
// IVGEqualitySequenceAsTable
// ---

// public members

template <class Element, class ElementOps>
inline
IVGEqualitySequenceAsTable <Element, ElementOps>::
IVGEqualitySequenceAsTable (INumber numberOfElements)
: IGEqualitySequenceAsTable
    <Element, ElementOps> (*(Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements))
{
}

// protected members

template <class Element, class ElementOps>
inline
IVGEqualitySequenceAsTable <Element, ElementOps>::
IVGEqualitySequenceAsTable (PureImplementation& impl)
: IGEqualitySequenceAsTable
    <Element, ElementOps> (impl)
{
}

// ---
// IVEqualitySequenceAsTable
// ---

// public members

template <class Element>
inline
IVEqualitySequenceAsTable <Element>::
IVEqualitySequenceAsTable (INumber numberOfElements)
: IVGEqualitySequenceAsTable
   <Element, IEOps <Element> > (numberOfElements)
{
}

// protected members

template <class Element>
inline
IVEqualitySequenceAsTable <Element>::
IVEqualitySequenceAsTable (PureImplementation& impl)
: IVGEqualitySequenceAsTable
   <Element, IEOps <Element> > (impl)
{
}
#endif

#endif // _IESTAB_INL_
