// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 45 1.5.1.3 source/core/collect/iexc.h, collection, ioc.v400, 000919 
#ifndef _IEXC_
#define _IEXC_

#include <iiglobal.h>
#include <iexcbase.hpp>
#include <iexctxt.h>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if ! defined (__MVS__)
#if defined (__RRBC_LIB__)
#define __RRBC_EXC__
#undef  __RRBC_LIB__
#endif
#endif

#if defined (__SOM_ENABLED__)
#if defined (__RRBC_LIB__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

#if ! defined(__INO_L1_LOCKING__)
class IC_EXPORTC ICollectionResourceException : public IException 
{
public:

           ICollectionResourceException
                            (char const*, unsigned long = 0,
                             Severity = IException::unrecoverable);

           ICollectionResourceException
                            (ICollectionResourceException const&);

  virtual  ~ICollectionResourceException
                            ();

  virtual  char const* name () const;

  static
  void     throwIt          (unsigned long,
                             char const*, unsigned long);

protected:

private:

        void     operator=        (ICollectionResourceException const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           ICollectionResourceException\
                            (char const*, unsigned long, Severity),\
           operator=        (ICollectionResourceException const&),\
           throwIt          (unsigned long,\
                             char const*, unsigned long)\
                        )
#endif
};

class IC_EXPORTC ICollectionLockException : public IException 
{
public:

           ICollectionLockException
                            (char const*, unsigned long = 0,
                             Severity = IException::unrecoverable);

           ICollectionLockException
                            (ICollectionLockException const&);

  virtual  ~ICollectionLockException
                            ();

  virtual  char const* name () const;

  static
  void     throwIt          (unsigned long,
                             char const*, unsigned long);

protected:

private:

        void     operator=        (ICollectionLockException const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           ICollectionLockException\
                            (char const*, unsigned long, Severity),\
           operator=        (ICollectionLockException const&),\
           throwIt          (unsigned long,\
                             char const*, unsigned long)\
                        )
#endif
};

class IC_EXPORTC ICollectionLockTimeOutException : public IException 
{
public:

           ICollectionLockTimeOutException
                            (char const*, unsigned long = 0,
                             Severity = IException::unrecoverable);

           ICollectionLockTimeOutException
                            (ICollectionLockTimeOutException const&);

  virtual  ~ICollectionLockTimeOutException
                            ();

  virtual  char const* name () const;

  static
  void     throwIt          (unsigned long,
                             char const*, unsigned long);

protected:

private:

        void     operator=        (ICollectionLockTimeOutException const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           ICollectionLockTimeOutException\
                            (char const*, unsigned long, Severity),\
           operator=        (ICollectionLockTimeOutException const&),\
           throwIt          (unsigned long,\
                             char const*, unsigned long)\
                        )
#endif
};

class IC_EXPORTC ICollectionUnlockException : public IException 
{
public:

           ICollectionUnlockException
                            (char const*, unsigned long = 0,
                             Severity = IException::unrecoverable);

           ICollectionUnlockException
                            (ICollectionUnlockException const&);

  virtual  ~ICollectionUnlockException
                            ();

  virtual  char const* name () const;

  static
  void     throwIt          (unsigned long,
                             char const*, unsigned long);

protected:

private:

        void     operator=        (ICollectionUnlockException const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           ICollectionUnlockException\
                            (char const*, unsigned long, Severity),\
           operator=        (ICollectionUnlockException const&),\
           throwIt          (unsigned long,\
                             char const*, unsigned long)\
                        )
#endif
};

#endif
class IC_EXPORTC IPreconditionViolation : public IException 
{
public:

           IPreconditionViolation
                            (char const*, unsigned long = 0,
                             Severity = IException::unrecoverable);

           IPreconditionViolation
                            (IPreconditionViolation const&);

  virtual ~IPreconditionViolation
                            ();

  virtual
  char const*
           name             () const;

  static
  void     throwIt          (unsigned long,
                             char const*, unsigned long);

protected:

private:

  void     operator=        (IPreconditionViolation const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IPreconditionViolation\
                            (char const*, unsigned long, Severity),\
           operator=        (IPreconditionViolation const&),\
           throwIt          (unsigned long,\
                             char const*, unsigned long)\
                        )
#endif

};

class IC_EXPORTC IFullException : public IPreconditionViolation 
{
public:

           IFullException   (char const*, unsigned long = 0,
                             Severity = IException::unrecoverable);

           IFullException   (IFullException const&);

  virtual ~IFullException   ();

  virtual
  char const*
           name             () const;

  static
  void     throwIt          (unsigned long,
                             char const*, unsigned long);

protected:

private:

  void     operator=        (IFullException const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IFullException   (char const*, unsigned long, Severity),\
           operator=        (IFullException const&),\
           throwIt          (unsigned long,\
                             char const*, unsigned long)\
                        )
#endif

};

class IC_EXPORTC IEmptyException : public IPreconditionViolation {
public:

           IEmptyException  (char const*, unsigned long = 0,
                             Severity = IException::unrecoverable);

           IEmptyException  (IEmptyException const&);

  virtual ~IEmptyException  ();

  virtual
  char const*
           name             () const;

  static
  void     throwIt          (unsigned long,
                             char const*, unsigned long);

protected:

private:

  void     operator=        (IEmptyException const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IEmptyException \
                            (char const*, unsigned long, Severity),\
           operator=        (IEmptyException const&),\
           throwIt          (unsigned long,\
                             char const*, unsigned long)\
                        )
#endif

};

class IC_EXPORTC INotEmptyException : public IPreconditionViolation 
{
public:

           INotEmptyException
                            (char const*, unsigned long = 0,
                             Severity = IException::unrecoverable);

           INotEmptyException
                            (INotEmptyException const&);

  virtual ~INotEmptyException
                            ();

  virtual
  char const*
           name             () const;

  static
  void     throwIt          (unsigned long,
                             char const*, unsigned long);

protected:

private:

  void     operator=        (INotEmptyException const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           INotEmptyException\
                            (char const*, unsigned long, Severity),\
           operator=        (INotEmptyException const&),\
           throwIt          (unsigned long,\
                             char const*, unsigned long)\
                        )
#endif

};

class IC_EXPORTC INotBoundedException : public IPreconditionViolation 
{
public:

           INotBoundedException
                            (char const*, unsigned long = 0,
                             Severity = IException::unrecoverable);

           INotBoundedException
                            (INotBoundedException const&);

  virtual ~INotBoundedException
                            ();

  virtual
  char const*
           name             () const;

  static
  void     throwIt          (unsigned long,
                             char const*, unsigned long);

protected:

private:

  void     operator=        (INotBoundedException const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           INotBoundedException\
                            (char const*, unsigned long, Severity),\
           operator=        (INotBoundedException const&),\
           throwIt          (unsigned long,\
                             char const*, unsigned long)\
                        )
#endif

};

class IC_EXPORTC ICursorInvalidException : public IPreconditionViolation 
{
public:

           ICursorInvalidException
                            (char const*, unsigned long = 0,
                             Severity = IException::unrecoverable);

           ICursorInvalidException
                            (ICursorInvalidException const&);

  virtual ~ICursorInvalidException
                            ();

  virtual
  char const*
           name             () const;

  static
  void     throwIt          (unsigned long,
                             char const*, unsigned long);

protected:

private:

  void     operator=        (ICursorInvalidException const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           ICursorInvalidException\
                            (char const*, unsigned long, Severity),\
           operator=        (ICursorInvalidException const&),\
           throwIt          (unsigned long,\
                             char const*, unsigned long)\
                        )
#endif

};

class IC_EXPORTC IPositionInvalidException : public IPreconditionViolation 
{
public:

           IPositionInvalidException
                            (char const*, unsigned long = 0,
                             Severity = IException::unrecoverable);

           IPositionInvalidException
                            (IPositionInvalidException const&);

  virtual ~IPositionInvalidException
                            ();

  virtual
  char const*
           name             () const;

  static
  void     throwIt          (unsigned long,
                             char const*, unsigned long);

protected:

private:

  void     operator=        (IPositionInvalidException const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IPositionInvalidException\
                            (char const*, unsigned long, Severity),\
           operator=        (IPositionInvalidException const&),\
           throwIt          (unsigned long,\
                             char const*, unsigned long)\
                        )
#endif

};

class IC_EXPORTC INotContainsKeyException : public IPreconditionViolation 
{
public:

           INotContainsKeyException
                            (char const*, unsigned long = 0,
                             Severity = IException::unrecoverable);

           INotContainsKeyException
                            (INotContainsKeyException const&);

  virtual ~INotContainsKeyException
                            ();

  virtual
  char const*
           name             () const;

  static
  void     throwIt          (unsigned long,
                             char const*, unsigned long);

protected:

private:

  void     operator=        (INotContainsKeyException const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           INotContainsKeyException\
                            (char const*, unsigned long, Severity),\
           operator=        (INotContainsKeyException const&),\
           throwIt          (unsigned long,\
                             char const*, unsigned long)\
                        )
#endif

};

class IC_EXPORTC IKeyAlreadyExistsException : public IPreconditionViolation 
{
public:

           IKeyAlreadyExistsException
                            (char const*, unsigned long = 0,
                             Severity = IException::unrecoverable);

           IKeyAlreadyExistsException
                            (IKeyAlreadyExistsException const&);

  virtual ~IKeyAlreadyExistsException
                            ();

  virtual
  char const*
           name             () const;

  static
  void     throwIt          (unsigned long,
                             char const*, unsigned long);

protected:

private:

  void     operator=        (IKeyAlreadyExistsException const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IKeyAlreadyExistsException\
                            (char const*, unsigned long, Severity),\
           operator=        (IKeyAlreadyExistsException const&),\
           throwIt          (unsigned long,\
                             char const*, unsigned long)\
                        )
#endif

};

class IC_EXPORTC IRootAlreadyExistsException : public IPreconditionViolation 
{
public:

           IRootAlreadyExistsException
                            (char const*, unsigned long = 0,
                             Severity = IException::unrecoverable);

           IRootAlreadyExistsException
                            (IRootAlreadyExistsException const&);

  virtual ~IRootAlreadyExistsException
                            ();

  virtual
  char const*
           name             () const;

  static
  void     throwIt          (unsigned long,
                             char const*, unsigned long);

protected:

private:

  void     operator=        (IRootAlreadyExistsException const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IRootAlreadyExistsException\
                            (char const*, unsigned long, Severity),\
           operator=        (IRootAlreadyExistsException const&),\
           throwIt          (unsigned long,\
                             char const*, unsigned long)\
                        )
#endif

};

class IC_EXPORTC IChildAlreadyExistsException : public IPreconditionViolation 
{
public:

           IChildAlreadyExistsException
                            (char const*, unsigned long = 0,
                             Severity = IException::unrecoverable);

           IChildAlreadyExistsException
                            (IChildAlreadyExistsException const&);

  virtual ~IChildAlreadyExistsException
                            ();

  virtual
  char const*
           name             () const;

  static
  void     throwIt          (unsigned long,
                             char const*, unsigned long);

protected:

private:

  void     operator=        (IChildAlreadyExistsException const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IChildAlreadyExistsException\
                            (char const*, unsigned long, Severity),\
           operator=        (IChildAlreadyExistsException const&),\
           throwIt          (unsigned long,\
                             char const*, unsigned long)\
                        )
#endif

};

class IC_EXPORTC IIdenticalCollectionException : public IPreconditionViolation 
{
public:

           IIdenticalCollectionException
                            (char const*, unsigned long = 0,
                             Severity = IException::unrecoverable);

           IIdenticalCollectionException
                            (IIdenticalCollectionException const&);

  virtual ~IIdenticalCollectionException
                            ();

  virtual
  char const*
           name             () const;

  static
  void     throwIt          (unsigned long,
                             char const*, unsigned long);

protected:

private:

  void     operator=        (IIdenticalCollectionException const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IIdenticalCollectionException\
                            (char const*, unsigned long, Severity),\
           operator=        (IIdenticalCollectionException const&),\
           throwIt          (unsigned long,\
                             char const*, unsigned long)\
                        )
#endif

};

class IC_EXPORTC IInvalidReplacementException : public IPreconditionViolation 
{
public:

           IInvalidReplacementException
                            (char const*, unsigned long = 0,
                             Severity = IException::unrecoverable);

           IInvalidReplacementException
                            (IInvalidReplacementException const&);

  virtual ~IInvalidReplacementException
                            ();

  virtual
  char const*
           name             () const;

  static
  void     throwIt          (unsigned long,
                             char const*, unsigned long);

protected:

private:

  void     operator=        (IInvalidReplacementException const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IInvalidReplacementException\
                            (char const*, unsigned long, Severity),\
           operator=        (IInvalidReplacementException const&),\
           throwIt          (unsigned long,\
                             char const*, unsigned long)\
                        )
#endif

};

class IC_EXPORTC ICyclicAttachException : public IPreconditionViolation 
{
public:

           ICyclicAttachException
                            (char const*, unsigned long = 0,
                             Severity = IException::unrecoverable);

           ICyclicAttachException
                            (ICyclicAttachException const&);

  virtual ~ICyclicAttachException
                            ();

  virtual
  char const*
           name             () const;

  static
  void     throwIt          (unsigned long,
                             char const*, unsigned long);

protected:

private:

  void     operator=        (ICyclicAttachException const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           ICyclicAttachException\
                            (char const*, unsigned long, Severity),\
           operator=        (ICyclicAttachException const&),\
           throwIt          (unsigned long,\
                             char const*, unsigned long)\
                        )
#endif

};

class IC_EXPORTC IOutOfCollectionMemory : public IOutOfMemory 
{
public:

           IOutOfCollectionMemory
                            (char const*, unsigned long = 0,
                             Severity = IException::unrecoverable);

           IOutOfCollectionMemory
                            (IOutOfCollectionMemory const&);

  virtual ~IOutOfCollectionMemory
                            ();

  virtual
  char const*
           name             () const;

  static
  void     throwIt          (unsigned long,
                             char const*, unsigned long);

protected:

private:

  void     operator=        (IOutOfCollectionMemory const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IOutOfCollectionMemory\
                            (char const*, unsigned long, Severity),\
           operator=        (IOutOfCollectionMemory const&),\
           throwIt          (unsigned long,\
                             char const*, unsigned long)\
                        )
#endif

};

#if ! defined (__INO_CONCUR__)
class IC_EXPORTC IUnlockInvalidException : public IPreconditionViolation 
{
public:

           IUnlockInvalidException
                            (char const*, unsigned long = 0,
                             Severity = IException::unrecoverable);

           IUnlockInvalidException
                            (IUnlockInvalidException const&);

  virtual ~IUnlockInvalidException
                            ();

  virtual
  char const*
           name             () const;

  static
  void     throwIt          (unsigned long,
                             char const*, unsigned long);

protected:

private:

  void     operator=        (IUnlockInvalidException const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IUnlockInvalidException\
                            (char const*, unsigned long, Severity),\
           operator=        (IUnlockInvalidException const&),\
           throwIt          (unsigned long,\
                             char const*, unsigned long)\
                        )
#endif

};
#endif

#if ! defined (__INO_OBJSTR__)
class IC_EXPORTC IContainedStreamedBeforeEnclosing :
  public IPreconditionViolation {
public:

           IContainedStreamedBeforeEnclosing
                            (char const*, unsigned long = 0,
                             Severity = IException::unrecoverable);

           IContainedStreamedBeforeEnclosing
                            (IContainedStreamedBeforeEnclosing const&);

  virtual ~IContainedStreamedBeforeEnclosing
                            ();

  virtual
  char const*
           name             () const;

  static
  void     throwIt          (unsigned long,
                             char const*, unsigned long);

protected:

private:

  void     operator=        (IContainedStreamedBeforeEnclosing const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IContainedStreamedBeforeEnclosing\
                            (char const*, unsigned long, Severity),\
           operator=        (IContainedStreamedBeforeEnclosing const&),\
           throwIt          (unsigned long,\
                             char const*, unsigned long)\
                        )
#endif

};

class IC_EXPORTC IContainerObjectIsNotReadYet : public IPreconditionViolation 
{
public:

           IContainerObjectIsNotReadYet
                            (char const*, unsigned long = 0,
                             Severity = IException::unrecoverable);

           IContainerObjectIsNotReadYet
                            (IContainerObjectIsNotReadYet const&);

  virtual ~IContainerObjectIsNotReadYet
                            ();

  virtual
  char const*
           name             () const;

  static
  void     throwIt          (unsigned long,
                             char const*, unsigned long);

protected:

private:

  void     operator=        (IContainerObjectIsNotReadYet const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IContainerObjectIsNotReadYet\
                            (char const*, unsigned long, Severity),\
           operator=        (IContainerObjectIsNotReadYet const&),\
           throwIt          (unsigned long,\
                             char const*, unsigned long)\
                        )
#endif

};

class IC_EXPORTC INoRestoreFunctionDefined : public IPreconditionViolation 
{
public:

           INoRestoreFunctionDefined
                            (char const*, unsigned long = 0,
                             Severity = IException::unrecoverable);

           INoRestoreFunctionDefined
                            (INoRestoreFunctionDefined const&);

  virtual ~INoRestoreFunctionDefined
                            ();

  virtual
  char const*
           name             () const;

  static
  void     throwIt          (unsigned long,
                             char const*, unsigned long);

protected:

private:

  void     operator=        (INoRestoreFunctionDefined const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           INoRestoreFunctionDefined\
                            (char const*, unsigned long, Severity),\
           operator=        (INoRestoreFunctionDefined const&),\
           throwIt          (unsigned long,\
                             char const*, unsigned long)\
                        )
#endif

};

class IC_EXPORTC INoConversionFunctionDefined : public IPreconditionViolation 
{
public:

           INoConversionFunctionDefined
                            (char const*, unsigned long = 0,
                             Severity = IException::unrecoverable);

           INoConversionFunctionDefined
                            (INoConversionFunctionDefined const&);

  virtual ~INoConversionFunctionDefined
                            ();

  virtual
  char const*
           name             () const;

  static
  void     throwIt          (unsigned long,
                             char const*, unsigned long);

protected:

private:

  void     operator=        (INoConversionFunctionDefined const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           INoConversionFunctionDefined\
                            (char const*, unsigned long, Severity),\
           operator=        (INoConversionFunctionDefined const&),\
           throwIt          (unsigned long,\
                             char const*, unsigned long)\
                        )
#endif

};
#endif

#if ! defined(__INO_STREAMING__)
class IC_EXPORTC IStreamErrorException : public IException 
{
public:

           IStreamErrorException
                            (char const*, unsigned long = 0,
                            Severity = IException::unrecoverable);

           IStreamErrorException
                            (IStreamErrorException const&);

  virtual  ~IStreamErrorException
                            ();

  virtual  char const* name () const;

  static
  void     throwIt          (unsigned long,
                             char const*, unsigned long);

protected:

private:

        void     operator=        (IStreamErrorException const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IStreamErrorException\
                            (char const*, unsigned long, Severity),\
           operator=        (IStreamErrorException const&),\
           throwIt          (unsigned long,\
                             char const*, unsigned long)\
                        )
#endif
};

class IC_EXPORTC IStreamerInvalidException : public IException 
{
public:

           IStreamerInvalidException
                            (char const*, unsigned long = 0,
                            Severity = IException::unrecoverable);

           IStreamerInvalidException
                            (IStreamerInvalidException const&);

  virtual  ~IStreamerInvalidException
                            ();

  virtual  char const* name () const;

  static
  void     throwIt          (unsigned long,
                             char const*, unsigned long);

protected:

private:

        void     operator=        (IStreamerInvalidException const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IStreamerInvalidException\
                            (char const*, unsigned long, Severity),\
           operator=        (IStreamerInvalidException const&),\
           throwIt          (unsigned long,\
                             char const*, unsigned long)\
                        )
#endif
};
#endif

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#if defined (__SOM_ENABLED__)
#pragma SOMAsDefault (pop)
#endif

#if ! defined (__MVS__)
#if defined (__RRBC_EXC__)
#define __RRBC_LIB__
#undef __RRBC_EXC__
#endif
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IEXC_
