// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 71 1.5.1.3 source/core/collect/iiaes.h, collection, ioc.v400, 000919 
#ifndef _IIAES_
#define _IIAES_

#include <iiacllct.h>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__) 
#if defined (__RRBC_LIB__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

class IC_EXPORTC IAEqualitySequenceImpl : public IACollectionImpl {
public:

          ~IAEqualitySequenceImpl
                            ();

  virtual
  long     Compare          (IAEqualitySequenceImpl const&,
                             ICompFunc, void*) const;

  virtual
  bool     LocateFirst      (void const*, ICursorImpl&) const = 0;

  virtual
  bool     LocateLast       (void const*, ICursorImpl&) const = 0;

  virtual
  bool     LocatePrevious   (void const*, ICursorImpl&) const = 0;

  virtual
  bool     operator==       (IAEqualitySequenceImpl const&) const = 0;

  bool     operator!=       (IAEqualitySequenceImpl const&) const;

protected:

           IAEqualitySequenceImpl
                            (Ops&);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           Compare          (IAEqualitySequenceImpl const&,\
                             ICompFunc, void*) const,\
           LocateFirst      (void const*, ICursorImpl&) const,\
           LocateLast       (void const*, ICursorImpl&) const,\
           LocatePrevious   (void const*, ICursorImpl&) const,\
           operator==       (IAEqualitySequenceImpl const&) const,\
           operator!=       (IAEqualitySequenceImpl const&) const,\
           IAEqualitySequenceImpl\
                            (Ops&)\
                        )
#endif

};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#if defined (__SOM_ENABLED__) 
#pragma SOMAsDefault (pop)
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IIAES_
