// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// "Restricted Materials of IBM"
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 76 1.5.1.2 source/core/collect/iiaks.cpp, collection, ioc.v400, 000919  
#ifdef IC_PAGETUNE
  #define _IIAKS_CPP_
  #include <ipagetun.h>
#endif

#include <iiaks.h>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif


// ---
// IAKeySetImpl
// ---

// public members

IAKeySetImpl::
~IAKeySetImpl ()
{
}

// protected members

IAKeySetImpl::
IAKeySetImpl (Ops& ops)
: IACollectionImpl (ops)
{
}

bool
IAKeySetImpl::
LocateNextElementWithKey (void const*, ICursorImpl& cursor) const
{ cursor.Invalidate ();
  return false;
}

INumber
IAKeySetImpl::
NumberOfDifferentKeys () const
{ return NumberOfElements ();
}

INumber
IAKeySetImpl::
NumberOfElementsWithKey (void const* key) const
{ if (ContainsElementWithKey (key))
    return 1;
  else
    return 0;
}

INumber
IAKeySetImpl::
RemoveAllElementsWithKey (void const* key)
{ if (RemoveElementWithKey (key))
    return 1;
  else
    return 0;
}

bool
IAKeySetImpl::
SetToNextWithDifferentKey (ICursorImpl& cursor) const
{ return SetToNext (cursor);
}

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif
