// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 91 1.5.1.3 source/core/collect/iiaset.h, collection, ioc.v400, 000919 
#ifndef _IIASET_
#define _IIASET_

#include <iiacllct.h>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__) 
#if defined (__RRBC_LIB__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

class IC_EXPORTC IASetImpl : public IACollectionImpl {
public:

          ~IASetImpl
                            ();

  virtual
  void     Antivalence      (IASetImpl const&);

  virtual
  void     AddAntivalence   (IASetImpl const&,
                             IASetImpl const&); 

  virtual
  void     AddDifference    (IASetImpl const&,
                             IASetImpl const&); 

  virtual
  void     AddIntersection  (IASetImpl const&,
                             IASetImpl const&);

  virtual
  void     AddUnion         (IASetImpl const&,
                             IASetImpl const&);

  virtual
  void     Difference       (IASetImpl const&);

  virtual
  void     Intersection     (IASetImpl const&);

  virtual
  void     Union            (IASetImpl const&);

  virtual
  bool     operator==       (IASetImpl const&) const = 0;

  bool     operator!=       (IASetImpl const&) const;

protected:

           IASetImpl
                            (Ops&);

  bool     LocateNext       (void const*, ICursorImpl&) const;

  INumber  NumberOfOccurrences
                            (void const*) const;

  INumber  RemoveAllOccurrences
                            (void const*);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           Antivalence      (IASetImpl const&),\
           AddAntivalence   (IASetImpl const&,\
                             IASetImpl const&),\
           AddDifference    (IASetImpl const&,\
                             IASetImpl const&),\
           AddIntersection  (IASetImpl const&,\
                             IASetImpl const&),\
           AddUnion         (IASetImpl const&,\
                             IASetImpl const&),\
           Difference       (IASetImpl const&),\
           Intersection     (IASetImpl const&),\
           Union            (IASetImpl const&),\
           operator==       (IASetImpl const&) const,\
           operator!=       (IASetImpl const&) const,\
           IASetImpl\
                            (Ops&)\
                        )
#endif

};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#if defined (__SOM_ENABLED__) 
#pragma SOMAsDefault (pop)
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IIASET_
