// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 95 1.5.1.3 source/core/collect/iiasr.h, collection, ioc.v400, 000919 
#ifndef _IIASR_
#define _IIASR_

#include <iiacllct.h>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__) 
#if defined (__RRBC_LIB__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

class IC_EXPORTC IASortedRelationImpl : public IACollectionImpl {
public:

          ~IASortedRelationImpl
                            ();

  virtual
  void     Antivalence      (IASortedRelationImpl const&);

  virtual
  void     AddAntivalence   (IASortedRelationImpl const&,
                             IASortedRelationImpl const&); 

  virtual
  void     AddDifference    (IASortedRelationImpl const&,
                             IASortedRelationImpl const&); 

  virtual
  void     AddIntersection  (IASortedRelationImpl const&,
                             IASortedRelationImpl const&);

  virtual
  void     AddUnion         (IASortedRelationImpl const&,
                             IASortedRelationImpl const&);

  virtual
  long     Compare          (IASortedRelationImpl const&,
                             ICompFunc, void*) const;

  virtual
  void     Difference       (IASortedRelationImpl const&);

  virtual
  void     Intersection     (IASortedRelationImpl const&);

  virtual
  void     Union            (IASortedRelationImpl const&);

  virtual
  bool     operator==       (IASortedRelationImpl const&) const = 0;

  bool     operator!=       (IASortedRelationImpl const&) const;

protected:

           IASortedRelationImpl
                            (Ops&);

  INumber  NumberOfOccurrences
                            (void const*) const;

  INumber  RemoveAllOccurrences
                            (void const*);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           Antivalence      (IASortedRelationImpl const&),\
           AddAntivalence   (IASortedRelationImpl const&,\
                             IASortedRelationImpl const&),\
           AddDifference    (IASortedRelationImpl const&,\
                             IASortedRelationImpl const&),\
           AddIntersection  (IASortedRelationImpl const&,\
                             IASortedRelationImpl const&),\
           AddUnion         (IASortedRelationImpl const&,\
                             IASortedRelationImpl const&),\
           Compare          (IASortedRelationImpl const&,\
                             ICompFunc, void*) const,\
           Difference       (IASortedRelationImpl const&),\
           Intersection     (IASortedRelationImpl const&),\
           Union            (IASortedRelationImpl const&),\
           operator==       (IASortedRelationImpl const&) const,\
           operator!=       (IASortedRelationImpl const&) const,\
           IASortedRelationImpl\
                            (Ops&)\
                        )
#endif

};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#if defined (__SOM_ENABLED__) 
#pragma SOMAsDefault (pop)
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IIASR_
