// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 01 1.4.1.2 source/core/collect/iibagdil.c, collection, ioc.v400, 000919 
#ifndef _IIBAGDIL_C_
#define _IIBAGDIL_C_

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

// ---
// IBagAsDilTableOps
// ---

// public members

template <class Element, class ElementOps, class Implementation>
IBagAsDilTableOps <Element, ElementOps, Implementation>::
IBagAsDilTableOps (INumber numberOfElements)
: Inherited (__isDTSClass (Element)),
  ivBase (numberOfElements),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
IBagAsDilTableOps <Element, ElementOps, Implementation>::
IBagAsDilTableOps (INumber numberOfElements, void* opsArg)
: Inherited (__isDTSClass (Element)),
  ivBase (numberOfElements, opsArg),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
IBagAsDilTableOps <Element, ElementOps, Implementation>::
IBagAsDilTableOps
  (IBagAsDilTableOps
    <Element, ElementOps, Implementation> const& collection)
: Inherited (__isDTSClass (Element)),
  ivBase (collection.ivBase),
  ivImpl (*this, collection.ivImpl)
{
}

template <class Element, class ElementOps, class Implementation>
IBagAsDilTableOps <Element, ElementOps, Implementation>::
~IBagAsDilTableOps ()
{
}

template <class Element, class ElementOps, class Implementation>
IACollectionImpl*
IBagAsDilTableOps <Element, ElementOps, Implementation>::
Clone () const
{ return (Implementation*) *new Self (*this);
}

template <class Element, class ElementOps, class Implementation>
IBagAsDilTableOps <Element, ElementOps, Implementation>::
operator IKeyBagAsDilTableImpl& ()
{ return *(IKeyBagAsDilTableImpl*)ivBase;
}

template <class Element, class ElementOps, class Implementation>
IBagAsDilTableOps <Element, ElementOps, Implementation>::
operator Implementation* ()
{ ivImpl.CheckPointer (this);
  return &ivImpl;
}

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IIBAGDIL_C_
