// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 13 1.4.1.2 source/core/collect/iibagtab.c, collection, ioc.v400, 000919 
#ifndef _IIBAGTAB_C_
#define _IIBAGTAB_C_

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

// ---
// IBagAsTableOps
// ---

// public members

template <class Element, class ElementOps, class Implementation>
IBagAsTableOps <Element, ElementOps, Implementation>::
IBagAsTableOps (INumber numberOfElements)
: Inherited (__isDTSClass (Element)),
  ivBase (numberOfElements),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
IBagAsTableOps <Element, ElementOps, Implementation>::
IBagAsTableOps (INumber numberOfElements, void* opsArg)
: Inherited (__isDTSClass (Element)),
  ivBase (numberOfElements, opsArg),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
IBagAsTableOps <Element, ElementOps, Implementation>::
IBagAsTableOps
  (IBagAsTableOps
    <Element, ElementOps, Implementation> const& collection)
: Inherited (__isDTSClass (Element)),
  ivBase (collection.ivBase),
  ivImpl (*this, collection.ivImpl)
{
}

template <class Element, class ElementOps, class Implementation>
IBagAsTableOps <Element, ElementOps, Implementation>::
~IBagAsTableOps ()
{
}

template <class Element, class ElementOps, class Implementation>
IACollectionImpl*
IBagAsTableOps <Element, ElementOps, Implementation>::
Clone () const
{ return (Implementation*) *new Self (*this);
}

template <class Element, class ElementOps, class Implementation>
IBagAsTableOps <Element, ElementOps, Implementation>::
operator IKeyBagAsTableImpl& ()
{ return *(IKeyBagAsTableImpl*)ivBase;
}

template <class Element, class ElementOps, class Implementation>
IBagAsTableOps <Element, ElementOps, Implementation>::
operator Implementation* ()
{ ivImpl.CheckPointer (this);
  return &ivImpl;
}

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IIBAGTAB_C_
