// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 51 1.5.1.2 source/core/collect/iieslst.c, collection, ioc.v400, 000919 
#ifndef _IIESLST_C_
#define _IIESLST_C_

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

// ---
// IEqualitySequenceAsListOps
// ---

// public members

template <class Element, class ElementOps, class Implementation>
IEqualitySequenceAsListOps <Element, ElementOps, Implementation>::
IEqualitySequenceAsListOps (INumber numberOfElements)
: ivElementOps (),
  ivBase (numberOfElements),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
IEqualitySequenceAsListOps <Element, ElementOps, Implementation>::
IEqualitySequenceAsListOps (INumber numberOfElements, void* opsArg)
: ivElementOps (opsArg),
  ivBase (numberOfElements, opsArg),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
IEqualitySequenceAsListOps <Element, ElementOps, Implementation>::
IEqualitySequenceAsListOps
  (IEqualitySequenceAsListOps
    <Element, ElementOps, Implementation> const& collection)
: ivElementOps (collection.ivElementOps),
  ivBase (collection.ivBase),
  ivImpl (*this, collection.ivImpl)
{
}

template <class Element, class ElementOps, class Implementation>
IEqualitySequenceAsListOps <Element, ElementOps, Implementation>::
~IEqualitySequenceAsListOps ()
{
}

template <class Element, class ElementOps, class Implementation>
IACollectionImpl*
IEqualitySequenceAsListOps
 <Element, ElementOps, Implementation>::
Clone () const
{ return (Implementation*) *new Self (*this);
}

template <class Element, class ElementOps, class Implementation>
bool
IEqualitySequenceAsListOps
 <Element, ElementOps, Implementation>::
EqualElements (void const* element1, void const* element2) const
{ return ivElementOps.Equal (*(Element const*)element1,
                             *(Element const*)element2);
}

template <class Element, class ElementOps, class Implementation>
IEqualitySequenceAsListOps
 <Element, ElementOps, Implementation>::
operator ISequenceAsListImpl& ()
{ return *(ISequenceAsListImpl*)ivBase;
}

template <class Element, class ElementOps, class Implementation>
IEqualitySequenceAsListOps
 <Element, ElementOps, Implementation>::
operator Implementation* ()
{ ivImpl.CheckPointer (this);
  return &ivImpl;
}

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IIESLST_C_
