// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 57 1.5.1.2 source/core/collect/iiestab.c, collection, ioc.v400, 000919 
#ifndef _IIESTAB_C_
#define _IIESTAB_C_

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

// ---
// IEqualitySequenceAsTableOps
// ---

// public members

template <class Element, class ElementOps, class Implementation>
IEqualitySequenceAsTableOps <Element, ElementOps, Implementation>::
IEqualitySequenceAsTableOps (INumber numberOfElements)
: ivElementOps (),
  ivBase (numberOfElements),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
IEqualitySequenceAsTableOps <Element, ElementOps, Implementation>::
IEqualitySequenceAsTableOps (INumber numberOfElements, void* opsArg)
: ivElementOps (opsArg),
  ivBase (numberOfElements, opsArg),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
IEqualitySequenceAsTableOps <Element, ElementOps, Implementation>::
IEqualitySequenceAsTableOps
  (IEqualitySequenceAsTableOps
    <Element, ElementOps, Implementation> const& collection)
: ivElementOps (collection.ivElementOps),
  ivBase (collection.ivBase),
  ivImpl (*this, collection.ivImpl)
{
}

template <class Element, class ElementOps, class Implementation>
IEqualitySequenceAsTableOps <Element, ElementOps, Implementation>::
~IEqualitySequenceAsTableOps ()
{
}

template <class Element, class ElementOps, class Implementation>
IACollectionImpl*
IEqualitySequenceAsTableOps
 <Element, ElementOps, Implementation>::
Clone () const
{ return (Implementation*) *new Self (*this);
}

template <class Element, class ElementOps, class Implementation>
bool
IEqualitySequenceAsTableOps
 <Element, ElementOps, Implementation>::
EqualElements (void const* element1, void const* element2) const
{ return ivElementOps.Equal (*(Element const*)element1,
                             *(Element const*)element2);
}

template <class Element, class ElementOps, class Implementation>
IEqualitySequenceAsTableOps
 <Element, ElementOps, Implementation>::
operator ISequenceAsTableImpl& ()
{ return *(ISequenceAsTableImpl*)ivBase;
}

template <class Element, class ElementOps, class Implementation>
IEqualitySequenceAsTableOps
 <Element, ElementOps, Implementation>::
operator Implementation* ()
{ ivImpl.CheckPointer (this);
  return &ivImpl;
}

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IIESTAB_C_
