// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 72 1.4.1.2 source/core/collect/iihptab.c, collection, ioc.v400, 000919 
#ifndef _IIHPTAB_C_
#define _IIHPTAB_C_

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

// ---
// IHeapAsTableOps
// ---

// public members

template <class Element, class ElementOps, class Implementation>
IHeapAsTableOps <Element, ElementOps, Implementation>::
IHeapAsTableOps (INumber numberOfElements)
: ivBase (numberOfElements),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
IHeapAsTableOps <Element, ElementOps, Implementation>::
IHeapAsTableOps (INumber numberOfElements, void* opsArg)
: ivBase (numberOfElements, opsArg),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
IHeapAsTableOps <Element, ElementOps, Implementation>::
IHeapAsTableOps
  (IHeapAsTableOps
    <Element, ElementOps, Implementation> const& collection)
: ivBase (collection.ivBase),
  ivImpl (*this, collection.ivImpl)
{
}

template <class Element, class ElementOps, class Implementation>
IHeapAsTableOps <Element, ElementOps, Implementation>::
~IHeapAsTableOps ()
{
}

template <class Element, class ElementOps, class Implementation>
IACollectionImpl*
IHeapAsTableOps <Element, ElementOps, Implementation>::
Clone () const
{ return (Implementation*) *new Self (*this);
}

template <class Element, class ElementOps, class Implementation>
IHeapAsTableOps <Element, ElementOps, Implementation>::
operator ISequenceAsTableImpl& ()
{ return *(ISequenceAsTableImpl*)ivBase;
}

template <class Element, class ElementOps, class Implementation>
IHeapAsTableOps <Element, ElementOps, Implementation>::
operator Implementation* ()
{ ivImpl.CheckPointer (this);
  return &ivImpl;
}

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IIHPTAB_C_
