// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 75 1.4.1.2 source/core/collect/iikbdil.c, collection, ioc.v400, 000919 
#ifndef _IIKBDIL_C_
#define _IIKBDIL_C_

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

// ---
// IKeyBagAsDilTableOps
// ---

// public members

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeyBagAsDilTableOps <Element, Key, ElementOps, Implementation>::
IKeyBagAsDilTableOps (INumber numberOfElements)
: ivBase (numberOfElements),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeyBagAsDilTableOps <Element, Key, ElementOps, Implementation>::
IKeyBagAsDilTableOps (INumber numberOfElements, void* opsArg)
: ivBase (numberOfElements, opsArg),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeyBagAsDilTableOps <Element, Key, ElementOps, Implementation>::
IKeyBagAsDilTableOps
  (IKeyBagAsDilTableOps
    <Element, Key, ElementOps, Implementation> const& collection)
: ivBase (collection.ivBase),
  ivImpl (*this, collection.ivImpl)
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeyBagAsDilTableOps <Element, Key, ElementOps, Implementation>::
~IKeyBagAsDilTableOps ()
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IACollectionImpl*
IKeyBagAsDilTableOps <Element, Key, ElementOps, Implementation>::
Clone () const
{ return (Implementation*) *new Self (*this);
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeyBagAsDilTableOps <Element, Key, ElementOps, Implementation>::
operator IKeySortedBagAsDilTableImpl& ()
{ return *(IKeySortedBagAsDilTableImpl*)ivBase ;
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeyBagAsDilTableOps <Element, Key, ElementOps, Implementation>::
operator Implementation* ()
{ ivImpl.CheckPointer (this);
  return &ivImpl ;
}

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IIKBDIL_C_
