// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 88 1.4.1.2 source/core/collect/iikbtab.c, collection, ioc.v400, 000919 
#ifndef _IIKBTAB_C_
#define _IIKBTAB_C_

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

// ---
// IKeyBagAsTableOps
// ---

// public members

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeyBagAsTableOps <Element, Key, ElementOps, Implementation>::
IKeyBagAsTableOps (INumber numberOfElements)
: ivBase (numberOfElements),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeyBagAsTableOps <Element, Key, ElementOps, Implementation>::
IKeyBagAsTableOps (INumber numberOfElements, void* opsArg)
: ivBase (numberOfElements, opsArg),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeyBagAsTableOps <Element, Key, ElementOps, Implementation>::
IKeyBagAsTableOps
  (IKeyBagAsTableOps
    <Element, Key, ElementOps, Implementation> const& collection)
: ivBase (collection.ivBase),
  ivImpl (*this, collection.ivImpl)
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeyBagAsTableOps <Element, Key, ElementOps, Implementation>::
~IKeyBagAsTableOps ()
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IACollectionImpl*
IKeyBagAsTableOps <Element, Key, ElementOps, Implementation>::
Clone () const
{ return (Implementation*) *new Self (*this);
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeyBagAsTableOps <Element, Key, ElementOps, Implementation>::
operator IKeySortedBagAsTableImpl& ()
{ return *(IKeySortedBagAsTableImpl*)ivBase ;
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeyBagAsTableOps <Element, Key, ElementOps, Implementation>::
operator Implementation* ()
{ ivImpl.CheckPointer (this);
  return &ivImpl ;
}

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IIKBTAB_C_
