// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 91 1.5.1.3 source/core/collect/iikeyops.h, collection, ioc.v400, 000919 
#ifndef _IIKEYOPS_
#define _IIKEYOPS_

#include <iiglobal.h>
#include <iistream.h>
#include <inumpos.h>
#include <stddef.h>

#if defined (__OSTORE__)
#include <ostore/ostore.hh>
#include <ostore/manschem.hh>
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__)
#pragma SOMAsDefault(off)
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

// indirection for keys

template <class Key>
void* IKeyFromOps (Key const&);

template <class Key>
Key const& IKeyForOps (Key const*);

#pragma pack(push,4)
#pragma enum(4)

// key extension

template <class Element, class ElementOps>
class IC_EXPORTC IOpsWithKey : public ElementOps {
public:

  ElementOps
           keyOps;

           IOpsWithKey      ();

           IOpsWithKey      (void*);

  Element const&
           Key              (Element const&) const;

protected:

private:

};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#if defined (__SOM_ENABLED__)
#pragma SOMAsDefault(pop)
#endif

#include <iikeyops.inl>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IIKEYOPS_
