// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 64 1.5.1.2 source/core/collect/iimaplst.c, collection, ioc.v400, 000919 
#ifndef _IIMAPLST_C_
#define _IIMAPLST_C_

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

// ---
// IMapAsListOps
// ---

// public members

template <class Element, class Key,
          class ElementOps, class Implementation>
IMapAsListOps <Element, Key, ElementOps, Implementation>::
IMapAsListOps (INumber numberOfElements)
: ivElementOps (),
  ivBase (numberOfElements),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IMapAsListOps <Element, Key, ElementOps, Implementation>::
IMapAsListOps (INumber numberOfElements, void* opsArg)
: ivElementOps (opsArg),
  ivBase (numberOfElements, opsArg),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IMapAsListOps <Element, Key, ElementOps, Implementation>::
IMapAsListOps
  (IMapAsListOps
    <Element, Key, ElementOps, Implementation> const& collection)
: ivElementOps (collection.ivElementOps),
  ivBase (collection.ivBase),
  ivImpl (*this, collection.ivImpl)
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IMapAsListOps <Element, Key, ElementOps, Implementation>::
~IMapAsListOps ()
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IACollectionImpl*
IMapAsListOps <Element, Key, ElementOps, Implementation>::
Clone () const
{ return (Implementation*) *new Self (*this);
}

template <class Element, class Key,
          class ElementOps, class Implementation>
bool
IMapAsListOps <Element, Key, ElementOps, Implementation>::
EqualElements (void const* element1, void const* element2) const
{ return ivElementOps.Equal (*(Element const*)element1,
                             *(Element const*)element2);
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IMapAsListOps <Element, Key, ElementOps, Implementation>::
operator IKeySetAsListImpl& ()
{ return *(IKeySetAsListImpl*) ivBase;
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IMapAsListOps <Element, Key, ElementOps, Implementation>::
operator Implementation* ()
{ ivImpl.CheckPointer (this);
  return &ivImpl;
}

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IIMAPLST_C_
