// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 86 1.5.1.2 source/core/collect/iireltab.c, collection, ioc.v400, 000919 
#ifndef _IIRELTAB_C_
#define _IIRELTAB_C_

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

// ---
// IRelationAsTableOps
// ---

// public members

template <class Element, class Key,
          class ElementOps, class Implementation>
IRelationAsTableOps
 <Element, Key, ElementOps, Implementation>::
IRelationAsTableOps (INumber numberOfElements)
: ivElementOps (),
  ivBase (numberOfElements),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IRelationAsTableOps
  <Element, Key, ElementOps, Implementation>::
IRelationAsTableOps (INumber numberOfElements, void* opsArg)
: ivElementOps (opsArg),
  ivBase (numberOfElements, opsArg),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IRelationAsTableOps
 <Element, Key, ElementOps, Implementation>::
IRelationAsTableOps
  (IRelationAsTableOps
    <Element, Key, ElementOps, Implementation> const& collection)
: ivElementOps (collection.ivElementOps),
  ivBase (collection.ivBase),
  ivImpl (*this, collection.ivImpl)
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IRelationAsTableOps
 <Element, Key, ElementOps, Implementation>::
~IRelationAsTableOps ()
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IACollectionImpl*
IRelationAsTableOps
 <Element, Key, ElementOps, Implementation>::
Clone () const
{ return (Implementation*) *new Self (*this);
}

template <class Element, class Key,
          class ElementOps, class Implementation>
bool
IRelationAsTableOps
 <Element, Key, ElementOps, Implementation>::
EqualElements (void const* element1, void const* element2) const
{ return ivElementOps.Equal (*(Element const*)element1,
                             *(Element const*)element2);
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IRelationAsTableOps
 <Element, Key, ElementOps, Implementation>::
operator IKeyBagAsTableImpl& ()
{ return *(IKeyBagAsTableImpl*) ivBase;
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IRelationAsTableOps
 <Element, Key, ElementOps, Implementation>::
operator Implementation* ()
{ ivImpl.CheckPointer (this);
  return &ivImpl;
}

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IIRELTAB_C_
