// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 89 1.4.1.2 source/core/collect/iisbdil.c, collection, ioc.v400, 000919 
#ifndef _IISBDIL_C_
#define _IISBDIL_C_

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

// ---
// ISortedBagAsDilTableOps
// ---

// public members

template <class Element, class ElementOps, class Implementation>
ISortedBagAsDilTableOps <Element, ElementOps, Implementation>::
ISortedBagAsDilTableOps (INumber numberOfElements)
: Inherited (__isDTSClass (Element)),
  ivBase (numberOfElements),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
ISortedBagAsDilTableOps <Element, ElementOps, Implementation>::
ISortedBagAsDilTableOps (INumber numberOfElements, void* opsArg)
: Inherited (__isDTSClass (Element)),
  ivBase (numberOfElements, opsArg),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
ISortedBagAsDilTableOps <Element, ElementOps, Implementation>::
ISortedBagAsDilTableOps
  (ISortedBagAsDilTableOps
    <Element, ElementOps, Implementation> const& collection)
: Inherited (__isDTSClass (Element)),
  ivBase (collection.ivBase),
  ivImpl (*this, collection.ivImpl)
{
}

template <class Element, class ElementOps, class Implementation>
ISortedBagAsDilTableOps <Element, ElementOps, Implementation>::
~ISortedBagAsDilTableOps ()
{
}

template <class Element, class ElementOps, class Implementation>
IACollectionImpl*
ISortedBagAsDilTableOps <Element, ElementOps, Implementation>::
Clone () const
{ return (Implementation*) *new Self (*this);
}

template <class Element, class ElementOps, class Implementation>
ISortedBagAsDilTableOps <Element, ElementOps, Implementation>::
operator IKeySortedBagAsDilTableImpl& ()
{ return *(IKeySortedBagAsDilTableImpl*)ivBase;
}

template <class Element, class ElementOps, class Implementation>
ISortedBagAsDilTableOps <Element, ElementOps, Implementation>::
operator Implementation* ()
{ ivImpl.CheckPointer (this);
  return &ivImpl;
}

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IISBDIL_C_
