// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 04 1.4.1.2 source/core/collect/iiseqdil.inl, collection, ioc.v400, 000919 
#ifndef _IISEQDIL_INL_
#define _IISEQDIL_INL_

// ---------------------------
// ISequenceAsDilTableNodeImpl
// ---------------------------

// public members

template <class Element>
inline
ISequenceAsDilTableNodeImpl <Element>::
ISequenceAsDilTableNodeImpl (Element const& element)
: ivElement (element)
{
}

#if ! defined(__INO_STREAMING__)
template <class Element>
inline void
ISequenceAsDilTableNodeImpl<Element>::
StreamIn (IACollectionStreamer *streamer, IDataStream& fromWhere)
{ streamer->streamIn (fromWhere, &ivElement);
}
#endif

template <class Element>
inline
ISequenceAsDilTableNodeImpl <Element>::
~ISequenceAsDilTableNodeImpl ()
{
}

// -----------------------------
// ISequenceAsDilTableCursorImpl
// -----------------------------

// public members

inline void
ISequenceAsDilTableCursorImpl::
Invalidate ()
{ ivIndex = 0;
}

inline bool
ISequenceAsDilTableCursorImpl::
IsInBetween () const
{ return false;
}

inline bool
ISequenceAsDilTableCursorImpl::
IsValid () const
{ return (ivIndex != 0);
}

inline void
ISequenceAsDilTableCursorImpl::
operator= (ISequenceAsDilTableCursorImpl const& cursor)
{ Inherited::operator= (cursor);
  ivIndex = cursor.ivIndex;
}

inline bool
ISequenceAsDilTableCursorImpl::
operator== (ICursorImpl const& cursor) const
{ return (Inherited::operator== (cursor) &&
          ivIndex == ((Self const&)cursor).ivIndex);
}

// -----------------------
// IASequenceAsDilTableOps
// -----------------------

// public members

inline
IASequenceAsDilTableOps::
~IASequenceAsDilTableOps ()
{
}

// protected members

inline
IASequenceAsDilTableOps::
IASequenceAsDilTableOps (bool containsDTSObjects)
: ivContainsDTSObjects (containsDTSObjects)
{
}

#endif // _IISEQDIL_INL_
