// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 08 1.4.1.2 source/core/collect/iiseqlst.inl, collection, ioc.v400, 000919 
#ifndef _IISEQLST_INL_
#define _IISEQLST_INL_

// -----------------------
// ISequenceAsListNodeImpl
// -----------------------

// public members

template <class Element>
inline
ISequenceAsListNodeImpl <Element>::
ISequenceAsListNodeImpl (Element const& element)
: ivNext (0), ivPrevious (0), ivElement (element)
{
}

template <class Element>
inline
ISequenceAsListNodeImpl <Element>::
~ISequenceAsListNodeImpl ()
{
}

#if ! defined(__INO_STREAMING__)
template <class Element>
inline void
ISequenceAsListNodeImpl<Element>::
StreamIn (IACollectionStreamer *streamer, IDataStream& fromWhere)
{ ivNext = ivPrevious = 0;
  streamer->streamIn(fromWhere, &ivElement);
}
#endif

// -------------------------
// ISequenceAsListCursorImpl
// -------------------------

// public members

inline void
ISequenceAsListCursorImpl::
Invalidate ()
{ ivNode = 0;
}

inline bool
ISequenceAsListCursorImpl::
IsInBetween () const
{ return false;
}

inline bool
ISequenceAsListCursorImpl::
IsValid () const
{ return (ivNode != 0);
}

inline void
ISequenceAsListCursorImpl::
operator= (ISequenceAsListCursorImpl const& cursor)
{ Inherited::operator= (cursor);
  ivNode = cursor.ivNode;
}

inline bool
ISequenceAsListCursorImpl::
operator== (ICursorImpl const& cursor) const
{ return (Inherited::operator== (cursor) &&
          ivNode == ((Self const&)cursor).ivNode);
}

// -------------------
// IASequenceAsListOps
// -------------------

// public members

inline
IASequenceAsListOps::
~IASequenceAsListOps ()
{
}

// protected members

inline
IASequenceAsListOps::
IASequenceAsListOps (bool containsDTSObjects)
: ivContainsDTSObjects (containsDTSObjects)
{
}

#endif // _IISEQLST_INL_
