// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 22 1.4.1.2 source/core/collect/iisethsh.c, collection, ioc.v400, 000919 
#ifndef _IISETHSH_C_
#define _IISETHSH_C_

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

// ---
// ISetAsHshTableOps
// ---

// public members

template <class Element, class ElementOps, class Implementation>
ISetAsHshTableOps <Element, ElementOps, Implementation>::
ISetAsHshTableOps (INumber numberOfElements)
: ivBase (numberOfElements),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
ISetAsHshTableOps <Element, ElementOps, Implementation>::
ISetAsHshTableOps (INumber numberOfElements, void* opsArg)
: ivBase (numberOfElements, opsArg),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
ISetAsHshTableOps <Element, ElementOps, Implementation>::
ISetAsHshTableOps
  (ISetAsHshTableOps
    <Element, ElementOps, Implementation> const& collection)
: ivBase (collection.ivBase),
  ivImpl (*this, collection.ivImpl)
{
}

template <class Element, class ElementOps, class Implementation>
ISetAsHshTableOps <Element, ElementOps, Implementation>::
~ISetAsHshTableOps ()
{
}

template <class Element, class ElementOps, class Implementation>
IACollectionImpl*
ISetAsHshTableOps <Element, ElementOps, Implementation>::
Clone () const
{ return (Implementation*) *new Self (*this);
}

template <class Element, class ElementOps, class Implementation>
ISetAsHshTableOps <Element, ElementOps, Implementation>::
operator IKeySetAsHshTableImpl& ()
{ return *(IKeySetAsHshTableImpl*)ivBase ;
}

template <class Element, class ElementOps, class Implementation>
ISetAsHshTableOps <Element, ElementOps, Implementation>::
operator Implementation* ()
{ ivImpl.CheckPointer (this);
  return &ivImpl ;
}

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IISETHSH_C_
