// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 26 1.6.1.3 source/core/collect/iisetks.h, collection, ioc.v400, 000919 
#ifndef _IISETKS_
#define _IISETKS_

#include <ilanglvl.hpp>
#include <iiaset.h>

#if defined (__OSTORE__)
#include <ostore/ostore.hh>
#include <ostore/manschem.hh>
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__)
#if defined (__RRBC_LIB__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

template <class Base>
class ISetOnKeySetMngCursorImpl;

template <class Base>
class ISetOnKeySetImpl;

#pragma pack(push,4)
#pragma enum(4)

template <class Base>
class IC_EXPORTC ISetOnKeySetMngCursorImpl : public Base::MngCursor {

  typedef TYPENAME Base::MngCursor Inherited;

public:

           ISetOnKeySetMngCursorImpl
                            (ISetOnKeySetImpl <Base> const&);

          ~ISetOnKeySetMngCursorImpl
                            ();

protected:

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
            ISetOnKeySetMngCursorImpl\
                            (ISetOnKeySetImpl <Base> const&)\
                        )
#endif

};

template <class Base>
class IASetOnKeySetOps;

template <class Base>
class IC_EXPORTC ISetOnKeySetImpl : public IASetImpl {

  typedef  IASetImpl Inherited;

  typedef  ISetOnKeySetImpl <Base> Self;

public:

  typedef  IASetOnKeySetOps <Base> Ops;

  typedef TYPENAME Base::Cursor Cursor;

  typedef  ISetOnKeySetMngCursorImpl <Base> MngCursor;

           ISetOnKeySetImpl (Ops&, INumber);

           ISetOnKeySetImpl (Ops&, ISetOnKeySetImpl <Base> const&);

          ~ISetOnKeySetImpl ();

  bool Add              (void const*, ICursorImpl&);

  void     AddAllFrom       (IACollectionImpl const&);

  bool AllElementsDo    (IApplFunc, void*);

  void*    Any              () const;

  bool CheckCursor      (ICursorImpl const&) const;

  bool CheckReplacement (ICursorImpl const&, void const*) const;

  char const*
           ClassName        () const;

  IACollectionImpl*
           Clone            () const;

  bool Contains         (void const*) const;

  bool ContainsAllFrom  (IACollectionImpl const&) const;

  void     Copy             (IACollectionImpl const&);

  Cursor*  CreateCursor     () const;

  MngCursor*
           CreateMngCursor  () const;

  void*    ElementAt        (ICursorImpl const&) const;

  bool IsBounded        () const;

  bool IsConsistent     () const;

  bool IsEmpty          () const;

  bool IsFull           () const;

  bool Locate           (void const*, ICursorImpl&) const;

  bool LocateOrAdd      (void const*, ICursorImpl&);

  INumber  NumberOfElements () const;

  bool Remove           (void const*);

  INumber  RemoveAll        ();

  INumber  RemoveAll        (IPredFunc, void*);

  void     RemoveAt         (ICursorImpl&);

  void     ReplaceAt        (ICursorImpl const&, void const*);

  bool SetToFirst       (ICursorImpl&) const;

  bool SetToNext        (ICursorImpl&) const;

  void     operator=        (ISetOnKeySetImpl <Base> const&);

  bool operator==       (IASetImpl const&) const;

protected:

private:

  static
  char const*
           cvClassName;

  Base&    ivBase;

  static
  Base&    BaseOf           (ISetOnKeySetImpl <Base> const&);

  static
  Ops&     OpsOf            (ISetOnKeySetImpl <Base> const&);

  friend
  class    ISetOnKeySetMngCursorImpl <Base>;

#if ! defined (__INO_STREAMING__)
public:
  IStreamerPtr&
           StreamerOf       (IACollectionImpl const&);

  void     StreamIn         (IDataStream&);

  void     StreamOut        (IDataStream&) const;

  void     AdoptStreamer    (IACollectionStreamer*);
#endif

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           ISetOnKeySetImpl (Ops&, INumber),\
           ISetOnKeySetImpl (Ops&, ISetOnKeySetImpl <Base> const&),\
           CheckCursor      (ICursorImpl const&) const ,\
           CheckReplacement (ICursorImpl const&, void const*) const ,\
           operator=,\
           cvClassName,\
           BaseOf           (ISetOnKeySetImpl <Base> const&),\
           OpsOf            (ISetOnKeySetImpl <Base> const&)\
#if ! defined (__INO_STREAMING__)
           ,StreamerOf       (IACollectionImpl const&)\
           ,StreamIn         (IDataStream&)\
           ,StreamOut        (IDataStream&) const\
           ,AdoptStreamer    (IACollectionStreamer*)\
#endif
                        )
#endif

};

template <class Base>
class IC_EXPORTC IASetOnKeySetOps {
public:

  virtual ~IASetOnKeySetOps ();

  virtual
  IACollectionImpl*
           Clone            () const = 0;

  virtual  operator Base&   () = 0;

protected:

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMReleaseOrder (\
           Clone            () const,\
           operator Base&   ()\
                        )
#endif

};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#if defined (__SOM_ENABLED__)
#pragma SOMAsDefault (pop)
#endif

#include <iisetks.inl>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IISETKS_
