// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 31 1.4.1.2 source/core/collect/iisettab.c, collection, ioc.v400, 000919 
#ifndef _IISETTAB_C_
#define _IISETTAB_C_

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

// ---
// ISetAsTableOps
// ---

// public members

template <class Element, class ElementOps, class Implementation>
ISetAsTableOps <Element, ElementOps, Implementation>::
ISetAsTableOps (INumber numberOfElements)
: ivBase (numberOfElements),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
ISetAsTableOps <Element, ElementOps, Implementation>::
ISetAsTableOps (INumber numberOfElements, void* opsArg)
: ivBase (numberOfElements, opsArg),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
ISetAsTableOps <Element, ElementOps, Implementation>::
ISetAsTableOps
  (ISetAsTableOps
    <Element, ElementOps, Implementation> const& collection)
: ivBase (collection.ivBase),
  ivImpl (*this, collection.ivImpl)
{
}

template <class Element, class ElementOps, class Implementation>
ISetAsTableOps <Element, ElementOps, Implementation>::
~ISetAsTableOps ()
{
}

template <class Element, class ElementOps, class Implementation>
IACollectionImpl*
ISetAsTableOps <Element, ElementOps, Implementation>::
Clone () const
{ return (Implementation*) *new Self (*this);
}

template <class Element, class ElementOps, class Implementation>
ISetAsTableOps <Element, ElementOps, Implementation>::
operator IKeySetAsTableImpl& ()
{ return *(IKeySetAsTableImpl*)ivBase ;
}

template <class Element, class ElementOps, class Implementation>
ISetAsTableOps <Element, ElementOps, Implementation>::
operator Implementation* ()
{ ivImpl.CheckPointer (this);
  return &ivImpl ;
}

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IISETTAB_C_
