// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 70 1.4.1.2 source/core/collect/iissdil.c, collection, ioc.v400, 000919 
#ifndef _IISSDIL_C_
#define _IISSDIL_C_

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

// ---
// ISortedSetAsDilTableOps
// ---

// public members

template <class Element, class ElementOps, class Implementation>
ISortedSetAsDilTableOps <Element, ElementOps, Implementation>::
ISortedSetAsDilTableOps (INumber numberOfElements)
: ivBase (numberOfElements),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
ISortedSetAsDilTableOps <Element, ElementOps, Implementation>::
ISortedSetAsDilTableOps (INumber numberOfElements, void* opsArg)
: ivBase (numberOfElements, opsArg),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
ISortedSetAsDilTableOps <Element, ElementOps, Implementation>::
ISortedSetAsDilTableOps
  (ISortedSetAsDilTableOps
    <Element, ElementOps, Implementation> const& collection)
: ivBase (collection.ivBase),
  ivImpl (*this, collection.ivImpl)
{
}

template <class Element, class ElementOps, class Implementation>
ISortedSetAsDilTableOps <Element, ElementOps, Implementation>::
~ISortedSetAsDilTableOps ()
{
}

template <class Element, class ElementOps, class Implementation>
IACollectionImpl*
ISortedSetAsDilTableOps <Element, ElementOps, Implementation>::
Clone () const
{ return (Implementation*) *new Self (*this);
}

template <class Element, class ElementOps, class Implementation>
ISortedSetAsDilTableOps <Element, ElementOps, Implementation>::
operator IKeySortedSetAsDilTableImpl& ()
{ return *(IKeySortedSetAsDilTableImpl*)ivBase ;
}

template <class Element, class ElementOps, class Implementation>
ISortedSetAsDilTableOps <Element, ElementOps, Implementation>::
operator Implementation* ()
{ ivImpl.CheckPointer (this);
  return &ivImpl ;
}

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IISSDIL_C_
