// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 76 1.4.1.2 source/core/collect/iisslst.c, collection, ioc.v400, 000919 
#ifndef _IISSLST_C_
#define _IISSLST_C_

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

// ---
// ISortedSetAsListOps
// ---

// public members

template <class Element, class ElementOps, class Implementation>
ISortedSetAsListOps <Element, ElementOps, Implementation>::
ISortedSetAsListOps (INumber numberOfElements)
: ivBase (numberOfElements),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
ISortedSetAsListOps <Element, ElementOps, Implementation>::
ISortedSetAsListOps (INumber numberOfElements, void* opsArg)
: ivBase (numberOfElements, opsArg),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
ISortedSetAsListOps <Element, ElementOps, Implementation>::
ISortedSetAsListOps
  (ISortedSetAsListOps
    <Element, ElementOps, Implementation> const& collection)
: ivBase (collection.ivBase),
  ivImpl (*this, collection.ivImpl)
{
}

template <class Element, class ElementOps, class Implementation>
ISortedSetAsListOps <Element, ElementOps, Implementation>::
~ISortedSetAsListOps ()
{
}

template <class Element, class ElementOps, class Implementation>
IACollectionImpl*
ISortedSetAsListOps <Element, ElementOps, Implementation>::
Clone () const
{ return (Implementation*) *new Self (*this);
}

template <class Element, class ElementOps, class Implementation>
ISortedSetAsListOps <Element, ElementOps, Implementation>::
operator IKeySortedSetAsListImpl& ()
{ return *(IKeySortedSetAsListImpl*)ivBase ;
}

template <class Element, class ElementOps, class Implementation>
ISortedSetAsListOps <Element, ElementOps, Implementation>::
operator Implementation* ()
{ ivImpl.CheckPointer (this);
  return &ivImpl ;
}

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IISSLST_C_
