// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 43 1.4.1.4 source/core/collect/iksblst.inl, collection, ioc.v400, 000919  
#ifndef _IKSBLST_INL_
#define _IKSBLST_INL_

// ---
// IGKeySortedBagAsListCursor
// ---

#include <ilanglvl.hpp>

// public members

template <class Element, class Key, class ElementOps>
inline
IGKeySortedBagAsListCursor <Element, Key, ElementOps>::
IGKeySortedBagAsListCursor
  (IGKeySortedBagAsList
    <Element, Key, ElementOps> const& collection)
: IOrderedCursor <Element>
    (collection.ivImpl->CreateCursor ())
{
}

template <class Element, class Key, class ElementOps>
inline IGKeySortedBagAsListCursor <Element, Key, ElementOps>&
IGKeySortedBagAsListCursor <Element, Key, ElementOps>::
operator=
  (IGKeySortedBagAsListCursor
    <Element, Key, ElementOps> const& cursor)
{ Inherited::operator= (cursor);
  return *this;
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGKeySortedBagAsListCursor <Element, Key, ElementOps>::
IGKeySortedBagAsListCursor (ICursorImpl* impl)
: IOrderedCursor <Element> (impl)
{
}

#if ! defined (__INO_MNGCURSOR__)
// ---
// IGKeySortedBagAsListMngCursor
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IGKeySortedBagAsListMngCursor <Element, Key, ElementOps>::
IGKeySortedBagAsListMngCursor
  (IGKeySortedBagAsList
    <Element, Key, ElementOps> const& collection)
: IGKeySortedBagAsListCursor <Element, Key, ElementOps>
    (collection.ivImpl->CreateMngCursor ())
{
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGKeySortedBagAsListMngCursor <Element, Key, ElementOps>::
IGKeySortedBagAsListMngCursor (ICursorImpl* impl)
: IGKeySortedBagAsListCursor <Element, Key, ElementOps> (impl)
{
}

#endif
// ---
// IGKeySortedBagAsList
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IGKeySortedBagAsList <Element, Key, ElementOps>::
IGKeySortedBagAsList (INumber numberOfElements)
{ this->SetImpl ((Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements));
}

template <class Element, class Key, class ElementOps>
inline
IGKeySortedBagAsList <Element, Key, ElementOps>::
IGKeySortedBagAsList
  (IGKeySortedBagAsList
    <Element, Key, ElementOps> const& collection)
{ this->CloneImplOf (collection);
}

template <class Element, class Key, class ElementOps>
inline IGKeySortedBagAsList <Element, Key, ElementOps>&
IGKeySortedBagAsList <Element, Key, ElementOps>::
operator= (IGKeySortedBagAsList
            <Element, Key, ElementOps> const& collection)
{ this->ImplOf (*this).Copy (this->ImplOf (collection));
  return *this;
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGKeySortedBagAsList <Element, Key, ElementOps>::
IGKeySortedBagAsList (PureImplementation& impl)
{ this->SetImpl (&impl);
}

template <class Element, class Key, class ElementOps>
inline TYPENAME IGKeySortedBagAsList
 <Element, Key, ElementOps>::Implementation&
IGKeySortedBagAsList <Element, Key, ElementOps>::
ImplOf (IGKeySortedBagAsList
         <Element, Key, ElementOps> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

// ---
// IKeySortedBagAsList
// ---

// public members

template <class Element, class Key>
inline
IKeySortedBagAsList <Element, Key>::
IKeySortedBagAsList (INumber numberOfElements)
: IGKeySortedBagAsList
   <Element, Key, IKCOps <Element, Key> > (numberOfElements)
{
}

// protected members

template <class Element, class Key>
inline
IKeySortedBagAsList <Element, Key>::
IKeySortedBagAsList (PureImplementation& impl)
: IGKeySortedBagAsList
   <Element, Key, IKCOps <Element, Key> > (impl)
{
}
#if ! defined (__INO_AVALON__)

// ---
// IVGKeySortedBagAsList
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IVGKeySortedBagAsList <Element, Key, ElementOps>::
IVGKeySortedBagAsList (INumber numberOfElements)
: IGKeySortedBagAsList
    <Element, Key, ElementOps> (*(Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements))
{
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IVGKeySortedBagAsList <Element, Key, ElementOps>::
IVGKeySortedBagAsList (PureImplementation& impl)
: IGKeySortedBagAsList
    <Element, Key, ElementOps> (impl)
{
}

// ---
// IVKeySortedBagAsList
// ---

// public members

template <class Element, class Key>
inline
IVKeySortedBagAsList <Element, Key>::
IVKeySortedBagAsList (INumber numberOfElements)
: IVGKeySortedBagAsList
   <Element, Key, IKCOps <Element, Key> > (numberOfElements)
{
}

// protected members

template <class Element, class Key>
inline
IVKeySortedBagAsList <Element, Key>::
IVKeySortedBagAsList (PureImplementation& impl)
: IVGKeySortedBagAsList
   <Element, Key, IKCOps <Element, Key> > (impl)
{
}
#endif

#endif // _IKSBLST_INL_
