// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 60 1.5.1.4 source/core/collect/ikssbst.h, collection, ioc.v400, 000919 
#ifndef _IKSSBST_
#define _IKSSBST_

#include <ilanglvl.hpp>
#include <iakss.h>
#include <iickss.h>
#if ! defined (__INO_AVALON__)
#include <iivkss.h>
#endif
#include <iikssbst.h>

#if defined (__OSTORE__)
#include <ostore/ostore.hh>
#include <ostore/manschem.hh>
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__)
#if defined (__RRBC_IBM__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

template <class Element, class Key, class ElementOps>
class IGKeySortedSetAsBstTree;

#pragma pack(push,4)
#pragma enum(4)

template <class Element, class Key, class ElementOps>
class IGKeySortedSetAsBstTreeCursor :
  public IOrderedCursor <Element> {

  typedef  IOrderedCursor <Element> Inherited;

  typedef TYPENAME IGKeySortedSetAsBstTree
            <Element, Key, ElementOps>::
              Implementation::Cursor Implementation;

public:

           IGKeySortedSetAsBstTreeCursor
                            (IGKeySortedSetAsBstTree
                              <
                               Element, Key, ElementOps> const&);

  IGKeySortedSetAsBstTreeCursor <Element, Key, ElementOps>&
           operator=        (IGKeySortedSetAsBstTreeCursor
                              <
                               Element, Key, ElementOps> const&);

protected:

           IGKeySortedSetAsBstTreeCursor
                            (ICursorImpl*);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IGKeySortedSetAsBstTreeCursor\
                            (IGKeySortedSetAsBstTree\
                              <\
                               Element, Key, ElementOps> const&),\
           operator=,\
           IGKeySortedSetAsBstTreeCursor\
                            (ICursorImpl*)\
                        )
#endif

};

#if ! defined (__INO_MNGCURSOR__)
template <class Element, class Key, class ElementOps>
class IGKeySortedSetAsBstTreeMngCursor :
  public IGKeySortedSetAsBstTreeCursor <Element, Key, ElementOps>  {

  typedef  IGKeySortedSetAsBstTreeCursor
            <Element, Key, ElementOps> Cursor;

  typedef TYPENAME IGKeySortedSetAsBstTree
            <Element, Key, ElementOps>::
              Implementation::MngCursor Implementation;

public:

           IGKeySortedSetAsBstTreeMngCursor
                            (IGKeySortedSetAsBstTree
                              <
                               Element, Key, ElementOps> const&);

protected:

           IGKeySortedSetAsBstTreeMngCursor
                            (ICursorImpl*);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IGKeySortedSetAsBstTreeMngCursor\
                            (IGKeySortedSetAsBstTree\
                              <\
                               Element, Key, ElementOps> const&),\
           IGKeySortedSetAsBstTreeMngCursor\
                            (ICursorImpl*)\
                        )
#endif

};

#endif
template <class Element, class Key, class ElementOps>
class IGKeySortedSetAsBstTree :
  public IAKeySortedSet <Element, Key> {
protected:

  typedef  IGKeySortedSetAsBstTree <Element, Key, ElementOps> Self;

  typedef  IKeySortedSetAsBstTreeImpl PureImplementation;

#if defined (INO_CHECKS)
  typedef  PureImplementation Implementation;
#else
  typedef  ICKeySortedSetImpl
            <PureImplementation> Implementation;
#endif

#define IGKeySortedSetAsBstTreeTypedef(Element, Key, ElementOps)\
  typedef  IKeySortedSetAsBstTreeOps\
            <Element, Key,\
             IWKCOps <Element, Key, ElementOps>,\
             Implementation> Instantiation

           IGKeySortedSetAsBstTreeTypedef (Element, Key, ElementOps);

public:

#if ! defined(__INO_L1_LOCKING__)
  typedef ICollectionGuard<Element> Guard;
#endif

  typedef  IGKeySortedSetAsBstTreeCursor
            <Element, Key, ElementOps> Cursor;

#if ! defined (__INO_MNGCURSOR__)
  typedef  IGKeySortedSetAsBstTreeMngCursor
            <Element, Key, ElementOps> MngCursor;
#endif

           IGKeySortedSetAsBstTree
                            (INumber = 100);

           IGKeySortedSetAsBstTree
                            (IGKeySortedSetAsBstTree
                              <
                               Element, Key, ElementOps> const&);

  IGKeySortedSetAsBstTree <Element, Key, ElementOps>&
           operator=        (IGKeySortedSetAsBstTree
                              <
                               Element, Key, ElementOps> const&);

#if defined (__OSTORE__)
  static
  os_typespec*
           get_os_typespec  ()
           { return 0; }

  static
  void     os_mark_schema_type ()
           {
             Instantiation::os_mark_schema_type ();
#if ! defined (_AIX)
             OS_MARK_SCHEMA_TYPESPEC((Self));
#else
             { Self* _OSMT_ = 0; }
#endif
           }
#endif

protected:

           IGKeySortedSetAsBstTree
                            (PureImplementation&);

  static
  Implementation&
           ImplOf           (IGKeySortedSetAsBstTree
                              <
                               Element, Key, ElementOps> const&);

private:

  friend
  class    IGKeySortedSetAsBstTreeCursor <Element, Key, ElementOps>;

#if ! defined (__INO_MNGCURSOR__)
  friend
  class    IGKeySortedSetAsBstTreeMngCursor
            <Element, Key, ElementOps>;
#endif

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine ()
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IGKeySortedSetAsBstTree\
                            (INumber),\
           operator=,\
           IGKeySortedSetAsBstTree\
                            (PureImplementation&),\
           ImplOf           (IGKeySortedSetAsBstTree\
                              <\
                               Element, Key, ElementOps> const&)\
                        )
#endif

};

template <class Element, class Key>
class IKeySortedSetAsBstTree :
  public IGKeySortedSetAsBstTree
          <Element, Key, IKCOps <Element, Key> > {

  typedef  IGKeySortedSetAsBstTree
            <Element, Key,
             IKCOps <Element, Key> > Inherited;

protected:

  typedef TYPENAME Inherited::PureImplementation PureImplementation;

  typedef  IKeySortedSetAsBstTree <Element, Key> Self;

#define IKeySortedSetAsBstTreeTypedef(Element, Key)\
  typedef  IKeySortedSetAsBstTreeOps\
            <Element, Key,\
             IWKCOps <Element, Key, IKCOps <Element, Key> >,\
             Implementation> Instantiation

public:

#if ! defined(__INO_L1_LOCKING__)
  typedef ICollectionGuard<Element> Guard;
#endif

           IKeySortedSetAsBstTree
                            (INumber = 100);

#if defined (__OSTORE__)
  static
  os_typespec*
           get_os_typespec  ()
           { return 0; }

  static
  void     os_mark_schema_type ()
           {
             Inherited::os_mark_schema_type ();
#if ! defined (_AIX)
             OS_MARK_SCHEMA_TYPESPEC((Self));
#else
             { Self* _OSMT_ = 0; }
#endif
           }
#endif

protected:

           IKeySortedSetAsBstTree
                              (PureImplementation&);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IKeySortedSetAsBstTree\
                              (INumber),\
           IKeySortedSetAsBstTree\
                              (PureImplementation&)\
                        )
#endif

};

#if ! defined (__INO_AVALON__)
template <class Element, class Key, class ElementOps>
class IVGKeySortedSetAsBstTree :
  public IGKeySortedSetAsBstTree
          <Element, Key, ElementOps > {

  typedef  IVGKeySortedSetAsBstTree
            <Element, Key, ElementOps> Inherited;

protected:

  typedef TYPENAME
           IGKeySortedSetAsBstTree
            <Element, Key, ElementOps>::PureImplementation PureImplementation;

#if defined (INO_CHECKS)
  typedef  IVKeySortedSetImpl
            <PureImplementation> Implementation;
#else
  typedef  ICKeySortedSetImpl
            <IVKeySortedSetImpl
              <PureImplementation> > Implementation;
#endif

#define IVGKeySortedSetAsBstTreeTypedef(Element, Key, ElementOps)\
  typedef  IKeySortedSetAsBstTreeOps\
            <Element, Key,\
             IWKCOps <Element, Key, ElementOps>,\
             Implementation> Instantiation

           IVGKeySortedSetAsBstTreeTypedef (Element, Key, ElementOps);

public:

#if ! defined(__INO_L1_LOCKING__)
  typedef ICollectionGuard<Element> Guard;
#endif

           IVGKeySortedSetAsBstTree
                            (INumber = 100);

#if defined (__OSTORE__)
  static
  os_typespec*
           get_os_typespec  ()
           { return 0; }

  static
  void     os_mark_schema_type ()
           {
             Inherited::os_mark_schema_type ();
#if ! defined (_AIX)
             OS_MARK_SCHEMA_TYPESPEC((Self));
#else
             { Self* _OSMT_ = 0; }
#endif
           }
#endif

protected:

           IVGKeySortedSetAsBstTree
                              (PureImplementation&);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IVGKeySortedSetAsBstTree\
                              (INumber),\
           IVGKeySortedSetAsBstTree\
                              (PureImplementation&)\
                        )
#endif

};

template <class Element, class Key>
class IVKeySortedSetAsBstTree :
  public IVGKeySortedSetAsBstTree
          <Element, Key, IKCOps <Element, Key> > {

  typedef  IVGKeySortedSetAsBstTree
            <Element, Key,
             IKCOps <Element, Key> > Inherited;

protected:

  typedef TYPENAME Inherited::PureImplementation PureImplementation;

  typedef  IVKeySortedSetAsBstTree <Element, Key> Self;

#define IVKeySortedSetAsBstTreeTypedef(Element, Key)\
  typedef  IVKeySortedSetAsBstTreeOps\
            <Element, Key,\
             IWKCOps <Element, Key, IKCOps <Element, Key> >,\
             Implementation> Instantiation

public:

#if ! defined(__INO_L1_LOCKING__)
  typedef ICollectionGuard<Element> Guard;
#endif

           IVKeySortedSetAsBstTree
                            (INumber = 100);

#if defined (__OSTORE__)
  static
  os_typespec*
           get_os_typespec  ()
           { return 0; }

  static
  void     os_mark_schema_type ()
           {
             Inherited::os_mark_schema_type ();
#if ! defined (_AIX)
             OS_MARK_SCHEMA_TYPESPEC((Self));
#else
             { Self* _OSMT_ = 0; }
#endif
           }
#endif

protected:

           IVKeySortedSetAsBstTree
                              (PureImplementation&);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IVKeySortedSetAsBstTree\
                              (INumber),\
           IVKeySortedSetAsBstTree\
                              (PureImplementation&)\
                        )
#endif

};

#endif

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#if defined (__SOM_ENABLED__) 
#pragma SOMAsDefault (pop)
#endif

#include <ikssbst.inl>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IKSSBST_
