// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 97 1.4.1.3 source/core/collect/imcllct.h, collection, ioc.v400, 000919 
#ifndef _IMCLLCT_
#define _IMCLLCT_

#include <iiacllct.h>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__RRBC_LIB__)                    
#define IMetaCollection IRRBCMetaCollection   
#endif                                        

#if defined (__SOM_ENABLED__) 
#if defined (__RRBC_IBM__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

class IC_EXPORTC IMetaCollection
{
public:

protected:

  IACollectionImpl*
           ivImpl;

           IMetaCollection  ();

           IMetaCollection  (IMetaCollection const&);

  virtual  ~IMetaCollection  ();

  static
  void*    CheckPointer     (void*);

  void     CloneImplOf      (IMetaCollection const&);

  static
  IACollectionImpl&
           ImplOf           (IMetaCollection const&);

  void     SetImpl          (IACollectionImpl*);

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMAttribute (ivImpl)
#pragma SOMReleaseOrder (\
           CheckPointer     (void*),\
           CloneImplOf      (IMetaCollection const&),\
           ImplOf           (IMetaCollection const&),\
           SetImpl          (IACollectionImpl*)\
                        )
#endif

};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#if defined (__SOM_ENABLED__) 
#pragma SOMAsDefault (pop)
#endif

#include <imcllct.inl>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IMCLLCT_
