// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 00 1.4.1.3 source/core/collect/imtree.h, collection, ioc.v400, 000919 
#ifndef _IMTREE_
#define _IMTREE_

#include <iiatree.h>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__RRBC_LIB__)       
#define IMetaTree IRRBCMetaTree  
#endif                           

#if defined (__SOM_ENABLED__) 
#if defined (__RRBC_IBM__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

class IC_EXPORTC IMetaTree
{
public:

protected:

  IATreeImpl*
           ivImpl;

           IMetaTree        ();

           IMetaTree        (IMetaTree const&);

  virtual  ~IMetaTree        ();

  static
  void*    CheckPointer     (void*);

  void     CloneImplOf      (IMetaTree const&);

  IATreeImpl const&
           GetImpl          () const;

  void     SetImpl          (IATreeImpl*);

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMAttribute (ivImpl)
#pragma SOMReleaseOrder (\
           CheckPointer     (void*),\
           CloneImplOf      (IMetaTree const&),\
           GetImpl          () const,\
           SetImpl          (IATreeImpl*)\
                        )
#endif

};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#if defined (__SOM_ENABLED__) 
#pragma SOMAsDefault (pop)
#endif

#include <imtree.inl>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IMTREE_
