// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 10 1.4.1.4 source/core/collect/ipqudil.inl, collection, ioc.v400, 000919  
#ifndef _IPQUDIL_INL_
#define _IPQUDIL_INL_

// ---
// IGPriorityQueueAsDilTableCursor
// ---

#include <ilanglvl.hpp>

// public members

template <class Element, class Key, class ElementOps>
inline
IGPriorityQueueAsDilTableCursor <Element, Key, ElementOps>::
IGPriorityQueueAsDilTableCursor
  (IGPriorityQueueAsDilTable
    <Element, Key, ElementOps> const& collection)
: IOrderedCursor <Element>
    (collection.ivImpl->CreateCursor ())
{
}

template <class Element, class Key, class ElementOps>
inline IGPriorityQueueAsDilTableCursor <Element, Key, ElementOps>&
IGPriorityQueueAsDilTableCursor <Element, Key, ElementOps>::
operator=
  (IGPriorityQueueAsDilTableCursor
    <Element, Key, ElementOps> const& cursor)
{ Inherited::operator= (cursor);
  return *this;
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGPriorityQueueAsDilTableCursor <Element, Key, ElementOps>::
IGPriorityQueueAsDilTableCursor (ICursorImpl* impl)
: IOrderedCursor <Element> (impl)
{
}

#if ! defined (__INO_MNGCURSOR__)
// ---
// IGPriorityQueueAsDilTableMngCursor
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IGPriorityQueueAsDilTableMngCursor <Element, Key, ElementOps>::
IGPriorityQueueAsDilTableMngCursor
  (IGPriorityQueueAsDilTable
    <Element, Key, ElementOps> const& collection)
: IGPriorityQueueAsDilTableCursor <Element, Key, ElementOps>
    (collection.ivImpl->CreateMngCursor ())
{
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGPriorityQueueAsDilTableMngCursor <Element, Key, ElementOps>::
IGPriorityQueueAsDilTableMngCursor (ICursorImpl* impl)
: IGPriorityQueueAsDilTableCursor <Element, Key, ElementOps> (impl)
{
}

#endif
// ---
// IGPriorityQueueAsDilTable
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IGPriorityQueueAsDilTable <Element, Key, ElementOps>::
IGPriorityQueueAsDilTable (INumber numberOfElements)
{ this->SetImpl ((Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements));
}

template <class Element, class Key, class ElementOps>
inline
IGPriorityQueueAsDilTable <Element, Key, ElementOps>::
IGPriorityQueueAsDilTable
  (IGPriorityQueueAsDilTable
    <Element, Key, ElementOps> const& collection)
{ this->CloneImplOf (collection);
}

template <class Element, class Key, class ElementOps>
inline IGPriorityQueueAsDilTable <Element, Key, ElementOps>&
IGPriorityQueueAsDilTable <Element, Key, ElementOps>::
operator= (IGPriorityQueueAsDilTable
            <Element, Key, ElementOps> const& collection)
{ this->ImplOf (*this).Copy (this->ImplOf (collection));
  return *this;
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGPriorityQueueAsDilTable <Element, Key, ElementOps>::
IGPriorityQueueAsDilTable (PureImplementation& impl)
{ this->SetImpl (&impl);
}

template <class Element, class Key, class ElementOps>
inline TYPENAME IGPriorityQueueAsDilTable
 <Element, Key, ElementOps>::Implementation&
IGPriorityQueueAsDilTable <Element, Key, ElementOps>::
ImplOf (IGPriorityQueueAsDilTable
         <Element, Key, ElementOps> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

// ---
// IPriorityQueueAsDilTable
// ---

// public members

template <class Element, class Key>
inline
IPriorityQueueAsDilTable <Element, Key>::
IPriorityQueueAsDilTable (INumber numberOfElements)
: IGPriorityQueueAsDilTable
   <Element, Key, IKCOps <Element, Key> > (numberOfElements)
{
}

// protected members

template <class Element, class Key>
inline
IPriorityQueueAsDilTable <Element, Key>::
IPriorityQueueAsDilTable (PureImplementation& impl)
: IGPriorityQueueAsDilTable
   <Element, Key, IKCOps <Element, Key> > (impl)
{
}
#if ! defined (__INO_AVALON__)

// ---
// IVGPriorityQueueAsDilTable
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IVGPriorityQueueAsDilTable <Element, Key, ElementOps>::
IVGPriorityQueueAsDilTable (INumber numberOfElements)
: IGPriorityQueueAsDilTable
    <Element, Key, ElementOps> (*(Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements))
{
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IVGPriorityQueueAsDilTable <Element, Key, ElementOps>::
IVGPriorityQueueAsDilTable (PureImplementation& impl)
: IGPriorityQueueAsDilTable
    <Element, Key, ElementOps> (impl)
{
}

// ---
// IVPriorityQueueAsDilTable
// ---

// public members

template <class Element, class Key>
inline
IVPriorityQueueAsDilTable <Element, Key>::
IVPriorityQueueAsDilTable (INumber numberOfElements)
: IVGPriorityQueueAsDilTable
   <Element, Key, IKCOps <Element, Key> > (numberOfElements)
{
}

// protected members

template <class Element, class Key>
inline
IVPriorityQueueAsDilTable <Element, Key>::
IVPriorityQueueAsDilTable (PureImplementation& impl)
: IVGPriorityQueueAsDilTable
   <Element, Key, IKCOps <Element, Key> > (impl)
{
}
#endif

#endif // _IPQUDIL_INL_
