// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 41 1.4.1.4 source/core/collect/irelhsh.inl, collection, ioc.v400, 000919  
#ifndef _IRELHSH_INL_
#define _IRELHSH_INL_

// ---
// IGRelationAsHshTableCursor
// ---

#include <ilanglvl.hpp>

// public members

template <class Element, class Key, class ElementOps>
inline
IGRelationAsHshTableCursor <Element, Key, ElementOps>::
IGRelationAsHshTableCursor
  (IGRelationAsHshTable
    <Element, Key, ElementOps> const& collection)
: IElementCursor <Element>
    (collection.ivImpl->CreateCursor ())
{
}

template <class Element, class Key, class ElementOps>
inline IGRelationAsHshTableCursor <Element, Key, ElementOps>&
IGRelationAsHshTableCursor <Element, Key, ElementOps>::
operator=
  (IGRelationAsHshTableCursor
    <Element, Key, ElementOps> const& cursor)
{ Inherited::operator= (cursor);
  return *this;
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGRelationAsHshTableCursor <Element, Key, ElementOps>::
IGRelationAsHshTableCursor (ICursorImpl* impl)
: IElementCursor <Element> (impl)
{
}

#if ! defined (__INO_MNGCURSOR__)
// ---
// IGRelationAsHshTableMngCursor
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IGRelationAsHshTableMngCursor <Element, Key, ElementOps>::
IGRelationAsHshTableMngCursor
  (IGRelationAsHshTable
    <Element, Key, ElementOps> const& collection)
: IGRelationAsHshTableCursor <Element, Key, ElementOps>
    (collection.ivImpl->CreateMngCursor ())
{
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGRelationAsHshTableMngCursor <Element, Key, ElementOps>::
IGRelationAsHshTableMngCursor (ICursorImpl* impl)
: IGRelationAsHshTableCursor <Element, Key, ElementOps> (impl)
{
}

#endif
// ---
// IGRelationAsHshTable
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IGRelationAsHshTable <Element, Key, ElementOps>::
IGRelationAsHshTable (INumber numberOfElements)
{ this->SetImpl ((Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements));
}

template <class Element, class Key, class ElementOps>
inline
IGRelationAsHshTable <Element, Key, ElementOps>::
IGRelationAsHshTable
  (IGRelationAsHshTable
    <Element, Key, ElementOps> const& collection)
{ this->CloneImplOf (collection);
}

template <class Element, class Key, class ElementOps>
inline IGRelationAsHshTable <Element, Key, ElementOps>&
IGRelationAsHshTable <Element, Key, ElementOps>::
operator= (IGRelationAsHshTable
            <Element, Key, ElementOps> const& collection)
{ this->ImplOf (*this).Copy (this->ImplOf (collection));
  return *this;
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGRelationAsHshTable <Element, Key, ElementOps>::
IGRelationAsHshTable (PureImplementation& impl)
{ this->SetImpl (&impl);
}

template <class Element, class Key, class ElementOps>
inline TYPENAME IGRelationAsHshTable
 <Element, Key, ElementOps>::Implementation&
IGRelationAsHshTable <Element, Key, ElementOps>::
ImplOf (IGRelationAsHshTable
         <Element, Key, ElementOps> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

// ---
// IRelationAsHshTable
// ---

// public members

template <class Element, class Key>
inline
IRelationAsHshTable <Element, Key>::
IRelationAsHshTable (INumber numberOfElements)
: IGRelationAsHshTable
   <Element, Key, IEKEHOps <Element, Key> > (numberOfElements)
{
}

// protected members

template <class Element, class Key>
inline
IRelationAsHshTable <Element, Key>::
IRelationAsHshTable (PureImplementation& impl)
: IGRelationAsHshTable
   <Element, Key, IEKEHOps <Element, Key> > (impl)
{
}
#if ! defined (__INO_AVALON__)

// ---
// IVGRelationAsHshTable
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IVGRelationAsHshTable <Element, Key, ElementOps>::
IVGRelationAsHshTable (INumber numberOfElements)
: IGRelationAsHshTable
    <Element, Key, ElementOps> (*(Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements))
{
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IVGRelationAsHshTable <Element, Key, ElementOps>::
IVGRelationAsHshTable (PureImplementation& impl)
: IGRelationAsHshTable
    <Element, Key, ElementOps> (impl)
{
}

// ---
// IVRelationAsHshTable
// ---

// public members

template <class Element, class Key>
inline
IVRelationAsHshTable <Element, Key>::
IVRelationAsHshTable (INumber numberOfElements)
: IVGRelationAsHshTable
   <Element, Key, IEKEHOps <Element, Key> > (numberOfElements)
{
}

// protected members

template <class Element, class Key>
inline
IVRelationAsHshTable <Element, Key>::
IVRelationAsHshTable (PureImplementation& impl)
: IVGRelationAsHshTable
   <Element, Key, IEKEHOps <Element, Key> > (impl)
{
}
#endif

#endif // _IRELHSH_INL_
