// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 43 1.4.1.4 source/core/collect/irellst.inl, collection, ioc.v400, 000919  
#ifndef _IRELLST_INL_
#define _IRELLST_INL_

// ---
// IGRelationAsListCursor
// ---

#include <ilanglvl.hpp>

// public members

template <class Element, class Key, class ElementOps>
inline
IGRelationAsListCursor <Element, Key, ElementOps>::
IGRelationAsListCursor
  (IGRelationAsList
    <Element, Key, ElementOps> const& collection)
: IElementCursor <Element>
    (collection.ivImpl->CreateCursor ())
{
}

template <class Element, class Key, class ElementOps>
inline IGRelationAsListCursor <Element, Key, ElementOps>&
IGRelationAsListCursor <Element, Key, ElementOps>::
operator=
  (IGRelationAsListCursor
    <Element, Key, ElementOps> const& cursor)
{ Inherited::operator= (cursor);
  return *this;
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGRelationAsListCursor <Element, Key, ElementOps>::
IGRelationAsListCursor (ICursorImpl* impl)
: IElementCursor <Element> (impl)
{
}

#if ! defined (__INO_MNGCURSOR__)
// ---
// IGRelationAsListMngCursor
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IGRelationAsListMngCursor <Element, Key, ElementOps>::
IGRelationAsListMngCursor
  (IGRelationAsList
    <Element, Key, ElementOps> const& collection)
: IGRelationAsListCursor <Element, Key, ElementOps>
    (collection.ivImpl->CreateMngCursor ())
{
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGRelationAsListMngCursor <Element, Key, ElementOps>::
IGRelationAsListMngCursor (ICursorImpl* impl)
: IGRelationAsListCursor <Element, Key, ElementOps> (impl)
{
}

#endif
// ---
// IGRelationAsList
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IGRelationAsList <Element, Key, ElementOps>::
IGRelationAsList (INumber numberOfElements)
{ this->SetImpl ((Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements));
}

template <class Element, class Key, class ElementOps>
inline
IGRelationAsList <Element, Key, ElementOps>::
IGRelationAsList
  (IGRelationAsList
    <Element, Key, ElementOps> const& collection)
{ this->CloneImplOf (collection);
}

template <class Element, class Key, class ElementOps>
inline IGRelationAsList <Element, Key, ElementOps>&
IGRelationAsList <Element, Key, ElementOps>::
operator= (IGRelationAsList
            <Element, Key, ElementOps> const& collection)
{ this->ImplOf (*this).Copy (this->ImplOf (collection));
  return *this;
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGRelationAsList <Element, Key, ElementOps>::
IGRelationAsList (PureImplementation& impl)
{ this->SetImpl (&impl);
}

template <class Element, class Key, class ElementOps>
inline TYPENAME IGRelationAsList
 <Element, Key, ElementOps>::Implementation&
IGRelationAsList <Element, Key, ElementOps>::
ImplOf (IGRelationAsList
         <Element, Key, ElementOps> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

// ---
// IRelationAsList
// ---

// public members

template <class Element, class Key>
inline
IRelationAsList <Element, Key>::
IRelationAsList (INumber numberOfElements)
: IGRelationAsList
   <Element, Key, IEKCOps <Element, Key> > (numberOfElements)
{
}

// protected members

template <class Element, class Key>
inline
IRelationAsList <Element, Key>::
IRelationAsList (PureImplementation& impl)
: IGRelationAsList
   <Element, Key, IEKCOps <Element, Key> > (impl)
{
}
#if ! defined (__INO_AVALON__)

// ---
// IVGRelationAsList
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IVGRelationAsList <Element, Key, ElementOps>::
IVGRelationAsList (INumber numberOfElements)
: IGRelationAsList
    <Element, Key, ElementOps> (*(Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements))
{
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IVGRelationAsList <Element, Key, ElementOps>::
IVGRelationAsList (PureImplementation& impl)
: IGRelationAsList
    <Element, Key, ElementOps> (impl)
{
}

// ---
// IVRelationAsList
// ---

// public members

template <class Element, class Key>
inline
IVRelationAsList <Element, Key>::
IVRelationAsList (INumber numberOfElements)
: IVGRelationAsList
   <Element, Key, IEKCOps <Element, Key> > (numberOfElements)
{
}

// protected members

template <class Element, class Key>
inline
IVRelationAsList <Element, Key>::
IVRelationAsList (PureImplementation& impl)
: IVGRelationAsList
   <Element, Key, IEKCOps <Element, Key> > (impl)
{
}
#endif

#endif // _IRELLST_INL_
