// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 60 1.5.1.3 source/core/collect/irprioqu.h, collection, ioc.v400, 000919 
#ifndef _IRPRIOQU_
#define _IRPRIOQU_

#include <ilanglvl.hpp>
#include <iapqu.h>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__)
#if defined (__RRBC_IBM__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

template <class Element, class Key, class Base>
class IRPriorityQueue : public IAPriorityQueue <Element, Key> {
public:

  typedef TYPENAME Base::Cursor Cursor;

           IRPriorityQueue
                            (Base&);

  IRPriorityQueue <Element, Key, Base>&
           operator=        (IRPriorityQueue
                              <Element, Key, Base> const&);

protected:

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IRPriorityQueue\
                            (Base&),\
           operator=\
                        )
#endif

};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#if defined (__SOM_ENABLED__) 
#pragma SOMAsDefault (pop)
#endif

#include <irprioqu.inl>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IRPRIOQU_
