// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 87 1.4.1.4 source/core/collect/isbdil.inl, collection, ioc.v400, 000919  
#ifndef _ISBDIL_INL_
#define _ISBDIL_INL_

// ---
// IGSortedBagAsDilTableCursor
// ---

#include <ilanglvl.hpp>

// public members

template <class Element, class ElementOps>
inline
IGSortedBagAsDilTableCursor <Element, ElementOps>::
IGSortedBagAsDilTableCursor
  (IGSortedBagAsDilTable
    <Element, ElementOps> const& collection)
: IOrderedCursor <Element>
    (collection.ivImpl->CreateCursor ())
{
}

template <class Element, class ElementOps>
inline IGSortedBagAsDilTableCursor <Element, ElementOps>&
IGSortedBagAsDilTableCursor <Element, ElementOps>::
operator=
  (IGSortedBagAsDilTableCursor
    <Element, ElementOps> const& cursor)
{ Inherited::operator= (cursor);
  return *this;
}

// protected members

template <class Element, class ElementOps>
inline
IGSortedBagAsDilTableCursor <Element, ElementOps>::
IGSortedBagAsDilTableCursor (ICursorImpl* impl)
: IOrderedCursor <Element> (impl)
{
}

#if ! defined (__INO_MNGCURSOR__)
// ---
// IGSortedBagAsDilTableMngCursor
// ---

// public members

template <class Element, class ElementOps>
inline
IGSortedBagAsDilTableMngCursor <Element, ElementOps>::
IGSortedBagAsDilTableMngCursor
  (IGSortedBagAsDilTable
    <Element, ElementOps> const& collection)
: IGSortedBagAsDilTableCursor <Element, ElementOps>
    (collection.ivImpl->CreateMngCursor ())
{
}

// protected members

template <class Element, class ElementOps>
inline
IGSortedBagAsDilTableMngCursor <Element, ElementOps>::
IGSortedBagAsDilTableMngCursor (ICursorImpl* impl)
: IGSortedBagAsDilTableCursor <Element, ElementOps> (impl)
{
}

#endif
// ---
// IGSortedBagAsDilTable
// ---

// public members

template <class Element, class ElementOps>
inline
IGSortedBagAsDilTable <Element, ElementOps>::
IGSortedBagAsDilTable (INumber numberOfElements)
{ this->SetImpl ((Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements));
}

template <class Element, class ElementOps>
inline
IGSortedBagAsDilTable <Element, ElementOps>::
IGSortedBagAsDilTable
  (IGSortedBagAsDilTable
    <Element, ElementOps> const& collection)
{ this->CloneImplOf (collection);
}

template <class Element, class ElementOps>
inline IGSortedBagAsDilTable <Element, ElementOps>&
IGSortedBagAsDilTable <Element, ElementOps>::
operator= (IGSortedBagAsDilTable
            <Element, ElementOps> const& collection)
{ this->ImplOf (*this).Copy (this->ImplOf (collection));
  return *this;
}

// protected members

template <class Element, class ElementOps>
inline
IGSortedBagAsDilTable <Element, ElementOps>::
IGSortedBagAsDilTable (PureImplementation& impl)
{ this->SetImpl (&impl);
}

template <class Element, class ElementOps>
inline TYPENAME IGSortedBagAsDilTable
 <Element, ElementOps>::Implementation&
IGSortedBagAsDilTable <Element, ElementOps>::
ImplOf (IGSortedBagAsDilTable
         <Element, ElementOps> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

// ---
// ISortedBagAsDilTable
// ---

// public members

template <class Element>
inline
ISortedBagAsDilTable <Element>::
ISortedBagAsDilTable (INumber numberOfElements)
: IGSortedBagAsDilTable
   <Element, ICOps <Element> > (numberOfElements)
{
}

// protected members

template <class Element>
inline
ISortedBagAsDilTable <Element>::
ISortedBagAsDilTable (PureImplementation& impl)
: IGSortedBagAsDilTable
   <Element, ICOps <Element> > (impl)
{
}
#if ! defined (__INO_AVALON__)

// ---
// IVGSortedBagAsDilTable
// ---

// public members

template <class Element, class ElementOps>
inline
IVGSortedBagAsDilTable <Element, ElementOps>::
IVGSortedBagAsDilTable (INumber numberOfElements)
: IGSortedBagAsDilTable
    <Element, ElementOps> (*(Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements))
{
}

// protected members

template <class Element, class ElementOps>
inline
IVGSortedBagAsDilTable <Element, ElementOps>::
IVGSortedBagAsDilTable (PureImplementation& impl)
: IGSortedBagAsDilTable
    <Element, ElementOps> (impl)
{
}

// ---
// IVSortedBagAsDilTable
// ---

// public members

template <class Element>
inline
IVSortedBagAsDilTable <Element>::
IVSortedBagAsDilTable (INumber numberOfElements)
: IVGSortedBagAsDilTable
   <Element, ICOps <Element> > (numberOfElements)
{
}

// protected members

template <class Element>
inline
IVSortedBagAsDilTable <Element>::
IVSortedBagAsDilTable (PureImplementation& impl)
: IVGSortedBagAsDilTable
   <Element, ICOps <Element> > (impl)
{
}
#endif

#endif // _ISBDIL_INL_
