// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 00 1.4.1.4 source/core/collect/iseqlst.inl, collection, ioc.v400, 000919  
#ifndef _ISEQLST_INL_
#define _ISEQLST_INL_

// ---
// IGSequenceAsListCursor
// ---

#include <ilanglvl.hpp>

// public members

template <class Element, class ElementOps>
inline
IGSequenceAsListCursor <Element, ElementOps>::
IGSequenceAsListCursor
  (IGSequenceAsList
    <Element, ElementOps> const& collection)
: IOrderedCursor <Element>
    (collection.ivImpl->CreateCursor ())
{
}

template <class Element, class ElementOps>
inline IGSequenceAsListCursor <Element, ElementOps>&
IGSequenceAsListCursor <Element, ElementOps>::
operator=
  (IGSequenceAsListCursor
    <Element, ElementOps> const& cursor)
{ Inherited::operator= (cursor);
  return *this;
}

// protected members

template <class Element, class ElementOps>
inline
IGSequenceAsListCursor <Element, ElementOps>::
IGSequenceAsListCursor (ICursorImpl* impl)
: IOrderedCursor <Element> (impl)
{
}

#if ! defined (__INO_MNGCURSOR__)
// ---
// IGSequenceAsListMngCursor
// ---

// public members

template <class Element, class ElementOps>
inline
IGSequenceAsListMngCursor <Element, ElementOps>::
IGSequenceAsListMngCursor
  (IGSequenceAsList
    <Element, ElementOps> const& collection)
: IGSequenceAsListCursor <Element, ElementOps>
    (collection.ivImpl->CreateMngCursor ())
{
}

// protected members

template <class Element, class ElementOps>
inline
IGSequenceAsListMngCursor <Element, ElementOps>::
IGSequenceAsListMngCursor (ICursorImpl* impl)
: IGSequenceAsListCursor <Element, ElementOps> (impl)
{
}

#endif
// ---
// IGSequenceAsList
// ---

// public members

template <class Element, class ElementOps>
inline
IGSequenceAsList <Element, ElementOps>::
IGSequenceAsList (INumber numberOfElements)
{ this->SetImpl ((Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements));
}

template <class Element, class ElementOps>
inline
IGSequenceAsList <Element, ElementOps>::
IGSequenceAsList
  (IGSequenceAsList
    <Element, ElementOps> const& collection)
{ this->CloneImplOf (collection);
}

template <class Element, class ElementOps>
inline IGSequenceAsList <Element, ElementOps>&
IGSequenceAsList <Element, ElementOps>::
operator= (IGSequenceAsList
            <Element, ElementOps> const& collection)
{ this->ImplOf (*this).Copy (this->ImplOf (collection));
  return *this;
}

// protected members

template <class Element, class ElementOps>
inline
IGSequenceAsList <Element, ElementOps>::
IGSequenceAsList (PureImplementation& impl)
{ this->SetImpl (&impl);
}

template <class Element, class ElementOps>
inline TYPENAME IGSequenceAsList
 <Element, ElementOps>::Implementation&
IGSequenceAsList <Element, ElementOps>::
ImplOf (IGSequenceAsList
         <Element, ElementOps> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

// ---
// ISequenceAsList
// ---

// public members

template <class Element>
inline
ISequenceAsList <Element>::
ISequenceAsList (INumber numberOfElements)
: IGSequenceAsList
   <Element, IStdOps <Element> > (numberOfElements)
{
}

// protected members

template <class Element>
inline
ISequenceAsList <Element>::
ISequenceAsList (PureImplementation& impl)
: IGSequenceAsList
   <Element, IStdOps <Element> > (impl)
{
}
#if ! defined (__INO_AVALON__)

// ---
// IVGSequenceAsList
// ---

// public members

template <class Element, class ElementOps>
inline
IVGSequenceAsList <Element, ElementOps>::
IVGSequenceAsList (INumber numberOfElements)
: IGSequenceAsList
    <Element, ElementOps> (*(Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements))
{
}

// protected members

template <class Element, class ElementOps>
inline
IVGSequenceAsList <Element, ElementOps>::
IVGSequenceAsList (PureImplementation& impl)
: IGSequenceAsList
    <Element, ElementOps> (impl)
{
}

// ---
// IVSequenceAsList
// ---

// public members

template <class Element>
inline
IVSequenceAsList <Element>::
IVSequenceAsList (INumber numberOfElements)
: IVGSequenceAsList
   <Element, IStdOps <Element> > (numberOfElements)
{
}

// protected members

template <class Element>
inline
IVSequenceAsList <Element>::
IVSequenceAsList (PureImplementation& impl)
: IVGSequenceAsList
   <Element, IStdOps <Element> > (impl)
{
}
#endif

#endif // _ISEQLST_INL_
