// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 10 1.4.1.4 source/core/collect/isetdil.inl, collection, ioc.v400, 000919  
#ifndef _ISETDIL_INL_
#define _ISETDIL_INL_

// ---
// IGSetAsDilTableCursor
// ---

#include <ilanglvl.hpp>

// public members

template <class Element, class ElementOps>
inline
IGSetAsDilTableCursor <Element, ElementOps>::
IGSetAsDilTableCursor
  (IGSetAsDilTable
    <Element, ElementOps> const& collection)
: IElementCursor <Element>
    (collection.ivImpl->CreateCursor ())
{
}

template <class Element, class ElementOps>
inline IGSetAsDilTableCursor <Element, ElementOps>&
IGSetAsDilTableCursor <Element, ElementOps>::
operator=
  (IGSetAsDilTableCursor
    <Element, ElementOps> const& cursor)
{ Inherited::operator= (cursor);
  return *this;
}

// protected members

template <class Element, class ElementOps>
inline
IGSetAsDilTableCursor <Element, ElementOps>::
IGSetAsDilTableCursor (ICursorImpl* impl)
: IElementCursor <Element> (impl)
{
}

#if ! defined (__INO_MNGCURSOR__)
// ---
// IGSetAsDilTableMngCursor
// ---

// public members

template <class Element, class ElementOps>
inline
IGSetAsDilTableMngCursor <Element, ElementOps>::
IGSetAsDilTableMngCursor
  (IGSetAsDilTable
    <Element, ElementOps> const& collection)
: IGSetAsDilTableCursor <Element, ElementOps>
    (collection.ivImpl->CreateMngCursor ())
{
}

// protected members

template <class Element, class ElementOps>
inline
IGSetAsDilTableMngCursor <Element, ElementOps>::
IGSetAsDilTableMngCursor (ICursorImpl* impl)
: IGSetAsDilTableCursor <Element, ElementOps> (impl)
{
}

#endif
// ---
// IGSetAsDilTable
// ---

// public members

template <class Element, class ElementOps>
inline
IGSetAsDilTable <Element, ElementOps>::
IGSetAsDilTable (INumber numberOfElements)
{ this->SetImpl ((Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements));
}

template <class Element, class ElementOps>
inline
IGSetAsDilTable <Element, ElementOps>::
IGSetAsDilTable
  (IGSetAsDilTable
    <Element, ElementOps> const& collection)
{ this->CloneImplOf (collection);
}

template <class Element, class ElementOps>
inline IGSetAsDilTable <Element, ElementOps>&
IGSetAsDilTable <Element, ElementOps>::
operator= (IGSetAsDilTable
            <Element, ElementOps> const& collection)
{ this->ImplOf (*this).Copy (this->ImplOf (collection));
  return *this;
}

// protected members

template <class Element, class ElementOps>
inline
IGSetAsDilTable <Element, ElementOps>::
IGSetAsDilTable (PureImplementation& impl)
{ this->SetImpl (&impl);
}

template <class Element, class ElementOps>
inline TYPENAME IGSetAsDilTable
 <Element, ElementOps>::Implementation&
IGSetAsDilTable <Element, ElementOps>::
ImplOf (IGSetAsDilTable
         <Element, ElementOps> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

// ---
// ISetAsDilTable
// ---

// public members

template <class Element>
inline
ISetAsDilTable <Element>::
ISetAsDilTable (INumber numberOfElements)
: IGSetAsDilTable
   <Element, ICOps <Element> > (numberOfElements)
{
}

// protected members

template <class Element>
inline
ISetAsDilTable <Element>::
ISetAsDilTable (PureImplementation& impl)
: IGSetAsDilTable
   <Element, ICOps <Element> > (impl)
{
}
#if ! defined (__INO_AVALON__)

// ---
// IVGSetAsDilTable
// ---

// public members

template <class Element, class ElementOps>
inline
IVGSetAsDilTable <Element, ElementOps>::
IVGSetAsDilTable (INumber numberOfElements)
: IGSetAsDilTable
    <Element, ElementOps> (*(Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements))
{
}

// protected members

template <class Element, class ElementOps>
inline
IVGSetAsDilTable <Element, ElementOps>::
IVGSetAsDilTable (PureImplementation& impl)
: IGSetAsDilTable
    <Element, ElementOps> (impl)
{
}

// ---
// IVSetAsDilTable
// ---

// public members

template <class Element>
inline
IVSetAsDilTable <Element>::
IVSetAsDilTable (INumber numberOfElements)
: IVGSetAsDilTable
   <Element, ICOps <Element> > (numberOfElements)
{
}

// protected members

template <class Element>
inline
IVSetAsDilTable <Element>::
IVSetAsDilTable (PureImplementation& impl)
: IVGSetAsDilTable
   <Element, ICOps <Element> > (impl)
{
}
#endif

#endif // _ISETDIL_INL_
