// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 20 1.4.1.4 source/core/collect/isettab.inl, collection, ioc.v400, 000919  
#ifndef _ISETTAB_INL_
#define _ISETTAB_INL_

// ---
// IGSetAsTableCursor
// ---

#include <ilanglvl.hpp>

// public members

template <class Element, class ElementOps>
inline
IGSetAsTableCursor <Element, ElementOps>::
IGSetAsTableCursor
  (IGSetAsTable
    <Element, ElementOps> const& collection)
: IElementCursor <Element>
    (collection.ivImpl->CreateCursor ())
{
}

template <class Element, class ElementOps>
inline IGSetAsTableCursor <Element, ElementOps>&
IGSetAsTableCursor <Element, ElementOps>::
operator=
  (IGSetAsTableCursor
    <Element, ElementOps> const& cursor)
{ Inherited::operator= (cursor);
  return *this;
}

// protected members

template <class Element, class ElementOps>
inline
IGSetAsTableCursor <Element, ElementOps>::
IGSetAsTableCursor (ICursorImpl* impl)
: IElementCursor <Element> (impl)
{
}

#if ! defined (__INO_MNGCURSOR__)
// ---
// IGSetAsTableMngCursor
// ---

// public members

template <class Element, class ElementOps>
inline
IGSetAsTableMngCursor <Element, ElementOps>::
IGSetAsTableMngCursor
  (IGSetAsTable
    <Element, ElementOps> const& collection)
: IGSetAsTableCursor <Element, ElementOps>
    (collection.ivImpl->CreateMngCursor ())
{
}

// protected members

template <class Element, class ElementOps>
inline
IGSetAsTableMngCursor <Element, ElementOps>::
IGSetAsTableMngCursor (ICursorImpl* impl)
: IGSetAsTableCursor <Element, ElementOps> (impl)
{
}

#endif
// ---
// IGSetAsTable
// ---

// public members

template <class Element, class ElementOps>
inline
IGSetAsTable <Element, ElementOps>::
IGSetAsTable (INumber numberOfElements)
{ this->SetImpl ((Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements));
}

template <class Element, class ElementOps>
inline
IGSetAsTable <Element, ElementOps>::
IGSetAsTable
  (IGSetAsTable
    <Element, ElementOps> const& collection)
{ this->CloneImplOf (collection);
}

template <class Element, class ElementOps>
inline IGSetAsTable <Element, ElementOps>&
IGSetAsTable <Element, ElementOps>::
operator= (IGSetAsTable
            <Element, ElementOps> const& collection)
{ this->ImplOf (*this).Copy (this->ImplOf (collection));
  return *this;
}

// protected members

template <class Element, class ElementOps>
inline
IGSetAsTable <Element, ElementOps>::
IGSetAsTable (PureImplementation& impl)
{ this->SetImpl (&impl);
}

template <class Element, class ElementOps>
inline TYPENAME IGSetAsTable
 <Element, ElementOps>::Implementation&
IGSetAsTable <Element, ElementOps>::
ImplOf (IGSetAsTable
         <Element, ElementOps> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

// ---
// ISetAsTable
// ---

// public members

template <class Element>
inline
ISetAsTable <Element>::
ISetAsTable (INumber numberOfElements)
: IGSetAsTable
   <Element, ICOps <Element> > (numberOfElements)
{
}

// protected members

template <class Element>
inline
ISetAsTable <Element>::
ISetAsTable (PureImplementation& impl)
: IGSetAsTable
   <Element, ICOps <Element> > (impl)
{
}
#if ! defined (__INO_AVALON__)

// ---
// IVGSetAsTable
// ---

// public members

template <class Element, class ElementOps>
inline
IVGSetAsTable <Element, ElementOps>::
IVGSetAsTable (INumber numberOfElements)
: IGSetAsTable
    <Element, ElementOps> (*(Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements))
{
}

// protected members

template <class Element, class ElementOps>
inline
IVGSetAsTable <Element, ElementOps>::
IVGSetAsTable (PureImplementation& impl)
: IGSetAsTable
    <Element, ElementOps> (impl)
{
}

// ---
// IVSetAsTable
// ---

// public members

template <class Element>
inline
IVSetAsTable <Element>::
IVSetAsTable (INumber numberOfElements)
: IVGSetAsTable
   <Element, ICOps <Element> > (numberOfElements)
{
}

// protected members

template <class Element>
inline
IVSetAsTable <Element>::
IVSetAsTable (PureImplementation& impl)
: IVGSetAsTable
   <Element, ICOps <Element> > (impl)
{
}
#endif

#endif // _ISETTAB_INL_
