// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 41 1.4.1.4 source/core/collect/isrlst.inl, collection, ioc.v400, 000919  
#ifndef _ISRLST_INL_
#define _ISRLST_INL_

// ---
// IGSortedRelationAsListCursor
// ---

#include <ilanglvl.hpp>

// public members

template <class Element, class Key, class ElementOps>
inline
IGSortedRelationAsListCursor <Element, Key, ElementOps>::
IGSortedRelationAsListCursor
  (IGSortedRelationAsList
    <Element, Key, ElementOps> const& collection)
: IOrderedCursor <Element>
    (collection.ivImpl->CreateCursor ())
{
}

template <class Element, class Key, class ElementOps>
inline IGSortedRelationAsListCursor <Element, Key, ElementOps>&
IGSortedRelationAsListCursor <Element, Key, ElementOps>::
operator=
  (IGSortedRelationAsListCursor
    <Element, Key, ElementOps> const& cursor)
{ Inherited::operator= (cursor);
  return *this;
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGSortedRelationAsListCursor <Element, Key, ElementOps>::
IGSortedRelationAsListCursor (ICursorImpl* impl)
: IOrderedCursor <Element> (impl)
{
}

#if ! defined (__INO_MNGCURSOR__)
// ---
// IGSortedRelationAsListMngCursor
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IGSortedRelationAsListMngCursor <Element, Key, ElementOps>::
IGSortedRelationAsListMngCursor
  (IGSortedRelationAsList
    <Element, Key, ElementOps> const& collection)
: IGSortedRelationAsListCursor <Element, Key, ElementOps>
    (collection.ivImpl->CreateMngCursor ())
{
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGSortedRelationAsListMngCursor <Element, Key, ElementOps>::
IGSortedRelationAsListMngCursor (ICursorImpl* impl)
: IGSortedRelationAsListCursor <Element, Key, ElementOps> (impl)
{
}

#endif
// ---
// IGSortedRelationAsList
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IGSortedRelationAsList <Element, Key, ElementOps>::
IGSortedRelationAsList (INumber numberOfElements)
{ this->SetImpl ((Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements));
}

template <class Element, class Key, class ElementOps>
inline
IGSortedRelationAsList <Element, Key, ElementOps>::
IGSortedRelationAsList
  (IGSortedRelationAsList
    <Element, Key, ElementOps> const& collection)
{ this->CloneImplOf (collection);
}

template <class Element, class Key, class ElementOps>
inline IGSortedRelationAsList <Element, Key, ElementOps>&
IGSortedRelationAsList <Element, Key, ElementOps>::
operator= (IGSortedRelationAsList
            <Element, Key, ElementOps> const& collection)
{ this->ImplOf (*this).Copy (this->ImplOf (collection));
  return *this;
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGSortedRelationAsList <Element, Key, ElementOps>::
IGSortedRelationAsList (PureImplementation& impl)
{ this->SetImpl (&impl);
}

template <class Element, class Key, class ElementOps>
inline TYPENAME IGSortedRelationAsList
 <Element, Key, ElementOps>::Implementation&
IGSortedRelationAsList <Element, Key, ElementOps>::
ImplOf (IGSortedRelationAsList
         <Element, Key, ElementOps> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

// ---
// ISortedRelationAsList
// ---

// public members

template <class Element, class Key>
inline
ISortedRelationAsList <Element, Key>::
ISortedRelationAsList (INumber numberOfElements)
: IGSortedRelationAsList
   <Element, Key, IEKCOps <Element, Key> > (numberOfElements)
{
}

// protected members

template <class Element, class Key>
inline
ISortedRelationAsList <Element, Key>::
ISortedRelationAsList (PureImplementation& impl)
: IGSortedRelationAsList
   <Element, Key, IEKCOps <Element, Key> > (impl)
{
}
#if ! defined (__INO_AVALON__)

// ---
// IVGSortedRelationAsList
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IVGSortedRelationAsList <Element, Key, ElementOps>::
IVGSortedRelationAsList (INumber numberOfElements)
: IGSortedRelationAsList
    <Element, Key, ElementOps> (*(Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements))
{
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IVGSortedRelationAsList <Element, Key, ElementOps>::
IVGSortedRelationAsList (PureImplementation& impl)
: IGSortedRelationAsList
    <Element, Key, ElementOps> (impl)
{
}

// ---
// IVSortedRelationAsList
// ---

// public members

template <class Element, class Key>
inline
IVSortedRelationAsList <Element, Key>::
IVSortedRelationAsList (INumber numberOfElements)
: IVGSortedRelationAsList
   <Element, Key, IEKCOps <Element, Key> > (numberOfElements)
{
}

// protected members

template <class Element, class Key>
inline
IVSortedRelationAsList <Element, Key>::
IVSortedRelationAsList (PureImplementation& impl)
: IVGSortedRelationAsList
   <Element, Key, IEKCOps <Element, Key> > (impl)
{
}
#endif

#endif // _ISRLST_INL_
