// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 72 1.4.1.4 source/core/collect/istkdil.inl, collection, ioc.v400, 000919  
#ifndef _ISTKDIL_INL_
#define _ISTKDIL_INL_

// ---
// IGStackAsDilTableCursor
// ---

#include <ilanglvl.hpp>

// public members

template <class Element, class ElementOps>
inline
IGStackAsDilTableCursor <Element, ElementOps>::
IGStackAsDilTableCursor
  (IGStackAsDilTable
    <Element, ElementOps> const& collection)
: IOrderedCursor <Element>
    (collection.ivImpl->CreateCursor ())
{
}

template <class Element, class ElementOps>
inline IGStackAsDilTableCursor <Element, ElementOps>&
IGStackAsDilTableCursor <Element, ElementOps>::
operator=
  (IGStackAsDilTableCursor
    <Element, ElementOps> const& cursor)
{ Inherited::operator= (cursor);
  return *this;
}

// protected members

template <class Element, class ElementOps>
inline
IGStackAsDilTableCursor <Element, ElementOps>::
IGStackAsDilTableCursor (ICursorImpl* impl)
: IOrderedCursor <Element> (impl)
{
}

#if ! defined (__INO_MNGCURSOR__)
// ---
// IGStackAsDilTableMngCursor
// ---

// public members

template <class Element, class ElementOps>
inline
IGStackAsDilTableMngCursor <Element, ElementOps>::
IGStackAsDilTableMngCursor
  (IGStackAsDilTable
    <Element, ElementOps> const& collection)
: IGStackAsDilTableCursor <Element, ElementOps>
    (collection.ivImpl->CreateMngCursor ())
{
}

// protected members

template <class Element, class ElementOps>
inline
IGStackAsDilTableMngCursor <Element, ElementOps>::
IGStackAsDilTableMngCursor (ICursorImpl* impl)
: IGStackAsDilTableCursor <Element, ElementOps> (impl)
{
}

#endif
// ---
// IGStackAsDilTable
// ---

// public members

template <class Element, class ElementOps>
inline
IGStackAsDilTable <Element, ElementOps>::
IGStackAsDilTable (INumber numberOfElements)
{ this->SetImpl ((Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements));
}

template <class Element, class ElementOps>
inline
IGStackAsDilTable <Element, ElementOps>::
IGStackAsDilTable
  (IGStackAsDilTable
    <Element, ElementOps> const& collection)
{ this->CloneImplOf (collection);
}

template <class Element, class ElementOps>
inline IGStackAsDilTable <Element, ElementOps>&
IGStackAsDilTable <Element, ElementOps>::
operator= (IGStackAsDilTable
            <Element, ElementOps> const& collection)
{ this->ImplOf (*this).Copy (this->ImplOf (collection));
  return *this;
}

// protected members

template <class Element, class ElementOps>
inline
IGStackAsDilTable <Element, ElementOps>::
IGStackAsDilTable (PureImplementation& impl)
{ this->SetImpl (&impl);
}

template <class Element, class ElementOps>
inline TYPENAME IGStackAsDilTable
 <Element, ElementOps>::Implementation&
IGStackAsDilTable <Element, ElementOps>::
ImplOf (IGStackAsDilTable
         <Element, ElementOps> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

// ---
// IStackAsDilTable
// ---

// public members

template <class Element>
inline
IStackAsDilTable <Element>::
IStackAsDilTable (INumber numberOfElements)
: IGStackAsDilTable
   <Element, IStdOps <Element> > (numberOfElements)
{
}

// protected members

template <class Element>
inline
IStackAsDilTable <Element>::
IStackAsDilTable (PureImplementation& impl)
: IGStackAsDilTable
   <Element, IStdOps <Element> > (impl)
{
}
#if ! defined (__INO_AVALON__)

// ---
// IVGStackAsDilTable
// ---

// public members

template <class Element, class ElementOps>
inline
IVGStackAsDilTable <Element, ElementOps>::
IVGStackAsDilTable (INumber numberOfElements)
: IGStackAsDilTable
    <Element, ElementOps> (*(Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements))
{
}

// protected members

template <class Element, class ElementOps>
inline
IVGStackAsDilTable <Element, ElementOps>::
IVGStackAsDilTable (PureImplementation& impl)
: IGStackAsDilTable
    <Element, ElementOps> (impl)
{
}

// ---
// IVStackAsDilTable
// ---

// public members

template <class Element>
inline
IVStackAsDilTable <Element>::
IVStackAsDilTable (INumber numberOfElements)
: IVGStackAsDilTable
   <Element, IStdOps <Element> > (numberOfElements)
{
}

// protected members

template <class Element>
inline
IVStackAsDilTable <Element>::
IVStackAsDilTable (PureImplementation& impl)
: IVGStackAsDilTable
   <Element, IStdOps <Element> > (impl)
{
}
#endif

#endif // _ISTKDIL_INL_
