// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 82 1.4.1.3 source/core/collect/itree.h, collection, ioc.v400, 000919 
#ifndef _ITREE_
#define _ITREE_

#include <imwt.h>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__)
#if defined (__RRBC_IBM__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

template <class Element, class ElementOps, INumber numOfChildren>
class IGTree :
  public IGMultiwayTree <numOfChildren, Element, ElementOps> {

  typedef  IGMultiwayTree
            <numOfChildren, Element, ElementOps> Inherited;

public:

  IGTree <Element, ElementOps, numOfChildren>&
           operator=        (IGTree <Element, ElementOps,
                                     numOfChildren> const& tree)
           { Inherited::operator= (tree);
             return *this;
           }

protected:

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine ()
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           operator=\
                        )
#endif

};

template <class Element, INumber numOfChildren>
class ITree :
  public IGTree <Element, IStdOps <Element>, numOfChildren> {
public:

protected:

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
                        )
#endif

};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#if defined (__SOM_ENABLED__) 
#pragma SOMAsDefault (pop)
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _ITREE_
