/*
*****************************************************************************************
*                                                                                       *
* COPYRIGHT:                                                                            *
*   IBM Open Class Library                                                              *
*   (C) Copyright International Business Machines Corporation,  1997                    *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.                  *
*   US Government Users Restricted Rights - Use, duplication, or disclosure             *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                              *
*                                                                                       *
*****************************************************************************************
*/

// Revision: 79 1.4.1.3 source/core/filesys/win32/winhdl.cpp, filesystem, ioc.v400, 000919 
// winhdl.cpp
// Created by laura on Sat, Jan 26, 1996 @ 8:26 PM.

#include <iexcept.hpp>
#include "winhdl.hpp"

#ifdef IC_PAGETUNE
    #define _WINHDL_CPP_
    #include <ipagetun.h>
#endif

void    TWin32Handle::Close()
{
        if (fHandle != INVALID_HANDLE_VALUE) {
                BOOL result = ::CloseHandle(fHandle);
                fHandle = INVALID_HANDLE_VALUE;

                if (!result) {
                        ITHROWSYSTEMERROR(GetLastError(), "CloseHandle", IBaseErrorInfo::deviceError,
                                                                IException::recoverable);
                }
        }
}

TWin32Handle::TWin32Handle()
        : fHandle(INVALID_HANDLE_VALUE)
{

}

void    TWin32Handle::operator=( HANDLE hdl )
{
        Close();
        fHandle = hdl;
}


void    TWin32Handle::operator=(const TWin32Handle)
{
        // Disallowed
}


TWin32Handle::TWin32Handle(const TWin32Handle&)
{
        // Disallowed
}




TWin32Handle::~TWin32Handle()
{
        if (fHandle != INVALID_HANDLE_VALUE) {
                ::CloseHandle(fHandle);

                // Do NOT throw any exceptions; it's unsafe to do so from a
                // destructor, because a destructor could be called during
                // the stack unwind for another exception.
        }
}
