/*NOSHIP*/
/*
*****************************************************************************************
*                                                                                       *
* COPYRIGHT:                                                                            *
*   IBM Open Class Library                                                              *
*   (C) Copyright International Business Machines Corporation,  1997                    *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.                  *
*   US Government Users Restricted Rights - Use, duplication, or disclosure             *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                              *
*                                                                                       *
*****************************************************************************************
*/

// Revision: 87 1.6.1.4 source/core/filesys/win32/winhdl.hpp, filesystem, ioc.v400, 000919 
// Win32Handle.h
// Created by laura on Sat, Jan 26, 1996 @ 8:26 PM.

#ifndef _WINHDL_
#define _WINHDL_

#define WIN32_LEAN_AND_MEAN 1
#include <windows.h>

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)

class TWin32Handle {
public:
                        TWin32Handle();
                        TWin32Handle( HANDLE hdl ) : fHandle(hdl) {}
        virtual ~TWin32Handle();

        void    operator=( HANDLE hdl );

                        operator HANDLE() const         { return fHandle; }

        void    Close();

private:
        void    operator=(const TWin32Handle);
                        TWin32Handle(const TWin32Handle&);

        HANDLE  fHandle;
};

#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif // _WINHDL_
