/*NOSHIP*/
/*
*****************************************************************************************
*                                                                                       *
* COPYRIGHT:                                                                            *
*   IBM Open Class Library                                                              *
*   (C) Copyright International Business Machines Corporation,  1997                    *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.                  *
*   US Government Users Restricted Rights - Use, duplication, or disclosure             *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                              *
*                                                                                       *
*****************************************************************************************
*/

// Revision: 89 1.6.1.5 source/core/filesys/win32/winstrm.hpp, filesystem, ioc.v400, 000919 
// winstrm.hpp
// Created by laura on Tue, Feb 19, 1996 @ 10:58 PM.

#ifndef _WINSTRM_
#define _WINSTRM_

#include "fsstream.hpp"
#include "winpaths.hpp"

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)

class IWinFileStream : public IFSFileStream {
public:
                                                IWinFileStream(const INTPathName path, int myMode, int otherMode);
        virtual                         ~IWinFileStream();

        virtual ptrdiff_t       doRead  ( void *data, ptrdiff_t count ) ;


        virtual void            doWrite ( const void *data, ptrdiff_t count ) ;


        virtual IFileSize       doSeek  ( IFileSize position, seek_dir dir ) ;


        virtual void            close() ;


        virtual void            setEndOfFile(IFileSize newSize);


        virtual IFileSize       endOfFile() const ;


private:
// Disallowed functions...
                                                IWinFileStream(const IWinFileStream &copy);
        IWinFileStream &        operator = (const IWinFileStream &copy);

// Private data...
        HANDLE          fHandle;
    int         fMode;
};

#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif // _WINSTRM_
