/*
*****************************************************************************************
*                                                                                       *
* COPYRIGHT:                                                                            *
*   IBM Open Class Library                                                              *
*   (C) Copyright International Business Machines Corporation,  1997                    *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.                  *
*   US Government Users Restricted Rights - Use, duplication, or disclosure             *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                              *
*                                                                                       *
*****************************************************************************************
*/
// Revision: 43 1.9.1.3 source/core/streams/idatstrm.cpp, oss, ioc.v400, 000919 
//
//
//
// idatstrm.cpp
//
#include <idatstrm.hpp>
#include "imstrmbf.hpp"

#ifdef IC_PAGETUNE
    #define _IDATSTRM_CPP_
    #include <ipagetun.h>
#endif

IDataStream::IDataStream(IStreamIO* streamIO)
        :       fStreamIO(streamIO)
{
        streamIO->setStream(this);
}

IDataStream::IDataStream()
        :       fStreamIO(0)
{
}

IDataStream::IDataStream(const IDataStream& other)
        :       fStreamIO(0)
{
}

IDataStream::~IDataStream()
{
        delete fStreamIO;
}

IDataStream*
IDataStream::createMemoryStream(int encoding)
{
        IMemoryStreamBuffer* streamBuffer = new IMemoryStreamBuffer();
        return streamBuffer->createWithStreamEncoding(encoding);
}
