/*
*****************************************************************************************
*                                                                                       *
* COPYRIGHT:                                                                            *
*   IBM Open Class Library                                                              *
*   (C) Copyright International Business Machines Corporation,  1997                    *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.                  *
*   US Government Users Restricted Rights - Use, duplication, or disclosure             *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                              *
*                                                                                       *
*****************************************************************************************
*/
// Revision: 68 1.9.1.4 source/core/streams/istrmbf.hpp, oss, ioc.v400, 000919 
//
//
//
// istrmbf.hpp
//
#ifndef _ISTRMBF_
#define _ISTRMBF_

#include <imrefcnt.hpp>
#include <istrmfct.hpp>

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)

//
// IStreamBuffer
//
class IStreamBuffer : public virtual IMRefCounted, public IStreamFactory
{
public:
        virtual void    writeBytes(const char*  data, unsigned long length) = 0;
        virtual void    readBytes(char* data, unsigned long length) = 0;

        virtual void    reset() = 0;
        virtual void    flush() = 0;

protected:
        IStreamBuffer();
        IStreamBuffer(const IStreamBuffer& other);
        virtual ~IStreamBuffer();

        IDataStream*    createWithStreamEncoding(int encoding);
};

#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif // _ISTRMBF_
