/*
*****************************************************************************************
*                                                                                       *
* COPYRIGHT:                                                                            *
*   IBM Open Class Library                                                              *
*   (C) Copyright International Business Machines Corporation,  1997                    *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.                  *
*   US Government Users Restricted Rights - Use, duplication, or disclosure             *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                              *
*                                                                                       *
*****************************************************************************************
*/
// Revision: 77 1.10.1.4 source/core/streams/istrmfct.hpp, oss, ioc.v400, 000919 
//
//
//
// istrmfct.hpp
//
#ifndef _ISTRMFCT_
#define _ISTRMFCT_

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

//
// external class declarations.
//
class IDataStream;
class IStreamIO;
class IStreamBuffer;

#pragma pack(push,4)

//
// IStreamFactory
//
class IStreamFactory
{
protected:
        IStreamFactory();
        IStreamFactory(const IStreamFactory& other);
        virtual ~IStreamFactory();

        IDataStream*    createWithStreamIO(IStreamIO* streamIO);
        IDataStream*    createWithStreamEncoding(int encoding, IStreamBuffer* streamBuffer);
};

#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif // _STRMFCT_
