/*
*****************************************************************************************
*                                                                                       *
* COPYRIGHT:                                                                            *
*   IBM Open Class Library                                                              *
*   (C) Copyright International Business Machines Corporation,  1997                    *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.                  *
*   US Government Users Restricted Rights - Use, duplication, or disclosure             *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                              *
*                                                                                       *
*****************************************************************************************
*/
// Revision: 96 1.6.1.4 source/core/streams/itypenam.hpp, oss, ioc.v400, 000919 
//
//
//
// itypenam.hpp
//
#ifndef _ITYPENAM_
#define _ITYPENAM_

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

//
// external class declarations.
//
class ITypeRepresentation;
class IStreamModule;
class IStreamableFactory;

#pragma pack(push,4)

//
// ITypeName
//
class ITypeName
{
public:
        ITypeName(const char* formattedName);
        ITypeName();
        ITypeName(const ITypeName& other);
        ~ITypeName();
        ITypeName& operator=(const ITypeName& other);

        const char*     formattedName() const;

        static  const ITypeName&        nameOfTypeRepresentation(const ITypeRepresentation& typeRep);

private:
friend class IStreamableFactory;
        ITypeName(const char* moduleName, const char* className);

friend class IStreamModule;
        const char*     componentAt(unsigned long index) const;

private:
        unsigned long   fNComponents;
        char**  fComponents;
        char*   fFormattedName;
};

#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif // _ITYPENAM_
