// Revision: 38 1.4.1.3 source/core/testfw/idecwrap.cpp, testfw, ioc.v400, 000919 
/*
*****************************************************************************************
*                                                                                       *
* COPYRIGHT:                                                                            *
*   IBM Open Class Library                                                              *
*   (C) Copyright International Business Machines Corporation,  1997                    *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.                  *
*   US Government Users Restricted Rights - Use, duplication, or disclosure             *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                              *
*                                                                                       *
*****************************************************************************************
*/

#include <idecwrap.hpp>

// Segment definitions
#ifdef IC_PAGETUNE
    #define _IDECWRAP_CPP_
    #include <ipagetun.h>
#endif

//-----------------------------------------------------------------------------
//  IDecisionFnWrapper clas definitions
//-----------------------------------------------------------------------------
IDecisionFnWrapper::IDecisionFnWrapper(ITestDecisionFn v, const IString& key):fDecisionFn(v), fKey(key)
{
}

IDecisionFnWrapper::IDecisionFnWrapper()
{
}

IDecisionFnWrapper::IDecisionFnWrapper(const IDecisionFnWrapper& copyIn)
{
        fDecisionFn = copyIn.fDecisionFn;
        fKey = copyIn.fKey;
}

IDecisionFnWrapper::~IDecisionFnWrapper()
{
}

IDecisionFnWrapper& IDecisionFnWrapper::operator=(const IDecisionFnWrapper& copyIn)
{
        if (&copyIn != this)
        {
            fDecisionFn = copyIn.fDecisionFn;
                fKey = copyIn.fKey;
        }
        return *this;
}

bool IDecisionFnWrapper::operator==(IDecisionFnWrapper const& rhs) const
{
        return (fKey == rhs.fKey);
        }


const ITestDecisionFn IDecisionFnWrapper::decisionFn() const
{
        return fDecisionFn;
}

const IString& IDecisionFnWrapper::getkey() const
{
        return fKey;
}

void IDecisionFnWrapper::setDecisionFn(ITestDecisionFn v)
{
        fDecisionFn = v;
}

IString const& key(IDecisionFnWrapper const& d)
{
        return d.getkey();
}
