// Revision: 39 1.8.1.4 source/core/testfw/idecwrap.hpp, testfw, ioc.v400, 000919 
#ifndef _IDECWRAP_
#define _IDECWRAP_
/*
*****************************************************************************************
*                                                                                       *
* COPYRIGHT:                                                                            *
*   IBM Open Class Library                                                              *
*   (C) Copyright International Business Machines Corporation,  1997                    *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.                  *
*   US Government Users Restricted Rights - Use, duplication, or disclosure             *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                              *
*                                                                                       *
*****************************************************************************************
*/

#include <itest.hpp>
#include <istring.hpp>

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

typedef bool (ITest::*ITestDecisionFn)();

#pragma enum(4)
#pragma pack(push,4)

//--------------------------------------------------------------------------
//  IDecisionFnWrapper (Internal class)
//
//  This class is used by ITestMultiplexer to store decision function and key
//  in fDictionary.
//  It is intended purely for internal uses.
//--------------------------------------------------------------------------
class IDecisionFnWrapper {
public:

      IDecisionFnWrapper(ITestDecisionFn v, const IString& key);
      IDecisionFnWrapper(const IDecisionFnWrapper& copyIn);
      IDecisionFnWrapper& operator=(const IDecisionFnWrapper& copyIn);
     bool operator==(IDecisionFnWrapper const& rhs) const;
         const ITestDecisionFn decisionFn() const;
          const IString&  getkey() const;
      void setDecisionFn(ITestDecisionFn v);

     bool operator < (const IDecisionFnWrapper& dec)  const
       { return (fKey < dec.fKey); }
      IDecisionFnWrapper();
      ~IDecisionFnWrapper();

private:

      ITestDecisionFn   fDecisionFn;
          IString           fKey;
};

#pragma pack(pop)
#pragma enum(pop)

IString const& key(IDecisionFnWrapper const& d);

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif // _IDECWRAP_
