// Revision: 09 1.4.1.3 source/core/testfw/istrwrap.cpp, testfw, ioc.v400, 000919 
/*
*****************************************************************************************
*                                                                                       *
* COPYRIGHT:                                                                            *
*   IBM Open Class Library                                                              *
*   (C) Copyright International Business Machines Corporation,  1997                    *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.                  *
*   US Government Users Restricted Rights - Use, duplication, or disclosure             *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                              *
*                                                                                       *
*****************************************************************************************
*/

#include <istrwrap.hpp>

// Segment definitions
#ifdef IC_PAGETUNE
    #define _ISTRWRAP_CPP_
    #include <ipagetun.h>
#endif

IStringWrapper::IStringWrapper()
{
}

IStringWrapper::IStringWrapper(const IString& keystr,const IString& valuestr)
:fKey(keystr), fValue(valuestr)
{
}


IStringWrapper::~IStringWrapper()
{
}


IStringWrapper::IStringWrapper(const IStringWrapper& other)
:fKey(other.fKey), fValue(other.fValue)
{
}


IStringWrapper& IStringWrapper::operator=(IStringWrapper const& other)
{
                fKey = other.fKey;
                fValue = other.fValue;

        return *this;
}


IString const& IStringWrapper::getkey() const
{
        return fKey;
}

IString const& IStringWrapper::value() const
{
        return fValue;
}


bool IStringWrapper::operator==(IStringWrapper const&other) const
{
        return (fKey == other.fKey);
}

bool IStringWrapper::operator<(IStringWrapper const& other) const
{
        return (fKey < other.fKey);
}


IString const& key(IStringWrapper const& ism)
{
        return ism.getkey();
}
