// Revision: 19 1.4.1.3 source/core/testfw/itiertxt.cpp, testfw, ioc.v400, 000919 
/*
*****************************************************************************************
*                                                                                       *
* COPYRIGHT:                                                                            *
*   IBM Open Class Library                                                              *
*   (C) Copyright International Business Machines Corporation,  1997                    *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.                  *
*   US Government Users Restricted Rights - Use, duplication, or disclosure             *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                              *
*                                                                                       *
*****************************************************************************************
*/

#include <itiertxt.hpp>

// Segment definitions
#ifdef IC_PAGETUNE
    #define _ITIERTXT_CPP_
    #include <ipagetun.h>
#endif

//-----------------------------------------------------------------------------
// Special member functions
//-----------------------------------------------------------------------------

//_____________________________________________________________________________
ITieredText::ITieredText(): IString()
{
        fTier = ITieredTextBuffer::kNormal;
}

//_____________________________________________________________________________
ITieredText::ITieredText(const ITieredText& source): IString(source)
{
        fTier = source.fTier;
}

//_____________________________________________________________________________
ITieredText::ITieredText(const IString& text, ITieredTextBuffer::ETier tier): IString(text)
{
        setTier(tier);
}

//_____________________________________________________________________________
ITieredText& ITieredText::operator=(const ITieredText& source)
{
        if (this != &source) {
                IString::operator=(source);
                fTier = source.fTier;
        }
        return *this;
}

//_____________________________________________________________________________
ITieredText::~ITieredText()
{
}



//-----------------------------------------------------------------------------
// Tier access
//-----------------------------------------------------------------------------

//_____________________________________________________________________________
ITieredTextBuffer::ETier ITieredText::setTier(ITieredTextBuffer::ETier theTier)
{
        ITieredTextBuffer::ETier oldTier = fTier;
// CompTech suggests this is unneeded because theTier is unsigned and kTop is 0
//      if (theTier < ITieredTextBuffer::kTop) theTier = ITieredTextBuffer::kTop;
        if (theTier > ITieredTextBuffer::kBottom) theTier = ITieredTextBuffer::kBottom;
        fTier = theTier;
        return oldTier;
}

//_____________________________________________________________________________
ITieredTextBuffer::ETier ITieredText::tier() const
{
        return fTier;
}
