// Revision: 20 1.9.1.4 source/core/testfw/itiertxt.hpp, testfw, ioc.v400, 000919 
#ifndef _ITIERTXT_
#define _ITIERTXT_
/**
 * @package Test Framework
 * @category Testing
 *
 * @author Alan Liu
 * @task Initial Test Framework
 * @author Esther Tong
 * @task TestFrameworkLite
 * @author David McCusker, Christoper Miller, Carol Widra, and Kwansook Nam
 * @task Many of the other Contributors to TestFramework
 *
 * @copyright
 *      IBM Open Class Library
 *      (C) Copyright International Business Machines Corporation 1997
 *      Licensed Material - Program-Property of IBM - All Rights Reserved.
 *      US Government Users Restricted Rights - Use, duplication, or disclosure
 *      restricted by GSA ADP Schedule Contract with IBM Corp.
 *
 */

#include <istring.hpp>
#include <ittxtbuf.hpp>

#include <itfwpl.hpp>           // pragma library definitions

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma enum(4)
#pragma pack(push,4)

//-----------------------------------------------------------------------------
// ITieredText
//-----------------------------------------------------------------------------

/*
        class ITieredText
        ITieredText is a IString subclass which adds tier information. This
        indicates how important a piece of text is.
*/

class ITieredText: public IString {
public:

        //-------------------------------------------------------------------------
        // Canonical methods
        //-------------------------------------------------------------------------
        ITieredText();
        ITieredText(const IString&, ITieredTextBuffer::ETier tier = ITieredTextBuffer::kNormal);
        ITieredText(const ITieredText& source);
        ITieredText& operator=(const ITieredText& source);
        virtual ~ITieredText();


        //-------------------------------------------------------------------------
        // Tier access
        //-------------------------------------------------------------------------
        virtual ITieredTextBuffer::ETier                        setTier(ITieredTextBuffer::ETier); // Tier is clipped to valid range
                        ITieredTextBuffer::ETier                        tier() const;

//______________________________________________________________________________
private:
        ITieredTextBuffer::ETier                        fTier;

};

#pragma pack(pop)
#pragma enum(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif // _ITIERTXT_
