// Revision: 30 1.8.1.4 source/core/text/intl/transcod/csetiter.cpp, text, ioc.v400, 000919 
/*
*****************************************************************************************
*                                                                                       *
* COPYRIGHT:                                                                            *
*   IBM Open Class Library                                                              *
*   (C) Copyright International Business Machines Corporation,  1997                    *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.                  *
*   US Government Users Restricted Rights - Use, duplication, or disclosure             *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                              *
*                                                                                       *
*****************************************************************************************
*/
//
//  File: csetiter.cpp
//  Function: Character Set Iterator implementation.
//  Author: Chen-Lieh Huang
//  Date created: 04/05/1996
//
#ifndef IC_ITRANCOD
#include "itrancod.hpp"
#endif

#ifdef IC_PAGETUNE
        #define _CSETITER_CPP
        #include <ipagetun.h>
#endif


ICharacterSetIterator::ICharacterSetIterator()
        : fCurCharSetIdx (0)
{
}


ICharacterSetIterator::~ICharacterSetIterator()
{
}


ICharacterSetIterator::ICharacterSetIterator(const ICharacterSetIterator &source)
        : fCurCharSetIdx(source.fCurCharSetIdx)
{
}


ICharacterSetIterator &
ICharacterSetIterator::operator=(const ICharacterSetIterator &right)
{
        if (this != &right)
                fCurCharSetIdx = right.fCurCharSetIdx;

        return *this;
}


//      Platform specific APIs.
//ICharacterSetIterator::operator bool() const {...}
//const IText ICharacterSetIterator::operator*(){...}


ICharacterSetIterator&
ICharacterSetIterator::operator++()     // prefix
{
        ++fCurCharSetIdx;

        return *this;
}


ICharacterSetIterator
ICharacterSetIterator::operator++(int)  // postfix
{
        ICharacterSetIterator   temp(*this);

        ++fCurCharSetIdx;

        return temp;
}


bool
ICharacterSetIterator::operator==(const ICharacterSetIterator& right) const
{
        return fCurCharSetIdx == right.fCurCharSetIdx;
}


bool
ICharacterSetIterator::operator!=(const ICharacterSetIterator& right) const
{
        return !(operator==(right));
}


void
ICharacterSetIterator::reset()
{
        fCurCharSetIdx = 0;
}
