// Revision: 27 1.4 source/core/text/itext/istylset.inl, text, ioc.v400, 000919 
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//
//      IStylSet.inl
//
//  This file contains the definition of the inline functions for
//      the classes declared in istylset.hpp.
//
//      IBM Open Class Library
//      (C) Copyright International Business Machines Corporation 1997
//      Licensed Material - Program-Property of IBM - All Rights Reserved.
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#ifndef _ISTYLSET_INL
#define _ISTYLSET_INL



//========================================================================================
// INLINES FOR CLASS ITextStyleSet
//========================================================================================

inline void
ITextStyleSet::setContainmentFlag(unsigned long mask)
{
        fStyleContainmentFlags |= mask;
}

inline void
ITextStyleSet::clearContainmentFlag(unsigned long       mask)
{
        fStyleContainmentFlags &= ~mask;
}

inline bool
ITextStyleSet::testContainmentFlag(unsigned long        mask) const
{
        return !!(fStyleContainmentFlags & mask);
}

inline void
ITextStyleSet::setFloatValue(   short           index,
                                                                float           newValue)
{
        fFloatStyleValues[index] = newValue;
}

inline float
ITextStyleSet::floatValue(short index) const
{
        return fFloatStyleValues[index];
}

inline void
ITextStyleSet::setBooleanValue( unsigned long   mask,
                                                                bool                    newValue)
{
        if (newValue)
                fBooleanStyleValues |= mask;
        else
                fBooleanStyleValues &= ~mask;
}

inline bool
ITextStyleSet::booleanValue(unsigned long       mask) const
{
        return !!(fBooleanStyleValues & mask);
}

inline void
ITextStyleSet::setColorComponent(       short                   index,
                                                                        unsigned char   newValue)
{
        fColorStyleComponents[index] = newValue;
}

inline unsigned char
ITextStyleSet::colorComponent(  short   index) const
{
        return fColorStyleComponents[index];
}

inline void
ITextStyleSet::setTypefaceValue(const IText&    newValue)
{
        fTextTypefaceStyleValue = newValue;
}

inline IText
ITextStyleSet::typefaceValue() const
{
        return fTextTypefaceStyleValue;
}

inline void
ITextStyleSet::setJustificationValue(IParagraphJustificationStyle::EJustification       newValue)
{
        fParagraphJustificationStyleValue = newValue;
}

inline IParagraphJustificationStyle::EJustification
ITextStyleSet::justificationValue() const
{
        return fParagraphJustificationStyleValue;
}

inline void
ITextStyleSet::setSpreadValue(IParagraphSpreadStyle::ESpread    newValue)
{
        fParagraphSpreadStyleValue = newValue;
}

inline IParagraphSpreadStyle::ESpread
ITextStyleSet::spreadValue() const
{
        return fParagraphSpreadStyleValue;
}

inline ICharacterRenderer*
ITextStyleSet::characterRenderer() const
{
        return fCharacterRenderer;
}

inline IParagraphRenderer*
ITextStyleSet::paragraphRenderer() const
{
        return fParagraphRenderer;
}



#endif // _ISTYLSET_INL
