/*
*****************************************************************************************
*                                                                                       *
* COPYRIGHT:                                                                            *
*   IBM Open Class Library                                                              *
*   (C) Copyright International Business Machines Corporation,  1997                    *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.                  *
*   US Government Users Restricted Rights - Use, duplication, or disclosure             *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                              *
*                                                                                       *
*****************************************************************************************
*/
// Revision: 67 1.4.1.4 source/core/text/itext/itxtstyl.cpp, text, ioc.v400, 000919 

#ifndef IC_ITXTSTYL
#include "itxtstyl.hpp"
#endif

#ifdef IC_PAGETUNE
        #define _ITXTSTYL_CPP
        #include <ipagetun.h>
#endif

//*******************************************************
//      class ITextStyle
//*******************************************************


ITextStyle::ITextStyle()
{
}


ITextStyle::ITextStyle( const ITextStyle& )
{
}


ITextStyle::~ITextStyle()
{
}


ITextStyle&
ITextStyle::operator=( const ITextStyle& other )
{
        if ( &other != this ) {
                }
        return *this;
}


//*******************************************************
//      class ICharacterStyle
//*******************************************************


ICharacterStyle::ICharacterStyle() :
                                        ITextStyle()
{
}


ICharacterStyle::ICharacterStyle( const ICharacterStyle& other ) :
                                        ITextStyle( other )
{
}


ICharacterStyle::~ICharacterStyle()
{
}


ICharacterStyle&
ICharacterStyle::operator=( const ICharacterStyle& other )
{
        if ( &other != this ) {
                ITextStyle::operator=( other );
                }
        return *this;
}


ITextStyle::EStylePropagation
ICharacterStyle::propagates() const
{
        return ITextStyle::kPropagateByCharacter;
}

//*******************************************************
//      class IParagraphStyle
//*******************************************************

IParagraphStyle::IParagraphStyle() :
                                        ITextStyle()
{
}


IParagraphStyle::IParagraphStyle( const IParagraphStyle& other ) :
                                        ITextStyle( other )
{
}



IParagraphStyle::~IParagraphStyle()
{
}


IParagraphStyle&
IParagraphStyle::operator=( const IParagraphStyle& other )
{
        if ( &other != this ) {
                ITextStyle::operator=( other );
                }
        return *this;
}


ITextStyle::EStylePropagation
IParagraphStyle::propagates() const
{
        return ITextStyle::kPropagateByParagraph;
}
