/*
*****************************************************************************************
*                                                                                       *
* COPYRIGHT:                                                                            *
*   IBM Open Class Library                                                              *
*   (C) Copyright International Business Machines Corporation,  1997                    *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.                  *
*   US Government Users Restricted Rights - Use, duplication, or disclosure             *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                              *
*                                                                                       *
*****************************************************************************************
*/
// Revision: 94 1.8.1.4 source/core/text/unicode/iunames.hpp, text, ioc.v400, 000919 
//
//  FILE NAME   iunames.hpp
//
//      CREATED
//              Monday, February 1, 1996
//
//      CREATED BY
//              Text & International Team
//
//      29 Feb 1996             hsys            conform OpenClass coding guideline and update unicode info
//
//      DESCRIPTION
//              This file defines the unicode classes
//
//      COPYRIGHT
//
//
//
//********************************************************************************************


#ifndef _IUNAMES_
#define _IUNAMES_

#include <iunicode.hpp>

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

typedef UArrow::EArrowNames EArrowNames;
typedef UAPLFunctionalSymbol::EAPLFunctionalSymbolNames EAPLFunctionalSymbolNames;
typedef UControlCodePicture::EControlCodePictureNames EControlCodePictureNames;
typedef UOCR::EOCRNames EOCRNames;
typedef UCurrency::ECurrencyNames ECurrencyNames;
typedef ULetterLikeSymbol::ELetterLikeSymbolNames ELetterLikeSymbolNames;
typedef UMathematicalOperators::EMathematicalOperatorsNames EMathematicalOperatorsNames;
typedef UMiscellaneousTechnical::EMiscellaneousTechnicalNames EMiscellaneousTechnicalNames;
typedef UGeometricShapes::EGeometricShapesNames EGeometricShapesNames;
typedef UDingbats::EDingbatsNames EDingbatsNames;
typedef UZapfDingbats::EZapfDingbatsNames EZapfDingbatsNames;
typedef UHarpoon::EHarpoonNames EHarpoonNames;
typedef UCJKSymbols::ECJKSymbolsNames ECJKSymbolsNames;
typedef UStandardPhonetic::EStandardPhoneticNames EStandardPhoneticNames;


typedef UDevanagari::EDevanagariNames EDevanagariNames;
typedef UBengali::EBengaliNames EBengaliNames;
typedef UGurmukhi::EGurmukhiNames EGurmukhiNames;
typedef UGujarati::EGujaratiNames EGujaratiNames;
typedef UOriya::EOriyaNames EOriyaNames;
typedef UTamil::ETamilNames ETamilNames;
typedef UTelugu::ETeluguNames ETeluguNames;
typedef UKannada::EKannadaNames EKannadaNames;
typedef UMalayalam::EMalayalamNames EMalayalamNames;
typedef UThai::EThaiNames EThaiNames;
typedef ULao::ELaoNames ELaoNames;


typedef UHangulSyllable::EHangulSyllableNames EHangulSyllableNames;
typedef UHalfwidthHangulLetter::EHalfwidthHangulLetterNames EHalfwidthHangulLetterNames;
typedef UArabicLigature::EArabicLigatureNames EArabicLigatureNames;
typedef USuperscript::ESuperscriptNames ESuperscriptNames;
typedef USubscript::ESubscriptNames ESubscriptNames;
typedef UVulgarFraction::EVulgarFractionNames EVulgarFractionNames;
typedef URomanNumeral::ERomanNumeralNames ERomanNumeralNames;
typedef UIdeographicTelegraph::EIdeographicTelegraphNames EIdeographicTelegraphNames;
typedef UCircledDigit::ECircledDigitNames ECircledDigitNames;
typedef UCircledNumber::ECircledNumberNames ECircledNumberNames;
typedef UParenthesizedDigit::EParenthesizedDigitNames EParenthesizedDigitNames;
typedef UParenthesizedNumber::EParenthesizedNumberNames EParenthesizedNumberNames;
typedef UFullStopDigit::EFullStopDigitNames EFullStopDigitNames;
typedef UFullStopNumber::EFullStopNumberNames EFullStopNumberNames;
typedef UParenthesizedLatin::EParenthesizedLatinNames EParenthesizedLatinNames;
typedef UCircledLatin::ECircledLatinNames ECircledLatinNames;
typedef UBoxDrawings::EBoxDrawingsNames EBoxDrawingsNames;
typedef UParenthesizedHangul::EParenthesizedHangulNames EParenthesizedHangulNames;
typedef UParenthesizedIdeograph::EParenthesizedIdeographNames EParenthesizedIdeographNames;
typedef UCircledHangul::ECircledHangulNames ECircledHangulNames;
typedef UCircledIdeograph::ECircledIdeographNames ECircledIdeographNames;
typedef UCircledKatakana::ECircledKatakanaNames ECircledKatakanaNames;
typedef UCJKSquaredWords::ECJKSquaredWordsNames ECJKSquaredWordsNames;
typedef UCJKSquaredAbbreviations::ECJKSquaredAbbreviationsNames ECJKSquaredAbbreviationsNames;
typedef ULatinSmallLigature::ELatinSmallLigatureNames ELatinSmallLigatureNames;
typedef UArmenianSmallLigature::EArmenianSmallLigatureNames EArmenianSmallLigatureNames;
typedef UFullwidth::EFullwidthNames EFullwidthNames;
typedef UHalfwidth::EHalfwidthNames EHalfwidthNames;
typedef UPresentationFormForVertical::EPresentationFormForVerticalNames EPresentationFormForVerticalNames;
typedef USmallVariants::ESmallVariantsNames ESmallVariantsNames;
typedef UCJKCompatibility::ECJKCompatibilityNames ECJKCompatibilityNames;
typedef UCNSCompatibility::ECNSCompatibilityNames ECNSCompatibilityNames;
typedef UBlocks::EBlocksNames EBlocksNames;

typedef UKangXiRadical::EKangXiRadicalNames EKangXiRadicalNames;
typedef UHanNumeral::EHanNumeralNames EHanNumeralNames;
typedef UHiragana::EHiraganaNames EHiraganaNames;
typedef UKatakana::EKatakanaNames EKatakanaNames;
typedef UKatakanaHiragana::EKatakanaHiraganaNames EKatakanaHiraganaNames;
typedef UHangulChoseong::EHangulChoseongNames EHangulChoseongNames;
typedef UHangulJungseong::EHangulJungseongNames EHangulJungseongNames;
typedef UBopomofo::EBopomofoNames EBopomofoNames;
typedef UHangulLetter::EHangulLetterNames EHangulLetterNames;
typedef UHangulJongseong::EHangulJongseongNames EHangulJongseongNames;
typedef UHangzhouNumeral::EHangzhouNumeralNames EHangzhouNumeralNames;
typedef UIdeographicAnnotation::EIdeographicAnnotationNames EIdeographicAnnotationNames;

typedef UGreek::EGreekNames EGreekNames;
typedef UCyrillic::ECyrillicNames ECyrillicNames;
typedef UGeorgian::EGeorgianNames EGeorgianNames;
typedef UCoptic::ECopticNames ECopticNames;


typedef ULatin::ELatinNames ELatinNames;
typedef UModifierLetter::EModifierLetterNames EModifierLetterNames;
typedef UCombining::ECombiningNames ECombiningNames;
typedef UUnicodeDigit::EUnicodeDigitNames EUnicodeDigitNames;
typedef UASCII::EASCIINames EASCIINames;
typedef ULatin1::ELatin1Names ELatin1Names;
typedef UGeneralPunctuation::EGeneralPunctuationNames EGeneralPunctuationNames;
typedef UWhiteSpace::EWhiteSpaceNames EWhiteSpaceNames;
typedef UUnicodeSpecial::EUnicodeSpecialNames EUnicodeSpecialNames;
typedef UControlCode::EControlCodeNames EControlCodeNames;

typedef UHebrew::EHebrewNames EHebrewNames;
typedef UArabic::EArabicNames EArabicNames;
typedef UArmenian::EArmenianNames EArmenianNames;


typedef IUnicode::EUnicodeBounds                                EUnicodeBounds;
typedef IUnicode::EUnicodeScript                                EUnicodeScript;
typedef IUnicode::ECharacterProperty                    ECharacterProperty;
typedef IUnicode::ECharacterLayoutType                  ECharacterLayoutType;
typedef IUnicode::EDirectionProperty                    EDirectionProperty;
typedef IUnicode::ICharacterLayoutProperties    ICharacterLayoutProperties;
typedef IUnicode::ICharacterProperties                  ICharacterProperties;

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif // _IUNAMES_
