/*
*****************************************************************************************
*                                                                                       *
* COPYRIGHT:                                                                            *
*   IBM Open Class Library                                                              *
*   (C) Copyright International Business Machines Corporation,  1997                    *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.                  *
*   US Government Users Restricted Rights - Use, duplication, or disclosure             *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                              *
*                                                                                       *
*****************************************************************************************
*/

// Revision: 78 1.6.1.3 source/core/utils/inumutil.hpp, utilities, ioc.v400, 000919 
#ifndef _INUMUTIL_
#define _INUMUTIL_

#ifndef _IBASEPL_H
#include <ibasepl.hpp>          // Need the base library
#endif

/******************************************************************************
 *
 *      File: numericutilities.h
 *
 *      Description: General numerics utility routines for internal use
 *
 *      All rights reserved.
 *
 *      Modification History
 *              Created 7/30/93, Adolfo Nemirovsky
 *              SJP - Added _MULUL and _DIVUL for TDoubleLong and
 *                  TCanonicalNumber support.
 *      14 Feb 95  JPO  Specialized to Intel platforms running OS/2 with
 *                      keyword "_Optlink.
 *      09 Mar 95  JPO  Generalized to generic Intel X86 platform with
 *                      removal of OS/2 keyword "_Optlink".
 *
 *******************************************************************************/

#ifdef __cplusplus
    extern "C" {
#endif

/************************************************************
**      Internal to implementation of NaN() and TCanonicalNumber
************************************************************/
    float _NaN (unsigned short);

/************************************************************
**      Internal to implementation of Random classes
**      and CLibrary rand()
************************************************************/
    long _Random (long&);

/************************************************************
**      _MULUL and _DIVUL
************************************************************/
    void _MULUL (unsigned long, unsigned long, unsigned long *, unsigned long *);
    int _DIVUL (unsigned long, unsigned long *, unsigned long *);

#ifdef __cplusplus
    }
#endif

#endif // _INUMUTIL_
        // Taligent_NUMERICUTILITIES


