// Revision: 19 1.6.1.3 source/core/utils/win32/atomic.cpp, filesystem, ioc.v400, 000919 
/*
*****************************************************************************************
*                                                                                       *
* COPYRIGHT:                                                                            *
*   IBM Open Class Library                                                              *
*   (C) Copyright International Business Machines Corporation,  1997                    *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.                  *
*   US Government Users Restricted Rights - Use, duplication, or disclosure             *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                              *
*                                                                                       *
*****************************************************************************************
*/

// atomic.cpp
//
// Atomic get, set, and swap operations for Windows NT
//
// Laura Werner
//

#include "atomicop.hpp"

extern void*    AtomicGet486(void* const volatile* addr);
extern void     AtomicSet486(void* volatile* addr, void* newValue);

extern int      AtomicSwap486(void* volatile* addr, void* test, void* newValue);
extern int      AtomicSwap386(void* volatile* addr, void* test, void* newValue);

#if !_M_IX86
# error This file needs to be recoded to handle non-Intel processors
#endif

#ifdef IC_PAGETUNE
    #define _ATOMIC_CPP_
    #include <ipagetun.h>
#endif

void* AtomicGet(void* const volatile* address)
{
#if _MT
    return AtomicGet486(address);
#else
    return *address;
#endif
}

void AtomicSet(void* volatile* address, void *newValue)
{
#if _MT
    AtomicSet486(address, newValue);
#else
    *address = newValue;
#endif
}

int AtomicSwap(void* volatile* address, void *test, void *newValue)
{
#if _MT
    return AtomicSwap486(address, test, newValue);
#else
    if (*address == test)
    {
        *address = newValue;
        return 0;
    }
     else
    {
        return 1;
    }
#endif
}
