// COPYRIGHT:
//      IBM Open Class Library
//      (C) Copyright International Business Machines Corporation 1992, 1997
//      Licensed Material - Program-Property of IBM - All Rights Reserved.
//      US Government Users Restricted Rights - Use, duplication, or disclosure
//      restricted by GSA ADP Schedule Contract with IBM Corp.
//

// Revision: 59 1.7.1.3 source/core/utils/win32/ntrefcnt.cpp, utilities, ioc.v400, 000919 
// NTREFCNT.CPP

#include "imrefcnt.hpp"
#include "atomicop.hpp"

#define WIN32_LEAN_AND_MEAN 1
#include <windows.h>

#ifdef IC_PAGETUNE
    #define _NTREFCNT_CPP_
    #include <ipagetun.h>
#endif

void
IMRefCounted::addRef()
{
        InterlockedIncrement( LPLONG(&fCount) );
}

void
IMRefCounted::removeRef()
{
        if (::InterlockedDecrement( LPLONG(&fCount) ) == 0)
                delete this;
}

unsigned long
IMRefCounted::count() const
{
        return (unsigned long) AtomicGet( (void*const*) &fCount );
}
