// Revision: 89 1.3.1.5 source/ui/baseapp/ibmphdr.hpp, staticctls, ioc.v400, 000919 
/* NOSHIP */
#ifndef _IBMPHDR_
#define _IBMPHDR_
/*******************************************************************************
* FILE NAME: ibmphdr.hpp                                                       *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the class:                                                  *
*     IBitmapHandler                                                           *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <igbase2d.hpp>
#include <istathdr.hpp>

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

class IGImage;
class IBitmapControl;

#pragma enum(4)
#pragma pack(push,4)

class IBitmapHandler : public IStaticTextHandler {
typedef IStaticTextHandler
  Inherited;

public:
/*------------------------------- Constructor ----------------------------------
| The only way to construct instances of this class is to use the default      |
| constructor.                                                                 |
------------------------------------------------------------------------------*/
  IBitmapHandler();
  virtual
    ~IBitmapHandler();

/*-------------------------------- Drawing -------------------------------------
  drawBackground - draws the background area of the control, such as any
                   image or fill color.
  drawImage      - draws the image into the specified grafPort.
  captureImage   - Returns a new image representing the screen before the
                   graphic is rendered.  Use this function to capture
                   previous screen contents if transparency is desired.
------------------------------------------------------------------------------*/
virtual bool
  drawBackground ( IStaticText*      staticText,
                   IPresSpaceHandle& ps,
                   const IRectangle& updateRect );
virtual bool
  drawImage      ( IStaticText* window,
                   IGImage&     image );

virtual IGImage*
  captureImage   ( IPresSpaceHandle& ps,
                   const ISize&      size );

virtual IGRect2D
  targetRectangle( IBitmapControl* window,
                   const IGRect2D& windowRect,
                   const IGRect2D& bitmapRect);
}; // class IBitmapHandler


#pragma pack(pop)
#pragma enum(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif // _IBMPHDR_
