// Revision: 64 1.2.1.7 source/ui/baseapp/icmaphdr.hpp, frame, ioc.v400, 000919 
/* NOSHIP */
#ifndef _ICMAPHDR_
#define _ICMAPHDR_
/*******************************************************************************
* FILE NAME: icmaphdr.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the classes:                                                *
*     IColorMapHandler                                                         *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <ibase.hpp>
#include <ievent.hpp>
#include <ihandler.hpp>
#include <icolmap.hpp>

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

class IString;
class IWindow;
class IFrameWindow;
class IColorMapHandlerData;

#pragma enum(4)
#pragma pack(push,4)


class IColorMapHandler : public IHandler
{
typedef IHandler
  Inherited;
public:
/*------------------------------- Constructors -------------------------------*/
   IColorMapHandler ( IFrameWindow* frame,
                      IColorMap*    colorMap);
virtual
 ~IColorMapHandler ( );

/*------------------------------- Color Maps ---------------------------------*/
virtual void
 setColorMap      ( IColorMap* colorMap);
IColorMap
 &colorMap        ( ) const;
 
static bool
  isPaletteDevice ( );

protected:

/*---------------------------- Event Dispatching -----------------------------*/
virtual IColorMapHandler
 &handleEventsFor       ( IFrameWindow* window ),
 &stopHandlingEventsFor ( IFrameWindow* window );

virtual bool
  dispatchHandlerEvent ( IEvent& event );


#ifdef IC_PMWIN
virtual void
  handleRefresh        ( );
#endif



private:
/*----------------------------- Hidden Functions -----------------------------*/
IColorMapHandler (const IColorMapHandler&);
IColorMapHandler& operator= (const IColorMapHandler&);

virtual IHandler
 &handleEventsFor       ( IWindow* window ),
 &stopHandlingEventsFor ( IWindow* window );

/*--------------------------------- Private ----------------------------------*/
void
  realizeColorMap      ( const IWindowHandle&    paletteWindow,
                         bool                    forceBackground,
                         bool                    forceRefresh);
#ifdef IC_MOTIF
void
  propagateColorMapToChildren ( const IWindowHandle& window, unsigned long colorMap);
#endif

IFrameWindow
 *fFrameWindow;
IColorMap
 *fColorMap;
bool
  fPaletteSupported;
bool
  fHasFirstRealizationOccurred;

#ifdef IC_WIN  
IWindowHandle
  lastWindowToChange;
#endif  // IC_WIN

IColorMapHandlerData
 *fExtendedData;
};
   
#pragma pack(pop)
#pragma enum(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif /* _ICMAPHDR_ */
