// Revision: 96 1.3.2.2 source/ui/baseapp/icmdhdr.cpp, genhdr, ioc.v400, 000919  
/*******************************************************************************
* FILE NAME: icmdhdr.cpp                                                       *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the implementation of classes/functions declared        *
*   in icmdhdr.hpp.                                                            *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#define INCL_WINMESSAGEMGR
extern "C" {
   #include <iwindefs.h>
}

#ifndef _ICMDHDR_
  #include <icmdhdr.hpp>
#endif

// Segment definitions
#ifdef IC_PAGETUNE
  #define _ICMDHDR_CPP_
  #include <ipagetun.h>
#endif

/*------------------------------------------------------------------------------
| ICommandHandler::ICommandHandler                                             |
|                                                                              |
| Default constructor here for page tuning.                                    |
------------------------------------------------------------------------------*/
ICommandHandler::ICommandHandler ( )
  : ICommandHandler::Inherited ( )
{ ; }


/*------------------------------------------------------------------------------
| ICommandHandler::~ICommandHandler                                            |
|                                                                              |
| Emptry destructor here for page tuning.                                      |
------------------------------------------------------------------------------*/
ICommandHandler::~ICommandHandler ( )
{ ; }

/*------------------------------------------------------------------------------
| ICommandHandler::dispatchHandlerEvent                                        |
|                                                                              |
| Dispatch command functions for this handler.                                 |
------------------------------------------------------------------------------*/
bool  ICommandHandler::dispatchHandlerEvent ( IEvent& evt )
{
  bool bRc = false;

  switch (evt.eventId())
  {
     case WM_COMMAND:
     {
        ICommandEvent cmdevt(evt);
        // Invoke callback.
        bRc = command(cmdevt);
        if (bRc)
        {                         // processing done
           evt.setResult(cmdevt.result());  // copy result
        }
        break;
     }
     case WM_SYSCOMMAND:
     {
        ICommandEvent cmdevt(evt);
        // Invoke callback.
        bRc = systemCommand(cmdevt);
        if (bRc)
        {                         // processing done
           evt.setResult(cmdevt.result());  // copy result
        }
        break;
     } /* endif */
     default:
        break;
  } /* endswitch */

  return bRc;
}

/*------------------------------------------------------------------------------
| ICommandHandler::command                                                     |
|                                                                              |
| Dummy virtual handler function.                                              |
------------------------------------------------------------------------------*/
bool  ICommandHandler::command ( ICommandEvent & cmdevt )
{
  return false;
}

/*------------------------------------------------------------------------------
| ICommandHandler::systemCommand                                               |
|                                                                              |
| Dummy virtual handler function.                                              |
------------------------------------------------------------------------------*/
bool  ICommandHandler::systemCommand ( ICommandEvent & cmdevt )
{
  return false;
}
