// Revision: 19 1.8.1.5 source/ui/baseapp/ifildprv.hpp, views, ioc.v400, 000919 
/* NOSHIP */
#ifndef _IFILDPRV_
#define _IFILDPRV_
/*******************************************************************************
* FILE NAME: ifildprv.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the classes:                                                *
*     IFileDialogSettingsData                                                  *
*     IFileDialogData                                                          *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <icolor.hpp>
#include <ifiledlg.hpp>
#include <ifilehdr.hpp>
#include <ihandle.hpp>
#include <iqueue2.h>
#include <iobjwin.hpp>
#include <itrace.hpp>

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

class IHandler;
class IString;

#pragma enum(4)
#pragma pack(push,4)

// StringSeq class is used to maintain sequences of IStrings
// needed for Drives and Types lists.
class StringSeq : public IVPtrQueue<IString*> {
public:
  StringSeq ( );
 ~StringSeq ( );
}; // StringSeq

/*******************************************************************************
|  Objects of IFileDialogSettingsData contain the private data for Settings    |
*******************************************************************************/
class IFileDialogSettingsData {
public:
/*------------------------------- Constructors -------------------------------*/
  IFileDialogSettingsData ( );
  ~IFileDialogSettingsData ( );

StringSeq
 *fileTypes,
 *drives;

#ifdef IC_PMWIN
unsigned long
  dlgId;

IModuleHandle
  dlgHandle;
#endif //IC_PMWIN

#ifdef IC_WIN
bool
  isDirectorySet,
  isUsingFileFilters;
IString
  fDirectory;
#endif

bool
#ifdef IC_MOTIF
  fFileAsFilter,
#endif // IC_MOTIF
  isDlgTemplateSet;
}; // IFileDialogSettingsData


/*******************************************************************************
|  Objects of IFileDialogData contain the private data for the IFileDialog     |
|  class.                                                                      |
*******************************************************************************/
class IFileDialogData  {
public:
/*------------------------------- Constructors -------------------------------*/
  IFileDialogData ( );
  ~IFileDialogData ( );

  IFileDialog::Style
    fStyle;
#ifdef IC_PMWIN
IHandler
 *handlerToAdd;
#endif
#ifdef IC_WIN
long
  fSRC,
  fReturnVal;

char
 *fTitle,
 *fDrive;

IString
  fOKButton;

IPoint
  fPosition;

unsigned long
  fDialogId,
  fSettingsChanged;

IColor
  fclrbackground;

HBRUSH
  fbkgrndbrush;
#endif  // IC_WIN
#ifdef IC_MOTIF
IString
  fFileName;
IFileDialogHandler
  fDefaultHandler;
bool
  fFileAsFilter,
  fDeselectList;
#endif
}; // IFileDialogData

#ifdef IC_WIN
/*******************************************************************************
|  Objects of IModelessDialogWindow class serve as the owner for system        |
|  dialogs which have modeless behavior.                                       |
*******************************************************************************/
class IModelessDialogWindow : public IObjectWindow {
typedef IObjectWindow
  Inherited;
public:
  IModelessDialogWindow( IWindow* dialog );
virtual
  ~IModelessDialogWindow( );

void setDialogWindow( IWindow* dialog )
  {fdialog = dialog;} ;

private:
  IModelessDialogWindow ( const IModelessDialogWindow& another );
  IModelessDialogWindow& operator= ( const IModelessDialogWindow& another );

  IWindow* fdialog;
};
#endif //IC_WIN

#pragma pack(pop)
#pragma enum(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif /* _IFILDPRV_ */

