// Revision: 31 1.5.1.3 source/ui/baseapp/ifontdlg.inl, views, ioc.v400, 000919  
#ifndef _IFONTDLG_INL_
#define _IFONTDLG_INL_
/*******************************************************************************
* FILE NAME: ifontdlg.inl                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the inline functions for the          *
*   class(es) declared in ifontdlg.hpp.                                        *
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1997                                   *
*   All Rights Reserved                                                        *
*                                                                              *
*******************************************************************************/

#ifdef IC_MOTIF
inline IFontDialog::IFontDialog(IWindow*     parent,
                                IWindow*     owner,
                                const Style& style )
             : IFrameWindow(IFrameWindow::deferCreation)
{
   Settings tempSettings;
   initialize(parent, owner, style, (IHandler*)0, tempSettings );
}

inline IFontDialog::IFontDialog(IWindow*        parent,
                                IWindow*        owner,
                                const Settings& settings,
                                const Style&    style )
             : IFrameWindow(IFrameWindow::deferCreation)
{
   initialize(parent, owner, style, (IHandler*)0, settings );
}

inline IFontDialog::IFontDialog(IWindow*    parent,
                                IWindow*    owner,
                                const Style&    style,
                                const Settings& settings )
             : IFrameWindow(IFrameWindow::deferCreation)
{
   initialize(parent, owner, style, (IHandler*)0, settings );

}

inline IFontDialog::IFontDialog(IWindow*        parent,
                                IWindow*        owner,
                                IHandler*       handler,
                                const Style&    style,
                                const Settings& settings )
             : IFrameWindow(IFrameWindow::deferCreation)
{
   initialize(parent, owner, style, handler, settings );
}
#endif //IC_MOTIF

#ifdef IC_MOTIFPM
inline void  IFontDialog::setDefaultStyle(const IFontDialog::Style& newDefault)
{
  currentDefaultStyle = newDefault;
}
#endif
#endif // _IFONTDLG_INL_
