// Revision: 77 1.3.1.4 source/ui/baseapp/iiconhdr.hpp, staticctls, ioc.v400, 000919 
/* NOSHIP */
#ifndef _IICONHDR_
#define _IICONHDR_
/*******************************************************************************
* FILE NAME: iiconhdr.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the classes:                                                *
*     IIconHandler                                                             *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <ibmphdr.hpp>

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma enum(4)
#pragma pack(push,4)

class IIconHandler : public IBitmapHandler {
typedef IBitmapHandler
  Inherited;
public:
/*------------------------------- Constructor ----------------------------------
| The only way to construct instances of this class is to use the default      |
| constructor, which does not take any arguments.                              |
------------------------------------------------------------------------------*/
  IIconHandler();
virtual
  ~IIconHandler();

/*-------------------------------- Drawing -------------------------------------
  drawImage      - draws the image into the specified grafPort.
  captureImage   - Returns a new image representing the screen before the
                   graphic is rendered.  Use this function to capture
                   previous screen contents if transparency is desired.
------------------------------------------------------------------------------*/
virtual bool
  drawImage      ( IStaticText* window,
                   IGImage&     image );

virtual IGImage*
  captureImage   ( IPresSpaceHandle& ps,
                   const ISize&      size );
}; // class IIconHandler

#pragma pack(pop)
#pragma enum(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif // _IICONHDR_
