// Revision: 06 1.2.2.6 source/ui/baseapp/imndievt.cpp, menu, ioc.v400, 000919 
/*******************************************************************************
* FILE NAME: imndievt.cpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the implementation of classes/functions declared        *
*   in imndievt.hpp.                                                           *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
extern "C"
  {
  #include <stdio.h>
  #define INCL_WINMENUS
  #include <iwindefs.h>
  }

#include <imndievt.hpp>
#include <irect.hpp>
#ifdef IC_MOTIF
  #include <iownitem.hpp>
#endif
// Segment definitions
#ifdef IC_PAGETUNE
  #define _IMNDIEVT_CPP_
  #include <ipagetun.h>
#endif

#ifdef IC_WIN
  #define OIDATA ((LPDRAWITEMSTRUCT)ownerItemData())
#endif
#ifdef IC_PM
  #define OIDATA ((POWNERITEM)ownerItemData())
#endif
#ifdef IC_MOTIF
  #define OIDATA ((IOwnerItem *)ownerItemData())
#endif

/*------------------------------------------------------------------------------
| IMenuDrawItemEvent::IMenuDrawItemEvent                                       |
------------------------------------------------------------------------------*/
IMenuDrawItemEvent::IMenuDrawItemEvent( IEvent& evt )
  : IMenuDrawItemEvent::Inherited(evt)
{ }

/*------------------------------------------------------------------------------
| IMenuDrawItemEvent::~IMenuDrawItemEvent                                      |
------------------------------------------------------------------------------*/
IMenuDrawItemEvent::~IMenuDrawItemEvent( )
{ }

/*------------------------------------------------------------------------------
| IMenuDrawItemEvent::isDrawItem                                               |
------------------------------------------------------------------------------*/
bool IMenuDrawItemEvent::isDrawItem() const
{
#ifdef IC_WIN
   return (OIDATA->itemAction & ODA_DRAWENTIRE) ? true : false;
#endif
#ifdef IC_PM
   return (OIDATA->fsAttribute ==
           OIDATA->fsAttributeOld) ? true : false;
#endif
#ifdef IC_MOTIF
   return (OIDATA->fState & ODA_DRAWENTIRE) ? true : false;
#endif
}

/*------------------------------------------------------------------------------
| IMenuDrawItemEvent::isSetHighlight                                           |
------------------------------------------------------------------------------*/
bool IMenuDrawItemEvent::isSetHighlight() const
{
#ifdef IC_PMWIN
#ifdef IC_WIN
   return ((OIDATA->itemAction & ODA_SELECT) &&
           (OIDATA->itemState & ODS_SELECTED)) ? true : false;
#else
   return ( (OIDATA->fsAttribute != OIDATA->fsAttributeOld) &&
            (OIDATA->fsAttribute & MIA_HILITED) ) ?
      true : false;
#endif
#endif
#ifdef IC_MOTIF
   return (OIDATA->fState & ODA_SETHIGHLIGHT) ? true : false;
#endif
}

/*------------------------------------------------------------------------------
| IMenuDrawItemEvent::isRemoveHighlight                                        |
------------------------------------------------------------------------------*/
bool IMenuDrawItemEvent::isRemoveHighlight() const
{
#ifdef IC_PMWIN
#ifdef IC_WIN
   return ((OIDATA->itemAction & ODA_SELECT) &&
           !(OIDATA->itemState & ODS_SELECTED)) ? true : false;
#else
   return ( (OIDATA->fsAttribute != OIDATA->fsAttributeOld) &&
            !(OIDATA->fsAttribute & MIA_HILITED) ) ?
      true : false;
#endif
#endif
#ifdef IC_MOTIF
   return (OIDATA->fState & ODA_REMOVEHIGHLIGHT) ? true : false;
#endif
}

/*------------------------------------------------------------------------------
| IMenuDrawItemEvent::isSelected                                               |
------------------------------------------------------------------------------*/
bool IMenuDrawItemEvent::isSelected() const
{
#ifdef IC_PMWIN
#ifdef IC_WIN
   return (OIDATA->itemState & ODS_SELECTED) ? true : false;
#else
   return (OIDATA->fsAttribute & MIA_FRAMED) ? true : false;
#endif
#endif
#ifdef IC_MOTIF
//27554   return (OIDATA->fState & ODA_ACTIVATE) ? true : false;
   return (OIDATA->fState & ODA_SETHIGHLIGHT) ? true : false;      //27554
#endif
}

/*------------------------------------------------------------------------------
| IMenuDrawItemEvent::isChecked                                                |
------------------------------------------------------------------------------*/
bool IMenuDrawItemEvent::isChecked() const
{
#ifdef IC_PMWIN
#ifdef IC_WIN
   return (OIDATA->itemState & ODS_CHECKED) ? true : false;
#else
   return (OIDATA->fsAttribute & MIA_CHECKED) ? true : false;
#endif
#endif
#if IC_MOTIF
   return (OIDATA->fAttribute & ODA_CHECKED) ? true : false;    //27112
#endif
  return false;
}

/*------------------------------------------------------------------------------
| IMenuDrawItemEvent::isDisabled                                               |
------------------------------------------------------------------------------*/
bool IMenuDrawItemEvent::isDisabled() const
{
#ifdef IC_PMWIN
#ifdef IC_WIN
   return (OIDATA->itemState & ODS_DISABLED) ? true : false;
#else
   return (OIDATA->fsAttribute & MIA_DISABLED) ? true : false;
#endif
#endif
#ifdef IC_MOTIF
//27554   return (OIDATA->fState & ODA_SENSITIVE) ? true : false;
   return (OIDATA->fAttribute & MIA_DISABLED) ? true : false;
#endif
}
