// Revision: 07 1.5.1.3 source/ui/baseapp/imndievt.hpp, menu, ioc.v400, 000919 
#ifndef _IMNDIEVT_
#define _IMNDIEVT_
/*******************************************************************************
* FILE NAME: imndievt.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the classes:                                                *
*     IMenuDrawItemEvent                                                       *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   Licensed Material - Property of IBM                                        *
*   (C) Copyright IBM Corp. 1992, 1997  All Rights Reserved.                   *
*                                                                              *
*******************************************************************************/
#include <idievt.hpp>

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

class IMenuDrawItemHandler;

#pragma enum(4)
#pragma pack(push,4)

class IMenuDrawItemEvent : public IDrawItemEvent {
typedef IDrawItemEvent
  Inherited;
public:
/*------------------------------- Constructors -------------------------------*/
  IMenuDrawItemEvent ( IEvent& event );
virtual
 ~IMenuDrawItemEvent ( );

/*--------------------------- Menu Item Attributes ---------------------------*/
bool
  isSelected ( ) const,
  isChecked  ( ) const,
  isDisabled ( ) const;

private:
/*--------------------------------- Private ----------------------------------*/
friend class IMenuDrawItemHandler;

bool
  isDrawItem        ( ) const,
  isSetHighlight    ( ) const,
  isRemoveHighlight ( ) const;
}; // IMenuDrawItemEvent

#pragma pack(pop)
#pragma enum(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif /* _IMNDIEVT_ */
