// Revision: 12 1.9.1.3 source/ui/baseapp/imnitem.inl, menu, ioc.v400, 000919 
#ifndef _IMNITEM_INL_
#define _IMNITEM_INL_
/*******************************************************************************
* FILE NAME: imnitem.inl                                                       *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the inline functions for the          *
*   classes declared in imnitem.hpp.                                           *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   Licensed Material - Property of IBM                                        *
*   (C) Copyright IBM Corp. 1992, 1997  All Rights Reserved.                   *
*                                                                              *
*******************************************************************************/

#include <ireslib.hpp>
#include <istring.hpp>
#include <itrace.hpp>

#ifndef IC_WIN
inline void  IMenuItem :: setDefaultStyle( const IMenuItem::Style& newDefault)
{
  currentDefaultStyle = newDefault;
}

inline void  IMenuItem :: setDefaultAttribute
                          ( const IMenuItem::Attribute& newDefault)
{
  currentDefaultAttribute = newDefault;
}
#endif

inline IMenuItem&  IMenuItem :: setBitmap(unsigned long bitmapResId)
{
  return(setBitmap(IResourceId(bitmapResId)));
}

inline IMenuItem& IMenuItem::setIndex ( unsigned long index)
{
  iPosition = index;
  return *this;
}

inline unsigned long  IMenuItem::id() const
{
    return itemId;
}

inline unsigned long IMenuItem::index  ( ) const
{
    return iPosition;
}

inline IMenuHandle IMenuItem::submenuHandle( ) const
{
    return hwndSubmenu;
}

inline unsigned long IMenuItem:: style( ) const
{
  return afStyle;
}

inline unsigned long IMenuItem:: extendedStyle( ) const
{
  return afExtendedStyle;
}

inline unsigned long IMenuItem::attribute ( ) const
{
  return afAttribute;
}

inline unsigned long IMenuItem::helpId ( ) const
{
  return afHelpId;
}

inline IString IMenuItem::text( ) const
{
  return strClItemText;
}

inline IBitmapHandle IMenuItem::bitmap ( ) const
{
  return hBitmapHandle;
}

inline IMenuItem& IMenuItem::setStyle( unsigned long newStyle )
{
  afStyle = newStyle;
  return *this;
}

inline IMenuItem& IMenuItem::setExtendedStyle( unsigned long newExtStyle )
{
  afExtendedStyle = newExtStyle;
  return *this;
}

inline IMenuItem& IMenuItem::setAttribute( unsigned long newAttribute )
{
  afAttribute = newAttribute;
  return *this;
}

inline IMenuItem& IMenuItem::setHelpId( unsigned long newHelpTopicId )
{
  afHelpId = newHelpTopicId;
  return *this;
}
#endif // _IMNITEM_INL_
