// Revision: 20 1.5.1.3 source/ui/baseapp/imsghlpi.hpp, views, ioc.v400, 000919  
/* NOSHIP */
#ifndef _IMSGHLPI_
#define _IMSGHLPI_
/*******************************************************************************
* FILE NAME: imsghlpi.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the class(es):                                              *
*     IMessageHelpItem                                                         *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <ibase.hpp>
#include <ihandle.hpp>
#include <ithread.hpp>

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

class IWindow;

#pragma enum(4)
#pragma pack(push,4)

/*------------------------------------------------------------------------------
| IMessageHelpItem                                                             |
|                                                                              |
| Implementation class whose objects identify message boxes with help.         |
------------------------------------------------------------------------------*/
class IMessageHelpItem  {
public:
/*------------------------------- Constructors -------------------------------*/
  IMessageHelpItem ( unsigned long  msgBoxId,
                     const IWindow* msgBoxOwner,
                     const IThread& msgBoxThread = IThread::current() );
 ~IMessageHelpItem ( );

/*------------------------- Message Box Information --------------------------*/
unsigned long
  messageBoxId       ( ) const;
const IWindow
 *messageBoxOwner    ( ) const;
IWindowHandle
  messageBoxOwnerHandle ( ) const;
IThreadId
  messageBoxThreadId ( ) const;

private:
/*--------------------------------- Private ----------------------------------*/
unsigned long
  fMsgBoxId;
const IWindow
 *fMsgBoxOwner;
IWindowHandle
  fMsgBoxOwnerHandle;
IThreadId
  fMsgBoxThreadId;
}; // IMessageHelpItem

#pragma pack(pop)
#pragma enum(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#include <imsghlpi.inl>

#endif /* _IMSGHLPI_ */
