// Revision: 27 1.10 source/ui/baseapp/inotehdr.hpp, notebook, ioc.v400, 000919 
/* NOSHIP */
#ifndef _INOTEHDR_
#define _INOTEHDR_
/*******************************************************************************
* FILE NAME: inotehdr.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the classes:                                                *
*     INotebookHandler                                                         *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <ihandler.hpp>

#ifdef IC_PMWIN
  #include <ikeyevt.hpp>
#endif // IC_PMWIN

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

class INotebook;

#pragma enum(4)
#pragma pack(push,4)

class INotebookHandler : public IHandler {
typedef IHandler
  Inherited;
public:
  INotebookHandler ( );
virtual
  ~INotebookHandler ( );

protected:
/*-------------------------------- Overrides ---------------------------------*/
virtual bool
  dispatchHandlerEvent ( IEvent &anEvent );

private:
/*--------------------------------- Private ----------------------------------*/
#ifdef IC_WIN
bool
  handleTab  (IKeyboardEvent& event),
  gotFocus   (IEvent&         event);

bool
  fFocusFromPage;
#endif // IC_WIN
}; // INotebookHandler


#pragma pack(pop)
#pragma enum(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif // _INOTEHDR_
