// Revision: 41 1.3.1.2 source/ui/baseapp/ipmbidi.hpp, staticctls, ioc.v400, 000919  
/* NOSHIP */
#ifndef _IPMBIDI_
  #define _IPMBIDI_
/*******************************************************************************
* FILE NAME: ipmbidi.hpp                                                       *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains C routines used to implement BIDI support in OS/2.      *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <istring.hpp>
#include <iwindow.hpp>
#include <icolor.hpp>
#include <irect.hpp>

#pragma enum(4)
#pragma pack(push,4)


#pragma pack(pop)
#pragma enum(pop)

typedef PVOID LAYOUT_OBJECT;

LAYOUT_OBJECT 
  bidiCreateLayoutObject ( );

void 
  bidiDeleteLayoutObject ( LAYOUT_OBJECT layoutObject );

void 
  bidiPrepareForDisplay ( LAYOUT_OBJECT  layoutObject,
                          IString&       bidiText,
                          IBidiSettings& settings,
                          unsigned long& tildePosition );

unsigned long
  bidiDrawText ( IPresSpaceHandle presSpace,
                 IString          bidiText,
                 unsigned long    index,
                 LAYOUT_OBJECT    layoutObject,
                 IBidiSettings&   settings,
                 unsigned long    flags,
                 IColor           foregroundColor,
                 IColor           backgroundColor,
                 IRectangle       rectangle );

#endif // _IPMBIDI_
