// Revision: 42 1.3.2.2 source/ui/baseapp/ipmexsta.cpp, views, ioc.v400, 000919  
/*******************************************************************************
* FILE NAME: ipmexsta.cpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the implementation of classes/functions declared        *
*   in ipmexsta.hpp.                                                           *
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1997                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or               *
*   disclosure                                                                 *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#pragma priority( -2147481524 )

extern "C"
  {
  #include <stdio.h>
  #define INCL_WINSTDFILE
  #define INCL_WINSTDFONT
  #include <os2.h>
  }

#include <ipmexsta.hpp>

#ifndef _IRESLIB_
  #include <ireslib.hpp>
#endif

// Segment definitions
#ifdef IC_PAGETUNE
  #define _IHELPSTA_CPP_
  #include <ipagetun.h>
#endif

  IPMCtlStatics pmCtl;

IWinFontDlg*         IPMCtlStatics::entryFontDlg = 0;
IWinFileDlg*         IPMCtlStatics::entryFileDlg = 0;
IWinDefFontDlgProc*  IPMCtlStatics::entryDefFontDlgProc = 0;
IWinDefFileDlgProc*  IPMCtlStatics::entryDefFileDlgProc = 0;
IWinFreeFileDlgList* IPMCtlStatics::entryFreeFileDlgList = 0;

IDynamicLinkLibrary* IPMCtlStatics::pmCtlDynLinkLib = 0;

// This class enables us to prevent PMCTLS.DLL being reference
// until one of its exported functions is actually called.
// This improves the intial load time of DDE4MUI.DLL.


/*------------------------------------------------------------------------------
| IPMCtlStatics::~IPMCtlStatics                                                |
------------------------------------------------------------------------------*/
IPMCtlStatics ::  ~IPMCtlStatics()
  {
    if(pmCtlDynLinkLib)
      delete pmCtlDynLinkLib;
  }

/*------------------------------------------------------------------------------
| IPMCtlStatics::pmCtlDLL                                                      |
------------------------------------------------------------------------------*/
IDynamicLinkLibrary& IPMCtlStatics :: pmCtlDLL ( )
  {
     if(!pmCtlDynLinkLib)
       pmCtlDynLinkLib = new IDynamicLinkLibrary("pmctls");
     return *pmCtlDynLinkLib;
  }

/*------------------------------------------------------------------------------
| IPMCtlStatics::fontDlg                                                       |
------------------------------------------------------------------------------*/
IWindowHandle IPMCtlStatics :: fontDlg( IWindowHandle parent,
                                        IWindowHandle owner,
                                        _FONTDLG*     fontDialog)
  {
     if(!entryFontDlg)
        entryFontDlg = (IWinFontDlg*)pmCtlDLL().procAddress( "WinFontDlg");
     return (*entryFontDlg)(parent, owner, fontDialog);
  }



/*------------------------------------------------------------------------------
| IPMCtlStatics::fileDlg                                                       |
------------------------------------------------------------------------------*/
IWindowHandle IPMCtlStatics :: fileDlg( IWindowHandle parent,
                                        IWindowHandle owner,
                                        _FILEDLG*     fileDialog)
  {
     if(!entryFileDlg)
        entryFileDlg = (IWinFileDlg*)pmCtlDLL().procAddress( "WinFileDlg");
     return (*entryFileDlg)(parent, owner, fileDialog);
  }

/*------------------------------------------------------------------------------
| IPMCtlStatics::defFileDlgProc                                                |
------------------------------------------------------------------------------*/
IEventResult IPMCtlStatics :: defFileDlgProc ( IWindowHandle dialog,
                                               unsigned long msgId,
                                               IEventParameter1 mp1,
                                               IEventParameter2 mp2)
  {
     if(!entryDefFileDlgProc)
        entryDefFileDlgProc =
          (IWinDefFileDlgProc*)pmCtlDLL().procAddress( "WinDefFileDlgProc");
     return (*entryDefFileDlgProc)(dialog, msgId, mp1, mp2);
  }

/*------------------------------------------------------------------------------
| *IPMCtlStatics::defFileDlgProcAddr                                           |
------------------------------------------------------------------------------*/
IWinProc *IPMCtlStatics :: defFileDlgProcAddr ( )
  {
  if(!entryDefFileDlgProc)
     entryDefFileDlgProc =
       (IWinDefFileDlgProc*)pmCtlDLL().procAddress( "WinDefFileDlgProc");
  return (IWinProc*)entryDefFileDlgProc;
  }

/*------------------------------------------------------------------------------
| IPMCtlStatics::defFontDlgProc                                                |
------------------------------------------------------------------------------*/
IEventResult IPMCtlStatics :: defFontDlgProc ( IWindowHandle dialog,
                                               unsigned long msgId,
                                               IEventParameter1 mp1,
                                               IEventParameter1 mp2)
  {
     if(!entryDefFontDlgProc)
        entryDefFontDlgProc =
          (IWinDefFontDlgProc*)pmCtlDLL().procAddress( "WinDefFontDlgProc");
     return (*entryDefFontDlgProc)(dialog, msgId, mp1, mp2);
  }

/*------------------------------------------------------------------------------
| *IPMCtlStatics::defFontDlgProcAddr                                           |
------------------------------------------------------------------------------*/
IWinProc *IPMCtlStatics :: defFontDlgProcAddr ( )
  {
  if(!entryDefFontDlgProc)
     entryDefFontDlgProc =
       (IWinDefFontDlgProc*)pmCtlDLL().procAddress( "WinDefFontDlgProc");
  return (IWinProc*)entryDefFontDlgProc;
  }

/*------------------------------------------------------------------------------
| IPMCtlStatics::freeFileDlgList                                               |
------------------------------------------------------------------------------*/
bool IPMCtlStatics :: freeFileDlgList(char** fileNameTable)
  {
     if(!entryFreeFileDlgList)
        entryFreeFileDlgList =
          (IWinFreeFileDlgList*)pmCtlDLL().procAddress( "WinFreeFileDlgList");
     return (*entryFreeFileDlgList)(fileNameTable);
  }

