/*******************************************************************************
* FILE NAME: ireslib.inl                                                       *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the inline functions for the          *
*   classes declared in ireslib.hpp.                                           *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*                                                                              *
*******************************************************************************/
// Revision: 55 1.7.1.3 source/ui/baseapp/ireslib.inl, resource, ioc.v400, 000919  

#ifndef _IRESLIB_INL_
#define _IRESLIB_INL_

#include <iapp.hpp>

inline IResourceId::IResourceId(unsigned long resourceId, const IResourceLibrary& resourceLibrary)
                     : fResLibrary(resourceLibrary), fResId(resourceId)
{ }

inline IResourceId::IResourceId(const IResourceId& resourceId)
                     : fResLibrary(resourceId.fResLibrary), fResId(resourceId.fResId)
{ }


inline const IResourceLibrary& IResourceId::resourceLibrary() const
{ return fResLibrary; }

inline IResourceId::operator unsigned long( )   const
{ return this->fResId; }

inline unsigned long IResourceId::id( )   const
{ return this->fResId; }

#endif // _IRESLIB_INL_
