// Revision: 79 1.2.2.2 source/ui/baseapp/isizrect.cpp, basewin, ioc.v400, 000919  
/*******************************************************************************
* FILE NAME: isizrect.cpp                                                        *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the implementation of classes/functions declared        *
*   in isizrect.hpp.                                                             *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/

#include <isizrect.hpp>

// Segment definitions.
#ifdef IC_PAGETUNE
  #define _ISIZRECT_CPP_
  #include <ipagetun.h>
#endif


/*------------------------------------------------------------------------------
| ISizeRectangle::ISizeRectangle                                                               |
------------------------------------------------------------------------------*/
ISizeRectangle::ISizeRectangle ( const IRectangle& oldRect,
                                 const IRectangle& newRect )
 : _oldRect( oldRect )
 , _newRect( newRect )

{
}

/*------------------------------------------------------------------------------
| ISizeRectangle::ISizeRectangle                                                               |
------------------------------------------------------------------------------*/
ISizeRectangle::ISizeRectangle ( )

{
}

/*------------------------------------------------------------------------------
| ISizeRectangle::ISizeRectangle                                               |
------------------------------------------------------------------------------*/
ISizeRectangle::ISizeRectangle ( const ISizeRectangle& sizeRect)

{
  if ( this != &sizeRect )
    this->_oldRect = sizeRect._oldRect;
    this->_newRect = sizeRect._newRect;
}

/*------------------------------------------------------------------------------
| ISizeRectangle::~ISizeRectangle                                                               |
------------------------------------------------------------------------------*/
ISizeRectangle::~ISizeRectangle ( )

{
}

              
/*------------------------------------------------------------------------------
| ISizeRectangle::operator=                                                    |
------------------------------------------------------------------------------*/
ISizeRectangle& ISizeRectangle:: operator=(const ISizeRectangle sizeRect)
{
  if ( this != &sizeRect )
  {
    this->_oldRect = sizeRect._oldRect;
    this->_newRect = sizeRect._newRect;
  }
  return *this;
}
               
IRectangle ISizeRectangle::oldRectangle() const
{
  return this->_oldRect;
}

IRectangle ISizeRectangle::newRectangle() const
{
  return this->_newRect;
}
 
ISizeRectangle& ISizeRectangle::setOldRectangle( const IRectangle &oldRect )
{
  this->_oldRect = oldRect;
  return *this;
}

ISizeRectangle& ISizeRectangle::setNewRectangle( const IRectangle &newRect )
{
  this->_newRect = newRect;
  return *this;
}

bool ISizeRectangle::sizeChanged() const
{
  if (_oldRect.size() != _newRect.size() ) 
    return true; 
  else
    return false;
}

bool ISizeRectangle::rectangleMoved() const
{
  if (_oldRect.minXMinY() != _newRect.minXMinY() ) 
    return true; 
  else
    return false;
}

