// Revision: 80 1.4.1.3 source/ui/baseapp/isizrect.hpp, basewin, ioc.v400, 000919  
/* NOSHIP */
#ifndef _ISIZRECT_
  #define _ISIZRECT_
/*******************************************************************************
* FILE NAME: isizrect.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of classes that are private to the       *
*   implementation of ISizeRectangle.                                                  *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <irect.hpp>

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma enum(4)
#pragma pack(push,4)

class ISizeRectangle 
{
/*******************************************************************************
* The IBaseComboBoxData class encapsulates private data and functions used by the  *
* IBaseComboBox class.  An object of this class is created in the IBaseComboBox        *
* constructors.                                                                *
*******************************************************************************/
public:
  ISizeRectangle();
  ISizeRectangle( const IRectangle& oldRect, const IRectangle& newRect );
  ISizeRectangle( const ISizeRectangle& sizeRect );

virtual
 ~ISizeRectangle();

ISizeRectangle
  &operator=(const ISizeRectangle);

IRectangle     
  oldRectangle() const,
  newRectangle() const;

ISizeRectangle
 &setOldRectangle( const IRectangle &oldRect ),
 &setNewRectangle( const IRectangle &newRect );

bool
  sizeChanged() const,
  rectangleMoved() const;
                
private:
  IRectangle
    _oldRect,
    _newRect;
};

#pragma pack(pop)
#pragma enum(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif /* _ISIZRECT_ */
