// Revision: 73 1.4.1.2 source/ui/baseapp/islhdr.cpp, listctls, ioc.v400, 000919  
/*******************************************************************************
* FILE NAME: islhdr.cpp                                                        *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the implementation of classes/functions declared        *
*   in islhdr.hpp.                                                             *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#define INCL_WINENTRYFIELDS
#define INCL_WINWINDOWMGR
extern "C"
  {
  #include <iwindefs.h>
  #include <stdlib.h>

  }

#include <islhdr.hpp>
#include <ictlevt.hpp>
#include <ievent.hpp>
#include <iwindow.hpp>
#include <iwcname.hpp>
#include <icconst.h>

// Segment definitions.
#ifdef IC_PAGETUNE
  #define _ISLHDR_CPP_
  #include <ipagetun.h>
#endif


/*------------------------------------------------------------------------------
| IShowListHandler::IShowListHandler                                           |
|                                                                              |
| Default constructor here for page tuning.                                    |
------------------------------------------------------------------------------*/
IShowListHandler::IShowListHandler ( )
  : IShowListHandler::Inherited( )
{ }

/*------------------------------------------------------------------------------
| IShowListHandler::~IShowListHandler                                          |
|                                                                              |
| Empty destructor here for page tuning.                                       |
------------------------------------------------------------------------------*/
IShowListHandler::~IShowListHandler ( )
{ }

/*------------------------------------------------------------------------------
| IShowListHandler::dispatchHandlerEvent                                       |
|                                                                              |
| Dispatch command functions for this handler.                                 |
------------------------------------------------------------------------------*/
bool IShowListHandler::dispatchHandlerEvent ( IEvent& event )
{
  bool bRc = false;

#ifdef IC_PMWIN
  if ( event.eventId() == WM_CONTROL )
  {                                    // Control event.
     IControlEvent ctlevt( event );
     IWindowHandle hwndControl = ctlevt.controlHandle();

     if ( hwndControl  &&
          IWindowClassName( hwndControl ) == WC_COMBOBOX )
     {                                 // Combo-box case.
        unsigned long subMsg = ctlevt.parameter1().number2();
        if ( subMsg == CBN_SHOWLIST )
        {
           bRc = this->listShown( ctlevt );
        }

        if ( bRc )
        {                              // Processing done.
           event.setResult( ctlevt.result() );  // Copy event result.
        }
     }
  } /* endif WM_CONTROL */
#endif //IC_PMWIN

#ifdef IC_MOTIF
  // Check the notify code.
  if (event.eventId() == WM_CONTROL &&
      IEventData(event.parameter1()).number2() == CBN_SHOWLIST)
  {
     IControlEvent ctlevt(event);
     if (bRc = listShown (ctlevt))
        event.setResult(ctlevt.result());  // copy result
  }
#endif //IC_MOTIF

  return bRc;
}

#ifdef IC_MOTIF
bool  IShowListHandler :: listShown ( IControlEvent& evt )
/**************************************************************/
/* Dummy virtual handler function.                            */
/**************************************************************/
{
   return false;
}
#endif //IC_MOTIF
