// Revision: 78 1.3.1.3 source/ui/baseapp/ispinhdr.hpp, listctls, ioc.v400, 000919 
#ifndef _ISPINHDR_
  #define _ISPINHDR_
/*******************************************************************************
* FILE NAME: ispinhdr.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the classes:                                                *
*     ISpinHandler                                                             *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   Licensed Material - Property of IBM                                        *
*   (C) Copyright IBM Corp. 1992, 1997  All Rights Reserved.                   *
*                                                                              *
*******************************************************************************/
#include <ihandler.hpp>
#include <ictlevt.hpp>

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma enum(4)
#pragma pack(push,4)

class ISpinHandler : public IHandler {
typedef IHandler
  Inherited;

public:
/*-------------------------- Constructors -----------------------------------*/
virtual
 ~ISpinHandler ( );


protected:
/*------------------------- Protected Constructors --------------------------*/
  ISpinHandler ( );

/*---------------------------- Event Dispatching ----------------------------*/
virtual bool
  dispatchHandlerEvent ( IEvent& event );

/*----------------------------- Event Processing ----------------------------*/
virtual bool
  arrowUp              ( IControlEvent& event ),
  arrowDown            ( IControlEvent& event ),
  spinEnded            ( IControlEvent& event );
}; // ISpinHandler


#pragma pack(pop)
#pragma enum(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif /* _ISPINHDR_ */
