// Revision: 19 1.1.1.3 source/ui/baseapp/itimer.c, thread, ioc.v400, 000919 
#ifndef _ITIMER_C_
#define _ITIMER_C_
/*******************************************************************************
* FILE NAME: itimer.c                                                          *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the template functions                *
*   declared in itimer.hpp.                                                    * 
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*                                                                              *
*******************************************************************************/
#include <itimer.hpp>

template < class T >
ITimerMemberFn<T>::ITimerMemberFn ( T &object,
                                    void ( T::*memberFunction )( unsigned long ) )
  : fMemberFunction( memberFunction ),
    fObject( object )
  { }

template < class T >
ITimerMemberFn<T>::~ITimerMemberFn ( )
  { }

template < class T >
ITimerMemberFn<T>::ITimerMemberFn ( const ITimerMemberFn<T>& timerFunction )
  : fMemberFunction( timerFunction.fMemberFunction ),
    fObject( timerFunction.fObject )
  { }

template < class T >
ITimerMemberFn0<T>::ITimerMemberFn0 ( T &object,
                                      void ( T::*memberFunction )( ) )
  : fMemberFunction( memberFunction ),
    fObject( object )
  { }

template < class T >
ITimerMemberFn0<T>::~ITimerMemberFn0 ( )
  { }

template < class T >
ITimerMemberFn0<T>::ITimerMemberFn0 ( const ITimerMemberFn0<T>& timerFunction )
  : fMemberFunction( timerFunction.fMemberFunction ),
    fObject( timerFunction.fObject )
  { }

#endif // _ITIMER_C_
