// Revision: 97 1.3.1.2 source/ui/baseapp/iwidlist.cpp, basewin, ioc.v400, 000919 

/*******************************************************************************
* FILE NAME: iwidlist.cpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the implementation of classes/functions declared        *
*   in iwidlist.hpp                                                            *
*     IWidgetList                                                              *
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1997                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or               *
*   disclosure                                                                 *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <iwidlist.hpp>
extern "C" {
  #include <string.h>      // for memcpy
};

// Segment definitions.
#ifdef IC_PAGETUNE
    #define _IWIDLIST_CPP_
    #include <ipagetun.h>
#endif

IWidgetList::IWidgetList(unsigned long numItems)
   : size(numItems),
     pos(0)
{
   widgetList= new Widget[numItems];
}

IWidgetList::~IWidgetList()
{
   delete [] widgetList;
}

unsigned long
IWidgetList::add(Widget wid)
{
  if (pos == size)
     expand();

  widgetList[pos++] = wid;
  return pos;
}

unsigned long
IWidgetList::manage()
{
   XtManageChildren(widgetList, pos);
   unsigned long temp = pos;
   pos = 0;
   return temp;
}

void
IWidgetList::clear()
{
   pos = 0;
}

void
IWidgetList::expand()
{
  size *= 2;
  Widget* tempList = new Widget[size];
  memcpy(tempList, widgetList, pos * sizeof(Widget));
  delete [] widgetList;
  widgetList = tempList;
}
