#ifndef _IWIDLIST_
#define _IWIDLIST_

// Revision: 98 1.5.1.3 source/ui/baseapp/iwidlist.hpp, basewin, ioc.v400, 000919  
// NOSHIP

/*******************************************************************************
* FILE NAME: iwidlist.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains:                                                        *
*     IWidgetList                                                              *
*       This class builds a list of Widgets that can later all be managed by   *
*       by calling IWidgetList::manage(). This list is cleared out after the   *
*       call to manage(). You can clear it yourself at anytime by calling      *
*       IWigetList::clear().                                                   *

*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1997                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or               *
*   disclosure                                                                 *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <X11/Intrinsic.h>


#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

class IWidgetList
{
public:
  IWidgetList(unsigned long numItems = 1024);
  ~IWidgetList();

  unsigned long 
    add(Widget widget),
    manage();

  void
    clear();

private:
  void expand();

  unsigned long
    size,
    pos;

  Widget* widgetList;

  // disallow use of copy constructor and assignment operator
  IWidgetList(const IWidgetList&);

  IWidgetList&
    operator =(const IWidgetList&);


};

#pragma pack(pop)
#pragma enum(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif // IWIDLIST header guard
