// Revision: 01 1.7.1.2 source/ui/baseapp/iwindow.inl, basewin, ioc.v400, 000919  
#ifndef _IWINDOW_INL_
#define _IWINDOW_INL_
/*******************************************************************************
* FILE NAME: iwindow.inl                                                       *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the inline functions for the          *
*   classes declared in iwindow.hpp.                                           *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*                                                                              *
*******************************************************************************/

inline unsigned long const& key (IWindow* const& k)
{
  return k->hwnd;
}

/*******************************************************************************
* IWindow::windowData                                                          *
*                                                                              *
* DataHandle is invalid if 0 or not allocated yet.  In these cases, return 0   *
*******************************************************************************/
inline IWindowData* IWindow::windowData
                    (const IWindow::DataHandle& typeToken) const
{
  if ((typeToken != 0) && (typeToken <= ulWindowDataArraySize))
    return windowDataArray[typeToken-1];
  else
    return 0;
}

#endif // _IWINDOW_INL_
