/* Revision: 70 1.5.1.4 source/ui/baseapp/ixevtids.h, basewin, ioc.v400, 000919  */
#ifndef _IXEVTIDS_
  #define _IXEVTIDS_
/*******************************************************************************
* FILE NAME: ixevtids.h                                                        *
*                                                                              *
* DESCRIPTION:                                                                 *
*  This file contains event ids for the Motif environment.                     *
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1994, 1997                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or               *
*   disclosure                                                                 *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/

/***************************************************/
/*Make sure we don't use this with real PM toolkit */
/***************************************************/
#ifndef OS2_INCLUDED

/*------------------------------------------------------------------
   Event ids ICLUI_MESSAGE is the atom used in the message_type
   field of the XClientMessageEvent generated by sendEvent/postEvent
   The value of ICLUI_BASE below must be larger than any XEvent
   type value or any Motif callback reason code to allow these
   ICLUI events to be distinquished.
   (note that the notebook widget has some XmCR_ reasons in the
   low 100s)

   NOTE the values in the above should not exceed 0x220 (514) because
   ipf/x defines the HM_ messages starting there.
------------------------------------------------------------------*/
#define     ICLUI_BASE                200
#define     WM_HELP                   ICLUI_BASE + 2
#define     WM_COMMAND                ICLUI_BASE + 3
#define     WM_SYSCOMMAND             ICLUI_BASE + 4
#define     WM_DESTROY                ICLUI_BASE + 5
#define     WM_QUIT                   ICLUI_BASE + 6

#define     SB_ENDSCROLL              ICLUI_BASE + 12
#define     WM_CLOSE                  ICLUI_BASE + 13
#define     WM_CONTROL                ICLUI_BASE + 14
#define     WM_MOVE                   ICLUI_BASE + 15   // ConfigureNotify when
                                                        // position changes
#define     WM_SIZE                   ICLUI_BASE + 16   // ConfigureNotify when
                                                        // size changes
#define     WM_DRAWITEM               ICLUI_BASE + 17
#define     WM_MEASUREITEM            ICLUI_BASE + 18
#define     WM_CONTEXTMENU            ICLUI_BASE + 19
#define     WM_BUTTON1DOWN            ICLUI_BASE + 20
#define     WM_BUTTON2DOWN            ICLUI_BASE + 21
#define     WM_BUTTON3DOWN            ICLUI_BASE + 22
#define     WM_BUTTON1UP              ICLUI_BASE + 23
#define     WM_BUTTON2UP              ICLUI_BASE + 24
#define     WM_BUTTON3UP              ICLUI_BASE + 25
#define     WM_BUTTON1CLICK           ICLUI_BASE + 26
#define     WM_BUTTON2CLICK           ICLUI_BASE + 27
#define     WM_BUTTON3CLICK           ICLUI_BASE + 28
#define     WM_BUTTON1DBLCLK          ICLUI_BASE + 29
#define     WM_BUTTON2DBLCLK          ICLUI_BASE + 30
#define     WM_BUTTON3DBLCLK          ICLUI_BASE + 31
#define     WM_CHORD                  ICLUI_BASE + 32
#define     FDM_FILTER                ICLUI_BASE + 33
#define     WM_INITMENU               ICLUI_BASE + 36   // Menu:XmCR_MAP
#define     WM_MENUSELECT             ICLUI_BASE + 37   // Menu:XmCR_ARM,
                                                        //      XmCR_ACTIVATE,
                                                        //      XmCR_CASCADING
#define     WM_MENUEND                ICLUI_BASE + 38   // Menu:XmCR_UNMAP
#define     WM_MENUUNMAP              ICLUI_BASE + 39   // Menu:XmCR_UNMAP
#define     HM_GENERAL_HELP_UNDEFINED ICLUI_BASE + 40   // Not in ipfx,
                                                        // ICLUI supported
#define     WM_POPUPDESTROY           ICLUI_BASE + 41   // Menu:XmCR_UNMAP
#define     DM_DRAGOVER               ICLUI_BASE + 42
#define     DM_DRAGLEAVE              ICLUI_BASE + 43
#define     DM_DROP                   ICLUI_BASE + 44
#define     DM_ENDCONVERSATION        ICLUI_BASE + 45
#define     DM_DROPHELP               ICLUI_BASE + 46
#define     WM_BEGINDRAG              ICLUI_BASE + 47

#define     IC_UM_QUERYFRAMECTLCOUNT  IC_UM_BASE + 49
#define     IC_UM_FORMATFRAME         IC_UM_BASE + 50
#define     IC_UM_UPDATEFRAME         IC_UM_BASE + 51
#define     IC_UM_CALCFRAMERECT       IC_UM_BASE + 52
#define     IC_UM_DRAWGRIDLINES       IC_UM_BASE + 53
#define     FDM_VALIDATE              ICLUI_BASE + 54

#define     IC_UM_QUERY_HELP_WINDOW   ( IC_UM_BASE + 0xC9 )

#endif /* OS2_INCLUDED */
#endif
