// Revision: 20 1.4.1.4 source/ui/baseapp/ixmlabel.hpp, basewin, ioc.v400, 000919 
/* NOSHIP */
#ifndef _IXMLABEL_
#define _IXMLABEL_
/*******************************************************************************
* FILE NAME: iwinpriv.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the helper ixmlabel class.            *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <ibase.hpp>
#include <ihandle.hpp>

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

class IMString;
class IString;

#pragma pack(push,4)
#pragma enum(4)

class IXmLabel
{
public:
static bool
  initializeXmLabelString ( IWindowHandle  initializeThis,
                            const IString& setBlankIfThis,
                            bool           bRemoveMnemonic = false );
static bool
  initializeXmLabelString ( IMString&      initializeThis,
                            const IString& setBlankIfThis,
                            bool           bRemoveMnemonic = false );
static bool
  removeMnemonic          ( IString& label );

static bool
  applyWordBreak( long                 maxWidth,      //Maximum width wanted
                  const IWindowHandle& handle,        //Window to hold text
                  IString&             text,          //Text to be modified
                  IString*             originalText=0); //Original text if changed
}; // IXmLabel

#pragma pack(pop)
#pragma enum(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif // _IXMLABEL_
