// Revision: 26 1.7.1.2 source/ui/basectl/ibctlob2.cpp, control, ioc.v400, 000919 
/*******************************************************************************
* FILE NAME: ibctlob2.cpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the implementation of functions that have been replaced *
*   and are now obsolete.  They have been placed here to provide compatibility *
*   with prior releases.                                                       *
*   This is OS/2 and Windows unique code.                                      *
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1994                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or               *
*   disclosure                                                                 *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#pragma priority( -2147481524 )

extern "C"
  {
  #define INCL_WINSTDSPIN
  #define INCL_WINSYS
  #define INCL_WINBUTTONS
  #define INCL_WINSTDBOOK
  #define INCL_WINDIALOGS           // Needed for PDLGTEMPLATE in BOOKPAGEINFO
  #define INCL_WINENTRYFIELDS
  #define INCL_WINMLE
  #include <iwindefs.h>
  }

#include <ientryfd.hpp>
#include <imle.hpp>

#ifdef IC_MOTIF
  #include <iefpriv.hpp>
#endif //IC_MOTIF

// Segment definitions
#ifdef IC_PAGETUNE
  #define _IBCTLOB2_CPP_
  #include <ipagetun.h>
#endif


#if (IC_OBSOLETE <= IC_OBSOLETE_2)

//
//
//  Block of obsolete function for obsolete level 2
//
//

/*------------------------------------------------------------------------------
| IMultiLineEdit::setChangedFlag                                               |
|                                                                              |
| Set a flag to indicate that the MLE contents have changed.                   |
------------------------------------------------------------------------------*/
IMultiLineEdit&   IMultiLineEdit:: setChangedFlag( bool changed )
{
#ifdef IC_PMWIN
   handle().sendEvent(MLM_SETCHANGED, IEventParameter1(changed),
                                      IEventParameter2(0));
#endif //IC_PMWIN

#ifdef IC_MOTIF
  setTextChangedFlag(changed);
#endif //IC_MOTIF

   return *this;
}

/*------------------------------------------------------------------------------
| IEntryField::hasChanged                                                      |
|                                                                              |
| Queries whether the entry field has changed since the last query.            |
------------------------------------------------------------------------------*/
bool IEntryField::hasChanged( ) const
{
#ifdef IC_PMWIN
  IEventResult evt = handle().sendEvent(EM_QUERYCHANGED,
                                        IEventParameter1(0),
                                        IEventParameter2(0));

  if (evt.asUnsignedLong())
    return( true );
  else
    return( false );
#endif //IC_PMWIN

#ifdef IC_MOTIF
  bool val = (fEntryFieldData->flagsCl & IEntryFieldData::changed);
  //Clear the value for next time.
  fEntryFieldData->flagsCl &= ~IEntryFieldData::changed;
  return val;
#endif //IC_MOTIF
}

/*------------------------------------------------------------------------------
| IEntryField::setChangedFlag                                                  |
------------------------------------------------------------------------------*/
IEntryField& IEntryField::setChangedFlag( bool changeFlag )
{
#ifdef IC_PM
  if (changeFlag)
    ISETWINDOWTEXT(handle(), (PSZ)text());
  else
    hasChanged();
#endif

#ifdef IC_WIN
  handle().sendEvent(EM_SETMODIFY, IEventParameter1(changeFlag),
                                   IEventParameter2(0));
#endif

#ifdef IC_MOTIF
  setTextChangedFlag(changeFlag);
#endif //IC_MOTIF

  return *this;
}

//
//
//  End of obsolete function for obsolete level 2
//
//
#endif
