// Revision: 27 1.7.1.2 source/ui/basectl/ibctlobs.cpp, control, ioc.v400, 000919 
/*******************************************************************************
* FILE NAME: ibctlobs.cpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the implementation of functions that have been replaced *
*   and are now obsolete.  They have been placed here to provide compatibility *
*   with prior releases.                                                       *
*   This is the platform independent file.  See ibctlob1.cpp and ibctlob2.cpp  *
*   for platform dependent code.                                               *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#pragma priority( -2147481424 )

#define INCL_WIN
#include <iwindefs.h>
#include <islider.hpp>
#include <imle.hpp>
#include <ientryfd.hpp>
#include <iscroll.hpp>

// Segment definitions
#ifdef IC_PAGETUNE
  #define _IBCTLOBS_CPP_
  #include <ipagetun.h>
#endif

#if (IC_OBSOLETE <= IC_OBSOLETE_2)

//
//
//  Block of obsolete function for obsolete level 2
//
//

/******************************************************************************/
/* Slider Notification strings                                                */
/******************************************************************************/
INotificationId const IProgressIndicator::armTickOffsetId  =
                                    "IProgressIndicator::armTickOffset";
INotificationId const IProgressIndicator::armPixelOffsetId =
                                    "IProgressIndicator::armPixelOffset";

/*------------------------------------------------------------------------------
| IMultiLineEdit::isChanged                                                    |
|                                                                              |
| Queries whether the MLE text has changed since the last time the changed     |
| flag was cleared.                                                            |
------------------------------------------------------------------------------*/
bool  IMultiLineEdit::isChanged() const
{
  return ( hasTextChanged() );
}

/*------------------------------------------------------------------------------
| IMultiLineEdit::resetChangedFlag                                             |
|                                                                              |
| Reset the changed flag to indicate no changes have been made.                |
------------------------------------------------------------------------------*/
IMultiLineEdit& IMultiLineEdit::resetChangedFlag()
{
  setChangedFlag( false );
  return *this;
}


//
//
//  End of obsolete function for obsolete level 2
//
//
#endif


#if (IC_OBSOLETE <= IC_OBSOLETE_3)

//
//
//  Block of obsolete function for obsolete level 3
//
//

#ifdef IC_PM
/******************************************************************************/
/* Public scrollbar style                                                     */
/******************************************************************************/
const IScrollBar::Style
  IScrollBar::autoSize          = SBS_AUTOSIZE;
#endif // IC_PM

//
//
//  End of obsolete function for obsolete level 3
//
//
#endif
