// Revision: 37 1.12 source/ui/basectl/icanvprv.hpp, canvas, ioc.v400, 000919 
/* NOSHIP */
#ifndef _ICANVPRV_
  #define _ICANVPRV_
/*******************************************************************************
* FILE NAME: icanvprv.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the classes:                                                *
*     ICanvasData                                                              *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <ibase.hpp>         // For IC_MOTIF.
#ifdef IC_MOTIF
  #include <X11/Xlib.h>
  #include <X11/Xutil.h>     // For Region.
#endif

#include <icvhdr.hpp>
#include <ipoint.hpp>

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma enum(4)
#pragma pack(push,4)

class ICanvasData {
public:
/*------------------------------- Constructors -------------------------------*/
  ICanvasData ( );
 ~ICanvasData ( );

/*----------------------------------- Data -----------------------------------*/
#ifdef IC_MOTIF
static const char
  className [ 21 ];
#endif
bool
  fShowWindow;
unsigned long
  fChildCount;
bool
  IAmAnICanvas;
ICVKeyboardHandler
  fHandler;
#ifdef IC_MOTIF
ICanvasHandler
  fCanvasHandler;
IString
  xlfdString;
#endif // IC_MOTIF
bool
  fClassStyleAllPaints;
#ifdef IC_WIN
ISize
  fSize;
#endif
}; // ICanvasData

#pragma pack(pop)
#pragma enum(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif /* _ICANVPRV_ */
