// Revision: 68 1.8.1.6 source/ui/basectl/iefpriv.hpp, editctls, ioc.v400, 000919 
/* NOSHIP */
#ifndef _IEFPRIV_
#define _IEFPRIV_
/*******************************************************************************
* FILE NAME: iefpriv.hpp                                                       *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of classes that are private              *
*   to the implementation of IEntryField for Windows 32-bit.                   *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/

#include <istring.hpp>
#include <ientryfd.hpp>
#include <ihandler.hpp>
#ifdef IC_WIN
  #include <ibrushdr.hpp>
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma enum(4)
#pragma pack(push,4)

class IEntryHandler : public IHandler
{
typedef IHandler
  Inherited;
public:

/*------------------------------- Constructors -------------------------------*/
  IEntryHandler ( );

virtual
  ~IEntryHandler ( );

protected:
/*----------------------------- Event Processing -----------------------------*/
virtual bool
  dispatchHandlerEvent ( IEvent& anEvent );

}; // class IEntryHandler

class IEntryFieldData  {
/*------------------------------------------------------------------------------
| The IEntryFieldData class encapsulates private data and functions            |
| used by the IEntryField class.  An object of this class is created in the    |
| IEntryField constructors.                                                    |
------------------------------------------------------------------------------*/
public:
  IEntryFieldData ( IWindow *pwin );

virtual
 ~IEntryFieldData ( );

IWindow
 *dispatchingWindow;

#ifdef IC_WIN
bool
  pointInSelectedText(const IEvent& evt);
unsigned long
  charLimit;
bool
  bCheckingRightDragStart;
IPoint
  pointRButtonDown;
#endif /* IC_WIN */

#ifdef IC_MOTIF
void registerCallbacks();
void unregisterCallbacks(IEntryField* entryField);

enum Flags {                    // values for flagsCl
  autoTab     = 1,
  unreadable  = 2,
  command     = 4,
  replaceMode = 8,
  ignoreTab   = 16,
  changed     = 64
};

unsigned long
  flagsCl;

IString                         // actual value for unreadable
  urValueCl;

int
  iClrestOfMinimumWidth,
  iClrestOfMinimumHeight;

IWindowHandle
  efHandle;
#endif /* IC_MOTIF */

IEntryHandler
  fdefaultHandler;
#ifdef IC_WIN
IBrushHandler
  fBrushHandler;
#endif
}; // IEntryFieldData

#pragma pack(pop)
#pragma enum(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif /* _IEFPRIV_ */

