// Revision: 05 1.3 source/ui/basectl/imcelcvc.cpp, canvas, ioc.v400, 000919  
/*******************************************************************************
* FILE NAME: imcelcvc.cpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the implementation of classes/functions declared        *
*   in imcelcvc.hpp.                                                           *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#pragma priority( -2147481424 )

extern "C"
  {
  #include <stdio.h>
#ifdef IC_PM
  #include <os2.h>
#endif
  }

#include <imcelcvc.hpp>
#include <istring.hpp>


// Segment definitions
#ifdef IC_PAGETUNE
  #define _IMCELCVC_CPP_
  #include <ipagetun.h>
#endif


IMCCvCell* IMCCvCell::pnull= 0;

IMCCvCell& IMCCvCell::nullCell()
{
  if(pnull==0) {
     pnull = new IMCCvCell(0,0);
  }
  return *pnull;
}


IString IMCCvCell::asString( ) const
{
IString str = IString("IMultiCellCvCell(")+IString(column())+
              IString(",")+IString(row())+IString(",")+
              IString(ulColumnRange)+IString(",")+
              IString(ulRowRange)+IString(")");
return str;
}


IString IMCCvCell::asDebugInfo( ) const
{
IString str = asString() + IString(" Minimum(")+IString(ulMinimumWidth)
                         + IString(",")          +IString(ulMinimumHeight)
                         + IString("), pCtrl=")
                         + IString((unsigned long)pWindow).x2d();
return str;
}
