// Revision: 08 1.6 source/ui/basectl/imcelcvh.hpp, canvas, ioc.v400, 000919  
/* NOSHIP */
#ifndef _IMCELCVH_
  #define _IMCELCVH_
/*******************************************************************************
* FILE NAME: imcelcvh.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the classes:                                                *
*     IMultiCellCanvasHandler                                                  *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <ihandler.hpp>

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

class IEvent;
class IMultiCellCanvas;

#pragma enum(4)
#pragma pack(push,4)

class IMultiCellCanvasHandler : public IHandler {
typedef IHandler
  Inherited;
public:
/*-------------------------- Constructor/Destructor ----------------------------
| The only way to construct instances of this class is by using the            |
| default constructor, which does not take any arguments.                      |
------------------------------------------------------------------------------*/
  IMultiCellCanvasHandler ( );
virtual
 ~IMultiCellCanvasHandler ( );

/*---------------------------- Window Attachment -------------------------------
| These functions permit attaching and detaching the handler object to/from    |
| a multi-cell canvas object:                                                  |
|   handleEventsFor       - Attaches the handler to the specified multi-cell   |
|                           canvas object.                                     |
|   stopHandlingEventsFor - Detaches the handler from the specified multi-cell |
|                           canvas object.                                     |
------------------------------------------------------------------------------*/
virtual IMultiCellCanvasHandler
 &handleEventsFor         ( IMultiCellCanvas* canvas ),
 &stopHandlingEventsFor   ( IMultiCellCanvas* canvas );

protected:
/*-------------------------------- Overrides -----------------------------------
| This class overrides the following protected functions:                      |
|   dispatchHandlerEvent - Processes events as appropriate for a multi-cell    |
|                          canvas.                                             |
------------------------------------------------------------------------------*/
virtual bool
  dispatchHandlerEvent    ( IEvent& event );

private:
/*--------------------------------- Private ----------------------------------*/
virtual IHandler
 &handleEventsFor         ( IWindow* window  ),
 &stopHandlingEventsFor   ( IWindow* window  );
}; // IMultiCellCanvasHandler

#pragma pack(pop)
#pragma enum(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif // _IMCELCVH_
