/* NOSHIP */
#ifndef _IRADIOBP_
#define _IRADIOBP_
// Revision: 24 1.2 source/ui/basectl/iradiobp.hpp, buttonctls, ioc.v400, 000919 
/*******************************************************************************
* FILE NAME: iradiobp.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the private classes for IRadioButton.                   *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
extern "C" {
  #include <iwindefs.h>
}

#ifdef IC_WIN
  #include <ibrushdr.hpp>
#endif
#include <ihandler.hpp>
#include <ipoint.hpp>

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#ifdef IC_WIN
/*------------------------------------------------------------------------------
| The IRadioHandler class is a default handler for IRadioButton                |
------------------------------------------------------------------------------*/
#pragma enum(4)
#pragma pack(push,4)

class IRadioHandler : public IHandler {
typedef IHandler
  Inherited;
public:

/*------------------------------- Constructors -------------------------------*/
  IRadioHandler ( );

virtual
  ~IRadioHandler ( );

/*----------------------------- Event Processing -----------------------------*/
virtual bool
  dispatchHandlerEvent ( IEvent& event );

}; // class IRadioHandler
#pragma pack(pop)
#pragma enum(pop)

#endif  //IC_WIN

#ifdef IC_MOTIFWIN
/*------------------------------------------------------------------------------
| The IRadioButtonData class encapsulates private data and functions           |
| used by the IRadioButton class.  An object of this class is created in       |
| the IRadioButton constructors.  This is the Windows/Motif version.           |
------------------------------------------------------------------------------*/
#pragma enum(4)
#pragma pack(push,4)

class IRadioButtonData  {
public:
  IRadioButtonData ( );
 ~IRadioButtonData ( );

#ifdef IC_MOTIF
static int
  groupSelection( Widget widget, bool resetOthers);
#endif //IC_MOTIF

#ifdef IC_WIN
static ISize
  gBitmapSize;

IRadioHandler
  fdefaultHandler;
IBrushHandler
  fBrushHandler;
#endif //IC_WIN
}; // IRadioButtonData

#pragma pack(pop)
#pragma enum(pop)

#endif //IC_MOTIFWIN

#ifdef IC_PM
/*------------------------------------------------------------------------------
| The IRadioButtonData class only contains static data for OS/2 platform,      |
| so an object of this class is not required.  Once non-static data is added   |
| to this class, then the IRadioButtonData constructors must be changed to     |
| create an object of this class.                                              |
------------------------------------------------------------------------------*/
#pragma enum(4)
#pragma pack(push,4)

class IRadioButtonData  {
public:
static ISize
  gBitmapSize;
};  // IRadioButtonData

#pragma pack(pop)
#pragma enum(pop)

#endif // IC_PM

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif
