// Revision: 61 1.4.1.3 source/ui/basectl/ispinbdh.hpp, listctls, ioc.v400, 000919  
/* NOSHIP */
#ifndef _ISPINBDH_
#define _ISPINBDH_
/*******************************************************************************
* FILE NAME: ispinbdh.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the declaration(s) of the class(es):                    *
*     IBaseSpinDefaultHandler - IBaseSpinButton window event handler.          *
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1997                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or               *
*   disclosure                                                                 *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*******************************************************************************/
#include <ikeyhdr.hpp>
#include <isizehdr.hpp>

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

class IBaseSpinButton;
class INumericSpinButton;
class ITextSpinButton;

#pragma enum(4)
#pragma pack(push,4)

class IBaseSpinDefaultHandler : public IKeyboardHandler ,
                                public IResizeHandler
{ 
public:
/*------------------------------- Constructor ----------------------------------
| The only way to construct instances of this class is to use the default      |
| constructor, which does not take any arguments.                              |
------------------------------------------------------------------------------*/

  IBaseSpinDefaultHandler();
  virtual ~IBaseSpinDefaultHandler();

protected:
/*-------------------------------- Overrides -----------------------------------
| These inherited functions are overridden:                                    |
|   virtualKeyPress -   Process the virtual up and down keys for the entry     |
|                       field.                                                 |
|   key             -   Process the key release for the up and down virtual    |
|                       keys.                                                  |
------------------------------------------------------------------------------*/
virtual bool
  virtualKeyPress (IKeyboardEvent& event),
  key (IKeyboardEvent& event),
  windowResize (IResizeEvent& event);

private:
  IBaseSpinDefaultHandler (const IBaseSpinDefaultHandler&);
  IBaseSpinDefaultHandler& operator= (const IBaseSpinDefaultHandler&);
}; // class IBaseSpinDefaultHandler

#pragma pack(pop)
#pragma enum(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif // _ISPINBDH_
