/* Revision: 09 1.3.1.3 source/ui/cclnt/cnr/cnrs1p3.c, cclcnr, ioc.v400, 000919  */
/**********************************************************************/
/*                                                                    */
/*                         IBM CONFIDENTIAL                           */
/*                                                                    */
/*        (IBM Confidential-Restricted when combined with the         */
/*         aggregated OCO source modules for this program)            */
/*                                                                    */
/*                       OCO SOURCE MATERIALS                         */
/*                                                                    */
/*         20G0400 (C) Copyright IBM Corp. 1992, 1997 (Unpublished)   */
/*                                                                    */
/* ================================================================== */
/*                                                                    */
/*                         C O N T A I N E R                          */
/*                                                                    */
/*                        Filename: CNRS1P3.C                         */
/*                                                                    */
/*             ( Windows NT Container Control Component )             */
/*                                                                    */
/*                         IBM CONFIDENTIAL                           */
/*                                                                    */
/*                (C) Copyright IBM Corporation 1997                  */
/*                       All Rights Reserved                          */
/*            Licensed Material - Program Property of IBM             */
/*                                                                    */
/**********************************************************************/
/**********************************************************************/
/* Product: ICLUINT.DLL                                               */
/* Filename: CNRS1P3.C - Drawing routines for the container control   */
/*                                                                    */
/* Flag    Date    By:  Description                                   */
/* ----  --------  ---  --------------------------------------------- */
/* DAB1  11/16/93  DAB  Initial modifications for NT execution        */
/* D6386  1/16/95  ASM  Enable message passing in Win32s environment  */
/*                      Change SendMessage to SENDMESSAGE             */
/* DAB2   8/01/96  DAB  Defect 8172 - Fixed CM_PAINTBACKGROUND parms  */
/**********************************************************************/
#include <math.h>
#include <stdlib.h>
#include <windows.h>
#include <iclccl.h>     /* CCL common include file  */
#include "cnr2win.h"
#include "iclcnrw.h"

#include "cnrcbn.h"

//#include "storwin.h"

#ifdef SEGMENTOR
#define CNRS1P3_C
#include "cnrpragw.h"
#endif


/**********************************************************************/
/*                                                                    */
/*  Function Name:  xxx                                               */
/*                                                                    */
/*  Descriptive Name:  xxx                                            */
/*                                                                    */
/*                                                                    */
/*  Functional Description:                                           */
/*                                                                    */
/*  xxx                                                               */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*  Notes:                                                            */
/*                                                                    */
/*  xxx                                                               */
/*                                                                    */
/*                                                                    */
/*  Input:  hwndCnr - Handle of the Container Window.                 */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*  Output:  xxx                                                      */
/*                                                                    */
/*                                                                    */
/*  Exit-Normal:  xxx                                                 */
/*                                                                    */
/*  Exit-Error:   N/A                                                 */
/*                                                                    */
/*  Side Effects:  None                                               */
/*                                                                    */
/*  Author:  Peter Haggar                                             */
/**********************************************************************/
BOOL FAR CnrDrawLeftDetailsWindow (hwnd, hps, InvalidRect)

HANDLE hwnd;
HDC    hps;
RECT   InvalidRect;

{
 HANDLE        hwndCnr;      /* Handle of the Container window.       */
 LPCNRINFON    pccinfon;     /*                                       */
 LPFIELDINFO   pFieldInfo;   /*                                       */
 long          cyHScroll;    /*                                       */
 long          CxBetweenCols;
 LPRECORDCOREN pRecord;
 RECT          RowRect;
 BOOL          FirstColLeft = FALSE;

 hwndCnr   = PARENTOF (hwnd);
 pccinfon  = (LPCNRINFON)GetWindowLong (hwndCnr, QWL_CONTAINER);
 cyHScroll = GetSystemMetrics (SM_CYHSCROLL);

 CxBetweenCols = 3 * (pccinfon->lAveCharWidth);

 /*********************************************************************/
 /* Turn these flags off to be sure we process things properly.       */
 /* Neither flag should ever be set on entry to this procedure.       */
 /*********************************************************************/
 pccinfon->ulFlagSet &= ~( FL_BELOWINVRECT | FL_RIGHTOFINVRECT );

 /*********************************************************************/
 /* Start with the first record in rect.  Since we know the view      */
 /* scrolled down we want to start with the first row that was in     */
 /* rect.                                                             */
 /*********************************************************************/
 pRecord = CnrGetFirstItemInRect(hwndCnr, InvalidRect);

#if 0
 /*********************************************************************/
 /* Get the record that we will start drawing with.  If we scrolled   */
 /* the window down, we want to start with the bottomost record in    */
 /* the window.                                                       */
 /*********************************************************************/
 if (pccinfon->ulFlagSet2 & FL2_SCROLLDOWNLEFT)
 {
    /******************************************************************/
    /* Start with the last record in view.  Since we know the view    */
    /* scrolled down we want to start with the last row that was in   */
    /* view.                                                          */
    /******************************************************************/
    pRecord = pccinfon->preccLastRowInDV;
    pccinfon->ulFlagSet2 &= ~FL2_SCROLLDOWNLEFT;
 }
 else
 {
    pRecord = pccinfon->preccFirstRowInDV;
 }
#endif


 if (!pRecord)
 {
    pRecord = pccinfon->preccItem;
 }

 /*********************************************************************/
 /* Get the column that we will start drawing with.  If we scrolled   */
 /* the window to the right, we want to start with the rightmost      */
 /* column in the window.                                             */
 /*********************************************************************/
 if (pccinfon->ulFlagSet2 & FL2_SCROLLRIGHT)
 {
    pFieldInfo = pccinfon->pFILastColLeftInDV;
 }
 else
 {
    pFieldInfo = pccinfon->pFIFirstColLeftInDV;
 }

 /*********************************************************************/
 /* If there is no current first in view, then we set it to be the    */
 /* first FieldInfo (column) in the list.                             */
 /*********************************************************************/
 if (!pFieldInfo)
 {
    pFieldInfo = pccinfon->pFirstVisibleFI;
    FirstColLeft = TRUE;
 }
 /*********************************************************************/
 /* If there was a first in view, let's be sure that it's not the     */
 /* first column anyway.  If it is, we have to set this flag for the  */
 /* painting routing.  The position of the first column in the left   */
 /* window is calculated differently than the rest of the items.      */
 /* Thats why we set this flag.                                       */
 /*********************************************************************/
 else if (pFieldInfo == pccinfon->pFirstVisibleFI)
 {
    FirstColLeft = TRUE;
 }

 /*********************************************************************/
 /* Start painting only if there are columns to paint.                */
 /*********************************************************************/
 if (pFieldInfo)
 {
    /******************************************************************/
    /* If the app. specified Details View to be split into 2 windows  */
    /* and pFieldInfoLast is valid, we know to paint Details View in  */
    /* both the left and right window.  pFieldInfoLast indicates the  */
    /* last column in the left window.                                */
    /******************************************************************/
    if ((!(pccinfon->ulFlagSet & FL_UNSPLIT)) &&
        (CnrVerifyFieldInfoPtrs (hwndCnr, pccinfon->pFieldInfoLast, 1)))
    {
       /***************************************************************/
       /* Continue as long as pRecord is not NULL and we are not      */
       /* processing a record which is below the invalid rectangle.   */
       /***************************************************************/
       while ((pRecord) && (!(pccinfon->ulFlagSet & FL_BELOWINVRECT)))
       {
          /************************************************************/
          /* If the current record is not Filtered, go for it.        */
          /************************************************************/
          if (ISRECORDVISIBLE(pRecord))
          {
             if (!(CnrProcessColumnData (hwndCnr, hps, pRecord,
                                         pFieldInfo, InvalidRect,
                                         TRUE, FirstColLeft)))
             {
                /******************************************************/
                /* Turn the flags off.                                */
                /******************************************************/
                pccinfon->ulFlagSet &= ~( FL_BELOWINVRECT |
                                     FL_RIGHTOFINVRECT );
                pccinfon->ulFlagSet2 &= ~FL2_SCROLLRIGHT;
                return (FALSE);
             }

             /*********************************************************/
             /* Go to next column                                     */
             /*********************************************************/
             pFieldInfo = NEXTVISIBLEFI(pFieldInfo);

             /*********************************************************/
             /* Now draw the remaining items in this row for the left */
             /* window.  We draw only the items up to the             */
             /* pFieldInfoLast since this dictates where the left     */
             /* window ends and the right window begins.              */
             /*********************************************************/
             while ((pFieldInfo) && (pFieldInfo !=
                  NEXTVISIBLEFI(pccinfon->pFieldInfoLast)) &&
                  (!(pccinfon->ulFlagSet & FL_RIGHTOFINVRECT)))
             {
                if (!(CnrProcessColumnData (hwndCnr, hps, pRecord,
                                            pFieldInfo, InvalidRect,
                                            TRUE, FALSE)))
                {
                   /***************************************************/
                   /* Turn the flags off.                             */
                   /***************************************************/
                   pccinfon->ulFlagSet &= ~( FL_BELOWINVRECT |
                                        FL_RIGHTOFINVRECT );
                   pccinfon->ulFlagSet2 &= ~FL2_SCROLLRIGHT;
                   return (FALSE);
                }

                /******************************************************/
                /* Go to next column                                  */
                /******************************************************/
                pFieldInfo = NEXTVISIBLEFI(pFieldInfo);
             }

             /*********************************************************/
             /* When we get to here it means that we have finished    */
             /* with a particular row and it is time to go to the     */
             /* next one, so we must set pFieldInfo to the first      */
             /* column to be processed and go to the next record.     */
             /*********************************************************/
             if (pccinfon->ulFlagSet2 & FL2_SCROLLRIGHT)
             {
                pFieldInfo = pccinfon->pFILastColLeftInDV;
             }
             else
             {
                pFieldInfo = pccinfon->pFIFirstColLeftInDV;
             }

             if (!pFieldInfo)
             {
                pFieldInfo = pccinfon->pFirstVisibleFI;
             }

             /*********************************************************/
             /* Check to see if this row has cursored emphasis.  If   */
             /* it does, draw cursored emphasis.                      */
             /*********************************************************/
             if (pRecord->flRecordAttr & CRA_CURSORED)
             {
                CnrCalcRowRect (hwndCnr, pRecord, TRUE, &RowRect);

                /******************************************************/
                /* Subtract 1 from the top so the rectangle will be   */
                /* drawn properly.  Add 2 to the right so that edge   */
                /* will not be shown.                                 */
                /******************************************************/
                RowRect.top ++;
                RowRect.bottom --;
                RowRect.right += 2;

                CnrDrawCursorBox (hwndCnr, hps, pRecord, RowRect, TRUE);
             }

             /*********************************************************/
             /* Turn this flag off since we are staring a new row.    */
             /*********************************************************/
             pccinfon->ulFlagSet &= ~FL_RIGHTOFINVRECT;
          }

          pRecord = pRecord->preccNextItem;
       }
    }
    else
    /******************************************************************/
    /* If we get to here either pFieldInfoLast was not valid or the   */
    /* application did not specify a splitbar.  In either case we     */
    /* paint all of the columns in the left window and nothing will   */
    /* appear in the right window.                                    */
    /******************************************************************/
    {
       /***************************************************************/
       /* Continue as long as pRecord is not NULL and we are not      */
       /* processing a record which is below the invalid rectangle.   */
       /***************************************************************/
       while ((pRecord) && (!(pccinfon->ulFlagSet & FL_BELOWINVRECT)))
       {
          if (ISRECORDVISIBLE(pRecord))
          {
             if (!(CnrProcessColumnData (hwndCnr, hps, pRecord,
                                         pFieldInfo, InvalidRect,
                                         TRUE, FirstColLeft)))
             {
                /******************************************************/
                /* Turn the flags off.                                */
                /******************************************************/
                pccinfon->ulFlagSet &= ~( FL_BELOWINVRECT |
                                     FL_RIGHTOFINVRECT );
                pccinfon->ulFlagSet2 &= ~FL2_SCROLLRIGHT;
                return (FALSE);
             }

             /*********************************************************/
             /* Go to next column                                     */
             /*********************************************************/
             pFieldInfo = NEXTVISIBLEFI(pFieldInfo);

             /*********************************************************/
             /* Now draw the remaining items in this row for the left */
             /* window.  We draw only the items up to the             */
             /* pFieldInfoLast since this dictates where the left     */
             /* window ends and the right window begins.              */
             /*********************************************************/
             while ((pFieldInfo) &&
                   (!(pccinfon->ulFlagSet & FL_RIGHTOFINVRECT)))
             {
                if (!(CnrProcessColumnData (hwndCnr, hps, pRecord,
                                            pFieldInfo, InvalidRect,
                                            TRUE, FALSE)))
                {
                   /***************************************************/
                   /* Turn the flags off.                             */
                   /***************************************************/
                   pccinfon->ulFlagSet &= ~( FL_BELOWINVRECT |
                                        FL_RIGHTOFINVRECT );
                   pccinfon->ulFlagSet2 &= ~FL2_SCROLLRIGHT;
                   return (FALSE);
                }

                /******************************************************/
                /* Go to next column                                  */
                /******************************************************/
                pFieldInfo = NEXTVISIBLEFI(pFieldInfo);
              }

             /*********************************************************/
             /* When we get to here it means that we have finished    */
             /* with a particular row and it is time to go to the     */
             /* next one, so we set pFieldInfo to the first column to */
             /* be process and go to the next record.                 */
             /*********************************************************/
             if (pccinfon->ulFlagSet2 & FL2_SCROLLRIGHT)
             {
                pFieldInfo = pccinfon->pFILastColLeftInDV;
             }
             else
             {
                pFieldInfo = pccinfon->pFIFirstColLeftInDV;
             }

             if (!pFieldInfo)
             {
                pFieldInfo = pccinfon->pFirstVisibleFI;
             }

             /*********************************************************/
             /* Check to see if this row has cursored emphasis.  If   */
             /* it does, draw cursored emphasis.                      */
             /*********************************************************/
             if (pRecord->flRecordAttr & CRA_CURSORED)
             {
                CnrCalcRowRect (hwndCnr, pRecord, TRUE, &RowRect);

                /******************************************************/
                /* Subtract 1 from the top so the rectangle will be   */
                /* drawn properly.  Add 2 to the right so that edge   */
                /* will not be shown.                                 */
                /******************************************************/
                RowRect.right += 2;
                RowRect.top ++;
                RowRect.bottom --;

                CnrDrawCursorBox (hwndCnr, hps, pRecord, RowRect, TRUE);
             }

             /*********************************************************/
             /* Turn this flag off since we are staring a new row.    */
             /*********************************************************/
             pccinfon->ulFlagSet &= ~FL_RIGHTOFINVRECT;
          }

          pRecord = pRecord->preccNextItem;
       }
    }

    CnrDrawVertSep (hwndCnr, hps, TRUE, FALSE);
 }

 /*********************************************************************/
 /* Turn the flags off.                                               */
 /*********************************************************************/
 pccinfon->ulFlagSet &= ~( FL_BELOWINVRECT | FL_RIGHTOFINVRECT );
 pccinfon->ulFlagSet2 &= ~FL2_SCROLLRIGHT;

 return (TRUE);
}

/**********************************************************************/
/*                                                                    */
/*  Function Name:  CnrDrawRightDetailsWindow                         */
/*                                                                    */
/*  Descriptive Name:  Draw the right split window in Details View.   */
/*                                                                    */
/*  Functional Description:                                           */
/*                                                                    */
/*  This function handles the drawing of the right split window in    */
/*  Details View.                                                     */
/*                                                                    */
/*  Notes:  If the application does not specify a right split window, */
/*          this routine will do nothing.                             */
/*                                                                    */
/*  Input:  hwnd    - Handle of the right split window in Details     */
/*                    View.                                           */
/*          hps     - Handle to a presentation space.                 */
/*          pRecord - Pointer to a record for which to start          */
/*                    painting.                                       */
/*                                                                    */
/*  Output:  VOID                                                     */
/*                                                                    */
/*  Exit-Normal: VOID                                                 */
/*                                                                    */
/*  Exit-Error:  VOID                                                 */
/*                                                                    */
/*  Side Effects:  None                                               */
/*                                                                    */
/*  Author:  Peter Haggar                                             */
/**********************************************************************/
BOOL FAR CnrDrawRightDetailsWindow (hwnd, hps, InvalidRect)

HANDLE hwnd;            /* Handle of the Right split window.          */
HDC    hps;             /* Handle to a presentation space.            */
RECT   InvalidRect;

{
 LPCNRINFON    pccinfon;      /* Pointer to Internal Control Info.    */
 LPCNRINFO     pccinfo;       /* Pointer to Internal Control Info.    */
 HANDLE        hwndCnr;       /* Handle of the Container Window.      */
 LPFIELDINFO   pFieldInfo;    /* Pointer to a FieldInfo structure.    */
 long          CxBetweenCols;
 long          CyBetweenRows;
 LPRECORDCOREN pRecord;
 RECT          RowRect;
 long          top;
 BOOL          DataRightWnd = FALSE;

 hwndCnr   = PARENTOF (hwnd);
 pccinfon  = (LPCNRINFON)GetWindowLong (hwndCnr, QWL_CONTAINER);
 pccinfo  = PCCINFOXFROMN(pccinfon);
 CxBetweenCols = 3 * (pccinfon->lAveCharWidth);

 /*********************************************************************/
 /* Turn these flags off to be sure we process things properly.       */
 /* Neither flag should ever be set on entry to this procedure.       */
 /*********************************************************************/
 pccinfon->ulFlagSet &= ~( FL_BELOWINVRECT | FL_RIGHTOFINVRECT );

 /*********************************************************************/
 /* Start with the first record in rect.  Since we know the view      */
 /* scrolled down we want to start with the first row that was in     */
 /* rect.                                                             */
 /*********************************************************************/
 pRecord = CnrGetFirstItemInRect(hwndCnr, InvalidRect);

#if 0
 /*********************************************************************/
 /* Get the record that we will start drawing with.  If we scrolled   */
 /* the window down, we want to start with the bottomost record in    */
 /* the window.                                                       */
 /*********************************************************************/
 if (pccinfon->ulFlagSet2 & FL2_SCROLLDOWNRIGHT)
 {
    /******************************************************************/
    /* Start with the last record in view.  Since we know the view    */
    /* scrolled down we want to start with the last row that was in   */
    /* view.                                                          */
    /******************************************************************/
    pRecord = pccinfon->preccLastRowInDV;
    pccinfon->ulFlagSet2 &= ~FL2_SCROLLDOWNRIGHT;
 }
 else
 {
    pRecord = pccinfon->preccFirstRowInDV;
 }
#endif

 if (!pRecord)
 {
    pRecord = pccinfon->preccItem;
 }

 /*********************************************************************/
 /* If the app. specified Details View to have 2 windows, we draw the */
 /* data to be drawn in the right window.  If they didn't, that means */
 /* that all of the data is drawn in the left window and there is no  */
 /* right window, and this routine won't do anything...except return. */
 /*********************************************************************/
 if ((!(pccinfon->ulFlagSet & FL_UNSPLIT)) &&
     (CnrVerifyFieldInfoPtrs (hwndCnr, pccinfon->pFieldInfoLast, 1)))
 {
    /******************************************************************/
    /* Set pFieldInfo to be the first column in view in the right     */
    /* window.  If that doesn't exist yet, set pFieldInfo to be the   */
    /* column after the one specifed by pFieldInfoLast.  This is the  */
    /* first column in the right window.                              */
    /******************************************************************/
    if (pccinfon->ulFlagSet2 & FL2_SCROLLRIGHT)
    {
       pFieldInfo = pccinfon->pFILastColRightInDV;
    }
    else
    {
       pFieldInfo = pccinfon->pFIFirstColRightInDV;
    }

    if (!pFieldInfo)
    {
       pFieldInfo = NEXTVISIBLEFI(pccinfon->pFieldInfoLast);
    }

    if (pFieldInfo)
    {
       DataRightWnd = TRUE;

       /***************************************************************/
       /* Continue as long as pRecord is not NULL and we are not      */
       /* processing a record which is below the invalid rectangle.   */
       /***************************************************************/
       while ((pRecord) && (!(pccinfon->ulFlagSet & FL_BELOWINVRECT)))
       {
          if (ISRECORDVISIBLE(pRecord))
          {
             while ((pFieldInfo) &&
                    (!(pccinfon->ulFlagSet & FL_RIGHTOFINVRECT)))
             {
                if (!(CnrProcessColumnData (hwndCnr, hps, pRecord,
                                            pFieldInfo, InvalidRect,
                                            FALSE, FALSE)))
                {
                   /***************************************************/
                   /* Turn the flags off.                             */
                   /***************************************************/
                   pccinfon->ulFlagSet &= ~( FL_BELOWINVRECT |
                                        FL_RIGHTOFINVRECT );
                   pccinfon->ulFlagSet2 &= ~FL2_SCROLLRIGHT;
                   return (FALSE);
                }

                /******************************************************/
                /* Go to next column                                  */
                /******************************************************/
                pFieldInfo = NEXTVISIBLEFI(pFieldInfo);
             }

             /*********************************************************/
             /* When we get to here it means that we have finished    */
             /* with a particular row and it is time to go to the     */
             /* next one.  So, we set pFieldInfo to the column that   */
             /* we are starting with, and then go to the next record. */
             /*********************************************************/
             if (pccinfon->ulFlagSet2 & FL2_SCROLLRIGHT)
             {
                pFieldInfo = pccinfon->pFILastColRightInDV;
             }
             else
             {
                pFieldInfo = pccinfon->pFIFirstColRightInDV;
             }

             if (!pFieldInfo)
             {
                pFieldInfo = NEXTVISIBLEFI(pccinfon->pFieldInfoLast);
             }

             /*********************************************************/
             /* Check to see if this row has cursored emphasis.  If   */
             /* it does, draw cursored emphasis.                      */
             /*********************************************************/
             if (pRecord->flRecordAttr & CRA_CURSORED)
             {
                CnrCalcRowRect (hwndCnr, pRecord, FALSE, &RowRect);

                /******************************************************/
                /* Subtract 1 from the top so the rectangle will be   */
                /* drawn properly.  Subtract 2 from the left and add  */
                /* 2 to the right so those edges of the rectangle are */
                /* in view.                                           */
                /******************************************************/
                RowRect.top ++;
                RowRect.bottom --;
                RowRect.left -= 2;
                RowRect.right += 2;

                CnrDrawCursorBox (hwndCnr, hps, pRecord, RowRect, TRUE);
             }

             /*********************************************************/
             /* Turn this flag off since we are starting a new column.*/
             /*********************************************************/
             pccinfon->ulFlagSet &= ~FL_RIGHTOFINVRECT;
          }

          pRecord = pRecord->preccNextItem;
       }

       CnrDrawVertSep (hwndCnr, hps, FALSE, FALSE);
    }
 }

 /*********************************************************************/
 /* If the window is split, there is no data in the right window, and */
 /* there is data in the right window, we need to draw the            */
 /* appropriate cursored emphasis.                                    */
 /*********************************************************************/
 if ((!(pccinfon->ulFlagSet & FL_UNSPLIT)) && (!DataRightWnd) &&
     (pccinfon->pFirstVisibleFI))
 {
    /******************************************************************/
    /* Get the distance between the rows.                             */
    /******************************************************************/
    if (pccinfo->cyLineSpacing >= 0)
    {
       CyBetweenRows = pccinfo->cyLineSpacing;
    }
    else
    {
       CyBetweenRows = MINCY_BETWEENITEMS;
    }

    while (pRecord)
    {
       top = CnrQueryRowPosInDV (pRecord, PT_TOP) -
              (CyBetweenRows / 2);

       /***************************************************************/
       /* Make sure the row is in the viewport.  If not, go to the    */
       /* next one.                                                   */
       /***************************************************************/
       if (top >= pccinfon->ptlNonIconOrg.y)
       {
          CnrCalcRowRect (hwndCnr, pRecord, FALSE, &RowRect);
          RowRect.right += GetSystemMetrics (SM_CXVSCROLL) + 2;

          /************************************************************/
          /* Do this to draw any emphasis that may exist...ie. in-use */
          /* and or selection, etc.                                   */
          /************************************************************/
          IcnDrawTextInDV (hps, NULL, RowRect, RowRect,
                           pRecord->flRecordAttr, 0L, pccinfon);

          if (pRecord->flRecordAttr & CRA_CURSORED)
          {
             /*********************************************************/
             /* Subtract 1 from the top so the rectangle will be drawn*/
             /* properly.  Subtract 2 from the left and add 2 to the  */
             /* right so those edges of the rectangle are in view.    */
             /*********************************************************/
             RowRect.left -= 2;
             RowRect.right += 2;
             RowRect.top ++;
             RowRect.bottom --;

             CnrDrawCursorBox (hwndCnr, hps, pRecord, RowRect, TRUE);
          }
       }

       pRecord = pRecord->preccNextItem;
    }
 }

 /*********************************************************************/
 /* Turn the flags off.                                               */
 /*********************************************************************/
 pccinfon->ulFlagSet &= ~( FL_BELOWINVRECT | FL_RIGHTOFINVRECT );
 pccinfon->ulFlagSet2 &= ~FL2_SCROLLRIGHT;

 return (TRUE);
}

/*********************************************************************/
/*                                                                   */
/* FUNCTION NAME:  CnrGetFirstItemInRect                             */
/*                                                                   */
/* Usage: Internal                                                   */
/*                                                                   */
/* DESCRIPTIVE NAME:  Get the pointer to the first item in the       */
/*                    rect  for Name, Text and Details view.         */
/*                                                                   */
/* FUNCTIONAL DESCRIPTION:  This function finds the first item in    */
/*     the rect.                                                     */
/*                                                                   */
/* NOTES:                                                            */
/*    FORWARD DECLARATION:                                           */
/*                                                                   */
/* OUTPUT:                                                           */
/*                                                                   */
/* EXIT-NORMAL:                                                      */
/*                                                                   */
/* EXIT-ERROR:                                                       */
/*                                                                   */
/* SIDE EFFECTS:                                                     */
/*                                                                   */
/*********************************************************************/
LPRECORDCOREN FAR CnrGetFirstItemInRect (HWND hwndCnr, RECT rctlRedraw)
{
  LPCNRINFON    pccinfon;
  LPCNRINFO     pccinfo;
  RECT          rctlHscroll;       /* H scroll bar rectangle          */
  RECT          rctlTitle;         /* Title rectangle                 */
  POINT         ptIconSize;        /* size of the icon                */
  LPRECORDCOREN preccCurrinView;   /* the current item                */
  long          yBottom;           /* bottom of the record            */
  long          xRight;            /* Right of the record             */
  long          CyBetweenRows;

  /********************************************************************/
  /* Get pointer to Container internal data.                          */
  /********************************************************************/
  pccinfon  = (LPCNRINFON)GetWindowLong (hwndCnr, QWL_CONTAINER);
  pccinfo  = PCCINFOXFROMN(pccinfon);

  /******************************************************************/
  /* Calculate the size of the scroll bars and the viewport.        */
  /******************************************************************/
  CnrQuerySizeRect(hwndCnr, &ptIconSize, &rctlTitle, NULL, NULL,
                   &rctlHscroll);

  rctlRedraw.left += pccinfon->ptlNonIconOrg.x;
  rctlRedraw.right += pccinfon->ptlNonIconOrg.x;
  rctlRedraw.top += pccinfon->ptlNonIconOrg.y;
  rctlRedraw.bottom += pccinfon->ptlNonIconOrg.y;

  /*******************************************************************/
  /* Initialize the pointer to the current record                    */
  /*******************************************************************/
  if (pccinfo->flWindowAttr & CV_DETAIL)
  {
    preccCurrinView = pccinfon->preccFirstRowInDV;
  }
  else
  {
    if (pccinfo->flWindowAttr & CV_FLOW)
    {
      /************************************************************/
      /* Flowed Name View                                         */
      /************************************************************/
      if (pccinfo->flWindowAttr & CV_NAME)
      {
        preccCurrinView = pccinfon->preccFirstinFNV;
      }
      /************************************************************/
      /* Flowed Text View                                         */
      /************************************************************/
      else
      if (pccinfo->flWindowAttr & CV_TEXT)
      {
        preccCurrinView = pccinfon->preccFirstinFTV;
      }
    }
    else    //non-flow view
    {
      /************************************************************/
      /* Non-Flowed Name View                                     */
      /************************************************************/
      if (pccinfo->flWindowAttr & CV_NAME)
      {
        preccCurrinView = pccinfon->preccFirstinNV;
      }
      /************************************************************/
      /* Non-Flowed Text View                                     */
      /************************************************************/
      else
      if (pccinfo->flWindowAttr & CV_TEXT)
      {
        preccCurrinView = pccinfon->preccFirstinTV;
      }
    }
  }

  if (!preccCurrinView)
  {
    preccCurrinView = pccinfon->preccItem;
  }

  /********************************************************************/
  /* Find the first record in the rect.                               */
  /********************************************************************/
  if (preccCurrinView)
  {
    /******************************************************************/
    /* Get the coordinates of the record.                             */
    /******************************************************************/
    if (pccinfo->flWindowAttr & CV_DETAIL)
    {
       /***************************************************************/
       /* Set the distance between the rows.  If the application has  */
       /* specified it, use it...otherwise use our constant.          */
       /***************************************************************/
       if (pccinfo->cyLineSpacing >= 0)
       {
          CyBetweenRows = pccinfo->cyLineSpacing;
       }
       else
       {
          CyBetweenRows = MINCY_BETWEENITEMS;
       }

       yBottom = CnrQueryRowPosInDV (preccCurrinView,PT_BOTTOM) +  //FLIP - to +
                 (CyBetweenRows / 2);
    }
    else
    {
      yBottom = CnrQueryPtOfItemInNTV(hwndCnr, preccCurrinView,
                                      &ptIconSize, PT_BOTTOM);

      if (pccinfo->flWindowAttr & CV_FLOW)
      {
        xRight  = CnrQueryPtOfItemInNTV(hwndCnr, preccCurrinView,
                                        &ptIconSize, PT_RIGHT);
      }
    }

    /******************************************************************/
    /* Loop until the first record in rect is found                   */
    /******************************************************************/
    while (preccCurrinView &&
           ((!(pccinfo->flWindowAttr & CV_FLOW) &&
             (yBottom < rctlRedraw.top)) ||
            ((pccinfo->flWindowAttr & CV_FLOW)  &&
             (xRight < rctlRedraw.left))))
    {
      /****************************************************************/
      /* Index to the next item and reset the record bottom coordinate*/
      /****************************************************************/
      preccCurrinView = preccCurrinView->preccNextItem;
      if (preccCurrinView)
      {
        /**************************************************************/
        /* Get the bottom coordinate of the record.                   */
        /**************************************************************/
        if (pccinfo->flWindowAttr & CV_DETAIL)
        {
          yBottom = CnrQueryRowPosInDV (preccCurrinView,
                    PT_BOTTOM) + (CyBetweenRows / 2);
        }
        else
        {
          xRight  = CnrQueryPtOfItemInNTV(hwndCnr, preccCurrinView,
                                          &ptIconSize, PT_RIGHT);

          yBottom = CnrQueryPtOfItemInNTV(hwndCnr, preccCurrinView,
                                          &ptIconSize, PT_BOTTOM);
        }
      }
    }
  }
  return (preccCurrinView);
}

/**********************************************************************/
/*                                                                    */
/*  Function Name:  xxx                                               */
/*                                                                    */
/*  Descriptive Name:  xxx                                            */
/*                                                                    */
/*                                                                    */
/*  Functional Description:                                           */
/*                                                                    */
/*  xxx                                                               */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*  Notes:                                                            */
/*                                                                    */
/*  xxx                                                               */
/*                                                                    */
/*                                                                    */
/*  Input:  hwndCnr - Handle of the Container Window.                 */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*  Output:  xxx                                                      */
/*                                                                    */
/*                                                                    */
/*  Exit-Normal:  xxx                                                 */
/*                                                                    */
/*  Exit-Error:   N/A                                                 */
/*                                                                    */
/*  Side Effects:  None                                               */
/*                                                                    */
/*  Author:  Peter Haggar                                             */
/**********************************************************************/
BOOL FAR CnrDrawEraseRow (hwndCnr, pRecord, Draw)

HANDLE        hwndCnr;
LPRECORDCOREN pRecord;
BOOL          Draw;

{
 LPCNRINFON  pccinfon;
 LPCNRINFO   pccinfo;
 LPFIELDINFO pFirstInViewLeft;
 LPFIELDINFO pLastInViewLeft;
 LPFIELDINFO pFirstInViewRight;
 LPFIELDINFO pLastInViewRight;
 LPFIELDINFO pFieldInfo;
 HDC         hpsLeft;
 HDC         hpsRight;
 HANDLE      hwndLeft;
 HANDLE      hwndRight;
 long        xColumnPos;
 long        CxBetweenCols;
 RECT        RowRectLeft;
 RECT        RowRectRight;
 BOOL        FirstColLeft = FALSE;
 BOOL        DataRightWnd = FALSE;
 OWNERBACKGROUND  OwnerBack;
 BOOL        OwnerPaintBG = FALSE;
 long        CyBetweenRows;

 pccinfon = (LPCNRINFON)GetWindowLong (hwndCnr, QWL_CONTAINER);
 pccinfo  = PCCINFOXFROMN(pccinfon);

 /*********************************************************************/
 /* Calculate the distance between columns.                           */
 /*********************************************************************/
 CxBetweenCols = 3 * (pccinfon->lAveCharWidth);

 /*********************************************************************/
 /* Since we always have a left window, calculate the row rectangle   */
 /* for the left window.                                              */
 /*********************************************************************/
 CnrCalcRowRect (hwndCnr, pRecord, TRUE, &RowRectLeft);

 /*********************************************************************/
 /* If the Details View window is split in 2, we calculate the Row    */
 /* rectangle for right window too.                                   */
 /*********************************************************************/
 if (!(pccinfon->ulFlagSet & FL_UNSPLIT))
 {
    CnrCalcRowRect (hwndCnr, pRecord, FALSE, &RowRectRight);
 }

 /*********************************************************************/
 /* If we are drawing a row, do so.                                   */
 /*********************************************************************/
 if (Draw)
 {
    /******************************************************************/
    /* Draw the left window first.  If we are dragging, we must get   */
    /* the Drag PS.                                                   */
    /******************************************************************/
//  if (pccinfon->ulFlagSet & FL_DRAGPROGRESS)
//  {
//     hpsLeft = DrgGetPS (GetDlgItem (hwndCnr, CID_LEFTDVWND));
//  }

    hwndLeft = GetDlgItem (hwndCnr, CID_LEFTDVWND);
    hpsLeft = PMGetFlippedDC (hwndLeft);

    /******************************************************************/
    /* First get the first and last colunms in view for the Left      */
    /* window.                                                        */
    /******************************************************************/
    pFirstInViewLeft = pccinfon->pFIFirstColLeftInDV;

    if (!pFirstInViewLeft)
    {
       pFirstInViewLeft = pccinfon->pFirstVisibleFI;
       FirstColLeft = TRUE;
    }
    else if (pFirstInViewLeft == pccinfon->pFirstVisibleFI)
    {
       FirstColLeft = TRUE;
    }

    xColumnPos = CnrQueryColumnPosInDV (hwndCnr,
                                        pccinfon->pFirstVisibleFI,
                                        pFirstInViewLeft,
                                        TRUE,
                                        FALSE);

    pLastInViewLeft = CnrQueryLastColumnInView (hwndCnr,
                                                pFirstInViewLeft,
                                                TRUE);

    pFieldInfo = pFirstInViewLeft;

    /******************************************************************/
    /* If there is a last column in view, then we loop from the first */
    /* in view to the last in view and calculate the selection        */
    /* rectangle for each column (FieldInfo) for this row (record).   */
    /* Then we draw or erase each of these.                           */
    /******************************************************************/
    if (pLastInViewLeft)
    {
       while ((pFieldInfo) && (pFieldInfo !=
                                        NEXTVISIBLEFI(pLastInViewLeft)))
       {
          if (!(CnrProcessColumnData (hwndCnr, hpsLeft, pRecord,
                                      pFieldInfo, RowRectLeft,
                                      TRUE, FirstColLeft)))
          {
//           if (pccinfon->ulFlagSet & FL_DRAGPROGRESS)
//           {
//              DrgReleasePS (hpsLeft);
//           }

             ReleaseDC (hwndLeft, hpsLeft);

             return (FALSE);
          }

          if (pFieldInfo->cxWidth)
          {
             xColumnPos += pFieldInfo->cxWidth + CxBetweenCols;
          }
          else
          {
             xColumnPos += PFINFROMX(pFieldInfo)->usLongestLine +
                           CxBetweenCols;
          }

          FirstColLeft = FALSE;
          pFieldInfo = NEXTVISIBLEFI(pFieldInfo);
       }

       CnrDrawVertSep (hwndCnr, hpsLeft, TRUE, FALSE);
    }

    ReleaseDC (hwndLeft, hpsLeft);

    /******************************************************************/
    /* Now determine if there is a right window.                      */
    /******************************************************************/
    if (!(pccinfon->ulFlagSet & FL_UNSPLIT))
    {
//     if (pccinfon->ulFlagSet & FL_DRAGPROGRESS)
//     {
//        hpsRight = DrgGetPS (GetDlgItem (hwndCnr,
//                                              CID_RIGHTDVWND));
//     }

       hwndRight = GetDlgItem (hwndCnr, CID_RIGHTDVWND);
       hpsRight = PMGetFlippedDC (hwndRight);

       if (CnrVerifyFieldInfoPtrs (hwndCnr,
                                   pccinfon->pFieldInfoLast,
                                   1))
       {
          /************************************************************/
          /* Now check to see if there is any data in the right       */
          /* window.                                                  */
          /************************************************************/
          if (NEXTVISIBLEFI(pccinfon->pFieldInfoLast))
          {
             DataRightWnd = TRUE;
             pFirstInViewRight = pccinfon->pFIFirstColRightInDV;

             if (!pFirstInViewRight)
             {
                pFirstInViewRight =
                      NEXTVISIBLEFI(pccinfon->pFieldInfoLast);
             }

             xColumnPos = CnrQueryColumnPosInDV (hwndCnr,
                                 NEXTVISIBLEFI(pccinfon->pFieldInfoLast),
                                                 pFirstInViewRight,
                                                 TRUE,
                                                 FALSE);

             pLastInViewRight = CnrQueryLastColumnInView (hwndCnr,
                                                      pFirstInViewRight,
                                                         FALSE);

             pFieldInfo = pFirstInViewRight;

             if (pLastInViewRight)
             {
                while ((pFieldInfo) && (pFieldInfo !=
                              NEXTVISIBLEFI(pLastInViewRight)))
                {
                   if (!(CnrProcessColumnData (hwndCnr, hpsRight,
                                               pRecord, pFieldInfo,
                                               RowRectRight,
                                               FALSE, FALSE)))
                   {
//                    if (pccinfon->ulFlagSet & FL_DRAGPROGRESS)
//                    {
//                       DrgReleasePS (hpsRight);
//                    }

                      ReleaseDC (hwndRight, hpsRight);
                      return (FALSE);
                   }

                   if (pFieldInfo->cxWidth)
                   {
                      xColumnPos += pFieldInfo->cxWidth + CxBetweenCols;
                   }
                   else
                   {
                    xColumnPos += PFINFROMX(pFieldInfo)->usLongestLine +
                                    CxBetweenCols;
                   }

                   pFieldInfo = NEXTVISIBLEFI(pFieldInfo);
                }

                CnrDrawVertSep (hwndCnr, hpsRight, FALSE, FALSE);
             }
          }
       }

       /***************************************************************/
       /* If there is no data in the right window, and the right      */
       /* window exists, we still must draw any target or cursored    */
       /* emphasis.                                                   */
       /***************************************************************/
       if ((!DataRightWnd) && (pccinfon->pFirstVisibleFI))
       {
          /************************************************************/
          /* Draw the blank selection emphasis.                       */
          /************************************************************/
          IcnDrawTextInDV (hpsRight, NULL, RowRectRight, RowRectRight,
                           pRecord->flRecordAttr, 0L, pccinfon);
       }

//     if (pccinfon->ulFlagSet & FL_DRAGPROGRESS)
//     {
//        DrgReleasePS (hpsRight);
//     }

       ReleaseDC (hwndRight, hpsRight);
    }

//  if (pccinfon->ulFlagSet & FL_DRAGPROGRESS)
//  {
//     DrgReleasePS (hpsLeft);
//  }

 }
 else
 /*********************************************************************/
 /* We are supposed to erase the row specified by pRecord.            */
 /*********************************************************************/
 {
    /******************************************************************/
    /* Get the distance between the rows.                             */
    /******************************************************************/
    if (pccinfo->cyLineSpacing >= 0)
    {
       CyBetweenRows = pccinfo->cyLineSpacing;
    }
    else
    {
       CyBetweenRows = MINCY_BETWEENITEMS;
    }


    /******************************************************************/
    /* First we erase the left window.                                */
    /******************************************************************/
//  if (pccinfon->ulFlagSet & FL_DRAGPROGRESS)
//  {
//     hpsLeft = DrgGetPS (GetDlgItem (hwndCnr, CID_LEFTDVWND));
//  }

    hwndLeft = GetDlgItem (hwndCnr, CID_LEFTDVWND);
    hpsLeft = PMGetFlippedDC (hwndLeft);

    /******************************************************************/
    /* If the application wants to have a crack at painting the       */
    /* background, send them the CM_PAINTBACKGROUND message.          */
    /******************************************************************/
    if (pccinfo->flWindowAttr & CA_OWNERPAINTBACKGROUND)
    {
       OwnerBack.hwnd = GetDlgItem (hwndCnr, CID_LEFTDVWND);
       OwnerBack.hps  = hpsLeft;
       OwnerBack.rclBackground = RowRectLeft;
       OwnerBack.idWindow = getWindowId( GetDlgItem( hwndCnr,           /*DAB1*/
                                                  CID_LEFTDVWND ));     /*DAB1*/

       OwnerPaintBG = SENDMESSAGE( hwndCnr, CM_PAINTBACKGROUND,         /*DAB1*/
                           (DWORD)((LPOWNERBACKGROUND)&OwnerBack), 0);  /*DAB2*/
    }

    /******************************************************************/
    /* If the application didn't paint the background, we do it.      */
    /******************************************************************/
    if (!OwnerPaintBG)
    {
      HBRUSH hBrush;

      /****************************************************************/
      /* Paint the background with the current setting                */
      /****************************************************************/

      hBrush = CreateSolidBrush (
               pccinfon->ulColorPPSupport[CMA_BACKGROUNDCOLOR]);
      if (hBrush)
      {
        PMFillRect (hpsLeft, &RowRectLeft, hBrush);
        DeleteObject(hBrush);
      }
    }

//  if (pccinfon->ulFlagSet & FL_DRAGPROGRESS)
//  {
//     DrgReleasePS (hpsLeft);
//  }

    ReleaseDC (hwndLeft, hpsLeft);

    /******************************************************************/
    /* If there is a right window, we need to erase it too.           */
    /******************************************************************/
    if (!(pccinfon->ulFlagSet & FL_UNSPLIT))
    {
//     if (pccinfon->ulFlagSet & FL_DRAGPROGRESS)
//     {
//        hpsRight = DrgGetPS (GetDlgItem (hwndCnr, CID_RIGHTDVWND));
//     }

       hwndRight = GetDlgItem (hwndCnr, CID_RIGHTDVWND);
       hpsRight = PMGetFlippedDC (hwndRight);

       /***************************************************************/
       /* Reset the OwnerPaintBG flag.                                */
       /***************************************************************/
       OwnerPaintBG = FALSE;

       /***************************************************************/
       /* If the application wants to have a crack at painting the    */
       /* background, send them the CM_PAINTBACKGROUND message.       */
       /***************************************************************/
       if (pccinfo->flWindowAttr & CA_OWNERPAINTBACKGROUND)
       {
          OwnerBack.hwnd = GetDlgItem (hwndCnr, CID_RIGHTDVWND);
          OwnerBack.hps  = hpsRight;
          OwnerBack.rclBackground = RowRectRight;
          OwnerBack.idWindow = getWindowId( GetDlgItem( hwndCnr,
                                                CID_RIGHTDVWND));       /*DAB1*/

          OwnerPaintBG = SENDMESSAGE( hwndCnr, CM_PAINTBACKGROUND,
                             (DWORD)((LPOWNERBACKGROUND)&OwnerBack), 0);/*DAB2*/
       }

       /***************************************************************/
       /* If the application didn't paint the background, we do it.   */
       /***************************************************************/
       if (!OwnerPaintBG)
       {
         HBRUSH hBrush;

         /*************************************************************/
         /* Paint the background with the current setting             */
         /*************************************************************/
         hBrush =  CreateSolidBrush (
                   pccinfon->ulColorPPSupport[CMA_BACKGROUNDCOLOR]);
         if (hBrush)
         {
           PMFillRect (hpsRight, &RowRectRight, hBrush);
           DeleteObject(hBrush);
         }
       }

//     if (pccinfon->ulFlagSet & FL_DRAGPROGRESS)
//     {
//        DrgReleasePS (hpsRight);
//     }

       ReleaseDC (hwndRight, hpsRight);
    }
 }

 return (TRUE);
}

/**********************************************************************/
/*                                                                    */
/*  Function Name:  xxx                                               */
/*                                                                    */
/*  Descriptive Name:  xxx                                            */
/*                                                                    */
/*                                                                    */
/*  Functional Description:                                           */
/*                                                                    */
/*  xxx                                                               */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*  Notes:                                                            */
/*                                                                    */
/*  xxx                                                               */
/*                                                                    */
/*                                                                    */
/*  Input:  hwndCnr - Handle of the Container Window.                 */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*  Output:  xxx                                                      */
/*                                                                    */
/*                                                                    */
/*  Exit-Normal:  xxx                                                 */
/*                                                                    */
/*  Exit-Error:   N/A                                                 */
/*                                                                    */
/*  Side Effects:  None                                               */
/*                                                                    */
/*  Author:  Peter Haggar                                             */
/**********************************************************************/
VOID FAR CnrDrawHorzSep (hwndCnr, hps, pFieldInfo,
                          xColumnPos, LeftWindow)

HANDLE      hwndCnr;
HDC         hps;
LPFIELDINFO pFieldInfo;
long        xColumnPos;
BOOL        LeftWindow;

{
 LPCNRINFON pccinfon;    /* Pointer to Internal control information. */
 POINT      ptl;
 WORD       Width;
 LPLONG     WindowOrgx;
 HPEN       hpenOld;
 HPEN       hpenCurrent;
 RECT       rctlLeftColTitle;
 int        nSavedDC;

 pccinfon = (LPCNRINFON)GetWindowLong (hwndCnr, QWL_CONTAINER);
 PMGetClientRect (GetDlgItem (hwndCnr, CID_LEFTCOLTITLEWND),
                  &rctlLeftColTitle);

 if (pFieldInfo)
 {
    /******************************************************************/
    /* Save the current PS attributes.                                */
    /******************************************************************/
    if (!(nSavedDC = SaveDC (hps)))
      return;

    if (LeftWindow)
    {
       WindowOrgx = (LPLONG)&pccinfon->ptlNonIconOrg.x;
    }
    else
    {
       WindowOrgx = &pccinfon->RightWndxOrg;
    }

    /******************************************************************/
    /* We want to draw the horizontal separator such that it runs the */
    /* complete width of the column.  If the app. specified the width */
    /* of a column, we use it, otherwise we use the longest line in   */
    /* the column which is the width of the column when cxWidth is    */
    /* not explicitly specified.                                      */
    /******************************************************************/
    if (pFieldInfo->cxWidth)
    {
       Width = pFieldInfo->cxWidth;
    }
    else
    {
       Width = PFINFROMX(pFieldInfo)->usLongestLine;
    }

    /******************************************************************/
    /* Select the pen color of the horizontal separator.              */
    /******************************************************************/
    hpenCurrent = CreatePen (PS_SOLID, 1,
                     pccinfon->ulColorPPSupport[CMA_SEPARATORCOLOR]);
    if (hpenCurrent)
    {
      hpenOld = SelectObject (hps, hpenCurrent);

      /****************************************************************/
      /* Move to the first point.                                     */
      /****************************************************************/
      ptl.x = xColumnPos - *WindowOrgx;                                 /*DAB1*/
      ptl.y = rctlLeftColTitle.bottom - 1;
      MoveToEx (hps, ptl.x, ptl.y, NULL);                               /*DAB1*/

      /****************************************************************/
      /* Draw a line from the first point to the second point.        */
      /****************************************************************/
      ptl.x += Width + 1; /* add 1 to make point inclusive for LineTo */
      LineTo (hps, ptl.x, ptl.y);

      /****************************************************************/
      /* Select the old pen color and free resource.                  */
      /****************************************************************/
      DeleteObject (SelectObject (hps, hpenOld));
    }

    /******************************************************************/
    /* Restore the presentation space.                                */
    /******************************************************************/
    RestoreDC (hps, nSavedDC);
 }

 return;
}

/**********************************************************************/
/*                                                                    */
/*  Function Name:  xxx                                               */
/*                                                                    */
/*  Descriptive Name:  xxx                                            */
/*                                                                    */
/*                                                                    */
/*  Functional Description:                                           */
/*                                                                    */
/*  xxx                                                               */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*  Notes:                                                            */
/*                                                                    */
/*  xxx                                                               */
/*                                                                    */
/*                                                                    */
/*  Input:  hwndCnr - Handle of the Container Window.                 */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*  Output:  xxx                                                      */
/*                                                                    */
/*                                                                    */
/*  Exit-Normal:  xxx                                                 */
/*                                                                    */
/*  Exit-Error:   N/A                                                 */
/*                                                                    */
/*  Side Effects:  None                                               */
/*                                                                    */
/*  Author:  Peter Haggar                                             */
/**********************************************************************/
VOID FAR CnrDrawVertSep (hwndCnr, hps, LeftWindow, ColumnTitles)

HANDLE      hwndCnr;
HDC         hps;
BOOL        LeftWindow;
BOOL        ColumnTitles;

{
 LPCNRINFON   pccinfon;
 long         right;
 LPLONG       WindowOrgx;
 RECT         ViewPort;
 POINT        ptl;
 LPFIELDINFO  pFirst;
 LPFIELDINFO  pLast;
 long         CxBetweenCols;
 PLPFIELDINFO pStartFI;
 HPEN         hpenOld;
 HPEN         hpenCurrent;
 int          nSavedDC;

 pccinfon = (LPCNRINFON)GetWindowLong (hwndCnr, QWL_CONTAINER);

 /*********************************************************************/
 /* Get the distance between the columns.                             */
 /*********************************************************************/
 CxBetweenCols = 3 * (pccinfon->lAveCharWidth);

 /*********************************************************************/
 /* Save the current PS attributes.                                   */
 /*********************************************************************/
 if (!(nSavedDC = SaveDC (hps)))
   return;

 /*********************************************************************/
 /* Select the pen color of the horizontal separator.                 */
 /*********************************************************************/
 if (!(hpenCurrent = CreatePen (PS_SOLID, 1,
                       pccinfon->ulColorPPSupport[CMA_SEPARATORCOLOR])))
 {
   RestoreDC (hps, nSavedDC);
   return;
 }

 hpenOld = SelectObject (hps, hpenCurrent);

 /*********************************************************************/
 /* If we are drawing a vertical separator in the left window, set up */
 /* the appropriate information.                                      */
 /*********************************************************************/
 if (LeftWindow)
 {
    pStartFI = &pccinfon->pFirstVisibleFI;

    /******************************************************************/
    /* Get the first FieldInfo (column) in View in the left window.   */
    /******************************************************************/
    pFirst = pccinfon->pFIFirstColLeftInDV;

    if (!pFirst)
    {
       pFirst = pccinfon->pFirstVisibleFI;
    }

    /******************************************************************/
    /* Get the last FieldInfo structure in View for the left window.  */
    /******************************************************************/
    pLast = CnrQueryLastColumnInView (hwndCnr, pFirst, TRUE);

    WindowOrgx = (LPLONG)&pccinfon->ptlNonIconOrg.x;

    /******************************************************************/
    /* Query the ViewPort we are drawing vertical separators in.      */
    /******************************************************************/
    if (ColumnTitles)
    {
       PMGetClientRect( GetDlgItem( hwndCnr, CID_LEFTCOLTITLEWND ),
                        &ViewPort );
    }
    else
    {
       PMGetClientRect( GetDlgItem( hwndCnr, CID_LEFTDVWND ),
                        &ViewPort );
    }
 }
 else
 /*********************************************************************/
 /* Otherwise, we are dealing with either the right window of         */
 /* Details View or the right window of the Column Titles.            */
 /*********************************************************************/
 {
    pStartFI = &(NEXTVISIBLEFI(pccinfon->pFieldInfoLast));

    /******************************************************************/
    /* Get the first column in view in the right window.              */
    /******************************************************************/
    pFirst = pccinfon->pFIFirstColRightInDV;

    if (!pFirst)
    {
       pFirst = NEXTVISIBLEFI(pccinfon->pFieldInfoLast);
    }

    /******************************************************************/
    /* Get the last column in view in the right window.               */
    /******************************************************************/
    pLast = CnrQueryLastColumnInView (hwndCnr, pFirst, FALSE);

    WindowOrgx = &pccinfon->RightWndxOrg;

    /******************************************************************/
    /* Query the ViewPort of the window we are working with.          */
    /******************************************************************/
    if (ColumnTitles)
    {
       PMGetClientRect( GetDlgItem( hwndCnr, CID_RIGHTCOLTITLEWND ),
                        &ViewPort );
    }
    else
    {
       PMGetClientRect( GetDlgItem( hwndCnr, CID_RIGHTDVWND ),
                        &ViewPort);
    }
 }

 /*********************************************************************/
 /* Loop through the columns, starting at the first column in view,   */
 /* and ending with the last column in view.  For each column we      */
 /* check to see if the app. has specified a vertical separator to be */
 /* drawn.  If so, we draw it.                                        */
 /*********************************************************************/
 while ((pFirst) && (pFirst != NEXTVISIBLEFI(pLast)))
 {
    if (pFirst->flData & CFA_SEPARATOR)
    {
       right = CnrQueryColumnPosInDV( hwndCnr, *pStartFI, pFirst,
                                      FALSE, FALSE );

       /***************************************************************/
       /* Adjust right to take into account the distance between the */
       /* columns.                                                    */
       /***************************************************************/
       right += (CxBetweenCols / 2);

       /***************************************************************/
       /* Set the point to the top of the ViewPort at the correct     */
       /* position.                                                   */
       /***************************************************************/
       ptl.x = right - *WindowOrgx;                                     /*DAB1*/
       ptl.y = ViewPort.top;
       MoveToEx (hps, ptl.x, ptl.y, NULL);                              /*DAB1*/

       /***************************************************************/
       /* We want to draw the column separator from the top of the    */
       /* ViewPort to the bottom, so set the y value to 0 and draw it.*/
       /***************************************************************/
       ptl.y = ViewPort.bottom;
       LineTo (hps, ptl.x, ptl.y);    /* for LineTo                   */
    }

    /******************************************************************/
    /* Go to the next column.                                         */
    /******************************************************************/
    pFirst = NEXTVISIBLEFI(pFirst);
 }

 /*********************************************************************/
 /* Select the old pen color and free resource.                       */
 /*********************************************************************/
 DeleteObject (SelectObject (hps, hpenOld));

 /*********************************************************************/
 /* Restore the presentation space.                                   */
 /*********************************************************************/
 RestoreDC (hps, nSavedDC);

 return;
}

/**********************************************************************/
/*                                                                    */
/*  Function Name:  xxx                                               */
/*                                                                    */
/*  Descriptive Name:  xxx                                            */
/*                                                                    */
/*                                                                    */
/*  Functional Description:                                           */
/*                                                                    */
/*  xxx                                                               */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*  Notes:                                                            */
/*                                                                    */
/*  xxx                                                               */
/*                                                                    */
/*                                                                    */
/*  Input:  hwndCnr - Handle of the Container Window.                 */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*  Output:  xxx                                                      */
/*                                                                    */
/*                                                                    */
/*  Exit-Normal:  xxx                                                 */
/*                                                                    */
/*  Exit-Error:   N/A                                                 */
/*                                                                    */
/*  Side Effects:  None                                               */
/*                                                                    */
/*  Author:  Peter Haggar                                             */
/**********************************************************************/
LPVOID FAR CnrGetColumnData (hwndCnr, pRecord, pFieldInfo)

HANDLE        hwndCnr;
LPRECORDCORE  pRecord;
LPFIELDINFO   pFieldInfo;

{
 LPCNRINFON   pccinfon;
 LPCNRINFO    pccinfo;
 LPVOID       pBuffer;
// LPVOID       pSatPtr;
 LPCDATE      pDate;
 LPCTIME      pTime;
 DWORD        dwNumber;

 pccinfon = (LPCNRINFON)GetWindowLong (hwndCnr, QWL_CONTAINER);
 pccinfo  = PCCINFOXFROMN(pccinfon);
// pSatPtr  = (LPVOID)GetWindowLong (hwndCnr, QWL_STORAGEPTR);

 if ((!pRecord) || (!pFieldInfo))
 {
    return (NULL);
 }

 if (pFieldInfo->flData & CFA_BITMAPORICON)
 {
   if (pccinfo->flWindowAttr & CA_DRAWBITMAP)
   {
     return ((LPVOID)*(PHBITMAP)((LPBYTE)pRecord + pFieldInfo->offStruct));
   }
   else
   {
     return ((LPVOID)*(PHICON)((LPBYTE)pRecord + pFieldInfo->offStruct));
   }
 }
 else if (pFieldInfo->flData & CFA_STRING)
 {
    return (LPSTRATOFFSET (pRecord, pFieldInfo->offStruct));
 }
 else if (pFieldInfo->flData & CFA_DATE)
 {
    pDate = (LPCDATE)((LPBYTE)pRecord + pFieldInfo->offStruct);

//  if (!(pBuffer = StmAllocateStorage (pSatPtr, DATESIZE)))
    if (!(pBuffer = (LPVOID)GlobalAlloc( GPTR, DATESIZE)))              /*DAB1*/
    {
       SETERROR(PMERR_INSUFFICIENT_MEMORY);
       return ((LPVOID)NULL);
    }

    CnrCreateNLSDateString (hwndCnr, pDate, pBuffer);

    return (pBuffer);
 }
 else if (pFieldInfo->flData & CFA_TIME)
 {
    pTime = (LPCTIME)((LPBYTE)pRecord + pFieldInfo->offStruct);

//  if (!(pBuffer = StmAllocateStorage (pSatPtr, TIMESIZE)))
    if (!(pBuffer = (LPVOID)GlobalAlloc( GPTR, TIMESIZE)))              /*DAB1*/
    {
       SETERROR(PMERR_INSUFFICIENT_MEMORY);
       return ((LPVOID)NULL);
    }

    CnrCreateNLSTimeString (hwndCnr, pTime, pBuffer);

    return (pBuffer);
 }
 else if (pFieldInfo->flData & CFA_ULONG)
 {
    dwNumber = (*(LPDWORD)((LPBYTE)pRecord + pFieldInfo->offStruct));
//  if (!(pBuffer = StmAllocateStorage (pSatPtr, NUMSIZE)))
    if (!(pBuffer = (LPVOID)GlobalAlloc( GPTR, NUMSIZE)))               /*DAB1*/
    {
       SETERROR(PMERR_INSUFFICIENT_MEMORY);
       return ((LPVOID)NULL);
    }

    if (CnrCreateNLSNumberString (hwndCnr, dwNumber, pBuffer))
    {
      return (pBuffer);
    }
 }

 return (NULL);
}

/**********************************************************************/
/*                                                                    */
/*  Function Name:  xxx                                               */
/*                                                                    */
/*  Descriptive Name:  xxx                                            */
/*                                                                    */
/*                                                                    */
/*  Functional Description:                                           */
/*                                                                    */
/*  xxx                                                               */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*  Notes:                                                            */
/*                                                                    */
/*  xxx                                                               */
/*                                                                    */
/*                                                                    */
/*  Input:  hwndCnr - Handle of the Container Window.                 */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*  Output:  xxx                                                      */
/*                                                                    */
/*                                                                    */
/*  Exit-Normal:  xxx                                                 */
/*                                                                    */
/*  Exit-Error:   N/A                                                 */
/*                                                                    */
/*  Side Effects:  None                                               */
/*                                                                    */
/*  Author:  Peter Haggar                                             */
/**********************************************************************/
VOID FAR CnrHScrollDetailsView( HWND hwndCnr, HWND hwndHscroll,         /*DAB1*/
                                int  nThumbPos, UINT wNotifyCode )      /*DAB1*/
{
 LPCNRINFON    pccinfon;
 LPCNRINFO     pccinfo;
 int           HScrollInc;
 int           ScrollUnit;
 POINT         IconSize;
 RECT          ViewPort;
 RECT          TitleWndRect;
 WORD          TitleWindow;
 WORD          Window;
 WORD          ScrollBar;
 BOOL          WindowLeft;
 LPINT         HScrollPos;
 LPINT         HScrollMax;
 LPLONG        WindowOrgx;
 WORD          WndScrolled;
 long          lHscrollInc;
 NOTIFYSCROLL  NotifyScroll;
 UINT          wControlID;                                              /*DAB1*/
 int           sScrollPos;

 pccinfon = (LPCNRINFON)GetWindowLong (hwndCnr, QWL_CONTAINER);
 pccinfo  = PCCINFOXFROMN(pccinfon);

 /********************************************************************/
 /* Get handle of the scroll bar                                     */
 /********************************************************************/
 wControlID = getWindowId(hwndHscroll);                                /*DAB1*/
 sScrollPos = GetScrollPos (hwndHscroll, SB_CTL);

 if (wControlID == CID_HSCROLL)
 {
    TitleWindow  = CID_LEFTCOLTITLEWND;
    Window       = CID_LEFTDVWND;
    ScrollBar    = CID_HSCROLL;
    WindowLeft   = TRUE;
    WndScrolled  = CMA_LEFT;
    HScrollPos   = &pccinfon->sHscrollPos;
    HScrollMax   = &pccinfon->sHscrollMax;
    WindowOrgx   = (LPLONG)&pccinfon->ptlNonIconOrg.x;
 }
 else
 {
    if (wControlID == CID_RIGHTHSCROLL)
    {
       TitleWindow  = CID_RIGHTCOLTITLEWND;
       Window       = CID_RIGHTDVWND;
       ScrollBar    = CID_RIGHTHSCROLL;
       WindowLeft   = FALSE;
       WndScrolled  = CMA_RIGHT;
       HScrollPos   = &pccinfon->sHscrollPosRight;
       HScrollMax   = &pccinfon->sHscrollMaxRight;
       WindowOrgx   = &pccinfon->RightWndxOrg;
    }
    else
       return;
 }

 /*********************************************************************/
 /* Get the rectangle of the Title window we are scrolling.  Column   */
 /* Titles may not exist, and in this case this function will return  */
 /* all 0's.                                                          */
 /*********************************************************************/
 CnrQueryColumnTitleWndRect (hwndCnr, WindowLeft, &TitleWndRect);

 /*********************************************************************/
 /* Get the rectangle of the Details View window we are scrolling.    */
 /*********************************************************************/
 PMGetClientRect (GetDlgItem (hwndCnr, Window), &ViewPort);

 /*********************************************************************/
 /* Get the size of an Icon, and set 1 scrolling unit to be the       */
 /* width of an icon.                                                 */
 /*********************************************************************/
 CnrCalcIconSize (hwndCnr, &IconSize);

 ScrollUnit = IconSize.x / pccinfon->sHscrollFactor;

  switch (wNotifyCode)
  {
     case SB_LINEUP:
        HScrollInc = -(ScrollUnit);
     break;

     case SB_LINEDOWN:
        HScrollInc = ScrollUnit;
     break;

     case SB_PAGEUP:
        HScrollInc = -(ViewPort.right / pccinfon->sHscrollFactor);
     break;

     case SB_PAGEDOWN:
        HScrollInc = (ViewPort.right / pccinfon->sHscrollFactor);
     break;

     /*****************************************************************/
     /* If they are dragging the slider, we only scroll the contents  */
     /* of the window when they move it by an amount greater than or  */
     /* equal to a ScrollUnit.  Otherwise, we won't scroll.  This is  */
     /* so the window will not scroll pixel by pixel, but ScrollUnit  */
     /* by ScrollUnit.                                                */
     /*****************************************************************/
     case SB_THUMBTRACK:
       return;
     break;

     case SB_THUMBPOSITION:
        HScrollInc = nThumbPos - *HScrollPos;
     break;

     default:
        HScrollInc = 0;
     break;
  }

  HScrollInc = max(-(*HScrollPos),
                   min(HScrollInc,
                       *HScrollMax - *HScrollPos));

  if (HScrollInc != 0)
  {
     /*****************************************************************/
     /* If some scrolling occured, we set the new values for the      */
     /* scroll position and the Origin.                               */
     /*****************************************************************/
     *HScrollPos += HScrollInc;

     lHscrollInc = (long)HScrollInc * (long)pccinfon->sHscrollFactor;

     if ((HScrollInc > 0) &&
         ((pccinfon->ulFlagSet2 & FL2_HDYNAMICSCROLL) ||
          (wNotifyCode == SB_LINEDOWN)))
     {
        pccinfon->ulFlagSet2 |= FL2_SCROLLRIGHT;
     }
     else
     {
        pccinfon->ulFlagSet2 &= ~FL2_SCROLLRIGHT;
     }

     /*****************************************************************/
     /* Set the last column in view for the window that was scrolled. */
     /* This column can be partially or completely in view.           */
     /*****************************************************************/
     if (WindowLeft)
     {
       pccinfon->pFILastColLeftInDV = CnrQueryLastColumnInView (hwndCnr,
                                      pccinfon->pFirstVisibleFI, TRUE );
     }
     else
     {
       pccinfon->pFILastColRightInDV = CnrQueryLastColumnInView(hwndCnr,
                        NEXTVISIBLEFI(pccinfon->pFieldInfoLast), FALSE);
     }

     /*****************************************************************/
     /* Update the new window origin for the window that scrolled.    */
     /*****************************************************************/
     *WindowOrgx += lHscrollInc;

     /*****************************************************************/
     /* Set the new First Column in View for the window.              */
     /*****************************************************************/
     CnrSetFirstColInView (hwndCnr, WindowLeft);

     /*****************************************************************/
     /* Now we are set to scroll the window.  Call ScrollWindow to    */
     /* scroll the Title window first if Titles exist.                */
     /*****************************************************************/
     if (pccinfo->flWindowAttr & CA_DETAILSVIEWTITLES)
     {
        if (TitleWndRect.right < abs(lHscrollInc))                      /*DAB1*/
        {
           pccinfon->ulFlagSet2 &= ~FL2_SCROLLRIGHT;
           PMInvalidateRect( GetDlgItem( hwndCnr, TitleWindow ),
                             &TitleWndRect, FALSE );
        }
        else
        {
           ScrollWindow( GetDlgItem( hwndCnr, TitleWindow ),
                         (int)-lHscrollInc, 0,
                         &TitleWndRect, &TitleWndRect );
        }
     }

     /*****************************************************************/
     /* Now scroll the Left or Right Viewport window.                 */
     /*****************************************************************/
     if (ViewPort.right < abs(lHscrollInc))                             /*DAB1*/
     {
        pccinfon->ulFlagSet2 &= ~FL2_SCROLLRIGHT;
        PMInvalidateRect( GetDlgItem( hwndCnr, Window ),
                          &ViewPort, FALSE );
     }
     else
     {
        ScrollWindow( GetDlgItem(hwndCnr, Window),
                      (int)-lHscrollInc, 0, &ViewPort, &ViewPort );
     }

     /*****************************************************************/
     /* Set the new slider position.                                  */
     /*****************************************************************/
     SetScrollPos( GetDlgItem( hwndCnr, ScrollBar ), SB_CTL,
                   *HScrollPos, TRUE );

     if (pccinfo->flWindowAttr & CA_DETAILSVIEWTITLES)
     {
        UpdateWindow (GetDlgItem (hwndCnr, TitleWindow));
     }

     UpdateWindow (GetDlgItem (hwndCnr, Window));

     /*****************************************************************/
     /* Notify the application of the window that has scrolled.       */
     /*****************************************************************/
     NotifyScroll.hwndCnr    = hwndCnr;
     NotifyScroll.lScrollInc = lHscrollInc;
     NotifyScroll.fScroll    = (WORD)(CMA_HORIZONTAL | WndScrolled);
     NotifyOwner (hwndCnr, CN_SCROLL, (LPVOID)&NotifyScroll);
  }

 return;
}

/**********************************************************************/
/*                                                                    */
/*  Function Name:  xxx                                               */
/*                                                                    */
/*  Descriptive Name:  xxx                                            */
/*                                                                    */
/*                                                                    */
/*  Functional Description:                                           */
/*                                                                    */
/*  xxx                                                               */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*  Notes:                                                            */
/*                                                                    */
/*  xxx                                                               */
/*                                                                    */
/*                                                                    */
/*  Input:  hwndCnr - Handle of the Container Window.                 */
/*                                                                    */
/*  Output:  xxx                                                      */
/*                                                                    */
/*                                                                    */
/*  Exit-Normal:  xxx                                                 */
/*                                                                    */
/*  Exit-Error:   N/A                                                 */
/*                                                                    */
/*  Side Effects:  None                                               */
/*                                                                    */
/*  Author:  Peter Haggar                                             */
/**********************************************************************/
VOID FAR CnrVScrollDetailsView( HWND hwndCnr, HWND hwndHscroll,         /*DAB1*/
                                int nThumbPos, UINT wNotifyCode)        /*DAB1*/
{
 LPCNRINFON    pccinfon;
 LPCNRINFO     pccinfo;
 int           VScrollInc;
 int           ScrollUnit;
 POINT         IconSize;
 RECT          ViewPortLeft;
 RECT          ViewPortRight;
 long          lVscrollInc;
 NOTIFYSCROLL  NotifyScroll;
 BOOL          scrollDirection = TRUE;
 int           sScrollPos;

 pccinfon = (LPCNRINFON)GetWindowLong (hwndCnr, QWL_CONTAINER);
 pccinfo  = PCCINFOXFROMN(pccinfon);

 /********************************************************************/
 /* Get handle of the scroll bar                                     */
 /********************************************************************/
 sScrollPos = GetScrollPos (hwndHscroll, SB_CTL);

 /*********************************************************************/
 /* Get the window Rectangles for the left and right windows in       */
 /* Details View.                                                     */
 /*********************************************************************/
 PMGetClientRect (GetDlgItem (hwndCnr, CID_LEFTDVWND),
                     &ViewPortLeft);

 PMGetClientRect (GetDlgItem (hwndCnr, CID_RIGHTDVWND),
                     &ViewPortRight);

 /*********************************************************************/
 /* Get the size of an Icon, and set 1 scrolling unit to be the       */
 /* height of an icon.                                                */
 /*********************************************************************/
 CnrCalcIconSize (hwndCnr, &IconSize);

 ScrollUnit = IconSize.y / pccinfon->sVscrollFactor;

  switch (wNotifyCode)
  {
     /*****************************************************************/
     /* Move down 1 scrolling unit.                                   */
     /*****************************************************************/
     case SB_LINEUP:
        VScrollInc = -(ScrollUnit);
     break;

     /*****************************************************************/
     /* Move up 1 scrolling unit.                                     */
     /*****************************************************************/
     case SB_LINEDOWN:
        VScrollInc = ScrollUnit;
     break;

     /*****************************************************************/
     /* Move down the distance of the viewport minus the scrolling    */
     /* unit.  This will put the stuff currently at the top of the    */
     /* viewport at the bottom after we scroll it.  ViewPortLeft or   */
     /* ViewPortRight could be used.  Their top value is the same.   */
     /*****************************************************************/
     case SB_PAGEUP:
        VScrollInc = -(ViewPortLeft.bottom / pccinfon->sVscrollFactor);
     break;

     /*****************************************************************/
     /* Move up the distance of the viewport minus the scrolling      */
     /* unit.  This will put the stuff currently at the bottom of the */
     /* viewport at the top after we scroll it.                       */
     /*****************************************************************/
     case SB_PAGEDOWN:
        VScrollInc = (ViewPortLeft.bottom / pccinfon->sVscrollFactor);
     break;

     /*****************************************************************/
     /* If they are dragging the slider, we only scroll the contents  */
     /* of the window when they move it by an amount greater than or  */
     /* equal to a ScrollUnit.  Otherwise, we won't scroll.  This is  */
     /* so the window will not scroll pixel by pixel, but ScrollUnit  */
     /* by ScrollUnit.                                                */
     /*****************************************************************/
     case SB_THUMBTRACK:
       return;
     break;

     case SB_THUMBPOSITION:
        VScrollInc = nThumbPos - pccinfon->sVscrollPos;
     break;

     default:
       VScrollInc = 0;
     break;
  }

  VScrollInc = max (-(pccinfon->sVscrollPos),
                    min(VScrollInc,
                    pccinfon->sVscrollMax - pccinfon->sVscrollPos));

  if (VScrollInc != 0)
  {
     /*****************************************************************/
     /* If some scrolling occured, we set the new values for the      */
     /* scroll position and the Origin.                               */
     /*****************************************************************/
     pccinfon->sVscrollPos += VScrollInc;

     lVscrollInc = (long)VScrollInc * (long)(pccinfon->sVscrollFactor);

     /*****************************************************************/
     /* Update the origin for the amount of scrolling that occurred.  */
     /*****************************************************************/
     pccinfon->ptlNonIconOrg.y += lVscrollInc;

     if (VScrollInc > 0)
     {
        /**************************************************************/
        /* Set the new item that is First in View.  We search from    */
        /* the current record (row) downward to find the current item */
        /* that is first in view.  We search downward because we know */
        /* the window moved down.                                     */
        /**************************************************************/
        CnrSetFirstRowInView( hwndCnr, pccinfon->preccFirstRowInDV,
                              TRUE );
     }
     else
     {
        /**************************************************************/
        /* Set the new item that is First in View.                    */
        /**************************************************************/
        CnrSetFirstRowInView( hwndCnr, pccinfon->preccFirstRowInDV,
                              FALSE );

        scrollDirection = FALSE;
     }

     if (pccinfo->cDelta)
     {
       CnrProcessDelta (hwndCnr, scrollDirection);
     }
        /**************************************************************/
        /* Now we are set to scroll the windows.  Since we are        */
        /* scrolling vertically, we have to scroll both Details View  */
        /* windows together, if they both are being used.  If Details */
        /* View is unsplit, then this means that only the left window */
        /* is being used, and it is the only one to be scrolled.      */
        /**************************************************************/
        if ((ViewPortLeft.bottom - ViewPortLeft.top) <
                                            abs(lVscrollInc))           /*DAB1*/
        {
           PMInvalidateRect (GetDlgItem (hwndCnr, CID_LEFTDVWND),
                              &ViewPortLeft,
                              FALSE);
        }
        else
        {
           ScrollWindow( GetDlgItem(hwndCnr, CID_LEFTDVWND), 0,
                       (int)-lVscrollInc, &ViewPortLeft, &ViewPortLeft);
        }

        if (!(pccinfon->ulFlagSet & FL_UNSPLIT))
        {
           /***********************************************************/
           /* If Details View is split into 2 windows, scroll the     */
           /* right window too.                                       */
           /***********************************************************/
           if ((ViewPortRight.bottom - ViewPortRight.top) <
                                            abs(lVscrollInc))           /*DAB1*/
           {
              PMInvalidateRect( GetDlgItem( hwndCnr, CID_RIGHTDVWND ),
                                &ViewPortRight, FALSE );
           }
           else
           {
              ScrollWindow( GetDlgItem(hwndCnr, CID_RIGHTDVWND), 0,
                            (int)-lVscrollInc, &ViewPortRight,
                            &ViewPortRight);
           }
        }

        /**************************************************************/
        /* Set the new slider position.                               */
        /**************************************************************/
        SetScrollPos( GetDlgItem (hwndCnr, CID_VSCROLL),
                      SB_CTL, pccinfon->sVscrollPos, TRUE );

        UpdateWindow (GetDlgItem (hwndCnr, CID_LEFTDVWND));

        NotifyScroll.hwndCnr = hwndCnr;
        NotifyScroll.lScrollInc = lVscrollInc;
        NotifyScroll.fScroll = CMA_VERTICAL | CMA_LEFT;

        /**************************************************************/
        /* If there is a right window, then it was scrolled too.      */
        /**************************************************************/
        if (!(pccinfon->ulFlagSet & FL_UNSPLIT))
        {
           UpdateWindow (GetDlgItem (hwndCnr, CID_RIGHTDVWND));
           NotifyScroll.fScroll |= CMA_RIGHT;
        }

        /**************************************************************/
        /* Notify the application that some scrolling took place, and */
        /* how much.                                                  */
        /**************************************************************/
        NotifyOwner (hwndCnr, CN_SCROLL, (LPVOID)&NotifyScroll);
  }

 return;
}

/**********************************************************************/
/*                                                                    */
/*  Function Name:  xxx                                               */
/*                                                                    */
/*  Descriptive Name:  xxx                                            */
/*                                                                    */
/*                                                                    */
/*  Functional Description:                                           */
/*                                                                    */
/*  xxx                                                               */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*  Notes:                                                            */
/*                                                                    */
/*  xxx                                                               */
/*                                                                    */
/*                                                                    */
/*  Input:  hwndCnr - Handle of the Container Window.                 */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*  Output:  xxx                                                      */
/*                                                                    */
/*                                                                    */
/*  Exit-Normal:  xxx                                                 */
/*                                                                    */
/*  Exit-Error:   N/A                                                 */
/*                                                                    */
/*  Side Effects:  None                                               */
/*                                                                    */
/*  Author:  Peter Haggar                                             */
/**********************************************************************/
VOID FAR CnrSetDetailsViewScroll( HANDLE hwndCnr )
{
 LPRECORDCOREN preccFirstInView;
 LPRECORDCOREN pRecord;
 LPFIELDINFO   pFirstColInView;
 LPFIELDINFO   pFieldInfo;
 LPCNRINFON    pccinfon;
 LPCNRINFO     pccinfo;
 int           sRBPos;
 int           sLTPos;
 int           top;
 int           bottom;
 int           left;
 int           right;
 int           sLTPosTemp;
 int           sLTPosMove;
 RECT          CnrRect;
 RECT          ViewPortLeft;
 RECT          ViewPortRight;
 int           CyBetweenRows;
 int           ScrollRange = 0;

 pccinfon = (LPCNRINFON)GetWindowLong (hwndCnr, QWL_CONTAINER);
 pccinfo  = PCCINFOXFROMN(pccinfon);

 /*********************************************************************/
 /* Get the distance between the rows.                                */
 /*********************************************************************/
 if (pccinfo->cyLineSpacing >= 0)
 {
    CyBetweenRows = pccinfo->cyLineSpacing;
 }
 else
 {
    CyBetweenRows = MINCY_BETWEENITEMS;
 }

 if (CyBetweenRows & NUM_ODD)
 {
    CyBetweenRows++;
 }

 /*********************************************************************/
 /* Get the Rectangle for the Left window and Right window.           */
 /*********************************************************************/
 PMGetClientRect (GetDlgItem (hwndCnr, CID_LEFTDVWND),
                     &ViewPortLeft);

 PMGetClientRect (GetDlgItem (hwndCnr, CID_RIGHTDVWND),
                     &ViewPortRight);

 /*********************************************************************/
 /* Only set up Vertical scrolling if there are FieldInfos that are   */
 /* inserted.                                                         */
 /*********************************************************************/
 if (pccinfon->pFirstVisibleFI)
 {
    /******************************************************************/
    /* First, set up the vertical scrolling.  Calculate sRBPos which  */
    /* represents how far the viewport has been scrolled down.  This  */
    /* is the distance between the top of the first record, to the    */
    /* top of the first record in view.                               */
    /******************************************************************/
    preccFirstInView = pccinfon->preccFirstRowInDV;

    if (pccinfon->ulFlagSet & FL_NEWVIEWSCROLLSET)
    {
       sLTPos = (pccinfon->sVscrollPos * pccinfon->sVscrollFactor);
    }
    else
    {
       sLTPos = 0;

       if (!preccFirstInView)
       {
          preccFirstInView = pccinfon->preccItem;
       }
       else
       {
          if ((pccinfon->preccItem) &&
              (pccinfon->preccItem != preccFirstInView))
          {
             top = CnrQueryRowPosInDV (pccinfon->preccItem, PT_TOP);
             bottom = CnrQueryRowPosInDV (preccFirstInView, PT_TOP);
             sLTPos = bottom - top;
          }
       }

       pccinfon->ptlNonIconOrg.y = sLTPos;
    }

    /******************************************************************/
    /* Now calcuate sRBPos which represents how far the bottom record */
    /* in the viewport is from the bottom record in the list of       */
    /* records.  This amounts to the amount that the window can be    */
    /* scrolled down.  To do this, find the last non filtered record  */
    /* and have pRecord point to it.                                  */
    /******************************************************************/
    if ((pccinfon->preccItem) && (pccinfon->preccLastItem))
    {
       pRecord = pccinfon->preccLastItem;

       while ((pRecord->preccPrevItem) && !(ISRECORDVISIBLE(pRecord)))
       {
         pRecord = pRecord->preccPrevItem;
       }

       bottom = CnrQueryRowPosInDV (pRecord, PT_BOTTOM);
       bottom += (CyBetweenRows / 2);

       sRBPos = bottom - pccinfon->ptlNonIconOrg.y -
                ViewPortLeft.bottom;
    }
    else
    {
       sRBPos = 0;
    }

    /******************************************************************/
    /* Calculate total scroll range in pixels. (vertical)             */
    /******************************************************************/
    sLTPosTemp = max (0, min (sLTPos, sLTPos + sRBPos));
    sLTPosMove = sLTPosTemp - sLTPos;
    pccinfon->ptlNonIconOrg.y += sLTPosMove;
    sLTPos = sLTPosTemp;
    sRBPos = max (0, sRBPos);

    if (sLTPosMove < 0)
    {
       CnrSetFirstRowInView (hwndCnr,
                             pccinfon->preccFirstRowInDV,
                             FALSE);
    }

    /******************************************************************/
    /* Now we know how much distance there exists between the top of  */
    /* the viewport and the first item in the coordinate space        */
    /* (sRBPos), and how much distance there exists between the       */
    /* bottom of the viewport and the last item in the coordinate     */
    /* space (sLTPos).  Now we can compute the total scroll range.    */
    /******************************************************************/
    ScrollRange = sLTPos + sRBPos;

    /******************************************************************/
    /* Calculate the minimum unit of scrolling.                       */
    /******************************************************************/
    pccinfon->sVscrollFactor = CalcScrollFactor (hwndCnr,
                                                 ScrollRange,
                                                 TRUE);

    if (sLTPos % pccinfon->sVscrollFactor)
    {
       sLTPos = (sLTPos / pccinfon->sVscrollFactor) + 1;
    }
    else
    {
       sLTPos /= pccinfon->sVscrollFactor;
    }

    if (sRBPos % pccinfon->sVscrollFactor)
    {
       sRBPos = (sRBPos / pccinfon->sVscrollFactor) + 1;
    }
    else
    {
       sRBPos /= pccinfon->sVscrollFactor;
    }

    /******************************************************************/
    /* Calculate the total scroll range include the scroll factor.    */
    /******************************************************************/
    ScrollRange = sLTPos + sRBPos;

    pccinfon->sVscrollPos = sLTPos;
    pccinfon->sVscrollMax = ScrollRange;

    if (!(pccinfon->ulFlagSet & FL_UNSPLIT))
    {
       PMInvalidateRect (GetDlgItem (hwndCnr, CID_VSCROLL),
                          NULL,
                          FALSE);
    }
 }

 /*********************************************************************/
 /* If the ScrollRange is not 0, we set the scroll bar.               */
 /*********************************************************************/
 if (ScrollRange)
 {
    /******************************************************************/
    /* Enable the scroll bar if some outside  viewport                */
    /******************************************************************/
    EnableWindow (GetDlgItem (hwndCnr, CID_VSCROLL), TRUE);

    SetScrollRange (GetDlgItem (hwndCnr, CID_VSCROLL),
                    SB_CTL, 0, ScrollRange, FALSE );
    SetScrollPos  (GetDlgItem (hwndCnr, CID_VSCROLL),
                   SB_CTL, sLTPos, TRUE);
 }
 else
 {
    /*****************************************************************/
    /* Disable the scroll bar if nothing outside  viewport           */
    /*****************************************************************/
    EnableWindow (GetDlgItem (hwndCnr, CID_VSCROLL), FALSE);
 }

 /*********************************************************************/
 /* Now set up the horizontal scrolling.  We will do the left window  */
 /* first, then the right window.                                     */
 /*********************************************************************/
 pFirstColInView = pccinfon->pFIFirstColLeftInDV;

 if (pccinfon->ulFlagSet & FL_NEWVIEWSCROLLSET)
 {
    sLTPos = (pccinfon->sHscrollPos * pccinfon->sHscrollFactor);
 }
 else
 {
    sLTPos = 0;

    if (!pFirstColInView)
    {
       pFirstColInView = pccinfon->pFirstVisibleFI;
    }
    else
    {
       if ((pccinfon->pFirstVisibleFI) &&
           (pccinfon->pFirstVisibleFI != pFirstColInView))
       {
          left = CnrQueryColumnPosInDV (hwndCnr,
                                         pccinfon->pFirstVisibleFI,
                                         pccinfon->pFirstVisibleFI,
                                         TRUE, FALSE);

          right = CnrQueryColumnPosInDV (hwndCnr,
                                          pccinfon->pFirstVisibleFI,
                                          pFirstColInView,
                                          TRUE, FALSE);

          sLTPos = right - left;
       }
    }

    pccinfon->ptlNonIconOrg.x = sLTPos;
 }

 /*********************************************************************/
 /* Now calculate sRBPos which represents how far the last column in  */
 /* the left window is from the last column possible.  This will      */
 /* determine how far right the window can be scrolled.               */
 /*********************************************************************/
 pFieldInfo = pccinfon->pFirstVisibleFI;

 if (pFieldInfo)
 {
    /******************************************************************/
    /* If the application specified for Details View to be split into */
    /* 2 windows, we need to to calculate the rightmost point of the  */
    /* rightmost column in the left split window.                     */
    /******************************************************************/
    if ((!(pccinfon->ulFlagSet & FL_UNSPLIT)) &&
        (CnrVerifyFieldInfoPtrs (hwndCnr, pccinfon->pFieldInfoLast, 1)))
    {
       right = CnrQueryColumnPosInDV (hwndCnr,
                                       pccinfon->pFirstVisibleFI,
                                       pccinfon->pFieldInfoLast,
                                       FALSE, FALSE);

       right += pccinfon->lAveCharWidth;
    }
    else
    /******************************************************************/
    /* The application specfied Details View to be unsplit which means*/
    /* all of the data for Details View is in the left window.  This  */
    /* indicates that we want the Rightmost point of the last column  */
    /* in Details View.                                               */
    /******************************************************************/
    {
       /***************************************************************/
       /* By specifying TRUE as the last parameter to this function,  */
       /* it will return the rightmost point of the last column in    */
       /* list of FieldInfo structures.                               */
       /***************************************************************/
       right = CnrQueryColumnPosInDV (hwndCnr,
                                       pccinfon->pFirstVisibleFI,
                                       NULL, FALSE, TRUE);

       right += pccinfon->lAveCharWidth;
    }

    /*********************************************************************/
    /* There seems to be a bug in GetClientRect sometimes that returns   */
    /* not the viewport width for the left window (i.e., what is showing)*/
    /* but the entire left window width, showing or not.  Therefore we   */
    /* must check to see that the viewport size given is not wider than  */
    /* the visible portion of the window.                                */
    /*********************************************************************/
    PMGetClientRect (hwndCnr,&CnrRect);

    sRBPos = right - (pccinfon->ptlNonIconOrg.x +
       min(ViewPortLeft.right, (CnrRect.right - GetSystemMetrics(SM_CXVSCROLL))));
 }
 else
 {
    sRBPos = 0;
 }

 /*********************************************************************/
 /* Calculate total scroll range in pixels. (horizontal)              */
 /*********************************************************************/
 sLTPosTemp = max (0, min (sLTPos, sLTPos + sRBPos));
 sLTPosMove = sLTPosTemp - sLTPos;
 pccinfon->ptlNonIconOrg.x += sLTPosMove;
 sLTPos = sLTPosTemp;
 sRBPos = max(0, sRBPos);

 if (sLTPosMove < 0)
 {
    CnrSetFirstColInView (hwndCnr, TRUE);

    if (pccinfo->flWindowAttr & CA_DETAILSVIEWTITLES)
    {
       PMInvalidateRect( GetDlgItem( hwndCnr, CID_LEFTCOLTITLEWND ),
                         NULL, FALSE );
    }

    PMInvalidateRect( GetDlgItem( hwndCnr, CID_LEFTDVWND ),
                      NULL, FALSE );
 }

 ScrollRange = sRBPos + sLTPos;

 /*********************************************************************/
 /* Calculate the minimum unit of scrolling.                          */
 /*********************************************************************/
 pccinfon->sHscrollFactor = CalcScrollFactor( hwndCnr, ScrollRange,
                                              FALSE );

 if (sRBPos % pccinfon->sHscrollFactor)
 {
    sRBPos = (sRBPos / pccinfon->sHscrollFactor) + 1;
 }
 else
 {
    sRBPos /= pccinfon->sHscrollFactor;
 }

 if (sLTPos % pccinfon->sHscrollFactor)
 {
    sLTPos = (sLTPos / pccinfon->sHscrollFactor) + 1;
 }
 else
 {
    sLTPos /= pccinfon->sHscrollFactor;
 }

 /*********************************************************************/
 /* Calculate the total scroll range include the scroll factor.       */
 /*********************************************************************/
 ScrollRange = sRBPos + sLTPos;

 pccinfon->sHscrollPos = sLTPos;
 pccinfon->sHscrollMax = ScrollRange;

 if (!(pccinfon->ulFlagSet & FL_UNSPLIT))
 {
    PMInvalidateRect (GetDlgItem (hwndCnr, CID_HSCROLL),
                       NULL, FALSE);
 }

 if (ScrollRange)
 {
    /******************************************************************/
    /* Enable the scroll bar if some outside  viewport                */
    /******************************************************************/
    EnableWindow (GetDlgItem (hwndCnr, CID_HSCROLL), TRUE);

    SetScrollRange (GetDlgItem (hwndCnr, CID_HSCROLL),
                    SB_CTL, 0, ScrollRange, FALSE);
    SetScrollPos  (GetDlgItem (hwndCnr, CID_HSCROLL),
                   SB_CTL, sLTPos, TRUE);
 }
 else
 {
    /*****************************************************************/
    /* Disable the scroll bar if nothing outside  viewport           */
    /*****************************************************************/
    EnableWindow (GetDlgItem (hwndCnr, CID_HSCROLL), FALSE);
 }

 /*********************************************************************/
 /* Now we will set up the horizontal scroll bar for the right window */
 /* in Details View.  First check to see if a right window exists.    */
 /* If it does not, we do nothing.                                    */
 /*********************************************************************/
 ScrollRange = 0;

 if ((!(pccinfon->ulFlagSet & FL_UNSPLIT)) &&
     (CnrVerifyFieldInfoPtrs (hwndCnr, pccinfon->pFieldInfoLast, 1)))
 {
    if (NEXTVISIBLEFI(pccinfon->pFieldInfoLast))
    {
       pFirstColInView = pccinfon->pFIFirstColRightInDV;

       if (pccinfon->ulFlagSet & FL_NEWVIEWSCROLLSET)
       {
          sLTPos = (pccinfon->sHscrollPosRight * pccinfon->sHscrollFactor);
       }
       else
       {
          sLTPos = 0;

          if (!pFirstColInView)
          {
             pFirstColInView = NEXTVISIBLEFI(pccinfon->pFieldInfoLast);
          }
          else
          {
             if ((NEXTVISIBLEFI(pccinfon->pFieldInfoLast)) &&
                 (NEXTVISIBLEFI(pccinfon->pFieldInfoLast) !=
                  pFirstColInView))
             {
                left  = CnrQueryColumnPosInDV (hwndCnr,
                                NEXTVISIBLEFI(pccinfon->pFieldInfoLast),
                                NEXTVISIBLEFI(pccinfon->pFieldInfoLast),
                                                TRUE,
                                                FALSE);

                right = CnrQueryColumnPosInDV (hwndCnr,
                                NEXTVISIBLEFI(pccinfon->pFieldInfoLast),
                                                pFirstColInView,
                                                TRUE,
                                                FALSE);

                sLTPos = right - left;
             }
          }

          pccinfon->RightWndxOrg = sLTPos;
       }

       /***************************************************************/
       /* Now calculate sRBPos which represents how far the last      */
       /* column in the right window is from the last column possible.*/
       /* This will determine how far right the window can be         */
       /* scrolled.                                                   */
       /***************************************************************/
       pFieldInfo = NEXTVISIBLEFI(pccinfon->pFieldInfoLast);

       if (pFieldInfo)
       {
          right = CnrQueryColumnPosInDV (hwndCnr,
                            NEXTVISIBLEFI(pccinfon->pFieldInfoLast),
                                          NULL,
                                          FALSE,
                                          TRUE);

          right += pccinfon->lAveCharWidth;

          sRBPos = right - (pccinfon->RightWndxOrg +                    /*DAB1*/
                   ViewPortRight.right);
       }
       else
       {
          sRBPos = 0;
       }

       /***************************************************************/
       /* Calculate total scroll range in pixels.                     */
       /***************************************************************/
       sLTPosTemp = max (0, min (sLTPos, sLTPos + sRBPos));
       sLTPosMove = sLTPosTemp - sLTPos;
       pccinfon->RightWndxOrg += (long)(sLTPosMove);
       sLTPos = sLTPosTemp;
       sRBPos = max (0, sRBPos);

       if (sLTPosMove < 0)
       {
          CnrSetFirstColInView (hwndCnr, FALSE);

          if (pccinfo->flWindowAttr & CA_DETAILSVIEWTITLES)
          {
             PMInvalidateRect (GetDlgItem (hwndCnr,
                                                 CID_RIGHTCOLTITLEWND),
                                                 NULL, FALSE);
          }

          PMInvalidateRect (GetDlgItem (hwndCnr, CID_RIGHTDVWND),
                             NULL, FALSE);
       }

       /***************************************************************/
       /* Now we know how much distance exists between the rightmost  */
       /* item in the viewport, and the rightmost column possible.    */
       /* So we set the scroll range and scroll positions.            */
       /***************************************************************/
       ScrollRange = sRBPos + sLTPos;

       /***************************************************************/
       /* Calculate the minimum unit of scrolling.                    */
       /***************************************************************/
       pccinfon->sHscrollFactor = CalcScrollFactor (hwndCnr,
                                                    ScrollRange,
                                                    FALSE);

       if (sRBPos % pccinfon->sHscrollFactor)
       {
          sRBPos = (sRBPos / pccinfon->sHscrollFactor) + 1;
       }
       else
       {
          sRBPos /= (long)(pccinfon->sHscrollFactor);
       }

       if (sLTPos % pccinfon->sHscrollFactor)
       {
          sLTPos = (sLTPos / pccinfon->sHscrollFactor) + 1;
       }
       else
       {
          sLTPos /= pccinfon->sHscrollFactor;
       }

       /***************************************************************/
       /* Calculate the total scroll range include the scroll factor. */
       /***************************************************************/
       ScrollRange = sRBPos + sLTPos;

       pccinfon->sHscrollPosRight = sLTPos;
       pccinfon->sHscrollMaxRight  = ScrollRange;

       PMInvalidateRect (GetDlgItem (hwndCnr, CID_RIGHTHSCROLL),
                          NULL, FALSE);

       if (ScrollRange)
       {
          /************************************************************/
          /* Enable the scroll bar if some outside  viewport          */
          /************************************************************/
          EnableWindow (GetDlgItem (hwndCnr, CID_RIGHTHSCROLL), TRUE);

          SetScrollRange (GetDlgItem (hwndCnr, CID_RIGHTHSCROLL),
                          SB_CTL, 0, ScrollRange, FALSE);
          SetScrollPos  (GetDlgItem (hwndCnr, CID_RIGHTHSCROLL),
                         SB_CTL, sLTPos, TRUE);
       }
       else
       {
          /***********************************************************/
          /* Disable the scroll bar if nothing outside  viewport     */
          /***********************************************************/
          EnableWindow (GetDlgItem (hwndCnr, CID_RIGHTHSCROLL), FALSE);
       }
    }
 }

 pccinfon->ulFlagSet |= FL_NEWVIEWSCROLLSET;

 return;
}

/**********************************************************************/
/*                                                                    */
/*  Function Name:  CnrInsertDetailFieldInfo                          */
/*                                                                    */
/*  Descriptive Name:  Insert Detail FieldInfo structures             */
/*                                                                    */
/*  Functional Description:                                           */
/*                                                                    */
/*  This function inserts FieldInfo structures into a singly linked   */
/*  list.  One or more FieldInfo structures can be inserted at a      */
/*  time, with their position specified.                              */
/*                                                                    */
/*  Notes:                                                            */
/*                                                                    */
/*  Input:  hwndCnr - Handle of the Container Window.                 */
/*          mp1     - Pointer to a FieldInfo structure or a linked    */
/*                    list of FieldInfo structures to be inserted.    */
/*          mp2     - Pointer to a FIELDINFOINSERT data structure     */
/*                    which contains the following:                   */
/*                                                                    */
/*                    pFieldInfoOrder :  CMA_FIRST                    */
/*                                       CMA_END                      */
/*                                       Pointer to a currently       */
/*                                        inserted FieldInfo.         */
/*                                                                    */
/*                    cFieldInfoInsert : The number of FieldInfo      */
/*                                       structures to be inserted.   */
/*                                                                    */
/*  Output:  The number of FieldInfo structures currently in the      */
/*           linked list.                                             */
/*                                                                    */
/*  Exit-Normal:  The number of FieldInfo structures currently        */
/*                inserted in the linked list is returned.            */
/*                                                                    */
/*  Exit-Error:   NULL with WinSetErrorInfo message specifed:         */
/*                - PMERR_INVALID_PARAMETERS                          */
/*                                                                    */
/*  Side Effects:  None                                               */
/*                                                                    */
/*  Author:  Peter Haggar                                             */
/**********************************************************************/
WORD FAR CnrInsertDetailFieldInfo (hwndCnr, mp1, mp2)

HANDLE   hwndCnr;   /* Handle to the Container window.                 */
long     mp1;       /* Pointer to a FieldInfo structure or linked list */
                    /* of FieldInfo structures to be inserted.         */
long     mp2;       /* Pointer to the FIELDINFOINSERT data structure   */
                    /* which contains placement information.           */
{

 LPCNRINFON        pccinfon;          /* Pointer to Internal info.    */
 LPCNRINFO         pccinfo;
 LPFIELDINFO       pFieldInfo;        /* Pointer to the FieldInfo     */
                                      /* structure(s) to insert.      */
 LPFIELDINFOINSERT pFieldInfoInsert;  /* Pointer to the structure     */
                                      /* that dictates placement.     */
 LPFIELDINFO       pTempFI;           /* Temporary pointer used       */
                                      /* while inserting FieldInfo's  */
 WORD              i;                 /* Array index.                 */

  pccinfon = (LPCNRINFON)GetWindowLong (hwndCnr, QWL_CONTAINER);
  pccinfo  = PCCINFOXFROMN(pccinfon);

  pFieldInfo       = (LPVOID)mp1;
  pFieldInfoInsert = (LPVOID)mp2;

  if ((!pFieldInfoInsert) || (!pFieldInfo))
  {
     SETERROR(PMERR_INVALID_PARAMETERS);
     return (0);                                                        /*DAB1*/
  }

  /********************************************************************/
  /* Verify that we are inserting at least one FieldInfo and the      */
  /* control block size is set correctly.                             */
  /********************************************************************/
  if ((pFieldInfoInsert->cFieldInfoInsert <= 0) ||
      (pFieldInfoInsert->cb != sizeof (FIELDINFOINSERT)))
  {
     SETERROR(PMERR_INVALID_PARAMETERS);
     return (0);                                                        /*DAB1*/
  }

  /********************************************************************/
  /* If Verify Pointers is set, check to see if any of the FieldInfo  */
  /* structures the app is trying to insert are already inserted.  If */
  /* so, return NULL with the appropriate error information.          */
  /********************************************************************/
  if (GetWindowLong (hwndCnr, GWL_STYLE) & CCS_VERIFYPOINTERS)
  {
     if (CnrVerifyFieldInfoPtrs (hwndCnr,
                                 pFieldInfo,
                                 pFieldInfoInsert->cFieldInfoInsert))
     {
        SETERROR(PMERR_FI_CURRENTLY_INSERTED);
        return (0);                                                     /*DAB1*/
     }
  }

  /********************************************************************/
  /* Traverse the FieldInfo's passed in, and assign their internal    */
  /* pointers.  When finished, pTempFI will point to the last         */
  /* FieldInfo in the list. If only 1 FieldInfo is being inserted,    */
  /* pTempFI and pFieldInfo will point to the same and only Fieldinfo.*/
  /********************************************************************/
  pTempFI = pFieldInfo;

  for (i = 0; i < (WORD)(pFieldInfoInsert->cFieldInfoInsert - 1); i++)
  {
     NEXTFI(pTempFI) = pTempFI->pNextFieldInfo;

     /*****************************************************************/
     /* If the application has specified to draw Icons, call the      */
     /* function to handle any sizing that may need to be done.       */
     /*****************************************************************/
     if ((pccinfo->flWindowAttr & CA_DRAWICON) ||
        !(pccinfo->flWindowAttr & CA_DRAWBITMAP))
     {
       if (!(CnrProcessIconsForDV (hwndCnr, NULL, pTempFI, TRUE, FALSE)))
       {
          return (0);                                                   /*DAB1*/
       }
     }

     pTempFI = pTempFI->pNextFieldInfo;
  }

  NEXTFI(pTempFI) = NULL;
  pTempFI->pNextFieldInfo = NULL;

  /********************************************************************/
  /* If the application has specified to draw Icons, call the         */
  /* function to handle any sizing that may need to be done.          */
  /********************************************************************/
  if ((pccinfo->flWindowAttr & CA_DRAWICON) ||
     !(pccinfo->flWindowAttr & CA_DRAWBITMAP))
  {
    if (!(CnrProcessIconsForDV (hwndCnr, NULL, pTempFI, TRUE, FALSE)))
    {
       return (0);                                                      /*DAB1*/
    }
  }

  /********************************************************************/
  /* If there is no existing list of FieldInfo's, ignore the flags    */
  /* and insert the FieldInfo, or list of FieldInfo's.                */
  /********************************************************************/
  if (!pccinfon->pFirstFI)
  {
     pccinfon->pFirstFI = pFieldInfo;
     pTempFI->pNextFieldInfo = NULL;
     NEXTFI(pTempFI) = NULL;
  }
  else
  /********************************************************************/
  /* Now we know we have an existing list of FieldInfo structures.    */
  /********************************************************************/
  {
     /*****************************************************************/
     /* Add the FieldInfo structures to the front of the existing     */
     /* list.                                                         */
     /*****************************************************************/
     if (pFieldInfoInsert->pFieldInfoOrder == (LPFIELDINFO)CMA_FIRST)
     {
        NEXTFI(pTempFI) = pccinfon->pFirstFI;
        pTempFI->pNextFieldInfo = pccinfon->pFirstFI;
        pccinfon->pFirstFI = pFieldInfo;
     }
     else
     /*****************************************************************/
     /* If the app. wants the FieldInfo structures added to the       */
     /* end of the list it would help if we could find the end of     */
     /* the list.  Therefore, we'll do this.                          */
     /*****************************************************************/
     {
        if (pFieldInfoInsert->pFieldInfoOrder == (LPFIELDINFO)CMA_END)
        {
           pTempFI->pNextFieldInfo = NULL;
           NEXTFI(pTempFI) = NULL;

           pTempFI = pccinfon->pFirstFI;
           while (NEXTFI(pTempFI))
           {
              pTempFI = NEXTFI(pTempFI);
           }

           /***********************************************************/
           /* pTempFI now points to the last FieldInfo structure      */
           /* in the existing list.  Assign the pointers and be       */
           /* done with it.                                           */
           /***********************************************************/
           pTempFI->pNextFieldInfo = pFieldInfo;
           NEXTFI(pTempFI) = pFieldInfo;
        }
        else
        /**************************************************************/
        /* If we get to here, we must insert the given FieldInfo      */
        /* structures after the FieldInfo structure that the          */
        /* app. passed a pointer to.  It's messy, but it works.       */
        /**************************************************************/
        {
           /***********************************************************/
           /* If the app. has the verify pointers flag set, verify    */
           /* the pointer they are passing in to me.  If it is bad,   */
           /* set an error and return NULL.                           */
           /***********************************************************/
           if (GetWindowLong (hwndCnr, GWL_STYLE) &
                                    CCS_VERIFYPOINTERS)
           {
              if (!(CnrVerifyFieldInfoPtrs (hwndCnr,
                                      pFieldInfoInsert->pFieldInfoOrder,
                                            1)))
              {
                 SETERROR(PMERR_INVALID_PARAMETERS);
                 return (0);                                            /*DAB1*/
              }
           }
           else
           /***********************************************************/
           /* Check to see if the FieldInfo the app passed in is not  */
           /* NULL.  If it is, return NULL and an error.              */
           /***********************************************************/
           {
              if (!pFieldInfoInsert->pFieldInfoOrder)
              {
                 SETERROR(PMERR_INVALID_PARAMETERS);
                 return (0);                                            /*DAB1*/
              }
           }

           pTempFI->pNextFieldInfo =
                             NEXTFI(pFieldInfoInsert->pFieldInfoOrder);
           NEXTFI(pTempFI) = NEXTFI(pFieldInfoInsert->pFieldInfoOrder);

           pFieldInfoInsert->pFieldInfoOrder->pNextFieldInfo =
                                                             pFieldInfo;
           NEXTFI(pFieldInfoInsert->pFieldInfoOrder) = pFieldInfo;
        }
     }
  }

  /********************************************************************/
  /* If the app. specified that the container should be invalidated   */
  /* upon the insertion of FieldInfo structures, we do it.            */
  /********************************************************************/
  if (pFieldInfoInsert->fInvalidateFieldInfo)
  {
     CnrInvalidateDetailFieldInfo (hwndCnr);
  }
  else
  {
     /*****************************************************************/
     /* If we didn't invalidate the container, we need to reset the   */
     /* visible pointers in the linked list of FieldInfo's that are   */
     /* now inserted.                                                 */
     /*****************************************************************/
     CnrProcessVisibleColumns (hwndCnr);
  }

  /********************************************************************/
  /* Keep track of the number of FieldInfo structures currently in    */
  /* the list, and return this to the application so they know how    */
  /* many are inserted.                                               */
  /********************************************************************/
  pccinfo->cFields += pFieldInfoInsert->cFieldInfoInsert;
  return (pccinfo->cFields);
}
