/* Revision: 16 1.2.2.3 source/ui/cclnt/cnr/cnrs2p5.c, cclcnr, ioc.v400, 000919  */
/**********************************************************************/
/*                                                                    */
/*                         IBM CONFIDENTIAL                           */
/*                                                                    */
/*        (IBM Confidential-Restricted when combined with the         */
/*         aggregated OCO source modules for this program)            */
/*                                                                    */
/*                       OCO SOURCE MATERIALS                         */
/*                                                                    */
/*         20G0400 (C) Copyright IBM Corp. 1992, 1997 (Unpublished)   */
/*                                                                    */
/* ================================================================== */
/*                                                                    */
/*                         C O N T A I N E R                          */
/*                                                                    */
/*                        Filename: CNRS2P5.C                         */
/*                                                                    */
/*             ( Windows NT Container Control Component )             */
/*                                                                    */
/*                         IBM CONFIDENTIAL                           */
/*                                                                    */
/*                (C) Copyright IBM Corporation 1997                  */
/*                       All Rights Reserved                          */
/*            Licensed Material - Program Property of IBM             */
/*                                                                    */
/**********************************************************************/
/**********************************************************************/
/* Product: ICLUINT.DLL                                               */
/* Filename: CNRS2P5.C - More support routines for container control  */
/*                                                                    */
/* Flag    Date    By:  Description                                   */
/* ----  --------  ---  --------------------------------------------- */
/* DAB1  11/16/93  DAB  Initial modifications for NT execution        */
/* RKK1  04/30/96  RKK  Add changes required for Wind/U.              */
/* D7092 08/06/96  LJO  Add support for icon resizing.                */
/**********************************************************************/
#include <windows.h>
#include "cnr2win.h"
#include "iclcnrw.h"

#include "cnrcbn.h"

//#include "storwin.h"

#ifdef SEGMENTOR
#define CNRS2P5_C
#include "cnrpragw.h"
#endif

extern HANDLE  vhCNRInstance;

/* ********************************************************************/
/*                                                                    */
/*  Function Name:     UpdateFirstItemInView                          */
/*                                                                    */
/*  Usage: External                                                   */
/*                                                                    */
/*                                                                    */
/*  Descriptive Name:                                                 */
/*                                                                    */
/*  Functional Description:                                           */
/*                                                                    */
/*  Notes:                                                            */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*  Input:                                                            */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*  Output:                                                           */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*  Exit-Normal:                                                      */
/*                                                                    */
/*  Exit-Error:                                                       */
/*                                                                    */
/*  Side Effects:                                                     */
/*    xtai                                                            */
/**********************************************************************/
VOID FAR UpdateFirstItemInView(HANDLE hwnd, LPRECORDCOREN preccDel)
{

  LPCNRINFON  pccinfon;                /* Internal CNR control data   */

  /*******************************************************************/
  /* Initialize pointers to control data and local variables         */
  /*******************************************************************/
  pccinfon = (LPCNRINFON)GetWindowLong(hwnd,QWL_CONTAINER);

  /********************************************************************/
  /* If the first/last item in each view is same as the item to be    */
  /* deleted, set the first/last item to the previous item ptr.       */
  /* If previous item is filtered, check prev/next item of prev item  */
  /* until finding unfiltered one or no prev/next item exists.        */
  /* If no unfiltered prev/next item exists, the first/last item is   */
  /* next/prev unfiltered item in the linked list.                    */
  /********************************************************************/
  if (preccDel)
  {
    /******************************************************************/
    /* Tree View                                                      */
    /******************************************************************/
    if (!pccinfon->preccFirstinTRV)
    {
      pccinfon->preccFirstinTRV = pccinfon->preccItem;
    }

    if ((pccinfon->preccFirstinTRV == preccDel) ||
        TRVIsAncestor(preccDel, pccinfon->preccFirstinTRV) )
    {
      pccinfon->preccFirstinTRV = GetPrevVisualItem(hwnd, preccDel);

      if (!pccinfon->preccFirstinTRV)
      {
        pccinfon->preccFirstinTRV = GetNextUnfilteredItem (preccDel);
      }
    } /* endif */

    /******************************************************************/
    /* Flowed Name View                                               */
    /******************************************************************/
    if (!pccinfon->preccFirstinFNV)
    {
      pccinfon->preccFirstinFNV = pccinfon->preccItem;
    }

    if (preccDel == pccinfon->preccFirstinFNV)
    {
      pccinfon->preccFirstinFNV = GetPrevUnfilteredItem (preccDel);
      if (!pccinfon->preccFirstinFNV)
      {
        pccinfon->preccFirstinFNV = GetNextUnfilteredItem (preccDel);
      } /* endif */
    } /* endif */

#if 0
    if (preccDel == pccinfon->preccLastinFNV)
    {
      pccinfon->preccLastinFNV = GetNextUnfilteredItem (preccDel);
      if (!pccinfon->preccLastinFNV)
      {
        pccinfon->preccLastinFNV = GetPrevUnfilteredItem (preccDel);
      } /* endif */
    }
#endif

    /******************************************************************/
    /* Name View                                                      */
    /******************************************************************/
    if (!pccinfon->preccFirstinNV)
    {
      pccinfon->preccFirstinNV = pccinfon->preccItem;
    }

    if (preccDel == pccinfon->preccFirstinNV)
    {
      pccinfon->preccFirstinNV = GetPrevUnfilteredItem (preccDel);
      if (!pccinfon->preccFirstinNV)
      {
        pccinfon->preccFirstinNV = GetNextUnfilteredItem (preccDel);
      } /* endif */
    } /* endif */

#if 0
    if (preccDel == pccinfon->preccLastinNV)
    {
      pccinfon->preccLastinNV = GetNextUnfilteredItem (preccDel);
      if (!pccinfon->preccLastinNV)
      {
        pccinfon->preccLastinNV = GetPrevUnfilteredItem (preccDel);
      } /* endif */
    }
#endif

    /******************************************************************/
    /* Flowed Text View                                               */
    /******************************************************************/
    if (!pccinfon->preccFirstinFTV)
    {
      pccinfon->preccFirstinFTV = pccinfon->preccItem;
    }

    if (preccDel == pccinfon->preccFirstinFTV)
    {
      pccinfon->preccFirstinFTV = GetPrevUnfilteredItem (preccDel);
      if (!pccinfon->preccFirstinFTV)
      {
        pccinfon->preccFirstinFTV = GetNextUnfilteredItem (preccDel);
      } /* endif */
    } /* endif */

#if 0
    if (preccDel == pccinfon->preccLastinFTV)
    {
      pccinfon->preccLastinFTV = GetNextUnfilteredItem (preccDel);
      if (!pccinfon->preccLastinFTV)
      {
        pccinfon->preccLastinFTV = GetPrevUnfilteredItem (preccDel);
      } /* endif */
    }
#endif

    /******************************************************************/
    /* Text View                                                      */
    /******************************************************************/
    if (!pccinfon->preccFirstinTV)
    {
      pccinfon->preccFirstinTV = pccinfon->preccItem;
    }

    if (preccDel == pccinfon->preccFirstinTV)
    {
      pccinfon->preccFirstinTV = GetPrevUnfilteredItem (preccDel);
      if (!pccinfon->preccFirstinTV)
      {
        pccinfon->preccFirstinTV = GetNextUnfilteredItem (preccDel);
      } /* endif */
    } /* endif */

#if 0
    if (preccDel == pccinfon->preccLastinTV)
    {
      pccinfon->preccLastinTV = GetNextUnfilteredItem (preccDel);
      if (!pccinfon->preccLastinTV)
      {
        pccinfon->preccLastinTV = GetPrevUnfilteredItem (preccDel);
      } /* endif */
    }
#endif

    /******************************************************************/
    /* Icon View                                                      */
    /******************************************************************/
    if (!pccinfon->preccFirstinAutoPosIV)
    {
      pccinfon->preccFirstinAutoPosIV = pccinfon->preccItem;
    }

    if (preccDel == pccinfon->preccFirstinAutoPosIV)
    {
      pccinfon->preccFirstinAutoPosIV = GetPrevUnfilteredItem (preccDel);
      if (!pccinfon->preccFirstinAutoPosIV)
      {
        pccinfon->preccFirstinAutoPosIV = GetNextUnfilteredItem (preccDel);
      } /* endif */
    } /* endif */

    /******************************************************************/
    /* Details View                                                   */
    /******************************************************************/
    if (!pccinfon->preccFirstRowInDV)
    {
      pccinfon->preccFirstRowInDV = pccinfon->preccItem;
    }

    if (preccDel == pccinfon->preccFirstRowInDV)
    {
      pccinfon->preccFirstRowInDV = GetPrevUnfilteredItem (preccDel);
      if (!pccinfon->preccFirstRowInDV)
      {
        pccinfon->preccFirstRowInDV = GetNextUnfilteredItem (preccDel);
      } /* endif */
    }
#if 0
    if (preccDel == pccinfon->preccLastRowInDV)
    {
      pccinfon->preccLastRowInDV = GetNextUnfilteredItem (preccDel);
      if (!pccinfon->preccLastRowInDV)
      {
        pccinfon->preccLastRowInDV = GetPrevUnfilteredItem (preccDel);
      } /* endif */
    }
#endif
  }
  else
  {
    /******************************************************************/
    /* If no unfiltered prev item exists, the first item is NULL.     */
    /******************************************************************/
    pccinfon->preccFirstinFNV = pccinfon->preccFirstinNV = NULL;
    pccinfon->preccFirstinFTV = pccinfon->preccFirstinTV = NULL;
    pccinfon->preccFirstRowInDV = NULL;
    pccinfon->preccFirstinAutoPosIV = NULL;
    pccinfon->preccFirstinTRV = NULL;
  } /* endif */

  return;
}

/*********************************************************************/
/* FUNCTION NAME:  CnrResetInstanceData                              */
/*                                                                   */
/*  Usage: External                                                  */
/*                                                                   */
/* DESCRIPTIVE NAME:  Reset Container Instance Data.                 */
/*                                                                   */
/* FUNCTIONAL DESCRIPTION:  This function reset the Container        */
/*   instance data.                                                  */
/*                                                                   */
/* NOTES:                                                            */
/*    FORWARD DECLARATION:                                           */
/*                                                                   */
/* INPUT:  HANDLE hwnd - handle to the container window              */
/*                                                                   */
/* OUTPUT:                                                           */
/*                                                                   */
/*                                                                   */
/* EXIT-NORMAL:                                                      */
/*                                                                   */
/* EXIT-ERROR:                                                       */
/*                                                                   */
/* SIDE EFFECTS:                                                     */
/*********************************************************************/
VOID FAR CnrResetInstanceData(HANDLE hwnd)
{
  LPCNRINFON pccinfon;
  LPCNRINFO  pccinfo;

  /*******************************************************************/
  /* Initialize pointers to control data and local variables         */
  /*******************************************************************/
  pccinfon = (LPCNRINFON)GetWindowLong(hwnd,QWL_CONTAINER);
  pccinfo  = PCCINFOXFROMN(pccinfon);

  pccinfon->preccLastValid = pccinfon->preccCursor = NULL;
  pccinfon->preccItem = pccinfon->preccLastItem = NULL;
  pccinfon->preccZ = pccinfon->preccZTail = NULL;
  pccinfon->preccFirstinAutoPosIV = NULL;
  pccinfon->preccFirstinFNV = pccinfon->preccFirstinNV = NULL;
  pccinfon->preccFirstinFTV = pccinfon->preccFirstinTV = NULL;
  pccinfon->preccFirstRowInDV = NULL;
  pccinfon->preccFirstinTRV = NULL;
  pccinfon->lMaxHeight = 0;
  pccinfo->cRecords = 0;
  pccinfo->ptlOrigin.x = pccinfo->ptlOrigin.y = 0;

  pccinfon->ulFlagSet &= ~(FL_SETWORKPLACE | FL_SETSCROLL |
                           FL_NEWVIEWSCROLLSET);
  return;
}

/* ********************************************************************/
/*                                                                    */
/*  Function Name:     CnrSetCnrInfo                                  */
/*                                                                    */
/*  Usage: External                                                   */
/*                                                                    */
/*                                                                    */
/*  Descriptive Name:                                                 */
/*                                                                    */
/*  Functional Description:  Sets data for a container control.       */
/*                                                                    */
/*  Notes:                                                            */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*  Input:  mp1: LPCNRINFO (LPCNRINFO)-pointer to the CNRINFO         */
/*               from which to set the data for the container         */
/*                                                                    */
/*          mp2: ulCnrInfoFl (DWORD) - flags indicating which         */
/*               items are to be set                                  */
/*                                                                    */
/*                                                                    */
/*  Output: fSuccess (BOOL)                                           */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*  Exit-Normal: TRUE - container data successfully set               */
/*                                                                    */
/*  Exit-Error:  FALSE - not successful                               */
/*                                                                    */
/*  Side Effects: None                                                */
/*                                                                    */
/**********************************************************************/
BOOL FAR CnrSetCnrInfo(HANDLE hwnd, long mp1, long mp2)
{
#define  FL_INVALIDATECNR       1
#define  FL_INVALIDATETITLE     2

 LPCNRINFON  pccinfon;                  /* Internal CNR control data */
 LPCNRINFO   pccinfo;
 DWORD       ulXORedAttr;
 DWORD       ulOldAttr;
 RECT        CnrRect;
 BOOL        AddSplitbar = FALSE;
 WORD        flInvalidate = 0;

  /********************************************************************/
  /* Initialize pointers to control data and local variables          */
  /********************************************************************/
  pccinfon = (LPCNRINFON)GetWindowLong(hwnd,QWL_CONTAINER);
  pccinfo  = PCCINFOXFROMN(pccinfon);

  /*******************************************************************/
  /* Set the fields of CNRINFO with the parameters contained in the  */
  /* mp1 buffer according to the flags indicated with mp2            */
  /*******************************************************************/
  if (mp1)
  {
#if 0
    /******************************************************************/
    /* If the previous view was Details View, we must take down it's  */
    /* windows and scrollbars by setting their size and position to 0 */
    /******************************************************************/
    if ((pccinfo->flWindowAttr & CV_DETAIL) &&
        (mp2 & CMA_FLWINDOWATTR) &&
        (!(((LPCNRINFO)mp1)->flWindowAttr & CV_DETAIL)))
    {
       MoveWindow (GetDlgItem (hwnd, CID_LEFTDVWND),
                   0, 0, 0, 0, TRUE);

       MoveWindow (GetDlgItem (hwnd, CID_RIGHTDVWND),
                   0, 0, 0, 0, TRUE);

       MoveWindow (GetDlgItem (hwnd, CID_VSCROLL),
                   0, 0, 0, 0, TRUE);

       MoveWindow (GetDlgItem (hwnd, CID_HSCROLL),
                   0, 0, 0, 0, TRUE);

       MoveWindow (GetDlgItem (hwnd, CID_RIGHTHSCROLL),
                   0, 0, 0, 0, TRUE);

       MoveWindow (GetDlgItem (hwnd, CID_BLANKBOX),
                   0, 0, 0, 0, TRUE);

       MoveWindow (GetDlgItem (hwnd, CID_LEFTCOLTITLEWND),
                   0, 0, 0, 0, TRUE);

       MoveWindow (GetDlgItem (hwnd, CID_RIGHTCOLTITLEWND),
                   0, 0, 0, 0, TRUE);

    }
#endif

   if (mp2 & CMA_FLWINDOWATTR)
   {
     if (!((LPCNRINFO)mp1)->flWindowAttr)
     {
       SETERROR(PMERR_INVALID_PARAMETERS);
       return(FALSE);
     }

     /****************************************************************/
     /* Get the xored value from the original attribute and the new  */
     /* attribute to check what is changed.                          */
     /****************************************************************/
     ulXORedAttr = pccinfo->flWindowAttr ^ ((LPCNRINFO)mp1)->flWindowAttr;

     /****************************************************************/
     /* Save old Attr.                                               */
     /****************************************************************/
     ulOldAttr = pccinfo->flWindowAttr;

     /****************************************************************/
     /* Copy the new attribute to the pccinfo.                       */
     /****************************************************************/
     pccinfo->flWindowAttr = ((LPCNRINFO)mp1)->flWindowAttr;

     /****************************************************************/
     /* If CA_DRAWBITMAP or CA_DRAWICON bits are changed........     */
     /****************************************************************/
     if (ulXORedAttr & (CA_DRAWBITMAP | CA_DRAWICON))
     {
       flInvalidate |= FL_INVALIDATECNR;

       if ((pccinfo->flWindowAttr & CA_DRAWBITMAP) &&
           !(pccinfo->flWindowAttr & CA_DRAWICON))
       {
         /************************************************************/
         /* If CA_DRAWBITMAP only is specified, we use the bitmaps,  */
         /* and don't need resized icons. So get rid away the        */
         /* resized icon metrics. (Cnrcfunc.c)                       */
         /************************************************************/
         CnrDeleteAllResizedIcon(hwnd);
       }
       else
       {
         /************************************************************/
         /* Else, we use the pointers, so we need resized icons      */
         /* metrics.  (cnrcfunc.c)                                   */
         /************************************************************/
         pccinfo->flWindowAttr &= ~CA_DRAWBITMAP;
         pccinfo->flWindowAttr |= CA_DRAWICON;

         if (!(CnrOpenIRSMetrics(hwnd)))
         {
            return (FALSE);
         }

         if (pccinfon->pFirstFI)
         {
            if (!(CnrUpdateDetailsViewIcons (hwnd)))
            {
               return (FALSE);
            }
         }
       } /* endif */
     } /* endif */
     else
     /*****************************************************************/
     /* If CA_DRAWBITMAP and CA_DRAWICON are not changed, make sure   */
     /* we have a default set.                                        */
     /*****************************************************************/
     if (!(pccinfo->flWindowAttr & (CA_DRAWICON | CA_DRAWBITMAP)))
     {
       pccinfo->flWindowAttr |= CA_DRAWICON;
     }

     if (ulXORedAttr & (CA_DETAILSVIEWTITLES))
     {
       flInvalidate |= FL_INVALIDATECNR;
       pccinfon->ulFlagSet &= ~( FL_SIZECOLTITLES | FL_POSITIONCOLTITLES |
                    FL_SETSCROLL | FL_SIZECHILDREN | FL_CNRPOSITION |
                    FL_NEWVIEWSCROLLSET );
     }

     if (ulXORedAttr & CA_CONTAINERTITLE)
     {
       flInvalidate |= FL_INVALIDATECNR;
       pccinfon->ulFlagSet2 &= ~FL2_TITLESIZECALC;
       /***************************************************************/
       /* New view scroll bar is not set.                             */
       /***************************************************************/
       pccinfon->ulFlagSet &= ~(FL_SETCNRTITLE | FL_CNRPOSITION |
                                FL_NEWVIEWSCROLLSET);
     }

     if (ulXORedAttr & (CV_TEXT | CV_ICON | CV_NAME | CV_DETAIL |
                        CV_MINI | CV_FLOW | CV_TREE))
     {
       flInvalidate |= FL_INVALIDATECNR;
       InitWindowViewAttr (hwnd);

       /**************************************************************/
       /* If the previous view was Details View and current view is  */
       /* not, all window associated with details view are destroyed.*/
       /**************************************************************/
       if ((ulOldAttr & CV_DETAIL) &&
           !(pccinfo->flWindowAttr & CV_DETAIL))
       {
          DestroyDVWindows(hwnd);
       }
       else
       {
         /************************************************************/
         /* If the previous view was not details view and current    */
         /* view is, create the windows associated with details      */
         /* view.                                                    */
         /************************************************************/
         if (!(ulOldAttr & CV_DETAIL) &&
             (pccinfo->flWindowAttr & CV_DETAIL))
         {
           if (!CreateDVWindows(hwnd))
           {
             return FALSE;
           }
         }
       }

       /**************************************************************/
       /* If the previous view was not CV_MINI and this one is, we   */
       /* have to make sure we've resized the icons.                 */
       /**************************************************************/
       if (!(ulOldAttr & CV_MINI) &&
           (pccinfo->flWindowAttr & CV_MINI))
       {
          pccinfo->slBitmapOrIcon.x = GetSystemMetrics(SM_CXSMICON);
          pccinfo->slBitmapOrIcon.y = GetSystemMetrics(SM_CYSMICON);
          CnrChangeSizeInIRSMetrics(hwnd);
       }                                                            /* D7092 */

       /*----------------------------------------------------------------*/
       /* assume no mouse buttons are pressed (this was added to         */
       /* dragging the splitbar would work the first time through - JDR) */
       /*----------------------------------------------------------------*/
       pccinfon->ulFlagSet2 &= ~(FL2_BUTTONLEFT | FL2_BUTTONRIGHT);

       /***************************************************************/
       /* Turn flags off to reposition and recalculate the text size  */
       /***************************************************************/
       pccinfon->ulFlagSet &= ~(FL_TEXTCALC | FL_CNRPOSITION | FL_SETSCROLL |
                  FL_SETCNRTITLE |  FL_SIZECHILDREN | FL_SIZECOLTITLES |
                  FL_POSITIONCOLTITLES);

       CheckFirstInView (hwnd);

       /***************************************************************/
       /* New view scroll bar is not set.                             */
       /* Set flag for the workplace reset off to                     */
       /* to reset  the workplacee before painting in the icon view.  */
       /***************************************************************/
       pccinfon->ulFlagSet &= ~(FL_NEWVIEWSCROLLSET | FL_SETWORKPLACE);

       /***************************************************************/
       /* When change the view, initialize the noniconorigin          */
       /***************************************************************/
       pccinfon->ptlNonIconOrg.x = pccinfon->ptlNonIconOrg.y = 0;

       /***************************************************************/
       /* Clean the scroll range and scroll position.                 */
       /***************************************************************/
       pccinfon->sVscrollPos = pccinfon->sHscrollPos = 0;
       pccinfon->sVscrollMax = pccinfon->sHscrollMax = 0;
       pccinfon->sHscrollMaxRight = 0;

       /**************************************************************/
       /* If the view changes from or to the tree view,              */
       /* we need some initialization step.                          */
       /**************************************************************/
       if (ulXORedAttr & CV_TREE)
       {
         if (pccinfo->flWindowAttr & CV_TREE)
         {
           TRVProcessOpenTree(hwnd);
         }
         else
         {
           TRVProcessCloseTree(hwnd);
         }
       }

#if 0
       /***************************************************************/
       /* If changing to icon view and in add mode, turn off add mode */
       /* because this selection technique is not valid in icon view  */
       /***************************************************************/
       if (ulXORedAttr & (CV_ICON) && (pccinfon->ulFlagSet & FL_ADDMODE))
       {
         /*************************************************************/
         /* Toggle add mode off. The selection cursor changes to      */
         /* a dotted outline box.                                     */
         /*************************************************************/
         pccinfon->ulFlagSet &= ~FL_ADDMODE;
         CnrSetBlinkTimer(hwnd);
       }
#endif
     } /* endif */
   }

   if (mp2 & CMA_PTLORIGIN)
   {
     if (!(pccinfo->flWindowAttr & CV_TREE) &&
         (pccinfo->flWindowAttr & CV_ICON) )
     {
       flInvalidate |= FL_INVALIDATECNR;
     }

     pccinfo->ptlOrigin =
       (((LPCNRINFO)(mp1)))->ptlOrigin;
     ProcessChangeOrigin(hwnd);
   }
   if (mp2 & CMA_LINESPACING)
   {
     flInvalidate |= FL_INVALIDATECNR;
     pccinfo->cyLineSpacing =
       (((LPCNRINFO)(mp1)))->cyLineSpacing;
     ProcessChangeLineSpace(hwnd);
   }

   if (mp2 & CMA_SLTREEBITMAPORICON)
   {

     if (( (((LPCNRINFO)(mp1)))->slTreeBitmapOrIcon.x < 0) ||
         ( (((LPCNRINFO)(mp1)))->slTreeBitmapOrIcon.y < 0) )
     {
       SETERROR(PMERR_INVALID_PARAMETERS);
       return(FALSE);
     }

     pccinfo->slTreeBitmapOrIcon.x =
                             ((LPCNRINFO)mp1)->slTreeBitmapOrIcon.x;
     pccinfo->slTreeBitmapOrIcon.y =
                             ((LPCNRINFO)mp1)->slTreeBitmapOrIcon.y;

     /****************************************************************/
     /* Resize the bitmaps in the resized icon metrics.              */
     /****************************************************************/
     CnrChangeSizeInIRSTreeMetrics(hwnd);

     /****************************************************************/
     /* Flags are off to reposition and recalculate the text size    */
     /* New view scroll bar is not set.                              */
     /****************************************************************/
     if ((pccinfo->flWindowAttr & CV_TREE) &&
         !(pccinfo->flWindowAttr & CV_NAME) )
     {
       flInvalidate |= FL_INVALIDATECNR;
       pccinfon->ulFlagSet &= ~( FL_CNRPOSITION | FL_SETSCROLL |
                            FL_NEWVIEWSCROLLSET );
     }

   }

   if (mp2 & CMA_TREEICON)
   {
     CnrTRVInsDelResizedTreeIcon(hwnd, FALSE);
     pccinfo->hptrExpanded = ((LPCNRINFO)mp1)->hptrExpanded;
     pccinfo->hptrCollapsed = ((LPCNRINFO)mp1)->hptrCollapsed;
     CnrTRVInsDelResizedTreeIcon(hwnd, TRUE);
     if ((pccinfo->flWindowAttr & CV_TREE) &&
         !(pccinfo->flWindowAttr & CV_NAME) )
     {
       flInvalidate |= FL_INVALIDATECNR;
     }
   }

   if (mp2 & CMA_TREEBITMAP)
   {
     pccinfo->hbmCollapsed = ((LPCNRINFO)mp1)->hbmCollapsed;
     pccinfo->hbmExpanded = ((LPCNRINFO)mp1)->hbmExpanded;
     if ((pccinfo->flWindowAttr & CV_TREE) &&
         !(pccinfo->flWindowAttr & CV_NAME) )
     {
       flInvalidate |= FL_INVALIDATECNR;
     }
   }

   if (mp2 & CMA_CXTREEINDENT)
   {
     if (pccinfo->flWindowAttr & CV_TREE)
     {
       flInvalidate |= FL_INVALIDATECNR;
       pccinfon->ulFlagSet &= ~FL_CNRPOSITION;
     }
     pccinfo->cxTreeIndent = ((LPCNRINFO)mp1)->cxTreeIndent;
   }

   if (mp2 & CMA_CXTREELINE)
   {
     if (pccinfo->flWindowAttr & CV_TREE)
     {
       flInvalidate |= FL_INVALIDATECNR;
     }
     pccinfo->cxTreeLine = ((LPCNRINFO)mp1)->cxTreeLine;
   }

   if (mp2 & CMA_PSORTRECORD)
   {
     pccinfo->pSortRecord = (((LPCNRINFO)(mp1)))->pSortRecord;
     ProcessChangePSortRecord(hwnd);
     flInvalidate |= FL_INVALIDATECNR;
   }
   if (mp2 & CMA_XVERTSPLITBAR)
   {
      pccinfo->xVertSplitbar =
        (((LPCNRINFO)(mp1)))->xVertSplitbar;

      /****************************************************************/
      /* Set the flag to indicate if we have a splitbar or not.       */
      /****************************************************************/
      if (pccinfo->xVertSplitbar < 0)
      {
         pccinfon->ulFlagSet |= FL_UNSPLIT;
      }
      else
      {
         pccinfon->ulFlagSet &= ~FL_UNSPLIT;
         AddSplitbar = TRUE;
      }

      if (pccinfo->flWindowAttr & CV_DETAIL)
      {
        flInvalidate |= FL_INVALIDATECNR;
        pccinfon->ulFlagSet &= ~( FL_SETSCROLL | FL_SIZECOLTITLES |
                             FL_SIZECHILDREN );
      }
   }
   if (mp2 & CMA_SLBITMAPORICON)
   {
     if (( (((LPCNRINFO)(mp1)))->slBitmapOrIcon.x < 0) ||
         ( (((LPCNRINFO)(mp1)))->slBitmapOrIcon.y < 0) )
     {
       SETERROR(PMERR_INVALID_PARAMETERS);
       return(FALSE);
     }
     pccinfo->slBitmapOrIcon = (((LPCNRINFO)(mp1)))->slBitmapOrIcon;

     /****************************************************************/
     /* Resize the bitmaps in the resized icon metrics.              */
     /****************************************************************/
     if (pccinfo->flWindowAttr & CV_MINI)
        pccinfo->flWindowAttr &= ~CV_MINI;                          /* D7092 */

     CnrChangeSizeInIRSMetrics(hwnd);

     if ((!(pccinfo->flWindowAttr & CV_MINI) &&
          !(pccinfo->flWindowAttr & CV_TEXT)) ||
         (pccinfo->flWindowAttr & (CV_DETAIL | CV_TREE)) )
     {
       flInvalidate |= FL_INVALIDATECNR;
       /**************************************************************/
       /* Flags are off to reposition and recalculate the text size  */
       /* New view scroll bar is not set.                            */
       /* Set flag for the workplace reset off to                    */
       /* to reset  the workplacee before painting in the icon view. */
       /**************************************************************/
       pccinfon->ulFlagSet &= ~(FL_CNRPOSITION | FL_SETSCROLL |
                           FL_NEWVIEWSCROLLSET | FL_SETWORKPLACE );

       /***************************************************************/
       /* If we are in Details View, we need to set some additional   */
       /* flags to position and size the Column Title windows (if they*/
       /* exist) and size the child (left and right) windows.         */
       /***************************************************************/
       if (pccinfo->flWindowAttr & CV_DETAIL)
       {
          pccinfon->ulFlagSet &= ~( FL_SIZECHILDREN | FL_SIZECOLTITLES |
                               FL_POSITIONCOLTITLES );
       }
     }

     if (GetWindowLong( hwnd, GWL_STYLE ) & CCS_AUTOPOSITION)
     {
       pccinfon->ulFlagSet |= FL_NEEDARRANGE;
     } /* endif */

   }
   if (mp2 & CMA_CNRTITLE)
   {
     HDC   hps;
     SIZEL slOldTitle;

     if (hps = GetDC (hwnd))
     {
       slOldTitle.cy = pccinfon->slCnrTitle.cy;                         /*DAB1*/

       pccinfo->pszCnrTitle = ((LPCNRINFO)mp1)->pszCnrTitle;

       CnrUpdateTitleSize(hwnd, hps);
       ReleaseDC(hwnd, hps);
       pccinfon->ulFlagSet2 |= FL2_TITLESIZECALC;

       if (slOldTitle.cy != pccinfon->slCnrTitle.cy)                    /*DAB1*/
       {
          flInvalidate |= FL_INVALIDATECNR;
          /**************************************************************/
          /* Flags are off to reset title window                        */
          /* Flags are off to reposition and recalculate the text size  */
          /* New view scroll bar is not set.                            */
          /**************************************************************/
          pccinfon->ulFlagSet &= ~( FL_SETCNRTITLE | FL_CNRPOSITION |
                    FL_SETSCROLL | FL_SIZECOLTITLES |
                    FL_POSITIONCOLTITLES | FL_NEWVIEWSCROLLSET );

          if (GetWindowLong( hwnd, GWL_STYLE ) & CCS_AUTOPOSITION)
          {
            pccinfon->ulFlagSet |= FL_NEEDARRANGE;
          } /* endif */
       }
       else
       {
          flInvalidate |= FL_INVALIDATETITLE;
       }
        /*****************************************************************/
        /* Initialize the title height.                                  */
        /*****************************************************************/
     //   pccinfon->CnrTitleHeight = (USHORT)0;
     }
   }
   if (mp2 & CMA_PFIELDINFOOBJECT)
   {
      pccinfo->pFieldInfoObject = (((LPCNRINFO)(mp1)))->pFieldInfoObject;
      if (pccinfo->flWindowAttr & CV_DETAIL)
      {
        flInvalidate |= FL_INVALIDATECNR;
      }
   }
   if (mp2 & CMA_PFIELDINFOLAST)
   {
      if (!((((LPCNRINFO)(mp1)))->pFieldInfoLast))
      {
         pccinfon->pFIFirstColRightInDV = NULL;
      }
      else
      {
         if (GetWindowLong (hwnd, GWL_STYLE) & CCS_VERIFYPOINTERS)
         {
            if (!(CnrVerifyFieldInfoPtrs (hwnd,
                         (((LPCNRINFO)(mp1)))->pFieldInfoLast, 1)))
            {
               SETERROR(PMERR_INVALID_PARAMETERS);
               return (FALSE);                                          /*DAB1*/
            }
         }
      }

      pccinfo->pFieldInfoLast = (((LPCNRINFO)(mp1)))->pFieldInfoLast;

      pccinfon->pFieldInfoLast = pccinfo->pFieldInfoLast;

      pccinfon->pFIFirstColLeftInDV = NULL;
      pccinfon->pFIFirstColRightInDV = NULL;
      pccinfon->pFILastColLeftInDV = NULL;
      pccinfon->pFILastColRightInDV = NULL;

      if (pccinfon->pFieldInfoLast)
      {
        if (!(NEXTVISIBLEFI(pccinfon->pFieldInfoLast)))
        {
          pccinfon->pFIFirstColRightInDV = NULL;
        }
      }

      /****************************************************************/
      /* Check to see if FieldInfoLast is invisible.  If it is, we    */
      /* set it to be the first visible column.  Therefore, only 1    */
      /* column will exist in the left window.                        */
      /****************************************************************/
      CnrProcessVisibleColumns (hwnd);
      if (pccinfo->flWindowAttr & CV_DETAIL)
      {
        flInvalidate |= FL_INVALIDATECNR;
        pccinfon->ulFlagSet &= ~FL_SETSCROLL;
      }
   }
   if (mp2 & CMA_DELTA)
   {
     pccinfo->cDelta = (((LPCNRINFO)(mp1)))->cDelta;
   }
 }
 else
 {
   /*******************************************************************/
   /* If mp1 is NULL, error has occurred                              */
   /*******************************************************************/
   SETERROR(PMERR_INVALID_PARAMETERS);
   return(FALSE);
 }

 pccinfon->preccLastValid = NULL;

 if ((pccinfo->flWindowAttr & CV_DETAIL) &&
     (flInvalidate & FL_INVALIDATECNR))
 {
    PMGetClientRect (hwnd, &CnrRect);

    if ((CnrRect.right) && (CnrRect.bottom))
    {
       if ((pccinfon->ulFlagSet & FL_UNSPLIT) ||
           (pccinfo->xVertSplitbar > CnrRect.right) ||
           (AddSplitbar))
       {
          CnrDetailsVCtlProc (hwnd, WM_PAINT, 0, 0 );                   /*DAB1*/
       }
    }
 }

 if (flInvalidate & FL_INVALIDATECNR)
 {
   InvalidateChildren (hwnd, FALSE, FALSE);
 }
 else
 {
   if (flInvalidate & FL_INVALIDATETITLE)
   {
     InvalidateRect( GetDlgItem(hwnd, CID_CNRTITLEWND),
                     NULL, TRUE );
   }
 }
 return(TRUE);
}

/*********************************************************************/
/*                                                                   */
/*  Function Name:  InitWindowViewAttr                               */
/*                                                                   */
/*  Usage: External                                                  */
/*                                                                   */
/*  Descriptive Name:   Initialize Window View Attr                  */
/*                                                                   */
/*  Functional Description:                                          */
/*                                                                   */
/*  Notes:                                                           */
/*     Forward Declaration:                                          */
/*                                                                   */
/*  Input:                                                           */
/*                                                                   */
/*  Output:                                                          */
/*                                                                   */
/*  Exit-Normal:                                                     */
/*                                                                   */
/*  Exit-Error:                                                      */
/*                                                                   */
/*  Side Effects:                                                    */
/*                                                                   */
/*********************************************************************/
VOID FAR InitWindowViewAttr(hwnd)
HANDLE       hwnd;
{
  LPCNRINFON   pccinfon;
  LPCNRINFO    pccinfo;

  /*******************************************************************/
  /* Initialize pointers to control data and local variables         */
  /*******************************************************************/
  pccinfon = (LPCNRINFON)GetWindowLong(hwnd,QWL_CONTAINER);
  pccinfo  = PCCINFOXFROMN(pccinfon);

  /*******************************************************************/
  /* There is no combination between CV_TREE and CV_DETAILS          */
  /*******************************************************************/
  if (pccinfo->flWindowAttr & CV_TREE)
  {
    pccinfo->flWindowAttr &= ~(CV_DETAIL | CV_FLOW);
  }

  /*******************************************************************/
  /* If CV_ICON is specified, disregard all others.                  */
  /*******************************************************************/
  if (pccinfo->flWindowAttr & CV_ICON)
  {
    pccinfo->flWindowAttr &= ~(CV_DETAIL | CV_NAME | CV_TEXT | CV_FLOW);
  }
  /*******************************************************************/
  /* If CV_ICON is not specified and CV_NAME is specified,           */
  /* CV_TEXT and CV_DETAIL are disregarded.                          */
  /*******************************************************************/
  else if (pccinfo->flWindowAttr & CV_NAME)
  {
    pccinfo->flWindowAttr &= ~(CV_DETAIL | CV_TEXT);
  }
  /*******************************************************************/
  /* If CV_ICON and CV_NAME are not specified and CV_TEXT is         */
  /* specified,  CV_DETAIL is  disregarded.                          */
  /*******************************************************************/
  else if (pccinfo->flWindowAttr & CV_TEXT)
  {
    pccinfo->flWindowAttr &= ~CV_DETAIL;
  }
  /*******************************************************************/
  /* If CV_ICON, CV_NAME and CV_TEXT are not specified, and CV_DETAIL*/
  /* is specified, ok.  But if none are specified, CV_ICON is default*/
  /*******************************************************************/
  else if (pccinfo->flWindowAttr & CV_DETAIL)
  {
    pccinfo->flWindowAttr &= ~CV_FLOW;
  }
  else
  {
    pccinfo->flWindowAttr |= CV_ICON;
  }
  return;
}

/*********************************************************************/
/*                                               NEW FUNCTION        */
/*  Function Name:  DestroyDVWindows                                 */
/*                                                                   */
/*  Functional Description:                                          */
/*                                                                   */
/*  Notes:                                                           */
/*     Forward Declaration:                                          */
/*                                                                   */
/*  Input:                                                           */
/*                                                                   */
/*  Output:                                                          */
/*                                                                   */
/*  Exit-Normal:                                                     */
/*                                                                   */
/*  Exit-Error:                                                      */
/*                                                                   */
/*  Side Effects:                                                    */
/*                                                                   */
/*********************************************************************/
BOOL FAR DestroyDVWindows(HWND hwnd)
{
  HWND       hwndDestroy;

  if (hwndDestroy = GetDlgItem (hwnd, CID_LEFTDVWND))
  {
    DestroyWindow(hwndDestroy);
  }

  if (hwndDestroy = GetDlgItem (hwnd, CID_RIGHTDVWND))
  {
    DestroyWindow(hwndDestroy);
  }

  if (hwndDestroy = GetDlgItem (hwnd, CID_RIGHTHSCROLL))
  {
    DestroyWindow(hwndDestroy);
  }

  if (hwndDestroy = GetDlgItem (hwnd, CID_LEFTCOLTITLEWND))
  {
    DestroyWindow(hwndDestroy);
  }

  if (hwndDestroy = GetDlgItem (hwnd, CID_RIGHTCOLTITLEWND))
  {
    DestroyWindow(hwndDestroy);
  }
  return(TRUE);
}

/*********************************************************************/
/*                                                NEW FUNCTION       */
/*  Function Name:  CreateDVWindows                                  */
/*                                                                   */
/*  Functional Description:                                          */
/*                                                                   */
/*  Notes:                                                           */
/*     Forward Declaration:                                          */
/*                                                                   */
/*  Input:                                                           */
/*                                                                   */
/*  Output:                                                          */
/*                                                                   */
/*  Exit-Normal:                                                     */
/*                                                                   */
/*  Exit-Error:                                                      */
/*                                                                   */
/*  Side Effects:                                                    */
/*                                                                   */
/*********************************************************************/
BOOL FAR CreateDVWindows(HWND hwnd)
{
  if (!CreateWindow("SCROLLBAR",         /* horizontal scroll bar */
                    NULL,                /* (right)               */
                    SBS_HORZ | WS_VISIBLE | WS_CLIPSIBLINGS | WS_CHILD,
                    0,0,0,0, hwnd,
                    (HMENU)CID_RIGHTHSCROLL,                            /*DAB1*/
                    vhCNRInstance,
                    (LPSTR)NULL) ||                                     /*DAB1*/
      !CreateWindow(WC_LDETAIL,            /* Left Details View Window */
                    NULL,
                    WS_VISIBLE | WS_CLIPSIBLINGS | WS_CHILD,
                    0,0,0,0, hwnd,
                    (HMENU)CID_LEFTDVWND,                               /*DAB1*/
                    vhCNRInstance,
                    (LPSTR)NULL) ||                                     /*DAB1*/
      !CreateWindow(WC_RDETAIL,            /* Right Details View Window */
                    NULL,
                    WS_VISIBLE | WS_CLIPSIBLINGS | WS_CHILD,
                    0,0,0,0, hwnd,
                    (HMENU)CID_RIGHTDVWND,                              /*DAB1*/
                    vhCNRInstance,
                    (LPSTR)NULL) ||                                     /*DAB1*/
      !CreateWindow(WC_LCOLTITLE,         /* Left Details Column   */
                    NULL,                 /* Title Window.         */
                    WS_VISIBLE | WS_CLIPSIBLINGS | WS_CHILD,
                    0,0,0,0, hwnd,
                    (HMENU)CID_LEFTCOLTITLEWND,                         /*DAB1*/
                    vhCNRInstance,
                    (LPSTR)NULL) ||                                     /*DAB1*/
      !CreateWindow(WC_RCOLTITLE,         /* Right Details Column  */
                    NULL,                 /* Title Window.         */
                    WS_VISIBLE | WS_CLIPSIBLINGS | WS_CHILD,
                    0,0,0,0, hwnd,
                    (HMENU)CID_RIGHTCOLTITLEWND,                        /*DAB1*/
                    vhCNRInstance,
                    (LPSTR)NULL))                                       /*DAB1*/
  {
    /********************************************************/
    /* if we can't create all of the children, abort window */
    /* creation  ...                                        */
    /********************************************************/
    return(FALSE);
  }
  return(TRUE);
}

/*********************************************************************/
/*                                                                   */
/*  Function Name:  TRVProcessOpenTree                               */
/*                                                                   */
/*  Usage: External                                                  */
/*                                                                   */
/*  Descriptive Name:   Process For Opening TreeView                 */
/*                                                                   */
/*  Functional Description:                                          */
/*                                                                   */
/*  Notes:                                                           */
/*     Forward Declaration:                                          */
/*                                                                   */
/*  Input:   hwnd    - container control handle                      */
/*                                                                   */
/*  Output:                                                          */
/*                                                                   */
/*  Exit-Normal:                                                     */
/*                                                                   */
/*  Exit-Error:                                                      */
/*                                                                   */
/*  Side Effects:                                                    */
/*                                                                   */
/*********************************************************************/
VOID FAR TRVProcessOpenTree(hwnd)
HANDLE       hwnd;
{
  LPCNRINFON     pccinfon;
  LPRECORDCOREN  preccEnum;

  /*******************************************************************/
  /* Initialize pointers to control data and local variables         */
  /*******************************************************************/
  pccinfon = (LPCNRINFON)GetWindowLong(hwnd,QWL_CONTAINER);

  if (!pccinfon->preccCursor)
  {
    pccinfon->preccCursor = pccinfon->preccItem;
  } /* endif */

  preccEnum = pccinfon->preccItem;

  while (preccEnum)
  {
    if ((preccEnum != pccinfon->preccCursor) &&
        (preccEnum->flRecordAttr & (CRA_SELECTED | CRA_CURSORED)))
    {
      SetEmphasisBits( hwnd, NULL, preccEnum,
                       CRA_CURSORED | CRA_SELECTED, SEB_CLEAR );
    }
    preccEnum = GetNextItem(pccinfon, preccEnum);
  }

  /********************************************************************/
  /* If preccCursor is not selected, select it.                       */
  /********************************************************************/
  if (pccinfon->preccCursor &&
      (!(pccinfon->preccCursor->flRecordAttr & CRA_SELECTED) ||
       !(pccinfon->preccCursor->flRecordAttr & CRA_CURSORED)))
  {
    SetEmphasisBits( hwnd, NULL, pccinfon->preccCursor,
                     CRA_CURSORED | CRA_SELECTED, SEB_SET );
  }
  return;
}


/*********************************************************************/
/*                                                                   */
/*  Function Name:  TRVProcessCloseTree                              */
/*                                                                   */
/*  Usage: External                                                  */
/*                                                                   */
/*  Descriptive Name:   Process For Closing TreeView                 */
/*                                                                   */
/*  Functional Description:                                          */
/*                                                                   */
/*  Notes:                                                           */
/*     Forward Declaration:                                          */
/*                                                                   */
/*  Input:   hwnd    - container control handle                      */
/*                                                                   */
/*  Output:                                                          */
/*                                                                   */
/*  Exit-Normal:                                                     */
/*                                                                   */
/*  Exit-Error:                                                      */
/*                                                                   */
/*  Side Effects:                                                    */
/*                                                                   */
/*********************************************************************/
VOID FAR TRVProcessCloseTree(hwnd)
HANDLE       hwnd;
{
  LPCNRINFON    pccinfon;
  LPRECORDCOREN preccOldCursor;

  /*******************************************************************/
  /* Initialize pointers to control data and local variables         */
  /*******************************************************************/
  pccinfon = (LPCNRINFON)GetWindowLong(hwnd,QWL_CONTAINER);

  /*******************************************************************/
  /* If the preccCursor is not root node, de_cursored it and         */
  /* select and cursor the root node of the preccCurrent.            */
  /*******************************************************************/
  if (pccinfon->preccCursor && pccinfon->preccCursor->preccParent)
  {
    preccOldCursor = pccinfon->preccCursor;
    pccinfon->preccCursor = TRVGetRoot(preccOldCursor);

    SetEmphasisBits( hwnd, NULL, preccOldCursor,
                     CRA_CURSORED | CRA_SELECTED, SEB_CLEAR );

    SetEmphasisBits( hwnd, NULL, pccinfon->preccCursor,
                     CRA_CURSORED | CRA_SELECTED, SEB_SET );
  }
  return;
}

/*********************************************************************/
/*                                                                   */
/*  Function Name:  CnrSort                                          */
/*                                                                   */
/*  Usage: External                                                  */
/*                                                                   */
/*  Descriptive Name:   Sort List                                    */
/*                                                                   */
/*  Functional Description:                                          */
/*     This function sorts a list in item order                      */
/*                                                                   */
/*  Notes:                                                           */
/*                                                                   */
/*                                                                   */
/*                                                                   */
/*  Input:   hwnd    - container control handle                      */
/*                                                                   */
/*  Output:                                                          */
/*                                                                   */
/*                                                                   */
/*                                                                   */
/*  Exit-Normal:                                                     */
/*                                                                   */
/*  Exit-Error:                                                      */
/*                                                                   */
/*  Side Effects:                                                    */
/*                                                                   */
/*********************************************************************/
BOOL FAR  CnrSort(hwnd, mp1, mp2, fPaintRecord)
HANDLE    hwnd;
long      mp1;
long      mp2;
BOOL      fPaintRecord;

{
  LPCNRINFON   pccinfon;
  LPCNRINFO    pccinfo;

  /********************************************************************/
  /* Initialize pointers to control data and local variables          */
  /********************************************************************/
  pccinfon = (LPCNRINFON)GetWindowLong(hwnd,QWL_CONTAINER);
  pccinfo  = PCCINFOXFROMN(pccinfon);

  /********************************************************************/
  /* If more than one record, than sorting is required                */
  /********************************************************************/
  if (pccinfo->cRecords > 0)
  {
    if (!CallQuickSort(hwnd, mp1, mp2, pccinfon->preccItem, TRUE))
    {
      return FALSE;
    }
    pccinfon->ulFlagSet &= ~(FL_CNRPOSITION | FL_SETSCROLL |
                        FL_NEWVIEWSCROLLSET );

    /*****************************************************************/
    /* When change the view, initialize the noniconorigin            */
    /*****************************************************************/
    pccinfon->ptlNonIconOrg.x = pccinfon->ptlNonIconOrg.y = 0;

    /*****************************************************************/
    /* Clean the scroll range and scroll position.                   */
    /*****************************************************************/
    pccinfon->sVscrollPos = pccinfon->sHscrollPos =
    pccinfon->sVscrollMax = pccinfon->sHscrollMax =
    pccinfon->sHscrollMaxRight = 0;

    /*****************************************************************/
    /* Clean the scroll range and scroll position.                   */
    /*****************************************************************/
    pccinfon->preccFirstinNV = pccinfon->preccFirstinFNV =
    pccinfon->preccFirstinTV = pccinfon->preccFirstinFTV =
    pccinfon->preccFirstRowInDV = pccinfon->preccItem;

    /*****************************************************************/
    /* If CCS_AUTOPOSITION is set on, we need rearrange the icons     */
    /* in icon view.                                                 */
    /*****************************************************************/
    if (GetWindowLong( hwnd, GWL_STYLE ) & CCS_AUTOPOSITION)
    {
      pccinfon->ulFlagSet |= FL_NEEDARRANGE;
    } /* endif */

    if (fPaintRecord)
    {
      if (pccinfo->flWindowAttr & CV_DETAIL)
      {
         InvalidateContainer (hwnd, FALSE, NULL);
      }
      else
      {
        /****************************************************************/
        /* Invalidate whole window if the current view is not  icon     */
        /* view and the window style is not CCS_AUTOPOSITION            */
        /****************************************************************/
        if (!(!(pccinfo->flWindowAttr & CV_TREE) &&
           (pccinfo->flWindowAttr & CV_ICON ) &&
           !(GetWindowLong( hwnd, GWL_STYLE ) & CCS_AUTOPOSITION)))
        {
          PMInvalidateRect(hwnd, NULL, TRUE);
        }
      }
    }

    return TRUE;
  }
  else
  {
    /******************************************************************/
    /* If the number of the items is less than 2, then already sorted */
    /******************************************************************/
    return (TRUE);
  } /* endif */
}

/*********************************************************************/
/* FUNCTION NAME:  ProcessChangeLineSpace                            */
/*                                                                   */
/*  Usage: External                                                  */
/*                                                                   */
/* DESCRIPTIVE NAME:  Reposition and Repaint For Chaning LineSpace   */
/*                                                                   */
/* FUNCTIONAL DESCRIPTION:  This function repositions and repaints   */
/*   after the application changes the space between tow rows        */
/*   (cyLineSpacing).                                                */
/*                                                                   */
/* NOTES:                                                            */
/*    FORWARD DECLARATION:                                           */
/*                                                                   */
/* INPUT:  HANDLE hwnd - handle to the container window              */
/*                                                                   */
/* OUTPUT:                                                           */
/*                                                                   */
/*                                                                   */
/* EXIT-NORMAL:                                                      */
/*                                                                   */
/* EXIT-ERROR:                                                       */
/*                                                                   */
/* SIDE EFFECTS:                                                     */
/*********************************************************************/
BOOL FAR ProcessChangeLineSpace(hwnd)
HANDLE    hwnd;
{
  LPCNRINFON   pccinfon;
  LPCNRINFO    pccinfo;

  /*******************************************************************/
  /* Initialize pointers to control data and local variables         */
  /*******************************************************************/
  pccinfon = (LPCNRINFON)GetWindowLong(hwnd,QWL_CONTAINER);
  pccinfo  = PCCINFOXFROMN(pccinfon);

  /*******************************************************************/
  /* If CCS_AUTOPOSITION is set on, we need rearrange the icons      */
  /* in icon view.                                                   */
  /*******************************************************************/
  if (GetWindowLong( hwnd, GWL_STYLE ) & CCS_AUTOPOSITION)
  {
    pccinfon->ulFlagSet |= FL_NEEDARRANGE;
  } /* endif */

  if (!(pccinfo->flWindowAttr & CV_ICON))
  {
    /*****************************************************************/
    /* Set flag for the repositioning off to                         */
    /* reposition the items in the container(only for the name view  */
    /* and text view.)                                               */
    /* New view scroll bar is not set.                               */
    /*****************************************************************/
    pccinfon->ulFlagSet &= ~( FL_CNRPOSITION | FL_SETSCROLL |
                         FL_NEWVIEWSCROLLSET );
    return TRUE;
  } else {
    return FALSE;
  } /* endif */
}


/*********************************************************************/
/* FUNCTION NAME:  ProcessChangePSortRecord                          */
/*                                                                   */
/*  Usage: External                                                  */
/*                                                                   */
/* DESCRIPTIVE NAME:  Sort List and Repaint For Chaning pSortRecord  */
/*                                                                   */
/* FUNCTIONAL DESCRIPTION:  This function sorts, repositions and     */
/*   repaint after changing pSortRecord.                             */
/*                                                                   */
/* NOTES:                                                            */
/*    FORWARD DECLARATION:                                           */
/*                                                                   */
/* INPUT:  HANDLE hwnd - handle to the container window              */
/*                                                                   */
/* OUTPUT:                                                           */
/*                                                                   */
/*                                                                   */
/* EXIT-NORMAL:                                                      */
/*                                                                   */
/* EXIT-ERROR:                                                       */
/*                                                                   */
/* SIDE EFFECTS:                                                     */
/*********************************************************************/
BOOL FAR ProcessChangePSortRecord(hwnd)
HANDLE    hwnd;
{
  LPCNRINFON   pccinfon;
  LPCNRINFO    pccinfo;

  /*******************************************************************/
  /* Initialize pointers to control data and local variables         */
  /*******************************************************************/
  pccinfon = (LPCNRINFON)GetWindowLong(hwnd,QWL_CONTAINER);
  pccinfo  = PCCINFOXFROMN(pccinfon);

  if (pccinfo->pSortRecord)
  {
    if (pccinfo->cRecords > 0)
    {
      /***************************************************************/
      /* Sort the item order list                                    */
      /***************************************************************/
      if (!CallQuickSort(hwnd, (long)(pccinfo->pSortRecord),
                         0, pccinfon->preccItem, TRUE))                 /*DAB1*/
      {
        return FALSE;
      }
      pccinfon->ulFlagSet &= ~(FL_CNRPOSITION | FL_SETSCROLL |
                          FL_NEWVIEWSCROLLSET );

      /***************************************************************/
      /* Clean the scroll range and scroll position.                 */
      /***************************************************************/
      pccinfon->preccFirstinNV = pccinfon->preccFirstinFNV =
      pccinfon->preccFirstinTV = pccinfon->preccFirstinFTV =
      pccinfon->preccFirstRowInDV = pccinfon->preccItem;

      /***************************************************************/
      /* If CCS_AUTOPOSITION is set on, we need rearrange the icons  */
      /* in icon view.                                               */
      /***************************************************************/
      if (GetWindowLong( hwnd, GWL_STYLE ) & CCS_AUTOPOSITION)
      {
        pccinfon->ulFlagSet |= FL_NEEDARRANGE;
      } /* endif */

      return TRUE;
    }
    else
    {
      return FALSE;
    }
  }
  else
  {
    return TRUE;
  }
}

/*********************************************************************/
/* FUNCTION NAME:  ProcessChangeOrigin                               */
/*                                                                   */
/*  Usage: External                                                  */
/*                                                                   */
/* DESCRIPTIVE NAME:  Update Workplace After Changing ptlOrigin      */
/*                                                                   */
/* FUNCTIONAL DESCRIPTION:  This function updates the workplace      */
/*   after the application changes ptlOrigin if necessary and if     */
/*   it is in the icon view sets the scroll bar.                     */
/*                                                                   */
/* NOTES:                                                            */
/*    FORWARD DECLARATION:                                           */
/*                                                                   */
/* INPUT:  HANDLE hwnd - handle to the container window              */
/*                                                                   */
/* OUTPUT:                                                           */
/*                                                                   */
/*                                                                   */
/* EXIT-NORMAL:                                                      */
/*                                                                   */
/* EXIT-ERROR:                                                       */
/*                                                                   */
/* SIDE EFFECTS:                                                     */
/*********************************************************************/
VOID FAR ProcessChangeOrigin(hwnd)
HANDLE    hwnd;
{
  LPCNRINFON   pccinfon;
  LPCNRINFO    pccinfo;
  RECT        rctlViewport;
  RECT        rctlHscroll;
  RECT        rctlTitle;

  /*******************************************************************/
  /* Initialize pointers to control data and local variables         */
  /*******************************************************************/
  pccinfon = (LPCNRINFON)GetWindowLong(hwnd,QWL_CONTAINER);
  pccinfo  = PCCINFOXFROMN(pccinfon);

  /*******************************************************************/
  /* Calculate the rectangles of the viewport and H scroll bar       */
  /*******************************************************************/
  CnrQuerySizeRect(hwnd, NULL, &rctlTitle, &rctlViewport,
                   NULL, &rctlHscroll);

  if (pccinfon->rctlWorkplace.right < pccinfo->ptlOrigin.x )
  {
    pccinfon->rctlWorkplace.right = pccinfo->ptlOrigin.x;
  } /* endif */

  if (pccinfon->rctlWorkplace.top >
      (pccinfo->ptlOrigin.y + rctlTitle.bottom))
  {
    pccinfon->rctlWorkplace.top = pccinfo->ptlOrigin.y +
                                  rctlTitle.bottom;
  } /* endif */

  if (pccinfon->rctlWorkplace.left > pccinfo->ptlOrigin.x )
  {
    pccinfon->rctlWorkplace.left = pccinfo->ptlOrigin.x;
  } /* endif */

  if (pccinfon->rctlWorkplace.bottom <
      (pccinfo->ptlOrigin.y + rctlTitle.bottom))
  {
    pccinfon->rctlWorkplace.bottom = pccinfo->ptlOrigin.y +
                                     rctlTitle.bottom;
  }

  if (pccinfo->flWindowAttr & CV_ICON)
  {
    pccinfon->ulFlagSet &= ~FL_SETSCROLL;
  } /* endif */

  return;
}

/**********************************************************************/
/*                                                                    */
/*  Function Name:     CnrSize                                        */
/*                                                                    */
/*  Descriptive Name:                                                 */
/*                                                                    */
/*  Functional Description:                                           */
/*                                                                    */
/*  Notes:                                                            */
/*     Forward Declaration:  long CnrSize(                            */
/*                               HANDLE       hwnd                    */
/*                               )                                    */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*  Input:   hwnd    - container control handle                       */
/*                                                                    */
/*  Output:                                                           */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*  Exit-Normal:   FALSE                                              */
/*                                                                    */
/*  Exit-Error:    TRUE                                               */
/*                                                                    */
/*  Side Effects:  None                                               */
/*     xtai                                                           */
/**********************************************************************/
VOID FAR CnrSize( HANDLE hwnd, UINT cxNew, UINT cyNew )                 /*DAB1*/
{
#define NEED_H          0x0001
#define NEED_HwithV     0x0002
#define NEED_V          0x0004
#define NEED_VwithH     0x0008

  int          sNeed = 0;
  int          cxScroll, cyScroll;
  LPCNRINFON    pccinfon;
  LPCNRINFO     pccinfo;
  LPRECORDCOREN preccTemp;
  WORD         usLongestLine;
  RECT         rctlCnr;
  RECT         rctlLTitle;
  RECT         ColTitleRect;
  POINT        iconSize;
  int          cxBorder;
  int          cxSizeBorder;
  WORD         LeftWndWidth;
  WORD         leftScrollWidth;

  /*******************************************************************/
  /* Get pointer to Container internal data and user defined data.   */
  /*******************************************************************/
  pccinfon = (LPCNRINFON)GetWindowLong(hwnd,QWL_CONTAINER);
  pccinfo  = PCCINFOXFROMN(pccinfon);

  cxBorder     = (int)GetSystemMetrics ( SM_CXBORDER);
  cxSizeBorder = (int)GetSystemMetrics ( SM_CXFRAME);

  PMGetClientRect(hwnd, &rctlCnr);

  CnrQueryTitleRect (hwnd, &rctlLTitle, NULL);

  /*******************************************************************/
  /* Set icon dimensions.                                            */
  /*******************************************************************/
  CnrCalcIconSize (hwnd, &iconSize);

  cxScroll = (int) GetSystemMetrics( SM_CXVSCROLL);
  cyScroll = (int) GetSystemMetrics( SM_CYHSCROLL);

  usLongestLine = 0;
  if (pccinfon->preccItem)
  {
    preccTemp = pccinfon->preccItem;

    while (preccTemp && !ISRECORDVISIBLE(preccTemp))
    {
      preccTemp = preccTemp->preccNextItem;
    }

    if (preccTemp)
    {
      /***************************************************************/
      /* The longest line in the column is the rightmost point of an */
      /* item plus lAveCharWidth for the left margin.                */
      /***************************************************************/
      if (pccinfo->flWindowAttr & CV_NAME)
      {
        usLongestLine = (WORD)(preccTemp->usLongestLine +
                       3 * pccinfon->lAveCharWidth + iconSize.x);
      }
      else
      {
        usLongestLine = (WORD)(preccTemp->usLongestLine +
                                 2 * pccinfon->lAveCharWidth);
      }
    }
  }

  if (!(pccinfo->flWindowAttr & CV_DETAIL))
  {
    if (pccinfo->flWindowAttr & CV_TREE)
    {
      int   cyResized;

      cyResized = pccinfon->ptlNonIconOrg.y + pccinfon->sVscrollPos *
                  pccinfon->sVscrollFactor;

      if (pccinfon->yTreeBottom >
          (rctlCnr.bottom - cyScroll - cyResized))
      {
        sNeed |= NEED_VwithH;
      }

      if (pccinfon->yTreeBottom >
          (rctlCnr.bottom - cyResized))
      {
        sNeed |= NEED_V;
      }

      if (pccinfon->xTreeRight > (rctlCnr.right - cxScroll))
      {
        sNeed |= NEED_HwithV;
      } /* endif */

      if (pccinfon->xTreeRight > rctlCnr.right)
      {
        sNeed |= NEED_H;
      } /* endif */

      if ((sNeed & NEED_H) && (sNeed & NEED_VwithH) &&
          !(sNeed & NEED_V))
      {
        sNeed |= NEED_V;
      }

      if ((sNeed & NEED_V) && (sNeed & NEED_HwithV) &&
          !(sNeed & NEED_H))
      {
        sNeed |= NEED_H;
      }
    }
    else if (pccinfo->flWindowAttr & CV_ICON)
    {
      if ((pccinfon->rctlWorkplace.top <
           (rctlCnr.top + rctlLTitle.bottom + pccinfo->ptlOrigin.y)) ||
          (pccinfon->rctlWorkplace.bottom >
           (rctlCnr.bottom + cyScroll + pccinfo->ptlOrigin.y)))
      {
        sNeed |= NEED_VwithH;
      }

      if ((pccinfon->rctlWorkplace.top <
           (rctlCnr.top + rctlLTitle.bottom + pccinfo->ptlOrigin.y)) ||
          (pccinfon->rctlWorkplace.bottom >
           (rctlCnr.bottom + pccinfo->ptlOrigin.y)))
      {
        sNeed |= NEED_V;
      }

      if ((pccinfon->rctlWorkplace.left <
           (rctlCnr.left + pccinfo->ptlOrigin.x)) ||
          (pccinfon->rctlWorkplace.right >
           (rctlCnr.right - cxScroll + pccinfo->ptlOrigin.x)) )
      {
        sNeed |= NEED_HwithV;
      }

      if ((pccinfon->rctlWorkplace.left <
           (rctlCnr.left + pccinfo->ptlOrigin.x)) ||
          (pccinfon->rctlWorkplace.right >
           (rctlCnr.right + pccinfo->ptlOrigin.x)) )
      {
        sNeed |= NEED_H;
      }

      if ((sNeed & NEED_H) && (sNeed & NEED_VwithH) && !(sNeed & NEED_V))
      {
        sNeed |= NEED_V;
      }

      if ((sNeed & NEED_V) && (sNeed & NEED_HwithV) && !(sNeed & NEED_H))
      {
        sNeed |= NEED_H;
      }
    }

    /******************************************************************/
    /* If current view is iconview, or it is non-flowed view and      */
    /* longest line is longer than the cx of the client area, or      */
    /* it is flowed view and maximum height of the items + upper      */
    /* margin (lAveCharWidth )  is larger  the height of the client   */
    /* area, we need both V and H scroll bars                         */
    /******************************************************************/
    if (((sNeed & NEED_V) && (sNeed & NEED_H)) ||
        (!(pccinfo->flWindowAttr & CV_FLOW) &&
          ( usLongestLine > ((WORD)rctlCnr.right - cxScroll))) ||
        ((pccinfo->flWindowAttr & CV_FLOW) &&
         ((rctlCnr.bottom - rctlLTitle.bottom - cyScroll) <
           pccinfon->lMaxHeight + pccinfon->lAveCharWidth)))
    {
      /****************************************************************/
      /* Set the V scroll bar on the right edge                       */
      /****************************************************************/
      MoveWindow (GetDlgItem(hwnd, CID_VSCROLL),
                  cxNew - cxScroll, rctlLTitle.bottom,
                  cxScroll, cyNew - cyScroll - rctlLTitle.bottom + 1,
                  TRUE);

      /****************************************************************/
      /* Set the H scroll bar                                         */
      /****************************************************************/
      MoveWindow (GetDlgItem(hwnd,CID_HSCROLL),
                  0, rctlCnr.bottom - cyScroll, cxNew - cxScroll + 1,
                  cyScroll, TRUE);

      /****************************************************************/
      /* Set the blank box below the vertical scroll bar              */
      /****************************************************************/
      MoveWindow (GetDlgItem(hwnd,CID_BLANKBOX),
                  cxNew - cxScroll, rctlCnr.bottom - cyScroll, cxScroll,
                  cyScroll, TRUE);
    }
    else
    {
      /**************************************************************/
      /* Non-flowed text/ name view needs vertical scroll bar       */
      /*     -  or this is tree view which needs a VSCROLL bar      */
      /**************************************************************/
      if ((!(pccinfo->flWindowAttr & CV_TREE) &&
           (pccinfo->flWindowAttr & (CV_NAME | CV_TEXT)) &&
           !(pccinfo->flWindowAttr & CV_FLOW)) || (sNeed & NEED_V) )
      {
        /************************************************************/
        /* Set the V scroll bar on the right edge                   */
        /************************************************************/
        MoveWindow (GetDlgItem(hwnd, CID_VSCROLL),
                    cxNew - cxScroll, rctlLTitle.bottom, cxScroll,
                    cyNew - rctlLTitle.bottom + 1, TRUE);

        /************************************************************/
        /* Set the H scroll bar (not to show)                       */
        /************************************************************/
#ifdef IC_WU
	SetWindowPos (GetDlgItem(hwnd,CID_HSCROLL),
		        NULL,
			0, 0, 0, 0, SWP_NOZORDER);		/*RKK1*/
#else
        MoveWindow (GetDlgItem(hwnd,CID_HSCROLL),
                    0, 0, 0, 0, TRUE);
#endif
        /************************************************************/
        /* Set the blank box (not to show )                         */
        /************************************************************/
#ifdef IC_WU
	SetWindowPos (GetDlgItem(hwnd,CID_BLANKBOX),
			NULL,
			0, 0, 0, 0, SWP_NOZORDER);		/*RKK1*/
#else
        MoveWindow (GetDlgItem(hwnd,CID_BLANKBOX),
                    0, 0, 0, 0, TRUE);
#endif
      }
      else
      {
        /**************************************************************/
        /* Flowed text/name view needs H scroll bar                   */
        /**************************************************************/
        if ((!(pccinfo->flWindowAttr & CV_TREE) &&
             (pccinfo->flWindowAttr & (CV_NAME | CV_TEXT)) &&
             (pccinfo->flWindowAttr & CV_FLOW)) || (sNeed & NEED_H))
        {
          /************************************************************/
          /* Set the V scroll bar (not to show)                       */
          /************************************************************/
#ifdef IC_WU
	  SetWindowPos (GetDlgItem(hwnd, CID_VSCROLL),
			  NULL, 0, 0, 0, 0, SWP_NOZORDER );	/*RKK1*/
#else
          MoveWindow (GetDlgItem(hwnd, CID_VSCROLL), 0, 0, 0, 0, TRUE);
#endif
          /************************************************************/
          /* Set the H scroll bar                                     */
          /************************************************************/
          MoveWindow (GetDlgItem(hwnd,CID_HSCROLL), 0,
                      rctlCnr.bottom - cyScroll,
                      cxNew, cyScroll, TRUE);

          /************************************************************/
          /* Set the blank box (not to show)                          */
          /************************************************************/
#ifdef IC_WU
	  SetWindowPos (GetDlgItem(hwnd,CID_BLANKBOX),
			  NULL, 0, 0, 0, 0, SWP_NOZORDER );	/*RKK1*/
#else
          MoveWindow (GetDlgItem(hwnd,CID_BLANKBOX), 0, 0, 0, 0, TRUE);
#endif
        }
        else
        {
          /************************************************************/
          /* No scroll bar is shown                                   */
          /************************************************************/
#ifdef IC_WU
	  SetWindowPos (GetDlgItem(hwnd, CID_VSCROLL),
			  NULL, 0, 0, 0, 0, SWP_NOZORDER );	/*RKK1*/
#else
          MoveWindow (GetDlgItem(hwnd, CID_VSCROLL), 0, 0, 0, 0, TRUE);
#endif
          /************************************************************/
          /* Set the H scroll bar                                     */
          /************************************************************/
#ifdef IC_WU
	  SetWindowPos (GetDlgItem(hwnd,CID_HSCROLL),
			  NULL, 0, 0, 0, 0, SWP_NOZORDER );	/*RKK1*/
#else
          MoveWindow (GetDlgItem(hwnd,CID_HSCROLL), 0, 0, 0, 0, TRUE);
#endif
          /************************************************************/
          /* Set the blank box (not to show)                          */
          /************************************************************/
#ifdef IC_WU
	  SetWindowPos (GetDlgItem(hwnd,CID_BLANKBOX),
			  NULL, 0, 0, 0, 0, SWP_NOZORDER );	/*RKK1*/
#else
          MoveWindow (GetDlgItem(hwnd,CID_BLANKBOX), 0, 0, 0, 0, TRUE);
#endif
        }
      } /* endif */
    }
  }
  else
  {
    /***************************************************************/
    /* We are in Details View, so set the new size of the windows. */
    /***************************************************************/
    CnrQueryColumnTitleWndRect (hwnd, TRUE, &ColTitleRect);

    /***************************************************************/
    /* If the application wants a split bar, ok.  Otherwise they   */
    /* don't and they want all of there data in one window. No     */
    /* problem.                                                    */
    /***************************************************************/
    leftScrollWidth = cxNew - cxScroll;
    if (!(pccinfon->ulFlagSet & FL_UNSPLIT))
    {
       LeftWndWidth = pccinfo->xVertSplitbar;
       if (LeftWndWidth < (cxNew - cxScroll))
          leftScrollWidth = LeftWndWidth;
    }
    else
    {
       LeftWndWidth = cxNew - cxScroll;
    }

    /***************************************************************/
    /* Set the size and positon of the left window.                */
    /***************************************************************/
    MoveWindow (GetDlgItem(hwnd, CID_LEFTDVWND),
                0,
                rctlLTitle.bottom + ColTitleRect.bottom,
                LeftWndWidth,
                cyNew - rctlLTitle.bottom - cyScroll - ColTitleRect.bottom,
                TRUE);

    /***************************************************************/
    /* Set the size and position of the horizontal scroll bar in   */
    /* the left window.                                            */
    /***************************************************************/
    MoveWindow (GetDlgItem(hwnd,CID_HSCROLL), 0,
                rctlCnr.bottom - cyScroll,
                leftScrollWidth,
                cyScroll,
                TRUE);

    /***************************************************************/
    /* Check to see if the Details View is split into 2 windows.   */
    /* If so, set up the right viewport, with its scrollbar.       */
    /***************************************************************/
    if (!(pccinfon->ulFlagSet & FL_UNSPLIT))
    {
       /************************************************************/
       /* Set the size and position of the right window.           */
       /************************************************************/
       MoveWindow (GetDlgItem(hwnd, CID_RIGHTDVWND),
                LeftWndWidth + cxSizeBorder,
                rctlLTitle.bottom + ColTitleRect.bottom,
                cxNew - LeftWndWidth - cxSizeBorder - cxScroll,
                cyNew - rctlLTitle.bottom - cyScroll - ColTitleRect.bottom,
                TRUE);

       /************************************************************/
       /* Set the size and position of the horizontal scrollbar in */
       /* the right window.                                        */
       /************************************************************/
       MoveWindow (GetDlgItem (hwnd, CID_RIGHTHSCROLL),
                        LeftWndWidth + cxSizeBorder,
                        rctlCnr.bottom - cyScroll,
                        cxNew - LeftWndWidth - cxSizeBorder - cxScroll,
                        cyScroll, TRUE);
    }
    else
    {
#ifdef IC_WU
       SetWindowPos (GetDlgItem (hwnd, CID_RIGHTDVWND),
			NULL, 0, 0, 0, 0, SWP_NOZORDER );	/*RKK1*/

       SetWindowPos (GetDlgItem (hwnd, CID_RIGHTHSCROLL),
			NULL, 0, 0, 0, 0, SWP_NOZORDER );	/*RKK1*/
#else
       MoveWindow (GetDlgItem (hwnd, CID_RIGHTDVWND),
                   0, 0, 0, 0, TRUE);

       MoveWindow (GetDlgItem (hwnd, CID_RIGHTHSCROLL),
                   0, 0, 0, 0, TRUE);
#endif
    }
    /***************************************************************/
    /* Set the size and position of the Vertical scrollbar.        */
    /***************************************************************/
    MoveWindow (GetDlgItem(hwnd, CID_VSCROLL),
                cxNew - cxScroll, rctlLTitle.bottom + ColTitleRect.bottom,
                cxScroll,
                cyNew - rctlLTitle.bottom - cyScroll - ColTitleRect.bottom,
                TRUE);

    /***************************************************************/
    /* Set the size and position of the blank box below the        */
    /* vertical scroll bar.                                        */
    /***************************************************************/
    MoveWindow (GetDlgItem(hwnd,CID_BLANKBOX),
                cxNew - cxScroll, rctlCnr.bottom - cyScroll, cxScroll,
                cyScroll, TRUE);
  }
  return;
}

/**********************************************************************/
/*                                                                    */
/*  Function Name:     CnrFreeAll                                     */
/*                                                                    */
/*  Descriptive Name:  Free all of the records in the container.      */
/*                                                                    */
/*  Functional Description:                                           */
/*                                                                    */
/*  This routine will free all of the records currently allocated     */
/*  from memory.  This routine is only called internally by us, and   */
/*  never by the application.  The freeing of memory is done through  */
/*  the use of a common Storage Manager.                              */
/*                                                                    */
/*  Input:  NONE                                                      */
/*                                                                    */
/*  Output:  TRUE  - The Records were freed successfully.             */
/*           FALSE - An error occured while freeing at least one of   */
/*                   the records.                                     */
/*                                                                    */
/*  Exit-Normal:  TRUE is returned.                                   */
/*                                                                    */
/*  Exit-Error:   FALSE is returned with WinSetErrorInfo message      */
/*                specified - PMERR_MEMORY_DEALLOCATION_ERR           */
/*                            PMERR_RECORD_CURRENTLY_INSERTED         */
/*                                                                    */
/*  Side Effects:  None                                               */
/*                                                                    */
/**********************************************************************/
BOOL FAR CnrFreeAll (hwnd, flRecords)

HANDLE  hwnd;
BOOL  flRecords;

{
  LPFIELDINFO    pFieldInfo;      /* Pointer to FieldInfo structure.    */
  LPFIELDINFO    pNextFI;         /* Pointer to FieldInfo structure.    */
  LPCNRINFON     pccinfon;        /* Pointer to internal CNR control    */
                                 /* data.                              */
//LPVOID         pSatPtr;         /* Pointer to Storage Space.          */
  BOOL          flReturn = TRUE;

  /*******************************************************************/
  /* Get the pointer to the internal control data.                   */
  /*******************************************************************/
  pccinfon = (LPCNRINFON)GetWindowLong (hwnd, QWL_CONTAINER);

  /*******************************************************************/
  /* Get the pointer to the storage space.                           */
  /*******************************************************************/
//pSatPtr = (LPVOID)GetWindowLong (hwnd, QWL_STORAGEPTR);

  /*******************************************************************/
  /* If FreeRecords is True, then we free all the records in the     */
  /* container.  Otherwise, we free all of the Detail FieldInfo      */
  /* structures.                                                     */
  /*******************************************************************/
  if (flRecords)
  {
    if (pccinfon->preccItem)
    {
      pccinfon->preccFreeFirst = NULL;
      pccinfon->preccFreeLast  = NULL;
      RemoveChildrenRecordN (hwnd, pccinfon->preccItem, CMA_FREE);
      FreeRecords (hwnd);
    }

    /******************************************************************/
    /* Reset Container Instance data.                                 */
    /******************************************************************/
    CnrResetInstanceData (hwnd);
  }
  /*******************************************************************/
  /* If we get here, we know we want to Free all of the Detail       */
  /* FieldInfo structures in the Container.                          */
  /*******************************************************************/
  else
  {
    pFieldInfo = pccinfon->pFirstFI;

    while (pFieldInfo)
    {
      pNextFI = PFINFROMX(pFieldInfo)->pNextFieldInfo;

//    if (!(StmFreeStorage (pSatPtr, (LPVOID)(PFINFROMX(pFieldInfo)))))
      if (GlobalFree( (LPVOID)(PFINFROMX(pFieldInfo))))                 /*DAB1*/
      {
        SETERROR (PMERR_MEMORY_DEALLOCATION_ERR);
        flReturn = FALSE;
      }
      pFieldInfo = pNextFI;
    }
  }

  return (flReturn);
}

/**********************************************************************/
/*                                                                    */
/*  Function Name:  CnrRemoveAllInternal                              */
/*                                                                    */
/*  Description:    Removes the internal record structure for all     */
/*                  of the currently inserted records.                */
/*                                                                    */
/*  Input:          hwndCnr  - container window handle                */
/*                                                                    */
/*  Output:         void                                              */
/*                                                                    */
/*  Programmer: Peter Haggar and Tai Woo Nam                          */
/**********************************************************************/
VOID FAR CnrRemoveAllInternal (hwndCnr)

HANDLE  hwndCnr;
{
  LPCNRINFON     pccinfon;        /* Ptr to internal CNR control data  */

  /*******************************************************************/
  /* Get the pointer to the internal control data.                   */
  /*******************************************************************/
  pccinfon = (LPCNRINFON)GetWindowLong (hwndCnr, QWL_CONTAINER);

  /********************************************************************/
  /* Remove all of the internal records from all of the records       */
  /* currently inserted into the container.                           */
  /********************************************************************/
  if (pccinfon->preccItem)
  {
    RemoveChildrenRecordN (hwndCnr, pccinfon->preccItem, 0);
  }

  /******************************************************************/
  /* Reset Container Instance data.                                 */
  /******************************************************************/
  CnrResetInstanceData (hwndCnr);

  return;
}

/**********************************************************************/
/*                                                                    */
/*  Function Name:     CnrFreeRecord                                  */
/*                                                                    */
/*  Descriptive Name:  Free a record or a list of records.            */
/*                                                                    */
/*  Functional Description:                                           */
/*                                                                    */
/*  This routine will free records from memory.  Individual records   */
/*  may be freed, or a list of records may be freed.                  */
/*  The freeing is accomplished through a common Storage Manager.     */
/*                                                                    */
/*  Input:  hwnd   - Handle to the Container window.                  */
/*          mp1    - Pointer to an array of pointers to               */
/*                   RECORDCORE structures to be freed.               */
/*          mp2    - The number of records to be freed.               */
/*          Verify - Flag to specify if we should verify              */
/*                   whether the pointers to be freed are             */
/*                   currently being used.                            */
/*                                                                    */
/*  Output:  TRUE  - The Records were freed successfully.             */
/*           FALSE - An error occured while freeing at least one of   */
/*                   the records.                                     */
/*                                                                    */
/*  Exit-Normal:  TRUE is returned.                                   */
/*                                                                    */
/*  Exit-Error:   FALSE is returned with WinSetErrorInfo message      */
/*                specified - PMERR_MEMORY_DEALLOCATION_ERR           */
/*                            PMERR_RECORD_CURRENTLY_INSERTED         */
/*                                                                    */
/*  Side Effects:  None                                               */
/*                                                                    */
/**********************************************************************/
BOOL FAR CnrFreeRecord (hwnd, mp1, mp2, Verify)

HANDLE hwnd;                    /* Handle of Container window         */
long   mp1;                     /* Pointer to array of pointers to    */
                                /* RECORDCORE structures to be freed. */
long   mp2;                     /* Number of records to be freed      */
BOOL   Verify;                  /* Flag to check for in-use records   */

{
 DWORD         i;               /* Array index                        */
 BOOL          Used;            /* Flag to determine if record is     */
                                /* being used.                        */
 WORD        NumRecords;        /* The number of records to be freed. */
 LPRECORDCORE  FAR *pRecordArray;/* Pointer to an array of pointers to */
                                /* RECORDCORE structures to be freed. */
//LPVOID         pSatPtr;        /* Pointer to Storage Space.          */
 Used  = FALSE;                 /* Assume the record pointed to has   */
                                /* been previously removed.           */

 pRecordArray = (LPVOID)mp1;
 NumRecords   = LOWORD(mp2);

 /*********************************************************************/
 /* Get the pointer to the storage space.                             */
 /*********************************************************************/
//pSatPtr = (LPVOID)GetWindowLong (hwnd, QWL_STORAGEPTR);

 /*********************************************************************/
 /* Validate the parameters passed into this routine.  If either is   */
 /* bad, flag error and return.                                       */
 /*********************************************************************/
 if ((NumRecords < 1) || (!pRecordArray))
 {
    SETERROR (PMERR_INVALID_PARAMETERS);
    return (FALSE);                                                     /*DAB1*/
 }

 for (i=0; i < NumRecords; i++)
 {
    /******************************************************************/
    /* First check to see if the record that is to be freed is still  */
    /* inserted in any other containers.  To do this we check to see  */
    /* if the pointer to the internal blocks is valid.  If it is it   */
    /* means that the app is trying to free a record that is          */
    /* currently inserted into another container.....can't do that.   */
    /******************************************************************/
    if (PRECCFIRSTNFROMX(pRecordArray[i]))
    {
      SETERROR (PMERR_RECORD_CURRENTLY_INSERTED);
      return (FALSE);                                                   /*DAB1*/
    }

    /******************************************************************/
    /* Check to see if we need to verify if the pointer is being used */
    /* or not.  If so, check it, and if it is not being used, attempt */
    /* to free it.  If it is being used, flag an error and continue.  */
    /* If we free the memory successfully, set the application's      */
    /* pointer to NULL.                                               */
    /******************************************************************/
    if (Verify)
    {
       /***************************************************************/
       /* If the entry in the array is NULL, return error.            */
       /***************************************************************/
       if (!(*(pRecordArray + i)))
       {
         SETERROR (PMERR_INVALID_PARAMETERS);
         return (FALSE);                                                /*DAB1*/
       }

       Used = CnrVerifyPointers (hwnd, pRecordArray + i, (DWORD)1);
    }

    if (!Used)
    {
       /***************************************************************/
       /* Free the record and flag any errors.  Note that we back up  */
       /* the pointer by 4 bytes to free the memory that we allocated.*/
       /***************************************************************/
//     if (!StmFreeStorage (pSatPtr,
//                          LPVOIDFROMPRECCX(*(pRecordArray + i))))
       if (GlobalFree( LPVOIDFROMPRECCX(*(pRecordArray + i))))          /*DAB1*/
       {
          SETERROR (PMERR_MEMORY_DEALLOCATION_ERR);
          return (FALSE);                                               /*DAB1*/
       }
    }
    else
    {
      /**************************************************************/
      /* The record is still in the list, so the memory cannot be   */
      /* freed.                                                     */
      /**************************************************************/
      SETERROR (PMERR_RECORD_CURRENTLY_INSERTED);
      return (FALSE);                                                   /*DAB1*/
    }
 }

 /*********************************************************************/
 /* If there were no errors, return the good news.                    */
 /*********************************************************************/
 return (TRUE);
}
