/* Revision: 30 1.2.2.3 source/ui/cclnt/cslider/cslider.c, cclcslid, ioc.v400, 000919  */
/****************************************************************************/
/*                                                                          */
/*                         IBM CONFIDENTIAL                                 */
/*                                                                          */
/*        (IBM Confidential-Restricted when combined with the               */
/*         aggregated OCO source modules for this program)                  */
/*                                                                          */
/*                       OCO SOURCE MATERIALS                               */
/*                                                                          */
/*         20G0400 (C) Copyright IBM Corp. 1992, 1997 (Unpublished)         */
/*                                                                          */
/****************************************************************************/
/**********************************************************************/
/*                                                                    */
/*                  C I R C U L A R   S L I D E R                     */
/*                                                                    */
/*                        Filename: CSLIDER.C                         */
/*                                                                    */
/*              ( Windows NT Slider Control Component )               */
/*                                                                    */
/*                         IBM CONFIDENTIAL                           */
/*                                                                    */
/*                (C) Copyright IBM Corporation 1997                  */
/*                       All Rights Reserved                          */
/*            Licensed Material - Program Property of IBM             */
/*                                                                    */
/**********************************************************************/
/******************************************************************************/
/* Filename: CSLIDER.C - Circular Slider class registration procedure         */
/*                                                                            */
/* Flag    Date    Defect  Description                                        */
/* ----  --------  -----  --------------------------------------------------- */
/* MAB2  01/23/96  6714   Initialization of cppwot3.dll failing sporatically. */
/******************************************************************************/
#include <windows.h>
#include "iclcsldw.h"
#include "dial.h"
// Segment definitions
#ifdef IC_PAGETUNE
  #define _CSLIDER_C_
  #include "icltune.h"
#endif

HANDLE hCircularSliderInstance=0;
extern HDC hpsMem;

#if !defined(CCL_SEPARATE_DLL)
#define LibMain CircularSliderLibMain
#endif

INT APIENTRY LibMain( HANDLE hInstance, DWORD ul_reason_being_called,
                      LPVOID lpReserved );

#if defined(CCL_SEPARATE_DLL)

#if defined(__IBMC__)

/* _CRT_init is the C run-time environment initialization function.         */
/* It will return 0 to indicate success and -1 to indicate failure.         */
int _CRT_init(void);

/* _DLL_InitTerm is the function that gets called by the operating system   */
/* loader when it loads and frees this DLL for each process that accesses   */
/* this DLL.  However, it only gets called the first time the DLL is loaded */
/* and the last time it is freed for a particular process.  The system      */
/* linkage convention MUST be used because the operating system loader is   */
/* calling this function.                                                   */
/* See DllEntryPoint in SDK documentation                                   */

INT APIENTRY          _DLL_InitTerm(HANDLE hInstance,
                                    DWORD  reasonCalled,
                                    LPVOID reserved );

INT APIENTRY          _DLL_InitTerm(HANDLE hInstance,
                                    DWORD  reasonCalled,
                                    LPVOID reserved )
{
   INT  rc = FALSE;     /* failed */
   switch (reasonCalled)
      {
      case  DLL_PROCESS_ATTACH:
         /*******************************************************************/
         /* The C run-time environment initialization function must be      */
         /* called before any calls to C run-time functions that are not    */
         /* inlined.                                                        */
         /*******************************************************************/

         if (_CRT_init() != -1)
            {
            /* initialize the controls */
            rc = LibMain( hInstance, reasonCalled, reserved );
            }
         break;

      case  DLL_THREAD_ATTACH:
      case  DLL_THREAD_DETACH:
      case  DLL_PROCESS_DETACH:
         /* We currently don't do anything with these */
         break;
      }
   return rc;
}

#endif

#endif  //CCL_SEPARATE_DLL

/**********************************************************************/
/* FUNCTION: LibMain(HANDLE, DWORD, LPVOID)                           */
/*                                                                    */
/* PURPOSE:  LibMain is called by Windows when the DLL is initialized,*/
/*           Thread Attached, and other times.  Refer to the SDK      */
/*           documentation, as to different ways this may be called.  */
/*                                                                    */
/*           The LibMain function should perform additional           */
/*           initialization tasks required by the DLL.  In this       */
/*           example, no initialization tasks are required.  LibMain  */
/*           should return a value of 1 if the initialization is      */
/*           successful.                                              */
/*                                                                    */
/**********************************************************************/
INT APIENTRY LibMain( HANDLE hInstance,
                      DWORD  ul_reason_being_called,
                      LPVOID lpReserved )
{
  WNDCLASS wndclass;
  BOOL     rc;

  /********************************************************************/
  /* Register client class, and check for prior existance             */
  /********************************************************************/
  if (!hCircularSliderInstance)
  {
    memset(&wndclass, 0x00, sizeof(WNDCLASS));
    wndclass.style         = CS_DBLCLKS | CS_VREDRAW | CS_HREDRAW |
                             CS_GLOBALCLASS;
    wndclass.lpfnWndProc   = (WNDPROC) DialWndProc;
    wndclass.cbClsExtra    = 0;
    wndclass.cbWndExtra    = sizeof(DWORD);
    wndclass.hInstance     = hInstance;
    wndclass.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
    wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW);
    wndclass.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
    wndclass.lpszMenuName  = NULL;
    wndclass.lpszClassName = ICL_CIRCULARSLIDER;

    rc = RegisterClass(&wndclass);

    if (!rc)
    {
      return (FALSE);
    }
    hCircularSliderInstance = hInstance;
  }

  return (TRUE);

  ul_reason_being_called;
  lpReserved;
}
