/* Revision: 34 1.3.1.3 source/ui/cclnt/iclccl.h, cclnt, ioc.v400, 000919  */
/* NOSHIP */
#ifndef _ICLCCL_
#define _ICLCCL_
/*******************************************************************************
* FILE NAME: iclccl.h                                                          *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the header information for the 32-bit version of        *
*   CCL.  Common to all CCL controls.                                          *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
/******************************************************************************/
/* Product: ICLUINT.DLL                                                       */
/* Filename: CPPWOT3.C - Initialization code for the Win32 CCL DLL.           */
/*                                                                            */
/* Flag    Date    Defect  Description                                        */
/* ----  --------  -----  --------------------------------------------------- */
/* RKK1  04/30/96  7680   Add changes required for Wind/U.                    */
/******************************************************************************/

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

#define CCL_MESSAGE_BASE               ( 0xF000 )
#define CCL_MESSAGE_TOP                ( 0xF0BF )

#define IC_UM_CCL_32TO16               ( CCL_MESSAGE_BASE+0x0001 )
#define IC_UM_CMD_CCLTOICLUI_32TO16    ( CCL_MESSAGE_BASE+0x0002 )

#define CCL_NOTIFY_CODE_BASE           ( 100 )
#define CCL_NOTIFY_CODE_TOP            ( 169 )

LRESULT WINAPI CCL32to16SendMessage(HWND, UINT, WPARAM, LPARAM);
LRESULT WINAPI CCL32to16PostMessage(HWND, UINT, WPARAM, LPARAM);

LRESULT WINAPI DllS16to32Message(HWND hWnd, unsigned int * Msg,
                              DWORD * wParam, LPARAM * lParam);

LRESULT WINAPI DllS32to16SendMessage(HWND hWnd, UINT Msg,
                                  WPARAM wParam, LPARAM lParam);

LRESULT WINAPI DllS32to16PostMessage(HWND hWnd, UINT Msg,
                                  WPARAM wParam, LPARAM lParam);



#define SENDMESSAGE(hwnd,msg,mp1,mp2) (CCL32to16SendMessage(hwnd,msg,mp1,mp2))
#define POSTMESSAGE(hwnd,msg,mp1,mp2) (CCL32to16PostMessage(hwnd,msg,mp1,mp2))

/***************************************************************************/
/*                      Added for Win32s                                   */
/*                                                                         */
/* Makes it easier to determine appropriate code paths:                    */
/***************************************************************************/
#ifdef _WIN32S
#define getWindowId(h)  ((long)((unsigned short)GetWindowLong((h),GWL_ID)))
#else
#define getWindowId(h)                         (GetWindowLong((h),GWL_ID))
#endif

#ifndef IS_WIN32
  #define IS_WIN32 TRUE
#endif

#ifndef IS_NT
  #define IS_NT      IS_WIN32 && (BOOL)(GetVersion() < 0x80000000)
#endif

#ifndef IS_WIN32S
#ifdef IC_WU							//->@RKK1
  /* Force IS_WIN32S to be FALSE for Wind/U */
  #define IS_WIN32S  0
#else								//@RKK1<-
  #define IS_WIN32S  IS_WIN32 && (BOOL)(!(IS_NT) && (LOBYTE(LOWORD(GetVersion()))<4))
#endif								//@RKK1
#endif

#ifndef IS_CHICAGO
  #define IS_CHICAGO (BOOL)(!(IS_NT) && !(IS_WIN32S)) && IS_WIN32
#endif

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif // _ICLCCL_
