#ifndef _SPINWIN_
#define _SPINWIN_

/* Revision: 72 1.3.2.2 source/ui/cclnt/spinbtn/spinwin.h, cclspin, ioc.v400, 000919  */
/***********************************************************************/
/*                                                                     */
/*              Licensed Materials - Property of IBM                   */
/*              20G0400 (C) Copyright IBM Corp. 1992, 1997.            */
/*                    See Copyright Instructions.                      */
/*                                                                     */
/***********************************************************************/
/***********************************************************************/
/*                                                                     */
/* CUA Controls Library/2 Version 1.0                       (Windows)  */
/*                                                                     */
/* Sample Application Code                                             */
/* Spinbutton Control                                                  */
/*                                                                     */
/* File:  spinwin.h                                                    */
/*                                                                     */
/* This header file includes macro includes for the spinbutton sample  */
/* application (spinwin.c).                                            */
/*                                                                     */
/***********************************************************************/

/**********************************************************************/
/*  Misc defines                                                      */
/**********************************************************************/
#define ID_NULL                       0        /* spinbtn ctrl id's   */
#define ID_SPINBUTTON_COLOR_RED       1
#define ID_SPINBUTTON_COLOR_GREEN     2
#define ID_SPINBUTTON_COLOR_BLUE      3
#define ID_SPINBUTTON_SIZE_X          4
#define ID_SPINBUTTON_SIZE_Y          5
#define ID_SPINBUTTON_SHAPE           6
#define ID_SPINBUTTON_PATTERN         7
#define SPINBUTTON_COUNT              7        /* number of spinbtns  */

#define ID_MENU                       100      /* menu id's           */
#define IDM_FILE                      110
#define IDM_SUBEXIT                   111

#define OPTION_COLOR_MIN              0        /* color min RGB value */
#define OPTION_COLOR_MAX              255      /* color max RGB value */
#define OPTION_COLOR_INIT             100      /* initial color value */

#define OPTION_SIZE_X_MIN             0        /* x-size min radius   */
#define OPTION_SIZE_X_MAX             99       /* x-size max radius   */
#define OPTION_SIZE_X_INIT            50       /* x-size init radius  */

#define OPTION_SIZE_Y_MIN             0        /* y-size min radius   */
#define OPTION_SIZE_Y_MAX             99       /* y-size max radius   */
#define OPTION_SIZE_Y_INIT            50       /* y-size init radius  */

#define OPTION_PATTERN_INIT           0        /* init pattern value  */

#define OPTION_SHAPE_INIT             0        /* init shape value    */

#define TEXT_MARGIN_X                 10       /* lefthand text margin*/
#define TEXT_OFFSET_Y                 10       /* text offset to bot- */
                                               /*  tom of spinbtn ctrl*/

#define SPIN_MARGIN_X                 180      /* distance from left  */
#define SPIN_LENGTH_X                 90       /* horizontal length   */
#define SPIN_TEXTLENGTH_X             150      /* len of text-filled  */
                                               /*  spin buttons       */
#define SPIN_TEXT_MAXCHARS            3        /* max chars in it     */
#define SPIN_VERT_SPACING             24       /* y-distance between  */
#define SPIN_HORZ_SPACING             5        /* x-distance between  */

#define NO_SPIN_CHANGE               -1        /* internal codes used */
#define NOT_SPINNING                  0        /* for deciding how to */
#define SPINNING                      1        /* render object       */

/**********************************************************************/
/*  The following four defines are the margins for the white field    */
/*  where the shape is drawn:                                         */
/*  ----------------------------------------------------------------  */
/*  Distance from left side of window                                 */
/**********************************************************************/
#define SHAPE_FIELD_LEFT              (SPIN_MARGIN_X            \
                                       + SPIN_TEXTLENGTH_X      \
                                       + SPIN_HORZ_SPACING)
/**********************************************************************/
/*  Distance from right side of window                                */
/**********************************************************************/
#define SHAPE_FIELD_RIGHT             50

/**********************************************************************/
/*  These are the color definitions:  background of gray, shape field */
/*  of white, text color of black.                                    */
/**********************************************************************/
#define SHAPE_FIELD_COLOR             RGB (255,255,255)
#define MAIN_TEXT_COLOR               RGB (0,0,0)

/**********************************************************************/
/*  Macro definitions                                                 */
/**********************************************************************/
#define PARENTOF(hwnd)  (HWND)GetWindowLong (hwnd, GWL_HWNDPARENT)

/**********************************************************************/
/*  Funtion prototypes                                                */
/**********************************************************************/
long FAR PASCAL ClientWndProc (HWND, UINT, WPARAM, LPARAM);
VOID     polyDraw (HWND, HDC, WORD, int);
VOID     createChildren (HWND, HANDLE, WORD);
VOID     createSpinButton (HWND, HANDLE, WORD, WORD, WORD, WORD,
                           DWORD, WORD, BOOL, LONG, LONG, LPSTR *,
                           WORD, LONG);

#endif // SPINWIN header guard
