// Revision: 46 1.4.1.3 source/ui/drag/idmcmdhr.hpp, dragdrop, ioc.v400, 000919  
/* NOSHIP */
#ifndef _IDMCMDHR_
#define _IDMCMDHR_
/*******************************************************************************
* FILE NAME: idmcmdhdr.hpp                                                     *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the classes:                                                *
*     IDMPopUpCommandHandler                                                   *
*     IDMPopUpMenuHandler                                                      *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <ipopmenu.hpp>
#include <imenuhdr.hpp>
#include <icmdhdr.hpp>

extern "C"
  {
  #define IUSING_OLE
  #ifdef WIN32_LEAN_AND_MEAN
    #undef WIN32_LEAN_AND_MEAN
  #endif
  #ifdef _OLE2_H_
    #undef _OLE2_H_
  #endif
  #include <iwindefs.h>
  }

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma enum(4)
#pragma pack(push,4)

#ifdef IC_WIN

class IDMPopUpCommandHandler ;

class IDMPopUpMenuHandler : public IMenuHandler
{
public:
  IDMPopUpMenuHandler(IWindow *) ;
  virtual
    ~IDMPopUpMenuHandler() ;
  IDMPopUpMenuHandler&
     startHandlingEvents() ;
  bool
     fNonDefaultDrag;

protected:
  virtual bool
     makePopUpMenu(IMenuEvent& menuEvent);
  bool
     dispatchHandlerEvent(IEvent& evt);

private:
  IDMPopUpMenuHandler ( const IDMPopUpMenuHandler&);
  IDMPopUpMenuHandler& operator=( const IDMPopUpMenuHandler&);
  IWindow
     *pWindowToHandle ;
};

class IDMPopUpCommandHandler : public ICommandHandler
{
public:
  IDMPopUpCommandHandler( IWindow* ) ;
  virtual
     ~IDMPopUpCommandHandler() ;
  IDMPopUpCommandHandler&
     startHandlingEvents() ;
  void setPoint(POINTL pt);
  void setDataObject(IDataObject* dataObj);
protected:
virtual bool
  command(ICommandEvent& cmdEvent);
private:
  IDMPopUpCommandHandler ( const IDMPopUpCommandHandler&);
  IDMPopUpCommandHandler& operator=( const IDMPopUpCommandHandler&);

  POINTL point;
  IDataObject* dataObject;
  IWindow
     *pWindowToHandle ;
};

#endif /* IC_WIN */

#pragma pack(pop)
#pragma enum(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif //_IDMCMDHR_
