// Revision: 52 1.3.1.3 source/ui/drag/idmdatob.hpp, dragdrop, ioc.v400, 000919  
/* NOSHIP */
#ifndef _IDMDATOB_
#define _IDMDATOB_
/*******************************************************************************
* FILE NAME: idmdatob.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the classes:                                                *
*     IDMDataObject                                                            *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifdef _OLE2_H_
  #undef _OLE2_H_
#endif

extern "C"
  {
  #ifndef _WIN32
    #define _WIN32
  #endif
  #define INC_OLE2
  #include <windows.h>
  }

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

class IEnumFORMATETC;
class IDMEnumFormat;
class IWindow;

#pragma enum(4)
#pragma pack(push,4)

class IDMDataObject : public IDataObject

  {
  public:
    IDMDataObject( IWindow *renderer,
                   IDMEnumFormat *enumFormat,
                   IStream* pIStreamParam = NULL);
    virtual
      ~IDMDataObject();

    virtual HRESULT __stdcall
      QueryInterface( REFIID refiid,
                      void **ppvoid );
    virtual ULONG __stdcall
      AddRef( );
    virtual ULONG __stdcall
      Release( );
    virtual HRESULT __stdcall
      GetData ( FORMATETC *pformatetcIn,
                STGMEDIUM *pmedium);
    virtual HRESULT __stdcall
      GetDataHere ( FORMATETC *pformatetc,
                    STGMEDIUM *pmedium);
    virtual HRESULT __stdcall
      QueryGetData ( FORMATETC *pformatetc);
    virtual HRESULT __stdcall
      GetCanonicalFormatEtc( FORMATETC *pformatectIn,
                             FORMATETC *pformatetcOut);
    virtual HRESULT __stdcall
      SetData( FORMATETC *pformatetc,
               STGMEDIUM *pmedium,
               BOOL fRelease);
    virtual HRESULT __stdcall
      EnumFormatEtc( DWORD dwDirection,
                     IEnumFORMATETC **ppenumFormatEtc);

    virtual HRESULT __stdcall
      DAdvise( FORMATETC *pformatetc,
               DWORD advf,
               IAdviseSink *pAdvSink,
               DWORD *pdwConnection);

    virtual HRESULT __stdcall
      DUnadvise( DWORD dwConnection);
    virtual HRESULT __stdcall
      EnumDAdvise( IEnumSTATDATA **ppenumAdvise);

    /*------------------- Misc member functions --------------------------*/
    static const char* formatDragInfo();

  private:
    ULONG m_cRef;
    IEnumFORMATETC *m_aFormatEtc;
    ULONG m_cFormats;
    HGLOBAL m_hGlobal;
    IWindow *_renderer;
    IStream* pIStream;
    };

#pragma pack(pop)      
#pragma enum(pop)
      
#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif
