// Revision: 64 1.3.1.3 source/ui/drag/idmdrptg.hpp, dragdrop, ioc.v400, 000919  
/*NOSHIP*/
#ifndef _IDMDRPTG_
#define _IDMDRPTG_
/*******************************************************************************
* FILE NAME: idmdrptg.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the classes:                                                *
*     IDMDropTarget                                                            *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/

extern "C"
  {
  #define IUSING_OLE
  #ifdef WIN32_LEAN_AND_MEAN
    #undef WIN32_LEAN_AND_MEAN
  #endif
  #ifdef _OLE2_H_
    #undef _OLE2_H_
  #endif
  #include <iwindefs.h>
  }

#include <ibase.hpp>
#include <iwindow.hpp>

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

class IDataObject;
class IDMDropTargetData;

#pragma enum(4)
#pragma pack(push,4)

class IDMDropTarget : public IDropTarget
  {
  public:
    IDMDropTarget(IWindow *win);
    ~IDMDropTarget();


    //---- IUnknown wrappers ----------

    virtual HRESULT __stdcall
      QueryInterface( REFIID refiid, void **ppvoid );
    virtual ULONG __stdcall
      AddRef(void);
    virtual ULONG __stdcall
      Release(void);


    //---- IDropTarget wrappers --------

    virtual HRESULT __stdcall
      DragEnter (LPDATAOBJECT pDataObject,
                 DWORD grfKeyState,
                 POINTL pt,
                 LPDWORD pdwEffect);

    virtual HRESULT __stdcall
      DragOver (DWORD grfKeyState,
                POINTL pt,
                LPDWORD pdwEffect);

    virtual HRESULT __stdcall
      DragLeave ();

    virtual HRESULT __stdcall
      Drop (LPDATAOBJECT pDataObject,
            DWORD grfKeyState,
            POINTL pt,
            LPDWORD pdwEffect);

    bool
      Register();
    void
      Revoke ();

  private:
    IDMDropTargetData
     *fDMDropTargetData;

};

#pragma pack(pop)
#pragma enum(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif

