// Revision: 67 1.4.1.3 source/ui/drag/idmdtprv.hpp, dragdrop, ioc.v400, 000919  
/* NOSHIP */
#ifndef _IDMDTPRV_
#define _IDMDTPRV_
/*******************************************************************************
* FILE NAME: idmdtprv.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of classes that are private              *
*   to the implementation of idmdptgh.hpp                                      *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <ikeyset2.h>

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

class IDMDropTarget;

#pragma enum(4)
#pragma pack(push,4)

class IDropTargetElement
  {
  public:
  IDropTargetElement( unsigned long      handle,
                      IDMDropTarget* dropTarget );

  ~IDropTargetElement( );
  unsigned long handleKey;
  IDMDropTarget *_dropTarget;

private:

  IDropTargetElement( const IDropTargetElement& );
  IDropTargetElement
    &operator =     ( const IDropTargetElement& );
  };

inline unsigned long const& key (IDropTargetElement* const& k)
  {
  return k->handleKey;
  }

class IDMDropTargetSet : public IKeySet < IDropTargetElement*, unsigned long >
  {
  public:
    IDMDropTargetSet() ;
    ~IDMDropTargetSet();
  };

#pragma pack(pop)
#pragma enum(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif

