// Revision: 74 1.3.1.3 source/ui/drag/idmfmten.hpp, dragdrop, ioc.v400, 000919  
/* NOSHIP */
#ifndef _IDMFMTEN_
#define _IDMFMTEN_
/*******************************************************************************
* FILE NAME: idmfmten.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the classes:                                                *
*     IDMFormatEnum                                                               *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/

#ifdef _OLE2_H_
  #undef _OLE2_H_
#endif

extern "C"
  {
  #ifndef _WIN32
    #define _WIN32
  #endif
  #define INC_OLE2
  #include <iwindefs.h>
  }

#include <ibase.hpp>
#include <iwindow.hpp>

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma enum(4)
#pragma pack(push,4)

class IDMEnumFormat : public IEnumFORMATETC
  {
  public:

    //IUnknown members
    virtual HRESULT __stdcall
      QueryInterface( REFIID refiid, void **ppvoid );
    virtual ULONG __stdcall
      AddRef(void);
    virtual ULONG __stdcall
      Release(void);

    //IEnumFORMATETC members
    virtual HRESULT __stdcall
        Next(ULONG, LPFORMATETC, ULONG *);
    virtual HRESULT __stdcall
        Skip(ULONG);
    virtual HRESULT __stdcall
        Reset();
    virtual HRESULT __stdcall
        Clone(IEnumFORMATETC **);

    IDMEnumFormat(ULONG cFE, LPFORMATETC prgFE);
    ~IDMEnumFormat();

  private:
    unsigned long
      m_iCur,           // Current FORMATETC
      m_cfe,            // Number of FORMATETCs
      m_cRef;           // Ref count
    LPFORMATETC
      m_prgfe;          //Source of FORMATETCs
    };
    
#pragma pack(pop)    
#pragma enum(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif

