// Revision: 89 1.4.1.3 source/ui/drag/idmoiprv.hpp, dragdrop, ioc.v400, 000919  
/* NOSHIP */
#ifndef _IDMOIPRV_
#define _IDMOIPRV_
/*******************************************************************************
* FILE NAME: idmoiprv.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of classes that are private              *
*   to the implementation of idmdptgh.hpp                                      *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <ikeyset2.h>

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

//class IThreadId;

#pragma enum(4)
#pragma pack(push,4)

class IDMThreadIdElement
  {
  public:
  IDMThreadIdElement( unsigned long   threadId,
                      int             refCount );

  ~IDMThreadIdElement( );

  unsigned long threadIdKey;
  int refCount;

private:

  IDMThreadIdElement( const IDMThreadIdElement& );
  IDMThreadIdElement
    &operator =     ( const IDMThreadIdElement& );
  };

inline unsigned long const& key (IDMThreadIdElement* const& k)
  {
  return k->threadIdKey;
  }

class IDMThreadIdSet : public IKeySet < IDMThreadIdElement*, unsigned long >
  {
  public:
    IDMThreadIdSet() ;
    ~IDMThreadIdSet();
  };
  
#pragma pack(pop)  
#pragma enum(pop)
  
#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif

