// Revision: 87 1.4.1.3 source/ui/drag/idmopma.hpp, dragdrop, ioc.v400, 000919  
/* NOSHIP */
#ifndef _IDMOPMA_
#define _IDMOPMA_
/*******************************************************************************
* FILE NAME: idmopma.hpp                                                       *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the classes:                                                *
*     IDMOperationMarshaller                                                   *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <imarsha.hpp>

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

class IDMOperation;

#pragma enum(4)
#pragma pack(push,4)

class IDMOperationMarshaller : public IDMMarshall {
public:
/*------------------------------- Constructors -------------------------------*/
  IDMOperationMarshaller ( IDMOperation& anOperation );
  IDMOperationMarshaller ( const IDMOperationMarshaller& aMarshaller );

virtual
 ~IDMOperationMarshaller ( );

virtual unsigned long
  marshall              ( unsigned long startPos=0, char* outStr=0 ) const;

virtual const char
 *unmarshall            ( const char* inStr );

private:
/*--------------------------------- Private ----------------------------------*/
// Dissallow assignment.
IDMOperationMarshaller
 &operator = ( const IDMOperationMarshaller& aMarshaller );

IDMOperation
 &theOperation;
}; // IDMOperationMarshaller

#pragma pack(pop)
#pragma enum(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#include <idmopma.inl>

#endif // _IDMOPMA_
