// Revision: 13 1.4.1.3 source/ui/drag/idmwin.hpp, dragdrop, ioc.v400, 000919  
/* NOSHIP */
#ifndef _IDMWIN_
#define _IDMWIN_
/*******************************************************************************
* FILE NAME: idmwin.hpp                                                        *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the declarations of the items that must be              *
*   exported in order to compile the template instantiation for idmwin.cpp.    *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <ibase.hpp>

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

class IDMItemProvider;
class IWindow;
class IPrivateResource;
class IDMProviderList;

#pragma enum(4)
#pragma pack(push,4)

struct Assoc {
  IDMItemProvider
   *provider;
  const IWindow
   *window;
  bool operator < ( const Assoc& assoc)   const
   { return (this < &assoc); }

  bool operator == ( const Assoc& assoc)  const
   { return (this == &assoc); }
};

inline const IWindow * const &key ( Assoc const &assoc )
{
  return assoc.window;
}

class IProviderStatics 
{
public:
 ~IProviderStatics          ( );

static IDMProviderList
 &providerList              ( );

static IPrivateResource
 &libraryKey                ( );

static IDMProviderList
 *pProviders;

static IPrivateResource
 *pLibKey;
};

#pragma pack(pop)
#pragma enum(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif
