// Revision: 14 1.4.1.2 source/ui/drag/idragobs.cpp, dragdrop, ioc.v400, 000919 
/*******************************************************************************
* FILE NAME: idragobs.cpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the implementation of functions that have been replaced *
*   and are now obsolete.  They have been placed here to provide compatibility *
*   with prior releases.                                                       *
*   This is a platform independent file.                                       *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/

#include <idmoper.hpp>
#include <icnrctl.hpp>
#include <idmimage.hpp>

// Segment definitions
#ifdef IC_PAGETUNE
  #define _IDRAGOBS_CPP_
  #include <ipagetun.h>
#endif

#if (IC_OBSOLETE <= IC_OBSOLETE_1)
//
// Block of obsolete code.  Obsolete level 1
//


/*------------------------------------------------------------------------------
| IDMOperation::setContainerNoRefresh                                          |
|                                                                              |
| Disables the container refreshes, will be re-enable it after processing.     |
------------------------------------------------------------------------------*/
IDMOperation& IDMOperation :: setContainerNoRefresh(IContainerControl* pCnr)
{
  return( setContainerRefreshOff( pCnr ) );
}

/*------------------------------------------------------------------------------
| IDMOperation::setContainerRefresh                                            |
|                                                                              |
| Re-enables container refreshes.                                              |
------------------------------------------------------------------------------*/
IDMOperation& IDMOperation :: setContainerRefresh()
{
  return( setContainerRefreshOn( ) );
}

/*------------------------------------------------------------------------------
| IDMImage::IDMImage                                                           |
|                                                                              |
| Constructor - Construct this class from an icon or bitmap resource id.       |
------------------------------------------------------------------------------*/
IDMImage :: IDMImage (const IResourceId& resourceId,
                      const ISize& ptrOffset,
                      const ISize& stretchSize,
                      const Style& style,
                      bool iconResource)
  : ptrOffset(ptrOffset),
#ifdef IC_PMWIN 
    fadeImage(ISystemPointerHandle::dragFade),
#endif
    imageStretchSize(stretchSize),
    imgStyle(style),
    pPointArray(0),
    points(0)
{
  if (iconResource)
  {
    this->pointerImage = *(new IPointerHandle(
                        resourceId.resourceLibrary().loadIcon(resourceId)));
    this->bitmapImage = 0;
    this->imgStyle |= IDMImage::ptr;
  }
  else
  {
    this->bitmapImage = *(new IBitmapHandle(
                       resourceId.resourceLibrary().loadBitmap(resourceId)));
    this->pointerImage = 0;
    this->imgStyle |= IDMImage::bmp;
  }

  if (this->imageStretchSize != 0)
  {
    this->imgStyle |= IDMImage::stretch;
  }
}

/*------------------------------------------------------------------------------
| IDMImage::IDMImage                                                           |
|                                                                              |
| Constructor - Construct this class from an array of points.                  |
------------------------------------------------------------------------------*/
IDMImage :: IDMImage (unsigned long pointArr[],
                      const ISize& ptrOffset,
                      const Style& style,
                      const unsigned long arrPts)
  : pointerImage(0),
    bitmapImage(0),
#ifdef IC_PMWIN 
    fadeImage(ISystemPointerHandle::dragFade),
#endif
    ptrOffset(ptrOffset),
    imageStretchSize(ISize(0,0)),
    imgStyle(style),
    pPointArray(pointArr),
    points(arrPts)
{
  this->imgStyle |= IDMImage::polygon;
}

/*------------------------------------------------------------------------------
| IDMImage::setPointArray                                                      |
|                                                                              |
| Sets the point array to be used to draw the image.                           |
------------------------------------------------------------------------------*/
IDMImage& IDMImage::setPointArray (unsigned long pointArr[])
{
  this->pPointArray = pointArr;
  IDMImage::Style imageStyle = style();
  imageStyle |= IDMImage::polygon;
  setStyle(imageStyle);
  return (*this);
}

//
// End block of obsolete code.  Obsolete level 1
//

#endif // IC_OBSOLETE
