// Revision: 18 1.4.1.3 source/ui/drag/imarsha.hpp, dragdrop, ioc.v400, 000919  
/* NOSHIP */
#ifndef _IMARSHA_
#define _IMARSHA_
/*******************************************************************************
* FILE NAME: imarsha.hpp                                                       *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the classes:                                                *
*     IDMMarshall                                                              *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <istring.hpp>

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma enum(4)
#pragma pack(push,4)

class IDMMarshall {
public:
/*------------------------------- Constructors -------------------------------*/
  IDMMarshall ( );

virtual
 ~IDMMarshall ( );

virtual unsigned long
  marshall     ( unsigned long startPos=0, char* outStr=0 ) const=0;

virtual const char
 *unmarshall   ( const char* inStr )=0;

// These are used to pack/unpack data into/from a string representation.

static unsigned long
  marshall     ( const IString& istr, unsigned long startPos=0, char* outStr=0),
  marshall     ( long num, unsigned long startPos=0, char* outStr=0);

static const char
 *unmarshall   ( IString& outStr, const char* inStr ),
 *unmarshall   ( long&    outNum, const char* inStr );
}; // IDMMarshall

#pragma pack(pop)
#pragma enum(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#include <imarsha.inl>

#endif // _IMARSHA_
