// Revision: 21 1.3.1.3 source/ui/drag/itemid.hpp, dragdrop, ioc.v400, 000919  
/* NOSHIP */
#ifndef _ITEMID_
#define _ITEMID_
/*******************************************************************************
* FILE NAME: itemid.hpp                                                        *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the classes:                                                *
*     Itemid                                                                   *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <istring.hpp>
#include <ihandle.hpp>

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

struct _ITEMIDLIST;
class IShellFolder;
class IMalloc;

#pragma enum(4)
#pragma pack(push,4)

class ItemID
{
  public:
    ItemID( struct _ITEMIDLIST *existingItem );
    ItemID( unsigned int cbSize );
    ItemID( const ItemID &other );
    ItemID( );
    virtual
     ~ItemID();

    ItemID
     &operator=  ( const ItemID& other ),
     &operator+= ( const ItemID& nextItem );

    ItemID
     &setToFirst(),
     &setToLast(),
     &setToNext( );

    ItemID
      current();
    bool
      currentIsValid();

    unsigned int
      size( ) const;

    ItemID
      concatItemIDs( ItemID &pidl );

    IString
      name( IShellFolder *lpsf, unsigned long dwFlags ),
      nameFromDesktop( );

    ItemID
      fullyQualifiedPidl(IShellFolder *lpsf);

    long /*HRESULT*/
      attributes( IShellFolder *lpsf, int itemNumber, unsigned long &ulAttr );

    struct _ITEMIDLIST *
      asLPITEMIDLIST();

    static ItemID
      itemIDFromDisplayName( const IString& displayName );

    IString
      fullyQualifiedName( );

    IPointerHandle
      ItemID::itemIcon( bool openIcon = false );

    IString
      itemType( );

  private:
    struct _ITEMIDLIST
      *thePidl,
      *currentPidl;
    IMalloc *lpMalloc;
};

#pragma pack(pop)
#pragma enum(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif
