/* Revision: 18 1.4.1.3 source/ui/widgets/canvasp.h, cuawidgets, ioc.v400, 000919  */
/*******************************************************************************
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1997, 1997                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifndef _CANVASP_
#define _CANVASP_

/***********************************************************************
 * Canvas Private definitions for Canvas widget
 **********************************************************************/

#include <Xm/XmP.h>

#include <Xm/BulletinBP.h>
#include <Xm/TransltnsP.h>

#include "canvas.h"

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

/* New fields for the Layout widget class record */

typedef struct {
        int empty;
} XiclCanvasClassPart;

/****************************************************************
 * Full class record declaration
 ****************************************************************/
typedef struct _XiclCanvasClassRec {
    CoreClassPart               core_class;
    CompositeClassPart          composite_class;
    ConstraintClassPart         constraint_class;
    XmManagerClassPart          manager_class;
    XiclCanvasClassPart         canvas_class;
} XiclCanvasClassRec;

extern XiclCanvasClassRec xiclCanvasClassRec;

/* New fields for the ICLCanvas widget record */
typedef struct {
    /* private state */
    int nothing;
} XiclCanvasPart;


/****************************************************************
 * Full instance record declaration
 ****************************************************************/

typedef struct _XiclCanvasRec {
    CorePart            core;
    CompositePart       composite;
    ConstraintPart      constraint;
    XmManagerPart       manager;
    XiclCanvasPart      canvas;
} XiclCanvasRec;

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif // _CANVASP_
