#ifndef _ICONGP_
#define _ICONGP_

/* Revision: 24 1.6.1.2 source/ui/widgets/icongp.h, cuawidgets, ioc.v400, 000919  */
/*
 * (c) Copyright 1989, 1990, 1991, 1992, 1993 OPEN SOFTWARE FOUNDATION, INC.
 * ALL RIGHTS RESERVED
 */
/*
 * Motif top of 2.0 tree as of Tue Jun  1 05:18:29 EDT 1993
 */
#ifndef _XmIconGP_h
#define _XmIconGP_h

#include <Xm/XmP.h>
#include <Xm/ManagerP.h>
#include <Xm/GadgetP.h>
#include "icong.h"

#ifdef __cplusplus
extern "C" {
#endif

static XRectangle nullRect = {0,0,0,0};

/* IconGadget class record */
typedef struct _XmIconGadgetClassPart
        {
        XtWidgetProc    icon_gadget_baseline;
        }       XmIconGadgetClassPart;

/* Full class record declaration */
typedef struct _XmIconGadgetClassRec
        {
        RectObjClassPart        rect_class;
        XmGadgetClassPart       gadget_class;
        XmIconGadgetClassPart   icong_class;
        }       XmIconGadgetClassRec;

extern  XmIconGadgetClassRec    xmIconGadgetClassRec;

/* IconGadget instance record */
typedef struct _XmIconGadgetPart
        {
        XmFontList      font_list;              /* XmNfontList */
        _XmString       _label;                 /* XmNlabelString */
        String          large_icon;             /* XmNlargeIcon */
        Pixmap          large_icon_mask;        /* XmNlargeIconMask */
        Pixmap          large_icon_pixmap;      /* XmNlargeIconPixmap */
        Boolean         recompute_size;         /* XmNrecomputeSize */
        String          small_icon;             /* XmNsmallIcon */
        Pixmap          small_icon_mask;        /* XmNsmallIconMask */
        Pixmap          small_icon_pixmap;      /* XmNsmallIconPixmap */
        unsigned char   viewtype;               /* XmNviewType */
        unsigned char   visual_emphasis;        /* XmNvisualEmphasis */
        unsigned char   cursor_emphasis;        /* XmNcursorEmphasis */
        unsigned char   inuse_emphasis;         /* XmNinUseEmphasis  */
        XtCallbackList  inuse_emphasis_cb;      /* XmNinUseEmphasisCallback */
        Boolean         refreshOn;              /* XmNrefreshGadget */
        /* Private variables */
        GC              normal_GC;
        GC              inverse_GC;
        GC              large_n_clip_GC;
        GC              large_i_clip_GC;
        GC              small_n_clip_GC;
        GC              small_i_clip_GC;
        Boolean         own_large_pixmap;
        Boolean         own_small_pixmap;
        XRectangle      label_rect;
        XRectangle      large_icon_rect;
        XRectangle      small_icon_rect;
        Dimension       spacing;
        unsigned char   layout_direction;
        }       XmIconGadgetPart;

/* Full instance record declaration */
typedef struct _XmIconGadgetRec
        {
        ObjectPart      object;
        RectObjPart     rectangle;
        XmGadgetPart    gadget;
        XmIconGadgetPart icong;
        }       XmIconGadgetRec;

/* Useful macros */
#define IG_FontList(w)          (((XmIconGadget)(w))->icong.font_list)
#define IG__LabelString(w)      (((XmIconGadget)(w))->icong._label)
#define IG_LargeIcon(w)         (((XmIconGadget)(w))->icong.large_icon)
#define IG_LargeIconMask(w)     (((XmIconGadget)(w))->icong.large_icon_mask)
#define IG_LargeIconPixmap(w)   (((XmIconGadget)(w))->icong.large_icon_pixmap)
#define IG_RecomputeSize(w)     (((XmIconGadget)(w))->icong.recompute_size)
#define IG_SmallIcon(w)         (((XmIconGadget)(w))->icong.small_icon)
#define IG_SmallIconMask(w)     (((XmIconGadget)(w))->icong.small_icon_mask)
#define IG_SmallIconPixmap(w)   (((XmIconGadget)(w))->icong.small_icon_pixmap)
#define IG_ViewType(w)          (((XmIconGadget)(w))->icong.viewtype)
#define IG_VisualEmphasis(w)    (((XmIconGadget)(w))->icong.visual_emphasis)
#define IG_CursorEmphasis(w)    (((XmIconGadget)(w))->icong.cursor_emphasis)
#define IG_InUseEmphasis(w)     (((XmIconGadget)(w))->icong.inuse_emphasis)
#define IG_NormalGC(w)          (((XmIconGadget)(w))->icong.normal_GC)
#define IG_InverseGC(w)         (((XmIconGadget)(w))->icong.inverse_GC)
#define IG_LargeNClipGC(w)      (((XmIconGadget)(w))->icong.large_n_clip_GC)
#define IG_LargeIClipGC(w)      (((XmIconGadget)(w))->icong.large_i_clip_GC)
#define IG_SmallNClipGC(w)      (((XmIconGadget)(w))->icong.small_n_clip_GC)
#define IG_SmallIClipGC(w)      (((XmIconGadget)(w))->icong.small_i_clip_GC)
#define IG_OwnLargePixmap(w)    (((XmIconGadget)(w))->icong.own_large_pixmap)
#define IG_OwnSmallPixmap(w)    (((XmIconGadget)(w))->icong.own_small_pixmap)
#define IG_Spacing(w)           (((XmIconGadget)(w))->icong.spacing)
#define IG_LayoutDirection(w)   (((XmIconGadget)(w))->icong.layout_direction)

#define IG_LabelRect(w)         (((XmIconGadget)(w))->icong.label_rect)
#define IG_LabelRectRV(w)       ( ShowLabel(w) ? ((XmIconGadget)(w))->icong.label_rect : nullRect)

#define IG_LargeIconRect(w)     (((XmIconGadget)(w))->icong.large_icon_rect)
#define IG_LargeIconRectRV(w)   ( ShowIcon(w) ? ((XmIconGadget)(w))->icong.large_icon_rect : nullRect)

#define IG_SmallIconRect(w)     (((XmIconGadget)(w))->icong.small_icon_rect)
#define IG_SmallIconRectRV(w)   ( ShowIcon(w) ? ((XmIconGadget)(w))->icong.small_icon_rect : nullRect)

#define IG_Highlighted(w)       (((XmIconGadget)(w))->gadget.highlighted)
#define IG_HLThickness(w)     (((XmIconGadget)(w))->gadget.highlight_thickness)
#define IG_ShadowThickness(w)   (((XmIconGadget)(w))->gadget.shadow_thickness)
#define IG_Xrm_Name(w)          (((XmIconGadget)(w))->object.xrm_name)
#define IG_Background(w)        (((XmManagerWidget) \
                (((XmGadget)(w))->object.parent))->core.background_pixel)
#define IG_Foreground(w)        (((XmManagerWidget) \
                (((XmGadget)(w))->object.parent))->manager.foreground)
#define IG_Depth(w)             (((XmManagerWidget) \
                (((XmGadget)(w))->object.parent))->core.depth)
#define IG_StringDirection(w)   (((XmManagerWidget) \
                (((XmGadget)(w))->object.parent))->manager.string_direction)
#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmIconGP_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */

#endif // ICONGP header guard
